**MrC Anvil Interface tool to ToolServer.
**V1.00 Lightsoft '98
**SB 200798
kAEShutdown:	equ	"shut"	*was shut
kAERestart:	equ	"rest"
kAEFinderEvents:	equ	"FNDR"
kFinderSig:	equ	"FNDR"

typeBoolean	equ	"bool"
typeChar	equ	"TEXT"
typeSMInt	equ	"shor"
typeInteger	equ	"long"
typeSMFloat	equ	"sing"
typeFloat	equ	"doub"
typeLongInteger	equ	"long"
typeShortInteger	equ	"shor"
typeLongFloat	equ	"doub"
typeShortFloat	equ	"sing"
typeExtended	equ	"exte"
typeComp	equ	"comp"
typeMagnitude	equ	"magn"
typeAEList	equ	"list"
typeAERecord	equ	"reco"
typeTrue	equ	"true"
typeFalse	equ	"fals"
typeAlias	equ	"alis"
typeEnumerated	equ	"enum"
typeType	equ	"type"
typeAppParameters	equ	"appa"
typeProperty	equ	"prop"
typeFSS	equ	"fss "
typeKeyword	equ	"keyw"
typeSectionH	equ	"sect"
typeWildCard	equ	"****"

typeApplSignature	equ	"sign"
typeSessionID	equ	"ssid"
typeTargetID	equ	"targ"
typeProcessSerialNumber	equ	"psn "
typeNull	equ	"null"                 /*the type of null/nonexistent data*/

kCoreEventClass	equ	"aevt"

kAEOpenApplication	equ	"oapp"
kAEOpenDocuments	equ	"odoc"
kAEPrintDocuments	equ	"pdoc"
kAEQuitApplication	equ	"quit"

kAECreatorType	equ	"crea"
kAEQuitAll	equ	"quia"

kAEApplicationDied	equ	"obit"
keyProcessSerialNumber	equ	"psn "

keyErrorNumber	equ	"errn"
keyErrorString	equ	"errs"

kAEAnswer	equ	"ansr"

keyDirectObject	equ	"----"


* keyword used in install special handler */
keyPreDispatch	equ	"phac"           * PreHandler Accessor Call */
keySelectProc	equ	"selh"            * More selector Call */

* keywords used in attributes */
keyTransactionIDAttr	equ	"tran"
keyReturnIDAttr	equ	"rtid"
keyEventClassAttr	equ	"evcl"
keyEventIDAttr	equ	"evid"
keyAddressAttr	equ	"addr"
keyOptionalKeywordAttr	equ	"optk"
keyTimeoutAttr	equ	"timo"
keyInteractLevelAttr	equ	"inte"     /*this attribute is read only will be set in AESend*/
keyEventSourceAttr	equ	"esrc"       /* this attribute is read only */
keyMissedKeywordAttr	equ	"miss"     /* this attribute is read only */

* constants for use in AESendMode */

kAENoReply	equ	$00000001            /* Sender doesn"t want a reply to event */
kAEQueueReply	equ	$00000002         /* Sender wants a reply but won"t wait */
kAEWaitReply	equ	$00000003          /* Sender wants a reply and will be waiting */

kAENeverInteract	equ	$00000010      /* Server should not interact with user */
kAECanInteract	equ	$00000020        /* Server may try to interact with user */
kAEAlwaysInteract	equ	$00000030     /* Server should always interact with user where appropriate */

kAECanSwitchLayer	equ	$00000040     /* Interaction may switch layer */

kAEDontReconnect	equ	$00000080      /* don"t reconnect if there is a sessClosedErr from PPCToolbox */

* constants to be used in AESendPriority */

kAENormalPriority	equ	$00000000     /* Post message at the end of event queue */

* special constants in generating events */

kAnyTransactionID	equ	0              /* no transaction is in use */
kAutoGenerateReturnID	equ	-1         /* AECreateAppleEvent will generate a session-unique ID */

* constant for use AESend */
kAEDefaultTimeout	equ	-1             /* timeout value determined by AEM */
kNoTimeOut	equ	-2                    /* wait until reply comes back, however long it takes */

* dispatch parameter to AEResumeTheCurrentEvent takes a pointer to a dispatch
*table, or one of these two constants */
kAENoDispatch	equ	0
kAEUseStandardDispatch	equ	-1


call_ccp:	macro
	if 	PPC

	mr	r5,r20	*pointer to params
	lwz	r3,callback(r25)	*16
	lwz	r4,anvil_info(rtoc)	*20
	Xcall	CallUniversalProc
	else
	move.l	a0,-(sp)	*request parameter block to anvil
	qmove.l	callback(a5),a0
	jsr	(a0)
	addq.l	#4,sp
	endif			*tidy up stack (Ah)
	endm

Link_IF:
	entry
**LXT Tool entry code
	if PPC
**Save regs
	macs_last	*NOTE TOOLS DO NOT USE LXT_INIT
	mflr	r5	*get rts
	stwu	r5,-4(sp)	*put on stack so we can use 68k to return
;	stmw	r10,-88(sp)	**save r10-31
;	subi	sp,sp,88	* Reset the stack pointer
	
;	stwu	sp,-88(sp)	* skip over the stack space where the caller
	lwz r25,(rtoc)		*Load global data (bss) pointer (first entry in TOC)
				*into a5
	mr	r21,r4	*Da param
	macs_first
	else
	move.l	8(sp),a1	*parameter block argv
	endif

	qmove.l	a1,command_save(a5)
	qmove.l	(a1),callback(a5)
	qmove.l	4(a1),callback_toc(a5)
	qmove.l	16(a1),d0
**check command
	cmpi.w	#A_Init,d0	*init
	beq	link_init
	cmpi.w	#A_Work_on_file,d0
	beq	link_add_file
	cmpi.w	#A_go,d0
	beq	link_go
	cmpi.w	#6,d0
	bne.s	not_link_prefs
	bsr.s	link_prefs
	bra.s	end		*for future proofing - nopped out by fant
not_link_prefs:
end:	clr.l	d0
term:
	qmove.l	command_save(a5),a0
	qmove.l	d0,(a0)		*error return
	rts_	"Link_IF"
link_init:
	clr.l	global_error(a5)
	clr.l	command_line_index(a5)
	tst.b	have_initted(a5)
	bne.s	init_end
	move.b	#1,have_initted(a5)
	move.l	#30*1024,d0
	OSNewHandleClear	d0,a0
	move.l	a0,handle_to_command_line(a5)
init_end:
	move.l	handle_to_command_line(a5),a0
**init cl
	move.l	(a0),a0
**copy pre
	lea	pre(pc),a1
copy_pre:
	move.b	(a1)+,(a0)+
	beq.s	done_copy_pre
	addq.l	#1,command_line_index(a5)
	bra.s	copy_pre
done_copy_pre:

	bra	end
	rts_	"LinkInit"
Link_prefs:

	rts_	"Link_prefs"


link_add_file:

**make fsspec and then path of output file

	move.l	24(a1),src_file_name(a5)
	move.l	32(a1),file_type(a5)	*1 object, 2=lib
	cmpi.l	#1,file_type(a5)
	bne	do_lib
**the output is going to be at phase 3, so we name_to_phase to get the name
	move.l	src_file_name(a5),a0
	lea	output_file_name(a5),a1
	qmoveq	#64,d2
	OSBlockMove	a0,a1,d2

**now get fsspec of phase 3 output folder
	lea	global_pb(a5),a0
	move.l	#A_get_phase_x_op_spec,(a0)
	move.l	#3,4(a0)
	call_ccp

	lea	global_pb(a5),a0
	addq.l	 #4,a0	 *point to fsspec of folder
	move.w	(a0),d7	*Save drive number
	bsr	get_folder_dirid	*in d0
**make fsspec
	qmove.l	d0,d1	*DirID
	qmove.w	d7,d0	*VRefNum
	lea	output_file_name(a5),a0
	lea	output_fsspec(a5),a1
	OSMakeFSspec	d0,d1,a0,a1,d0
**Change file to type OBJ
iodrparid:	equ	100	long
iodrdirid:	equ	48	long
ionameptr:	equ	18	*long
iocompletion:	equ	12	*long
iovrefnum:	equ	22	*word
iofdirindex:	equ	28	*word
iodirid:	equ	48	*long

	lea	output_fsspec(a5),a1
	lea	the_error_string(a5),a0
	qmove.w	(a1),iovrefnum(a0)
	qmove.l	2(a1),iodirid(a0)
	lea	6(a1),a1
	qmove.l	a1,ionameptr(a0)
	qmove.w	#0,iofdirindex(a0)
	qmove.l	#"OBJ ",32(a0)
	OSPBHSetFInfo	a0,d0

**get path for file
	lea	global_pb(a5),a0
	move.l	#A_fsspec_to_path,(a0)
	lea	output_fsspec(a5),a1
	move.l	a1,4(a0)
	lea	path_here(a5),a1
	move.l	a1,8(a0)
	call_ccp
	bra	got_path
do_lib:

**Find file in project, then get path
**get path for file
	lea	global_pb(a5),a0
	move.l	#A_file_to_path,(a0)
	move.l	src_file_name(a5),4(a0)
	lea	path_here(a5),a1
	move.l	a1,8(a0)
	call_ccp
got_path:

	lea	path_here(a5),a1
	move.l	handle_to_command_line(a5),a0
	move.l	(a0),a0
	add.l	command_line_index(a5),a0
	move.w	#0x2022,(a0)+
	add.l	#2,command_line_index(a5)
copy_file:
	move.b	(a1)+,d0
	beq.s	end_copy_file
	move.b	d0,(a0)+
	addq.l	#1,command_line_index(a5)
	bra.s	copy_file
end_copy_file:
	move.w	#0x2220,(a0)+
	addq.l	#2,command_line_index(a5)

	qmove.l	command_save(a5),a0
	qmove.l	#0,(a0)	*return no error
	qmove.l	#0,4(a0)	*handle to translated data
	qmove.l	#0,8(a0)	*size
	rts_	"link_add_file"
	
link_go:
**make output path
**the output is going to be at phase 3, so we name_to_phase to get the name

**now get fsspec of phase 3 output folder
	lea	global_pb(a5),a0
	move.l	#A_get_phase_x_op_spec,(a0)
	move.l	#3,4(a0)
	call_ccp

	lea	global_pb(a5),a0
	addq.l	 #4,a0	 *point to fsspec of folder
	move.w	(a0),d7	*Save drive number
	bsr	get_folder_dirid	*in d0
**make fsspec
	qmove.l	d0,d1	*DirID
	qmove.w	d7,d0	*VRefNum
	lea	out_file_name(pc),a0
	lea	output_fsspec(a5),a1
	OSMakeFSspec	d0,d1,a0,a1,d0	*probably wont exist, so may get error (ffd5) here

**get path for file
	lea	global_pb(a5),a0
	move.l	#A_fsspec_to_path,(a0)
	lea	output_fsspec(a5),a1
	move.l	a1,4(a0)
	lea	path_here(a5),a1
	move.l	a1,8(a0)
	call_ccp


********
	move.l	handle_to_command_line(a5),a0
	move.l	(a0),a0
	add.l	command_line_index(a5),a0
**Copy output path
	move.w	#"-o",(a0)+
	move.w	#0x2022,(a0)+
	lea	path_here(a5),a1
copy_out:
	move.b	(a1)+,(a0)+
	bne.s	copy_out
	subq.l	#1,a0	*before the zero		
	move.w	#0x2220,(a0)+
**copy post script
	lea	postscript(pc),a1
copy_postscript:
	move.b	(a1)+,(a0)+
	bne.s	copy_postscript
	move.l	handle_to_command_line(a5),a0
	move.l	(a0),a0
	
;	lea	default_command_line(pc),a1
;copy_cl:
;	move.b	(a1)+,(a0)+
;	bne.s	copy_cl
**Send script to to toolserver
**Create descriptor
	move.l	#typeApplSignature,d0
	lea	Tsig(pc),a0
	moveq	#4,d2	*sizeof
	lea	finder_addr(pc),a1	*we want descriptor here

	OSAECreateDescriptor	d0,a0,d2,a1,d0

	lea	finder_addr(pc),a0
	
**Create apple event
	move.l	#"misc",d0	*event class
	move.l	#"dosc",d1	*EVent ID
	lea	finder_addr(pc),a0		 	 *descriptor
	move.w	#kAutoGenerateReturnID,d3	*tells Apple Event Manager */
                                            * to generate a unique */
                                            * return ID*/
	move.l	#kAnyTransactionID,d4	*The apple event is not part of any transaction	
	lea	myshutdown(pc),a1			*AEvent here pse.
	OSAECreateAppleEvent	d0,d1,a0,d3,d4,a1,d0


**Create discriptor

	lea	my_discriptor(pc),a0
	move.l	#"TEXT",(a0)
	move.l	handle_to_command_line(a5),4(a0)
	
    lea	myshutdown(pc),a0	**appleevent
    move.l	#"----",d1	*keyword - direct object - the one and only
 	lea	my_discriptor(pc),a1
 	OSAEPutParamDesc	a0,d1,a1,d0


**Send apple event
	lea	myshutdown(pc),a0	*The aevt
	lea	nilreply(pc),a1	*The reply
	move.l	#kAEWaitReply+kAECanSwitchLayer+kAEAlwaysInteract,d2	*Sendmode
	move.w	#kAENormalPriority,d3	*priority
	move.l	#kNoTimeOut,d4	*Timeout
	move.l	#0,a2	*no idle proc
	move.l	#0,a3	*No event filter proc

	OSAESend	a0,a1,d2,d3,d4,a2,a3,d0	*and wait for link
	
	
**now, check for errors
	lea	nilreply(pc),a0	*The reply AE
	move.l	#"diag",d1	*keyword - direct object - the one and only
	move.l	#"TEXT",d2
	lea	return_descriptor(pc),a1
	OSAEGetKeyDesc	a0,d1,d2,a1,d0
	clr.l	global_error(a5)
	tst.w	d0
	bne	no_errors

**show errors
	lea	return_descriptor(pc),a0
	move.l	4(a0),a0
	OSGetHandleSize	a0,d0
	move.l	d0,error_size(a5)
	lea	return_descriptor(pc),a0
	move.l	4(a0),a0
	OSHLock	a0
	lea	return_descriptor(pc),a0
	move.l	4(a0),a0
	move.l	(a0),a0	*The errors

	move.l	a0,a1
	add.l	error_size(a5),a1
	move.l	(a1),end_of_errors(a5)
	lea	the_error_string(a5),a2
	lea	ppc_link_err_pre_string(pc),a3
copy_error_pre:	move.b	(a3)+,(a2)+
	bne.s	copy_error_pre
	subq.l	#1,a2
	
**Find CR, then rewind to find file name
find_cr:	cmpi.b	#13,(a0)+
	bne.s	find_cr
**Find colon
find_colon:
	cmpi.b	#":",-(a0)
	bne.s	find_colon
	addq.l	#1,a0
**Copy filename
copy_file_name:
	move.b	(a0)+,d0
	move.b	d0,(a2)+
	cmpi.b	#0x22,d0
	beq.s	end_copy_fn
	cmpi.b	#13,d0
	bne.s	copy_file_name
end_copy_fn:
**show error
	subq.l	#1,a2
	move.b	#" ",(a2)+
;	addq.l	#2,a0
copy_error:	move.b	(a0)+,d0
	move.b	d0,(a2)+
	cmpi.b	#13,d0
	bne.s	copy_error
	clr.b	(a2)+
	move.l	#-1,global_error(a5)
	lea	the_error_string(a5),a0
	bsr	send_to_error
	qmoveq	#-1,d0
	OSSysBeep	d0
	lea	return_descriptor(pc),a0	*we want descriptor here
	OSAEDisposeDesc	a0,d0

	bra	end_errors	



no_errors:
**Open file, get code 1 and release resource,
**close file, delete output from link

	qmoveq	#0,d1
	lea	output_fsspec(a5),a0
	OSFSpOpenResFile	a0,d1,d7	*get ref number in d7

	move.l	#"CODE",d0
	qmoveq	#1,d1
	OSGet1Resource	d0,d1,a0
	move.l	a0,output_file_handle(a5)

	OSGetHandleSize	a0,d0
	move.l	d0,output_file_size(a5)

	move.l	output_file_handle(a5),a0
	OSDetachResource	a0
	
	OSCloseResFile d7
	
**Nop out from 0 to 2f
	move.l	output_file_handle(a5),a0
	move.l	(a0),a0
	move.l	#0x28/2,d0
nop_loop:
	move.w	#0x4e71,(a0)+
	subq.l	#1,d0
	bne.s	nop_loop
**Delete the output file
;	lea	output_fsspec(a5),a0
;	OSFSpDelete a0,d0

**Set up a5 globals - send 20000 to Build
	lea	global_pb(a5),a0
	move.l	#A_send_command,(a0)
	qmove.l	#"BUIL",4(a0)	*param1
	qmove.w	#"Dx",8(a0)
	clr.l	12(a0)
	qmove.l	#20000,16(a0)
	qmove.l	#32000,20(a0)
	call_ccp


	qmove.l	command_save(a5),a0
	qmove.l	output_file_handle(a5),4(a0)	*handle to translated data
	qmove.l	output_file_size(a5),8(a0)	*size
	lea	finder_addr(pc),a0	*we want descriptor here
	OSAEDisposeDesc	a0,d0

	move.l	global_error(a5),d0
	
	bra	term
end_errors:
	lea	finder_addr(pc),a0	*we want descriptor here
	OSAEDisposeDesc	a0,d0
	
	qmove.l	command_save(a5),a0
	qmove.l	#0,4(a0)	*handle to translated data
	qmove.l	#0,8(a0)	*size
	move.l	global_error(a5),d0
	bra	term
	rts_	"Link_go"
	
send_to_error:
**needs C string in a0
	reset_locals
	local.b	my_pb1,300
	link	a4,#-400
	qmove.l	a0,d1		*string
	lea	my_pb1(a4),a0
	qmove.l	#300,(a0)	*command
	qmove.l	d1,4(a0)	*param1	
	call_ccp
	unlk	a4
	rts_	"send_to_error"

send_to_log:
**needs C string in a0
	reset_locals
	local.b	my_pb1,300
	link	a4,#-400
	qmove.l	a0,d1		*string
	lea	my_pb1(a4),a0
	qmove.l	#320,(a0)	*command
	qmove.l	d1,4(a0)	*param1	
	call_ccp
	qmoveq	#1,d0
	OSSysBeep	d0
	unlk	a4
	rts_	"send_to_error"


Ciocompletion:	equ	12	long
Cionameptr:	equ	18	long
Ciovrefnum:	equ	22	word
Ciodrdirid:	equ	48	long
Ciofdirindex:	equ	28	word - set to zero initially
CioDRParID:	equ	100	long
CioFrefnum:	equ	24	*file refnum on output from getcatinfo

**Fsspec of folder in a0, returns d0.l=dirid
	reset_locals
	local.b	my_pb,480
get_folder_dirid:
	link	a4,#-500
	lea	my_pb(a4),a1
	clr.l	Ciocompletion(a1)	no completion routine
	lea	6(a0),a2
	qmove.l	a2,Cionameptr(a1)	point to filename
	qmove.w	(a0),Ciovrefnum(a1)	vrefnum
	qmove.l	2(a0),Ciodrdirid(a1)	dir id	  
	qmove.w	#0,Ciofdirindex(a1)	
	OSPBGetCatInfoSync	a1,d0
	lea	my_pb(a4),a0
	qmove.l	Ciodrdirid(a0),d0
	unlk	a4
	rts_	"Build_get_folder_dirid"

TSig:	dc.l	"MPSX"
finder_addr:	ds.l	4	*KEyword,handle to data
myshutdown:	ds.l	4	*Shutdown apple event here
nilreply:	ds.l	4	*Reply from send
my_discriptor:	ds.l	2
return_descriptor:	ds.l	2

postscript:	dc.b	"  Dev:Error",13,0
	align
pre:	dc.b	"Link -model far -br 020 -w -sg Main"	*use 020 branches, 32 bit addressing
	dc.b	0
	align
out_file_name:	pstring	"Extern_link.out"
	align
ppc_link_err_pre_string:	cstring	"#MPW Link> "
	align
	global	Link_IF
