*******************************************************************************
*Project:                                                                     *
*Author:        Lightsoft                                                     *
*Filename:      DDB_Access.s                                                  *
*Version:       V1.00 (Auto)                                                  *
*Date started:  1:22:26 on 12th May 1997                                      *
*Rev. History:                                                                *
*                                                                             *
*                                                                             *
*******************************************************************************
call_ccp:	macro
	if 	PPC
	mr	r5,r20	*pointer to params
	lwz	r3,callback(r25)	*16
	lwz	r4,anvil_info(rtoc)	*20
	Xcall	CallUniversalProc
	else
	move.l	a0,-(sp)	*request parameter block to anvil
	qmove.l	callback(a5),a0
	jsr	(a0)
	addq.l	#4,sp
	endif			*tidy up stack (Ah)
	endm

ddb_access:
	global	ddb_access
	reset_locals
	local.l	my_pb_h,1
**LXT Tool entry code
	entry
	if PPC
**Save regs
	macs_last	*NOTE TOOLS DO NOT USE LXT_INIT
	mflr	r5	*get rts
	stwu	r5,-4(sp)	*put on stack so we can use 68k to return
	lwz r25,(rtoc)		*Load global data (bss) pointer (first entry in TOC)
				*into a5
	mr	r21,r4	*Da param
	macs_first
	else
	move.l	8(sp),a1	*parameter block argv
	endif
	link	a4,#-1000
	qmove.l	a1,command_save(a5)
	qmove.l	(a1),callback(a5)
	qmove.l	4(a1),callback_toc(a5)
	qmove.l	#0,ddb_error(a5)	*default return
	qmove.l	16(a1),d0	*command
	cmpi.w	#A_Cleanup,d0
	move.l	ddb_handle(a5),a0
	bne.s	not_cleanup
	move.l	a0,d0
	beq.s	oops
	OSDisposeHandle	d0
	qmove.l	#-1,ddb_handle(a5)
;	dc.w	_Disposehandle
	qmove.l	#0,d0
oops:
	bra.s	end
not_cleanup:
	cmpi.l	#A_Init,d0
	lea	ddb_tit(pc),a0
	bne	not_init
**Show ddb title
	bsr	send_to_log
	bra	end	
not_init:
	cmpi.l	#100,d0
	bne.s	not_add_entry	*tool sends this at end of processing
	bsr	add_entry
	bra.s	end
not_add_entry:
	cmpi.l	#200,d0
	bne	not_check_entry		*build sends this when checking whether to process a file or not
	bsr	check_entry
	bra.s	end
not_check_entry:
	cmpi.l	#300,d0
	bne.s	not_its_proj
	bsr.s	its_proj
	bra.s	end
not_its_proj:
	cmpi.l	#400,d0
	bne.s	not_give_ddb
**return 0 and ptr to ddb
	qmove.l	ddb_handle(a5),d0
	OSHLock	d0
;	dc.w	_Hlock
	move.l	ddb_handle(a5),a1
	move.l	(a1),a1
	move.l	command_save(a5),a0
	clr.l	(a0)
	qmove.l	a1,4(a0)
	bra.s	end1
not_give_ddb:

end:	qmove.l	ddb_error(a5),d0
	move.l	command_save(a5),a0
	qmove.l	d0,(a0)		*error return
end1:	unlk	a4

	rts_	"DDB_Access"

its_proj:
	qmove.l	20(a1),proj_ptr(a5)
**have we a DDB?
	move.l	proj_ptr(a5),a3
	lea	depend_offset(a3),a3
	add.l	(a3),a3
	move.l	proj_ptr(a5),a2
	lea	eof_offset(a2),a2
	add.l	(a2),a2
	qmove.l	a3,d0
	cmp.l	a2,d0
	lea	ddb_create(pc),a0
	bne	have_ddb
**Show creating ddb message
**Show ddb title
	bsr	send_to_log
**create a new ddb in local memory, returned to build with size at end
	qmove.l	#1000,d0
	OSNewHandle	d0,a0
;	dc.w	_Newhandle
	qmove.l	a0,ddb_handle(a5)
	OSHLock	a0
;	dc.w	_HLock
	qmove.l	ddb_handle(a5),a0
	move.l	(a0),a1
	lea	ddb_title(pc),a0
;	qmove.l	#0,d0
	qcmove.b	(a0)+,d2
	OSBlockMoveData	a0,a1,d2
;	dc.w	_blockmove	*copy ddb title
**make an empty entry at 128+8
	move.l	ddb_handle(a5),a0
	move.l	(a0),a0
	lea	128(a0),a0
	clr.l	(a0)+
	rts_	"DDB_its_proj"
have_ddb:
*Copy ddb out of project
	qmove.l	a2,d1		*eof offset
	sub.l	d0,d1		*size of current ddb
	qmove.l	d1,d7		*save
	add.l	#10000,d1
	qmove.l	d1,d0
	OSNewHandle	d0,a0
;	dc.w	_newhandle
	qmove.l	a0,ddb_handle(a5)
**copy ddb
	move.l	proj_ptr(a5),a3
	lea	depend_offset(a3),a3
	add.l	(a3),a3		*->ddb in project
	move.l	a3,a0
	move.l	ddb_handle(a5),a1
	move.l	(a1),a1
	qmove.l	d7,d2
	OSBlockMoveData	a0,a1,d2
;	dc.w	_BlockMove	*ddb now in our handle
	rts_	"DDB_its_proj_have_ddb"

**free size to inc by in d7
want_ddb_plus:
**Size of ddb calculated from 128(ddb)+132(ddb)+1000
	move.l	ddb_handle(a5),a0
	move.l	(a0),a0
	qmove.l	128(a0),d6	*Sizeof ddb
	add.l	#1000,d6	*current size
	add.l	d6,d7		*new size wanted
	move.l	ddb_handle(a5),a0
	OSHUnlock	a0
;	dc.w	_HUnlock
	move.l	ddb_handle(a5),a0
	OSGetHandleSize	a0,d0
;	dc.w	_gethandlesize	*in d0
	cmp.l	d7,d0
	bgt.s	ddb_size_ok
	qmove.l	d7,d1
	add.l	#4000,d1	*add on a wodge
	qmove.l	ddb_handle(a5),a0
	OSSetHandleSize	a0,d1
;	dc.w	_Sethandlesize
	OSGetMemErr	d0
	tst.w	d0
	beq.s	ddb_size_ok
	lea	mem_text(pc),a0
	OSDebugStr	a0
;	dc.w	_Debugstr
ddb_size_ok:
	qmove.l	ddb_handle(a5),d0
	OSHLock	d0
;	dc.w	_HLock
got_size:
	rts_	"DDBACC_want_proj_plus_d7"
	
	
	
add_entry:
	cmpi.l	#-1,ddb_handle(a5)
	bne.s	not_gone
	lea	ddb_gone(pc),a0
	bsr	send_to_log
	bra	ae_end
not_gone:
**20(a1)=ptr to list
	qmove.l	20(a1),input_list_ptr(a5)
	qmove.l	ddb_handle(a5),d0
	OSHLock	d0
;	dc.w	_HLock
**remove any list for this entry
	bsr	remove_entry
**add new entry
	bsr	add_new_entry
	move.l	ddb_handle(a5),a0
	move.l	(a0),a0
	qmove.l	128(a0),d0
	move.l	ddb_handle(a5),a0
	OSHUnlock	a0
;	dc.w	_HUnlock
ae_end:
	rts_	"DDB_add_entry"

remove_entry:
	move.l	ddb_handle(a5),a0
	move.l	(a0),a0
	tst.l	128(a0)
	beq	re_done		*no data
**lists start at 132
	lea	132(a0),a2	*first entry
**Check primary names
find_del_primary:
	qpush3	a2
	lea	8(a2),a1
	move.l	input_list_ptr(a5),a0
	addq.l	#4,a0
	bsr	compare_names	
	qpop3	a2
	tst.w	d0
	beq.s	found_it
	tst.l	(a2)
	bmi.s	re_done		*end of list
	add.l	4(a2),a2
	bra.s	find_del_primary
found_it:
**Subtract size of this entry from total size
	qmove.l	4(a2),d7	*size of this entry
**now we ahve to delete it by moving entries above down.
**Source is here+size, dest is here of this
	move.l	a2,a1	*dest
	move.l	a2,a0
	add.l	4(a0),a0	*source=end of this
**address of end of list - address of end of this
**calc address of end of list
	move.l	ddb_handle(a5),a3
	move.l	(a3),a3
	lea	128(a3),a3
	add.l	(a3),a3		*addr of end of list
	addq.l	#4,a3		*frig for "here"
	add.l	4(a2),a2	*end of here
	sub.l	a2,a3		*size of data to move

	move.l	ddb_handle(a5),a2
	move.l	(a2),a2
	sub.l	d7,128(a2)	*reduce size

	move.l	a3,d2
	beq.s	no_move_down	*we have to find "new" last entry
	OSBlockMoveData	a0,a1,d2
;	dc.w	_BlockMove
	bra.s	re_done
no_move_down:
**we find new last entry as follows (saves 4 bytes per primary filanme for a double link
**we scan from the start of the list
**at each entry we subtract this offset from the total size.
**when total size=current offset, we know this is the last entry, then we can set a -1
	move.l	ddb_handle(a5),a0
	move.l	(a0),a0
	qmove.l	128(a0),d7	*total size
	lea	132(a0),a0		*Start of list
	tst.l	d7
	beq.s	got_last_entry	*Missed this and it HURT!
find_new_last:
	cmp.l	4(a0),d7
	beq.s	got_last_entry
	sub.l	4(a0),d7	*math this way round is important!
	add.l	4(a0),a0
	bra.s	find_new_last
got_last_entry:
	move.l	#-1,(a0)	*new end of list
re_done:
	rts_	"DDB_remove_entry"

add_new_entry:
**Check ddb has space for entry
**space for entry calculated as number of entries*64+64
	move.l	input_list_ptr(a5),a0
	qmove.l	(a0),d0
;	mulu	#64,d0		*Secondary names
	lsl.l	#6,d0	*times 64
	add.l	#64,d0		*primary name
	qmove.l	d0,d7
	addq.l	#8,d7		*for end and offset
	qmove.l	d7,sizeof_this_entry(a5)
	bsr	want_ddb_plus
**now find end of list
	qmove.l	ddb_handle(a5),d0
	OSHLock	d0
;	dc.w	_HLock
	move.l	ddb_handle(a5),a0
	move.l	(a0),a0
	lea	132(a0),a2		*list pos
	tst.l	128(a0)
	beq.s	got_end_of_list
**find entry with a -1
find_last:	tst.l	(a2)
	bgt.s	not_last
	qmove.l	4(a2),(a2)	*not last now :-)
	add.l	4(a2),a2
	bra.s	got_end_of_list
not_last:
	add.l	4(a2),a2
	bra.s	find_last
**list pos in a2
got_end_of_list:
	move.l	ddb_handle(a5),a0
	move.l	(a0),a0
	qmove.l	sizeof_this_entry(a5),d0
	add.l	d0,128(a0)
	qmove.l	#-1,(a2)+				*last entry
	qmove.l	sizeof_this_entry(a5),(a2)+		*sizeof
**now copy list, primary file name (64) followed by secondary filenames (64)
	qmove.l	sizeof_this_entry(a5),d2
	subq.l	#8,d2					*correct for last and off to next
	move.l	a2,a1
	move.l	input_list_ptr(a5),a0
	addq.l	#4,a0					*Skip number of files
	OSBlockMoveData	a0,a1,d2
;	dc.w	_BlockMove
	qmove.l	ddb_handle(a5),d0
	OSHUnlock	d0
;	dc.w	_HUnlock
	rts_	"DDB_add_entry"
	
check_entry:
**20(a1)=ptr to filename, returns a list of included file names in a handle
	qmove.l	20(a1),input_list_ptr(a5)
	qmove.l	ddb_handle(a5),d0
	OSHLock	d0
;	dc.w	_HLock
**Find file, return a handle with number of entries(Int32), entries
	move.l	ddb_handle(a5),a0
	move.l	(a0),a0
	tst.l	128(a0)
	beq	ce_done_err		*no data
**lists start at 132
	lea	132(a0),a2	*first entry
**Check primary names
find_ce_primary:
	qpush3	a2
	lea	8(a2),a1
	move.l	input_list_ptr(a5),a0
	bsr	compare_names	
	qpop3	a2
	tst.w	d0
	beq.s	found_it_ce
	tst.l	(a2)
	bmi.s	ce_done_err		*end of list
	add.l	4(a2),a2
	bra.s	find_ce_primary
found_it_ce:
**last,offset to next, entries
	qpush1	a2	*save entry
	qmove.l	4(a2),d0
	OSNewHandle	d0,a0
;	dc.w	_newhandle
	qmove.l	a0,return_list_h(a5)
	OSHLock	a0
	qmove.l	return_list_h(a5),a0
	move.l	(a0),a1
	qpop1	a2
	qmove.l	4(a2),d0
	qmove.l	d0,d1
	lsr.l	#6,d1
;	divu.l	#64,d1	*number of entries
	subq.l	#1,d1
	qmove.l	d1,(a1)+
	lea		64+8(a2),a0	*list
	sub.l	#64+8,d0	*do not return primary filename
	qmove.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	qmove.l	return_list_h(a5),d0
	OSHUnlock	d0
	move.l	command_save(a5),a0
	qmove.l	return_list_h(a5),4(a0)	*return handle to data
bye1:
	qmove.l	ddb_handle(a5),d0
	OSHUnlock	d0	
	rts_	"DDB_check_entry"
ce_done_err:
	qmove.l	#-5,ddb_error(a5)
	bra.s	bye1
***********************************************
*a0=src name
*a2=cmp name
*d0=1 if src name is greater, -1 if less, 0=match, 2-=error
compare_names:
	section	l1
	qmove.l	a0,-(sp)
;	qmove.l	#0,d0
	qcmove.b	(a0)+,d0
	qcmove.b	(a1)+,d1
	cmp.l	d0,d1
	bne	.strncmp_end_lt
;	bsr	strNcmp		*a0<a1, d0=-1, a0>a1, d0=1, a0=a1, d0=0
        tst.l   d0
        beq.s     .strncmp_end_eq
.strncmp_loop:
        tst.b   (a1)
        beq.s     .strncmp_end_test
        cmpm.b   (a1)+,(a0)+
        bne.s     .strncmp_doit             ; if equal, next one
        subq.l  #1,d0
        bne     .strncmp_loop
        bra.s     .strncmp_end_eq
.strncmp_doit:
        blt.s     .strncmp_end_lt     ; unsigned compare
        moveq #1,d0   ; its greater than
        bra	.strncmp_bye
.strncmp_end_test:
        tst.b   (a0)
        bne.s     .strncmp_end_lt
.strncmp_end_eq:
        moveq #0,d0
        bra	.strncmp_bye
.strncmp_end_lt:
        moveq #-1,d0
.strncmp_bye:

	qmove.l	(sp)+,a0
	rts_	"DDB_compare_names"


send_to_log:
	qmove.l	#A_string_in_log,d0
	qmove.l	a0,d1
	bsr.s	send_1
	qmove.l	my_pb_h(a4),d0
	OSDisposeHandle	d0
;	dc.w	_disposehandle	
	rts_	"Send_to_log"	
send_1:
	movem.l	d0/d1,-(sp)	*Save params
	qmove.l	#256,d0		*NO alias will be bigger than this
	OSNewHandle	d0,a0
;	dc.w	_newhandle
	movem.l	(sp)+,d0/d1
	move.l	a0,d2
	bne.s	mem_ok7
	addq.l	#4,sp
	lea	mem_string(pc),a0
	bra	fault
mem_ok7:
	movem.l	d0/d1,-(sp)
	qmove.l	d2,my_pb_h(a4)
	OSHLock	a0
;	dc.w	_hlock
	movem.l	(sp)+,d0/d1
	move.l	my_pb_h(a4),a0
	move.l	(a0),a0
	qmove.l	d0,(a0)	*command
	qmove.l	d1,4(a0)	*param1
	call_ccp
;	move.l	a0,-(sp)	*request parameter block to anvil
;	move.l	callback(a5),a0
;	jsr	(A0)
;	addq.l	#4,sp			*tidy up stack (Ah)
fault1:
	rts_	"Send_1"
fault:
	OSDebugStr	a0
;	dc.w	_Debugstr
	rts_	"DDBACC_Low_level_fault"
	
*************
;strNcmp:
;	 section	lib
;	 global	strNcmp
;        tst.l   d0
;        beq.s     .strncmp_end_equal
;.strncmp_loop:
;        tst.b   (a1)
;        beq.s     .strncmp_end_test
;
;        cmpm.b   (a1)+,(a0)+
;        bne.s     .strncmp_doit             ; if equal, next one
;
;        subq.l  #1,d0
;        bne     .strncmp_loop
;        bra.s     .strncmp_end_equal
;.strncmp_doit:
;        blt.s     .strncmp_end_lessthan     ; unsigned compare
;
;        moveq #1,d0   ; its greater than
;        bra	.strncmp_bye
;
;.strncmp_end_test:
;        tst.b   (a0)
;        bne.s     .strncmp_end_lessthan
;
;.strncmp_end_equal:
;        moveq #0,d0
;        bra	.strncmp_bye
;
;.strncmp_end_lessthan:
;        moveq #-1,d0
;.strncmp_bye:        rts
*****************************
mem_string:	pstring	"DDBACC no mem to report mem error! STOP."
	align
ddb_tit:	dc.b	"DDBACC V1.20 LSA0017 [hours$]:[minutes$] on [day$]/[month$]/[year$]",13,13
	dc.b	"DDBACC Installed.",13,13,0
	align
ddb_create:	cstring	"No DDB found in this project.",13,"Making a new one.",13
	align
mem_text:	pstring	"Fatal mem error in DDBACC"
	align
ddb_title:	pstring	"Anvil DDB version 1. Auth: Stuart Ball. Birthday 11th Dec. Lightsoft 1998."
	align
ddb_gone:	cstring	"DDBADD - Error: DDB has been Cleaned up!",13,"DDBACC has no DDB!"
	align
anvil_info:	dc.l	0xF2		*4 data regs in, 1 long out, C
	dc.b	0		*resvd
	dc.b	0		*ppc (68k=0)
	dc.w	0		*Routine flags 4=native + 2=needs init + 1=offset
