*********************************************************************************
*FILE:	read_libs.s				*
*MOTHER FILE:	FANTASM3XX.S				*
*DATE:	120195				*
*PROGRAMMER:	STUART BALL				*
*DESCRIPTION:	LIGHTSOFT LINK V2.00 - SEE DOC FC_281094_01.		*
*INPUT:	Reads library files into system heap		*
*********************************************************************************
;LINKABLE FILE HEADER v2.xx
;0:		TITLE, COMMENTS,DESCRIPTION ETC
;400:		INPUTS
;724:		OUTPUTS, USEAGE
;1024:		.L		LENGTH OF GLOBAL LABELS/ADDRESSES (32 BYTES=1 LABEL)
;1028:		.L		LENGTH OF EXTERN LABELS/ADDRESSES (32 BYTES=1 LABEL)
;1032:		.L		0
;1036:				START OF EXTERN LABELS/ADDRESSES
;1036+(1028.L):			START OF GLOBAL LABS/ADDRESSES
;1036+(1028.L)+(1024.L)		START OF CODE

;
;FORMAT OF LABELS/ADDRESSES TABLES
;
;28 BYTES - LABEL
;4 BYTES  - ADDRESS RELATIVE TO 0

**read_libs calls calc_lib_size to calculate the size of all library files
**in ul_directory and sl_directory. Library files are type F3LB.
**next it allocates this space on the heap.
**now it reads the files from disk into the 
**heap.
**      myCInfoPBRec.ioCompletion := NIL;
**        myCInfoPBRec.ioNamePtr := @fileName;
**        myCInfoPBRec.ioVRefNum := odocFSSpec.vRefNum;
**        myCInfoPBRec.ioDrDirID := folderDirID;
**        myCInfoPBRec.ioFDirIndex := folderIndex;
**        retCode := PBGetCatInfoSync(@myCInfoPBRec);
Ciocompletion:	equ	12	long
Cionameptr:	equ	18	long
Ciovrefnum:	equ	22	word
Ciodrdirid:	equ	48	long
Ciofdirindex:	equ	28	word - set to zero initially

*********************************************************
**d1=file size
**file in source_buff(a5)
**name in link_name(pc)
add_library:
	move.l	libraries_h(A5),a1	pointer to libs
	move.l	(a1),a1
	clr.l	d5
	move.w	number_of_libraries(a5),d5

	move.l	lib_pos(a5),d6
	add.l	d6,a1
	move.l	a1,d4	for debug purps

	lea	library_starts(a5),a2
	move.l	d4,0(a2,d5.l*4)	store start address
	
	add.l	d1,d6	add size of data fork
	ADD.L	d1,D4
	MOVE.L	D4,4(A2,D5.L*4)	STORE END ADDRESS
	add.l	d1,lib_pos(a5)	*update lib pos
	save_all

**copy lib into a1

	move.l	source_buff(a5),a0
	move.l	d1,d0
	dc.w	_BlockMove
	restore_all
	addq.w	#1,number_of_libraries(a5)
	lea	library_starts(a5),a2
	move.l	d6,libraries_size(A5)
	inc.w	d5
	move.w	d5,number_of_libraries(A5)
	clr.l	d0
	rts
NO_LIBS2:	CLR.L	LIBRARIES_SIZE(A5)
	CLR.W	NUMBER_OF_LIBRARIES(A5)
	CLR.L	D0
	RTS_	"Link68K_Add_lib"
	even

	global	add_library

