*****************************************************************
*****************************************************************
*doc:	write_pef_frag.s		     			*
*auth:	sb							*
*date:	12/05/98		  	  	  	  	*
*based on write_xcoff_frag.s, sb '95                            *
*tabs:	8		  	  	  	  		*
*****************************************************************
**pef reloc opcodes
**normally the operand is in the lower bits, and the value is 1+operand
**e.g. func_desc+1 relocs two function descriptors
skip:	equ	0x8000
reloc_code:	equ	0x4000	*reloc a code section ptr (toc_routines)
reloc_data:	equ	0x4200	*reloc a data section ptr (used to do bss for example)
func_desc:	equ	0x4400
reloc_import_run:	equ	0x4a00	*mark 4 bytes as an import mapped to symbol index
reloc_import:	equ	0x6000	*mark 4 bytes as a import mapped to index in param (mask=0x1ff)
**see doc "external library calls"
**note a0 is used as the "file" pointer and should not be touched!
write_pef:

	lea	wxf_text(pc),a0
	bsr	printit
	move.l	rs_counter(a5),d0	*round up bss to nearest 4
mod44:	move.l	d0,d1
	andi.w	#%11,d1
	beq.s	mod44_ok
	addq.l	#1,d0		*file size
	bra.s	mod44	
mod44_ok:	
	move.l	d0,pef_bss_size(a5)
done_message:
	lea	my_time(pc),a0
	OSReadDateTime	a0,d0
	lea	my_time(pc),a0
	move.l	(a0),d7	*time stamp
**first copy file header
	move.l	source_buff(a5),a0	*this is where we make the file
**pef headers are:
*0: the main header - 40 bytes
*1-3: section headers, 28 bytes each. we do them thus:
*1=code, 2=data, 3=loader (note oposite code and dat from xcoff because instantiated sections must precede
*non-instantiated sections (the bss for ex.)
*total header size is 40+(3*28)=124 bytes
*the global string table (4 bytes of zeros) follows the headers, so firsst section is at 128.
 	move.l	a0,a1	*save off
**construct basic headers, we cant complete because we don't know the sizes of the sections yet

**main header
	move.l	#"Joy!",(a0)
	move.l	#"peff",4(a0)
	move.l	#"pwpc",8(a0)
	move.l	#1,12(a0)	*version
**time into 16
	move.l	d7,16(a0)	*time
	clr.l	20(a0)	*definversion
	clr.l	24(a0)	*implversion
	clr.l	28(a0)	*currentversion
	move.w	#3,32(a0)	*number of sections in file
	move.w	#2,34(a0)	*number of loadable sections (code and data)
	clr.l	36(a0)	*memory address
**code header
	lea	40(a0),a0
	move.l	a0,code_header(a5)	*save address so we can come back later
	move.l	#-1,(a0)	*sectionname
	clr.l	4(a0)	*section address
	clr.l	8(a0)	*execsize - rawsize
	clr.l	12(a0)	*initsize - rawsize
	clr.l	16(a0)	*rawsize - later
	move.l	#0x80,20(a0)	*offset to section
	move.b	#0,24(a0)	*regionkind - code
	move.b	#4,25(a0)	*sharing - 4 for code=globalshare
	move.b	#4,26(a0)	*aligment - 2 to the power of - 4 for code and data, 2 for loader
	clr.b	27(a0)	*resvd

**data header
	lea	28(a0),a0
	move.l	a0,data_header(a5)
	move.l	#-1,(a0)	*sectionname
	clr.l	4(a0)	*section address
	clr.l	8(a0)	*execsize - rawsize
	clr.l	12(a0)	*initsize - rawsize
	clr.l	16(a0)	*rawsize - later
	clr.l	20(a0)	*offset to section - later
	move.b	#1,24(a0)	*regionkind - data
	move.b	#1,25(a0)	*sharing - 1 for data=contextshare
	move.b	#4,26(a0)	*aligment - 2 to the power of - 4 for code and data, 2 for loader
	clr.b	27(a0)	*resvd

**loader header
	lea	28(a0),a0
	move.l	a0,loader_header(a5)
	move.l	#-1,(a0)	*sectionname
	clr.l	4(a0)	*section address
	clr.l	8(a0)	*execsize - 0 for loader
	clr.l	12(a0)	*initsize - 0 for loader
	clr.l	16(a0)	*rawsize of section - later
	clr.l	20(a0)	*offset to section - later
	move.b	#4,24(a0)	*regionkind - loader
	move.b	#4,25(a0)	*sharing - 4 for loader=contextshare
	move.b	#2,26(a0)	*aligment - 2 to the power of - 4 for code and data, 2 for loader
	clr.b	27(a0)	*resvd
	
	lea	128(a1),a0		*the headers are in this space
	move.l	#128,d4	*total file size accum
	clr.l	-4(a0)	*global string table
	
**now lets write the code (pc(a5) is length of code)
	move.l	code_start(a5),a1	*a1->code
	sub.l	#64,a1			*for our loader
**insert our loader
	move.l	#0x60000000,(a1)+	*nop
	move.l	#0x60000000,(a1)+	*nop
					*we want a b entry instruction, and as soon as i can find the
					*book we'll have one...
	move.l	#0x48000000,d0		*0x48xxxxxx
	add.l	#64-8,d0		*account for the two previous instructions

	move.l	main_entry(a5),d1
	bclr	#31,d1
	bclr	#0,d1
	bclr	#1,d1			*must be quad and this is quicker than an and.l inst.
	add.l	d1,d0
	move.l	d0,(a1)+
	move.l	#"Mjol",(a1)+
	move.l	#"QQDQ",(a1)+
	move.l	#" Mjh",(a1)+
	move.l	#"iutp",(a1)+
	move.l	#"gu 2",(a1)+
	move.l	#"009.",(a1)+		*our (c) message			
	move.l	pc(a5),d0
;	add.l	#64,d0		*acct for our 64 byte bit at the start
	add.l	d0,d4		*file size
	move.l	code_start(a5),a1	*a1->code
	sub.l	#64,a1			*for our loader
	bsr	copy
	move.l	pc(a5),d0
mod4:	move.l	d0,d1
	andi.w	#%11,d1
	beq.s	mod_ok
	addq.l	#1,d0
	addq.l	#1,d4		*file size
	bra.s	mod4	
mod_ok:	move.l	d0,pef_code_size(a5)
	bra.s	done_text
	rts_	"cpf_pef_move_code"

done_text:
*8write size of text into header
	move.l	code_header(a5),a2
	move.l	pef_code_size(a5),8(a2)	*into execsize
	move.l	pef_code_size(a5),12(a2)	*into initsize
	move.l	pef_code_size(a5),16(a2)	*into raw size	

**make next section 16 byte aligned	
	bsr	align_pef_section	*modifies a0, d4 and d7, aligns a0 so that d4 is mod 16 and not a0 is mod 16!
	
*****************data section*********************
	
	move.l	d4,pef_data_start_offset(a5)	*make a note of where the data is starting
**now lets make the data section
	clr.l	d7	*size counter
**first the pointer to the bss section (the size of the data section goes in here!)
	move.l	a0,a4	*save pointer pos
	clr.l	(a0)+	*pointer to bss goes here (size of data section really)
	addq.l	#4,d7
	addq.l	#4,d4
;**first do the toc for imported symbols
**a0 is pointing to the start of the data section
	move.w	total_imports_num(a5),d0
	beq.s	no_imports
	subq.w	#1,d0		*the old dbra ploy...
	
import_loop:
	clr.l	(a0)+	*clear a pointer where the link will put the ptr to the tv of the imported function
	addq.l	#4,d7
	addq.l	#4,d4
	dbra	d0,import_loop
no_imports:	
;**now do the data entries
	move.l	data_item_count(a5),d0
	beq.s	no_data20
	move.l	a0,a2		*save start of data table so we can calc offsets in a bit
	subq.l	#1,d0
	move.l	data_item_offsets(a5),a1	*point to the offsets
store_data_offsets:
	move.l	(a1)+,(a0)+			*store this offset
	addq.l	#4,d7
	addq.l	#4,d4
	dbra	d0,store_data_offsets
no_data20:
**now do the code entries
	move.l	toc_code_count(a5),d0
	beq.s	no_data30
	move.l	a0,code_pointers_va(a5)	*so we can get back and add data size
	subq.l	#1,d0

	move.l	toc_code_offsets(a5),a1
store_code_offsets:
	move.l	(a1)+,d1
	add.l	#64,d1	*our header size (wanker! - 'cause their off by 64 bytes!!!)
	move.l	d1,(a0)+
	addq.l	#4,d7
	addq.l	#4,d4
	dbra	d0,store_code_offsets			
no_data30:
;**now create function descriptors for the exports
;;	 tst.l	 export_all_flag(a5)
;;	 bne.s	 export_all
;;	 clr.l	 number_of_globs_present(a5)
;export_all:
**insert fd's for exports
	move.l	number_of_globs_present(a5),d6
	beq.s	skip_exports_fds
	move.l	a0,export_fds_start(a5)	*so we can come back and add data and bss size
	move.l	d7,va_of_exports(a5)

	move.l	libraries_h(a5),a1
	move.l	(a1),a1		*32 bytes a throw - code offset in 28-32 - upper byte is to be ignored. 
**save offset to first export in data section
	move.l	d4,d5	*offset to here
	sub.l	pef_data_start_offset(a5),d5
	move.l	d5,exports_fds_start(a5)
create_efd_loop:
**get code addr
	move.l	28(a1),d0
	andi.l	#0xffffff,d0	*8 meg limit
	addi.l	#64,d0
	move.l	d0,(a0)+	*code offset - may need to add on 64? yes.
	clr.l	(a0)+		*toc pointer
	clr.l	(a0)+		*pascal link bits
	add.l	#12,d7
	add.l	#12,d4
	lea	32(a1),a1
	subq.l	#1,d6
	bgt.s	create_efd_loop
skip_exports_fds:
	move.l	d4,xcoff_va_of_entry(a5)	*save va of entry point

**now we have to export the start of the code

	move.l	d4,offset_of_entry(a5)
	move.l	#0,(a0)+	*our entry is at address zero in the code
	clr.l	(a0)+	*entries toc
	clr.l	(a0)+	*entries frame	
;	move.l	d6,d7	*restore to previous before toc calcs	
	add.l	#12,d7
	add.l	#12,d4
**align data section to 16 bytes
pad_toc_to_16:
	move.l	d7,d0
	andi.l	#0xf,d0
	beq.s	toc_16
	addq.l	#1,a0
	addq.l	#1,d7
	addq.l	#1,d4
	bra.s	pad_toc_to_16
toc_16:
	move.l	d7,pef_toc_size(a5)


**now splat the data across
	move.l	data_buffer(a5),a1
	move.l	data_buffer_index(a5),d0
	sub.l	d0,a1			*back to start of buffer	
	tst.l	d0
	beq.s	no_data	
copy_data:
	move.b	(a1)+,(a0)+
	addq.l	#1,d4
	addq.l	#1,d7
	subq.l	#1,d0
	bne.s	copy_data
**pad out
mod41:	move.l	d7,d1
	andi.w	#%11,d1
	beq.s	mod4_ok
	addq.l	#1,d7
	addq.l	#1,d4		*file size
	clr.b	(a0)+	*pad byte
	bra.s	mod41	
mod4_ok:
no_data:
;	nop
	move.l	d7,pef_data_size(a5)	*save size of dat section for header


**now add toc size to data pointers so they are correct
	move.l	pef_toc_size(a5),d6		*toc size 
	move.l	data_item_count(a5),d0
	beq.s	no_data1
	subq.l	#1,d0
calc_data_offsets:
	add.l	d6,(a2)			*add data size to offset
	addq.l	#4,a2
;	subq.l	#4,d6
	dbra	d0,calc_data_offsets
**phew!

no_data1:
;	 move.l	code_pointers_va(a5),a2
;**now add data size to code pointers so they are correct
;
;;	 move.l	xcoff_data_size(a5),d6		 *toc size 
;
;	 move.l	#64,d6
;	 add.l	 pef_bss_size(a5),d6
;;	 add.l	 #12,d6		 	 	 *plus entry point is total size of toc
;**calc offsets and sub 4 from d6 as we go
;	 move.l	toc_code_count(a5),d0
;	 beq.s	 no_data2
;	 subq.l	#1,d0
;calc_code_offsets:
;	 add.l	 d6,(a2)+	 	 	 *add data size (and our boot code!) to offset
;;	 subq.l	#4,d6
;	 dbra	 d0,calc_code_offsets
;**phew!
;
no_data2:
**v5 go back and add bss+data size to export code pointer in fds
	
;	move.l	number_of_globs_present(a5),d0
;	beq.s	skip_exports_fds1
;	move.l	export_fds_start(a5),a1		*back to start of exports fds
;	move.l	xcoff_data_size(a5),d6		*toc size 
;	add.l	xcoff_bss_size(a5),d6		*total data section size
;add_data_to_fds_loop:
;	add.l	d6,(a1)	*added to code ptr
;	lea	12(a1),a1	*next code pointer in exports fds	
;	subq.l	#1,d0
;	bne.s	add_data_to_fds_loop
;skip_exports_fds1:
**finally save va to text (data+bss)
;	add.l	xcoff_bss_size(a5),d7	*plus bss is code va
;	sub.l	pef_bss_size(a5),d7	*minus bss is data size	

	move.l	d7,(a4)	*pointer to bss (for our global data)
	move.l	d7,xcoff_code_va(a5)	*save
	bra.s	done_toc
	rts_	"cpf_make_toc"

done_toc:	
*8write size of data into header
	move.l	data_header(a5),a2
	move.l	pef_data_size(a5),d0
	add.l	pef_bss_size(a5),d0
	move.l	d0,8(a2)	*into execsize
	move.l	pef_data_size(a5),d0
	move.l	d0,12(a2)	*into initsize
	move.l	d0,16(a2)	*into raw size	
	move.l	pef_data_start_offset(a5),20(a2)	*offset to data section

	clr.l	d2		*offset to lib string table
	clr.l	d3		*loader size counter
**make next section 16 byte aligned	
	bsr	align_pef_section	*modifies a0, d4 and d7, aligns a0 so that d4 is mod 16 and not a0 is mod 16!
	
	move.l	d4,pef_loader_start_offset(a5)
**now we can write the loader section
**
	move.l	loader_header(a5),a2
	move.l	pef_loader_start_offset(a5),20(a2)	*offset to loader section

****************************loader********************
**write loader header
	move.l	a0,pef_loader_header(a5)
	move.l	d4,pef_loader_header_offset(a5)
	move.l	#1,0(a0)	*section containing entry point
	move.l	offset_of_entry(a5),d0
	sub.l	pef_data_start_offset(a5),d0
	move.l	d0,4(a0)	*offset to entry fd in data section
	move.l	#-1,8(a0)	*no init section	
	clr.l	12(a0)	*offset of initpoint
	move.l	#-1,16(a0)	*no term section
	clr.l	20(a0)	*no term offset

	move.l	sl_connections_slot(a5),d1	*note we dont dec this for dbra cause we need default iflib
	bne.s	actual_number_of_slibs
	moveq	#1,d1
actual_number_of_slibs:
	move.l	d1,24(a0)	*number of import files
	
	clr.l	d0
	move.w	total_imports_num(a5),d0
	move.l	d0,28(a0)	*how many imported symbols
	move.l	#1,32(a0)	*how many loader sections
	
	clr.l	36(a0)	*section offset to relocation table
	clr.l	40(a0)	*section offset to loader strings
	clr.l	44(a0)	*section offset to hash slot table
	clr.l	48(a0)	*2 to this power is number of hash slots
	clr.l	52(a0)	*number of exported syms
	lea	56(a0),a0
	add.l	#56,d4
	add.l	#56,d7
**import libraries
**each entry is 24 bytes
**calc total size of libs strings

	move.l	sl_connections_slot(a5),d1	*note we dont dec this for dbra cause we need default iflib

;	move.l	#13,d5	*total size of libs names strings 
	move.l	#1,d5	; take into account the zero terminator
	push	a0
	lea	fixed_lib_name(pc),a1
	add.b	(a1),d5	*total size of libs names string - starts at just length of carbonlib+'0'
	pop	a0
	subq.l	#2,d1	*1 for dbra, 1 for iflib
	blt.s	no_additional_slibs1
	move.l	slibs_handle(a5),a1
	move.l	(a1),a1
	addq.l	#2,a1
calc_next_slib_str_size:
	clr.l	d0
	move.b	(a1)+,d0	*p to c
	inc.l	d0	*for zero byte and to skip options byte
	add.l	d0,a1	*skip name to options byte (soft)
	add.l	d0,d5	*add to accum
	dbra	d1,calc_next_slib_str_size
no_additional_slibs1:
**total size slibs names strings in d5
	move.l	d5,slibs_string_size(a5)	*save
	clr.l	d5	*first import index in import table for a slib
	move.l	sl_connections_slot(a5),d1
	sub.l	    #1,d1
**hardwire iflib
	lea	slibs_imports_buckets(a5),a2	*how many imports from each lib
**count, slib,options byte, slib, options byte etc
	move.l	slibs_handle(a5),a1
	move.l	(a1),a1
	addq.l	#2,a1
	clr.l	d2	*slibs names offset accum
	clr.l	d3	*index into string table of first import for this slib
			*added to d5 which is total size of slibs c strings
	clr.l	d0	*size of string to calc offset to slib name
;	move.b	     #12,d0	*carbonlib    ////not 12  interfacelib
;	move.b	     #9,d0	*carbonlib    ////not 12  interfacelib
	move.b	    fixed_lib_name(pc),d0
	move.l	    d2,(a0)	*offset to name
	add.l	    d0,d2	*size of this name
	addq.l	    #1,d2	*plus 1 'cause c string in pef
	clr.l	    4(a0)	*oldest def version
	clr.l	    8(a0)	*current version
	move.l	    (a2)+,d0	        *imports from this lib
	move.l	    d0,12(a0)
;	clr.l	12(a0)	*how many imports from this lib
	move.l	    #0,16(a0)	        *index into import symbols from this lib
;	lsl.l	#5,d0
	add.l	    d0,d5	*next slibs imports start here in string table
;	lsl.l	#5,d5	*each string is 32 bytes
	move.b	    #0,20(a0)	        *options - bit 7 is weak!!!!!!!!!
	clr.b	    21(a0)	*reserved
	clr.w	    22(a0)	*reserved
	lea	24(a0),a0
	add.l	    #24,d4
	add.l	    #24,d7

**now the additional libs from anvil
	tst.l	d1
	ble	no_additional_slibs2

**a1 points to first name
copy_slibs_info:
	clr.l	d0
	move.b	(a1)+,d0	*p to c
	add.l	d0,a1	*skip name to options byte (soft)
	move.l	d2,(a0)	*offset to name
	add.l	d0,d2	*size of this name
	addq.l	#1,d2	*plus 1 'cause c string in pef
	clr.l	4(a0)	*oldest def version
	clr.l	8(a0)	*current version
	clr.l	d0
	move.l	(a2)+,d0	*imports from this lib
	move.l	d0,12(a0)
;	clr.l	12(a0)	*how many imports from this lib
	move.l	d5,16(a0)	*index into import sym table of first import from this lib
;	lsl.l	#5,d0
	add.l	d0,d5	*next slibs imports start here in string table
	move.b	(a1)+,20(a0)	*options - bit 6 is weak!!!!!!!!!
	clr.b	21(a0)	*reserved
	clr.w	22(a0)	*reserved
	lea	24(a0),a0
	add.l	#24,d4
	add.l	#24,d7
	subq.l	#1,d1
	bne	copy_slibs_info
	
no_additional_slibs2:
**d2 holds total size of slibs strings we can add into the offsets to imports strings
**imported symbol table - unlike xcoff, this is simpler in that there is no long labels table
	clr.l	d0
	move.w	total_imports_num(a5),d0
	beq.s	no_imports2			*no imported labels to id
	subq.l	#1,d0
	move.l	toc_names_table(a5),a2		*names as 32 bytes each
	move.l	#0x02000000,d1	*string offset counter into string table
	add.l	slibs_string_size(a5),d1		*is now
set_imports_loop:
	move.l	d1,(a0)+	*import from code section of target
	addq.l	#4,d4
	addq.l	#4,d7
	add.l	#32,d1
	dbra	d0,set_imports_loop
no_imports2:
	move.l	d4,reloc_start(a5)
	move.l	a0,reloc_start_ptr(a5)	*we come back to insert number of reloc op codes
*******************************reloc********************************
**relocation header entry
	clr.l	reloc_op_code_ctr(a5)
	move.w	#1,(a0)	*section number being relocated - 1=data
	clr.w	2(a0)	*rsvd
	move.l	#0,4(a0)	*number of relocation instructions
	clr.l	8(a0)	*offset to reloc program
	lea	12(a0),a0
	add.l	#12,d4
	add.l	#12,d7
**now the reloc program
**skip bss
*relocation table
	move.l	d4,relocation_table_offset(a5)
**reloc bss ptr
	addq.l	#1,reloc_op_code_ctr(a5)
	move.w	#reloc_data,(a0)	*reloc bss ptr to end of ds
	addq.l	#2,d7
	addq.l	#2,d4
	lea	2(a0),a0

*reloc imports
	clr.l	d0
	move.w	total_imports_num(a5),d0
	beq.s	no_imports4
*8we do them in groups of import_relo_count
import_reloc_count:	equ	128
reloc_imports_loop:
	move.w	#reloc_import_run,d1	*opcode
	cmpi.w	#import_reloc_count,d0
	blt.s	got_final_import_count
	ori.w	#import_reloc_count-1,d1	*merge run length onto opcode
	move.w	d1,(a0)+
	addq.l	#2,d4
	addq.l	#2,d7
	addq.l	#1,reloc_op_code_ctr(a5)
	sub.l	#import_reloc_count,d0
	bra.s	reloc_imports_loop
**less than import_reloc_count
got_final_import_count:
	tst.w	d0
	beq.s	no_imports4	*done
	subq.w	#1,d0	*rl is 1-number of imports to reloc
	or.w	d0,d1	*merge run length into op code
	move.w	d1,(a0)+
	addq.l	#1,reloc_op_code_ctr(a5)
	addq.l	#2,d4
	addq.l	#2,d7

no_imports4:
**reloc data ptrs
	move.l	data_item_count(a5),d0
	beq.s	no_data21
reloc_data_loop:
	move.w	#reloc_data,(a0)+
	addq.l	#1,reloc_op_code_ctr(a5)
	addq.l	#2,d4
	addq.l	#2,d7
	subq.l	#1,d0
	bne.s	reloc_data_loop
no_data21:

	move.l	toc_code_count(a5),d0
	beq.s	no_data31
reloc_code_ptrs_loop:
	addq.l	#1,reloc_op_code_ctr(a5)
	move.w	#reloc_code,(a0)+
	addq.l	#2,d4
	addq.l	#2,d7
	subq.l	#1,d0
	bne.s	reloc_code_ptrs_loop
no_data31:
	move.l	number_of_globs_present(a5),d0
	beq.s	skip_exports_fds1
reloc_exports_loop:
	addq.l	#1,reloc_op_code_ctr(a5)
	move.w	#func_desc,(a0)+
	addq.l	#2,d4
	addq.l	#2,d7
	subq.l	#1,d0
	bne.s	reloc_exports_loop

skip_exports_fds1:
*reloc entry
	addq.l	#1,reloc_op_code_ctr(a5)
	move.w	#func_desc,(a0)+	*1 fd for entry
	addq.l	#2,d4
	addq.l	#2,d7
**fill in count of opcodes
	move.l	reloc_start_ptr(a5),a1
	move.l	reloc_op_code_ctr(a5),4(a1)	*count of reloc opcodes
******************strings*******************
**loader string table
	move.l	d4,loader_string_table_offset(a5)
	
;	move.l	#"carb",(a0)+
;	addq.l	#4,d4
;	addq.l	#4,d7
;	move.l	#"onli",(a0)+
;	addq.l	#4,d4
;	addq.l	#4,d7
;	move.b	#"b",(a0)+
;	addq.l	#1,d4
;	addq.l	#1,d7
	lea	fixed_lib_name(pc),a1
	clr.l	d0
	move.b	(a1)+,d0
	subq.l	#1,d0		; for dbra
newcs_loop:
	move.b	(a1)+,(a0)+
	addq.l	#1,d4
	addq.l	#1,d7
	dbra	d0,newcs_loop


;	move.b	#0,(a0)+
;	addq.l	#1,d4
;	addq.l	#1,d7
;	move.b	#0,(a0)+
;	addq.l	#1,d4
;	addq.l	#1,d7
;	move.b	#0,(a0)+
;	addq.l	#1,d4
;	addq.l	#1,d7
	move.b	#0,(a0)+
	addq.l	#1,d4
	addq.l	#1,d7
**additional slibs
	move.l	sl_connections_slot(a5),d1
	beq	no_additional_slibs	*huh?
	subq.l	#1,d1	*1 for iflib
	beq.s	no_additional_slibs	
**count, slib,options byte, slib, options byte etc
	move.l	slibs_handle(a5),a1
	move.l	(a1),a1
	addq.l	#2,a1
copy_slibs:
	clr.l	d0
	move.b	(a1)+,d0	*p to c
	subq.l	#1,d0
cs_loop:
	move.b	(a1)+,(a0)+
	addq.l	#1,d4
	addq.l	#1,d7
	dbra	d0,cs_loop
	clr.b	(a0)+	*c str
	addq.l	#1,d4
	addq.l	#1,d7
	addq.l	#1,a1	*skip options byte
	subq.l	#1,d1
	bne	copy_slibs
	
no_additional_slibs:
**imports - each is 32 bytes in our case, we just splat from

	clr.l	d0
	move.w	total_imports_num(a5),d0
	beq.s	no_imports3			*no imported labels to id
	subq.l	#1,d0	*for dbra
	move.l	new_toc_names_table(a5),a2		*names as 32 bytes each sorted by slib
copy_imports_names:
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	add.l	#32,d4
	add.l	#32,d7
	dbra	d0,copy_imports_names
no_imports3:
**dispose of new_toc_names_table(a5)
	push	a0
	move.l	new_toc_names_table(a5),a0
	OSDisposePtr	a0
	pop	a0
	clr.l	new_toc_names_table(a5)
	
**a new table, export_hash_data has the following info
**uint32 - hash slot
**uint32 - offset to string from start of strings
**uint32 - length of string
**uint32 - hash word
**uint32 - offset in fd of export
**sizeof=20 bytes/entry
*get mem for export_hash_data
	move.l	number_of_globs_present(a5),d0
	beq	no_exports21			*no exported labels to id
	mulu.l	#20,d0
	push	a0
	OSNewPtr	d0,a0
	move.l	a0,export_hash_data(a5)
	pop	a0
no_exports21:
**calc start of export strings

	move.l	d4,start_of_export_strings(a5)
**insert export strings
	move.l	d4,d1	*calc offset to first export string
	sub.l	loader_string_table_offset(a5),d1
	move.l	d1,string_table_exports_start(a5)
	move.l	number_of_globs_present(a5),d0
	beq	no_exports2			*no exported labels to id
	
	move.l	export_hash_data(a5),a3
	
	move.l	libraries_h(a5),a2
	move.l	(a2),a2		*32 bytes a throw - code offset in 28-32 - upper byte is to be ignored. 
	move.l	d4,d5
	sub.l	loader_string_table_offset(a5),d5	*offset to export strings in string table
	move.l	exports_fds_start(a5),d2

**copy export string
ce_loop:
**update data
	clr.l	(a3)+	*hash slot
	move.l	d5,(a3)+	*offset to string
**find length of string
	clr.l	d1
	push	a2
flos:	tst.b	(a2)+
	beq.s	got_los
	addq.l	#1,d1
	bra.s	flos
got_los:
	move.l	d1,(a3)+
	pop	a2
	clr.l	(a3)+	*hash word
	move.l	d2,(a3)+	*offset to fd in data section
**copy string
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	add.l	#12,d2	*each fd is 12 bytes
	add.l	#32,d4
	add.l	#32,d7
	add.l	#32,d5	*offset to next export string
	subq.l	#1,d0
	bne.s	ce_loop
**hash table for exports follows strings
	move.l	d4,start_of_hash_table(a5)
**move offset to hash table into loader header
	move.l	d4,d1
	sub.l	pef_loader_start_offset(a5),d1	     *offset
	move.l	pef_loader_header(a5),a1
	move.l	d1,44(a1)	*offset to hash table
	move.l	number_of_globs_present(a5),d1
	move.l	d1,52(a1)

**here we go generate a flat hash table
*we need to generate
**primary hash table

**the export key table - for each export an entry is generated having this format
**length of symbol (16 bits) encoded symbol name(16 bits) - i.e .a full 32 bit hash word

**the export symbol table - each entry is 10 bytes as follows
**class and name (uint32) - upper byte is class (2 for code export), lower 3 is offset into loader string table
**symbol value (uint32) - offset from beginning of section containing label
**section index (sint16) - index of section

**we need to take each import
**generate a hash value for it, translate it into a hash index value, inc the entries for that slot
**calc size of primary hash table


	bsr	computehashtableexponent
	move.l	d0,ht_e(a5)	*sizeof table to the power of 2
	clr.l	d1
	bset	d0,d1	*actual size
	move.l	d1,ht_real_size(a5)
	move.l	pef_loader_header(a5),a1
	move.l	d0,48(a1)	*size of primary hash table (2 to the power of)
**now for each label we need to calculate its hash value and hash index
	move.l	libraries_h(a5),a2
	move.l	(a2),a1		*32 bytes a throw - code offset in 28-32 - upper byte is to be ignored. 
	move.l	number_of_globs_present(a5),d6

	movem.l	d4/d7/a0,-(sp)
	move.l	export_hash_data(a5),a3

do_next:
	push	a1
	move.l	#32,d0
	bsr	computehashword32	*32 bit hash word
	move.l	d0,12(a3)	*hash word into data
	bsr	hashword_to_hashindex	*main hash table slot index
	move.l	d0,0(a3)	*hash slot into data
	pop	a1
	lea	32(a1),a1
	lea	20(a3),a3
	dec.l	d6
	bne.s	do_next
**now sort by slot
	move.l	export_hash_data(a5),a3
	bsr	sort_exports

	movem.l	(sp)+,d4/d7/a0
*generate primary hash table
*size is ht_real_size(a5)
*each entry is chain count(14 bits), index to first export(18 bits)
*do zero	
	move.l	ht_real_size(a5),d0
	
	move.l	export_hash_data(a5),a3	*20 bytes/entry
	clr.l	d0	*starting search index
	clr.l	d1	*current chain count
	clr.l	d3	*index of first export for next
	clr.l	d2	*index to first export for this
	move.l	number_of_globs_present(a5),d6	*count
check_next_index:
	tst.l	d6
	beq.s	done
	move.l	(a3),d5	*this index
	cmp.l	d5,d0
	bne	next_index
	addq.l	#1,d1	*current chain count
	addq.l	#1,d3	*index to first import for next
	subq.l	#1,d6
	lea	20(a3),a3
	bra.s	check_next_index
next_index:
**build entry
	push	d5	*save new index
	move.l	d1,d5	*chain count
	swap	d5
	lsl.l	#2,d5	*in upper 14 bits
	
	andi.l	#%111111111111111111,d2
	or.l	d2,d5	*index to first export for this entry
	move.l	d5,(a0)+	*store in hash table
	addq.l	#4,d4
	addq.l	#4,d7
	pop	d5	*restore new index
	move.l	d1,d2	*next index
	move.l	d5,d0	*reset search index
	clr.l	d1	*clear chain count
	bra.s	check_next_index	
done:
**generate last entry!
	move.l	d1,d5	*chain count
	swap	d5
	lsl.l	#2,d5	*in upper 14 bits
	
	andi.l	#%111111111111111111,d2
	or.l	d2,d5	*index to first export for this entry
	move.l	d5,(a0)+	*store in hash table
	addq.l	#4,d4
	addq.l	#4,d7
**table built
**now build export key table
	move.l	export_hash_data(a5),a3	*20 bytes/entry
	move.l	number_of_globs_present(a5),d6	*count
keyloop:
	move.l	12(a3),(a0)+
	lea	20(a3),a3
	addq.l	#4,d4
	addq.l	#4,d7
	subq.l	#1,d6
	bne.s	keyloop

*build export symbol table
	move.l	export_hash_data(a5),a3	*20 bytes/entry
	move.l	number_of_globs_present(a5),d6	*count

**uint32 - hash slot
**uint32 - offset to string from start of strings
**uint32 - length of string
**uint32 - hash word
**uint32 - offset to label in code section

**output
*1byte=class
*3bytes=offset ot string in string table
*4 bytes offset to fd in data section
*2 bytes = section index
export_sym_loop:
	move.l	#0x02000000,d0	*class
	move.l	4(a3),d1	*offset to string
	or.l	d1,d0
	move.l	d0,(a0)+	*class and string offset
	move.l	16(a3),d0
	move.l	d0,(a0)+	*offset to fd in data section
	move.w	#1,(a0)+	*data section
	lea	20(a3),a3	*to next
	add.l	#10,d4
	add.l	#10,d7
	subq.l	#1,d6
	bne.s	export_sym_loop
no_exports2:	
	move.l	d4,reloc_end(a5)
**put loader size - 0.64
	move.l	loader_header(a5),a1
	move.l	pef_loader_header_offset(a5),d1
	move.l	d4,d0
	sub.l	d1,d0
	move.l	d0,16(a1)
**calc offset to loader strings table for loader header
	move.l	pef_loader_header(a5),a1	*poke offset into 40(a1)
	move.l	loader_string_table_offset(a5),d0
	sub.l	pef_loader_start_offset(a5),d0
	move.l	d0,40(a1)
	
	move.l	relocation_table_offset(a5),d0
	sub.l	pef_loader_start_offset(a5),d0
	move.l	d0,36(a1)	*offset to reloc code
	bra	done_loader
done_loader:
**
	move.l	d4,pef_file_size(a5)	*save physical file size
	bra.s	make_headers
	rts_	"cpf_make_loader"
make_headers:
write_xcoff_now:

	bra	skip_ram

*test_frag:
*	 clr.w	 -(sp)
*	 move.l	source_buff(a5),d0
*	 move.l	d0,-(sp)
*	 move.l	pef_file_size(a5),-(sp)
*	 pea	 test_name(pc)
*	 move.l	#1,-(sp)	 *loadfrag
*	 pea	 conn_id(pc)	 *conn_id goes here
*	 pea	 main_addr(pc)	 *start addr goes here
*	 pea	 cxf_err_name(pc)	 *error		 	 
*	 move.w	#$0003,-(sp)
*	 dc.w 	 $aa5a	 	 *getmemfragment
*	 move.w	(sp)+,d0
*	 tst.w	 d0
*	 bne.s	 report_frag_error
*
*	 lea	 main_addr(pc),a0
*	 ext.l	 d0	 	 *v4.04
*	 rts_	 "cpf_test_frag"
*report_frag_error:
*	 move.w	d0,-(sp)	 *save error
*	 lea	 connection_error(pc),a0
*	 bsr	 printit
*	 move.w	(sp)+,d0
*	 cmpi.w	#-50,d0
*	 beq.s	 param_error
*	 cmpi.w	#-2804,d0
*	 beq.s	 frag_not_found
*	 cmpi.w	#-2807,d0
*	 beq.s	 unresolved_syms
*	 cmpi.w	#-2809,d0
*	 beq.s	 mem_err
*	 cmpi.w	#-2810,d0
*	 beq.s	 mem_err
*	 cmpi.w	#-2812,d0
*	 beq.s	 order_err
*	 cmpi.w	#-2813,d0
*	 beq.s	 too_old
*	 cmpi.w	#-2814,d0
*	 beq.s	 too_new
*	 cmpi.w	#-2815,d0
*	 beq.s	 circ	 
*	 cmpi.w	#-2817,d0
*	 beq.s	 conn_err
*	 cmpi.w	#-2821,d0
*	 beq.s	 init_err
*	 cmpi.w	#-2820,d0
*	 beq.s	 corrupt_err
*	 bra.s	 unk_err	
*param_error:
*	 lea	 param_err_text(pc),a0
*	 bra.s	 print_ferror
*frag_not_found:
*	 lea	 fnf_text(pc),a0
*	 bsr	 printit
*	 lea	 cxf_err_name(pc),a0
*	 clr.l	 d0
*	 move.b	(a0)+,d0
*	 clr.b	 0(a0,d0.w)	 *amke c str
*	 bsr	 printit
*	 lea	 dll_was(pc),a0
*	 bsr	 printit
*	 moveq	 #-1,d0
*;	 bset	 #7,flags(a5)	 *error detected flag
*	 st	 global_err(a5)
*	 rts
*unresolved_syms:
*	 lea	 urs_textpre(pc),a0
*	 bsr	 printit
*	 
*	 lea	 cxf_err_name(pc),a0
*	 clr.l	 d0
*	 move.b	(a0)+,d0
*	 clr.b	 0(a0,d0.w)	 *amke c str
*	 bsr	 printit
*
*	 lea	 urs_text(pc),a0
*	 bra.s	 print_ferror
*mem_err:
*	 lea	 me_text(pc),a0
*	 bra.s	 print_ferror
*order_err:
*	 lea	 order(pc),a0
*	 bra.s	 print_ferror
*too_old:
*	 lea	 old(pc),a0
*	 bra.s	 print_ferror
*too_new:
*	 lea	 new(pc),a0
*	 bra.s	 print_ferror
*circ:	 lea	 circ_text(pc),a0
*	 bra.s	 print_ferror
*conn_err:
*	 lea	 conn_text(pc),a0
*	 bra.s	 print_ferror
*init_err:
*	 lea	 init_text(pc),a0
*	 bra.s	 print_ferror
*corrupt_err:
*	 lea	 corrupt_text(pc),a0
*	 bra.s	 print_ferror	 	 	 	 	 	 	 	 	 
*unk_err:
*	 lea	 unk_text(pc),a0
*print_ferror:
*	 bsr	 printit
*	 moveq	 #-1,d0
*;	 bset	 #7,flags(a5)	 *error detected flag
*	 st	 global_err(a5)
*	 rts_	 "cpf_report_frag_error"
***minor stuff
copy_symbol:
	move.b	(a0)+,d0
	move.b	d0,(a1)+
	bne.s	copy_symbol
	rts_	"cpf_copy_sym"	

**this routine closes all open dll connections
close_connections:
	lea	sl_connections(a5),a0	*the connections
;	rts
	move.l	sl_connections_slot(a5),d7	*the number of connections
	subq.l	#1,d7
cc_loop:
	push	a0
	push	d7
	lsl.l	#2,d7
	add.l	d7,a0
	move.l	(a0),the_connection(a5)
	pop	d5
	pop	a3

;	move.l	0(a0,d7.l*4),the_connection(a5)	*connid
	movem.l	d7/a0,-(sp)	*save counter and connection list
	clr.w	-(sp)
	pea	the_connection(a5)
;	move.l	d0,-(sp)	*connid
	move.w	#$0004,-(sp)
	dc.w 	$aa5a
	move.w	(sp)+,d0
	movem.l	(sp)+,d7/a0	
	subq.l	#1,d7
	bge.s	cc_loop
	rts_	"cpf_close_conn"
**************************************************
**hash table stuff

**compute exponent of size of primary hash table in d0 from number_of_globs exported
exponentlimit:	equ	16
averagechainlength:	equ	10
computehashtableexponent:	
	move.l	number_of_globs_present(a5),d0
	moveq	#0,d1	*for exponent =0; exponent<exponentlimit; exponent+=1;
chte_loop:
	addq.l	#1,d1
	cmp.l	#exponentlimit,d1
	bgt.s	chte_end
**if (exportcount/(1<<exponent) < averagechainlimit)
**break
	move.l	#1,d2
	lsl.l	d1,d2	*1<<exponent
	move.l	d0,d3	*exportcount
	divu.l	d2,d3	*exportcount/(1<<exponent)
	cmp.l	#averagechainlength,d3
	blt.s	chte_end
	bra.s	chte_loop
chte_end:
	move.l	d1,d0	*return exponent
	rts_	"computehashtableexponent"

**generate a 32 bit hash value, upper 16 bits = length of name, lower 16 = hash of name
hashlengthshift:	equ	16
hashvaluemask:	equ	0x0000ffff

pseudorotate:	macro
	move.l	\1,d5	*copy input
	lsl.l	#1,\1
	lsr.l	#8,d5
	lsr.l	#8,d5
	sub.l	d5,\1
	endm
**takes a ptr to the name in a1, length of name in d0, return 32 bit hash in d0
;charptr:	reg	a2
;hashvalue:	reg	d1
;length:	reg	d2
;limit:	reg	d3
;result:	reg	d4
;currchar:	reg	d6
computehashword32:
	movem.l	d1/d2/d3/d4/d5/d6/d7/a0/a1/a2,-(sp)
	clr.l	d1
	clr.l	d2
	move.l	a1,a2
	move.l	d0,d3
computehash:
	tst.l	d3
	beq.s	endcomputehash
	subq.l	#1,d3	*char counter
	clr.l	d6	*uint8
	move.b	(a2)+,d6
	beq.s	endcomputehash	*just in case a c string gets through
	addq.l	#1,d2
	pseudorotate	d1
	eor.l	d6,d1	*hashvalue=pseudorotate(hashvalue)^currchar;
	bra.s	computehash

endcomputehash:
	move.l	d2,d4	*result=(length<<hashlengthshift) | 
				*((uint16) ((hashvalue^hashvalue>>16))&hashvaluemask
;	lsl.l	#hashlengthshift,`result
	lsl.l	#8,d4
	lsl.l	#8,d4	
	move.l	d1,d5
;	lsr.l	#16,d5
	lsr.l	#8,d5
	lsr.l	#8,d5
	eor.l	d5,d1
	andi.l	#hashvaluemask,d1
	or.w	d1,d4
	move.l	d4,d0
	movem.l	(sp)+,d1/d2/d3/d4/d5/d6/d7/a0/a1/a2
	rts_	"computehashword32"

**takes a 32 bit hash word in d0, return hash table index in d0
hashword_to_hashindex:
**1<<hashtablepower)-1
	move.l	ht_e(a5),d2
	move.l	#1,d3
	lsl.l	d2,d3
	subq.l	#1,d3
**hashword^(hashword>>hashtablepower)
	move.l	d0,d1
	
	lsr.l	d2,d1
	
	eor.l	d1,d0
	and.l	d3,d0	*slot number
	rts_	"hashword_to_hashindex"
		
*********************************************************************

**this routine checks with each dll to see if the label in symbol_name is exported by this lib
**list of connection id's in sl_connections
**number of connections in number_of_extra_sls(a5)
resolve_import:
	lea	sl_connections(a5),a0	*the connections
	move.l	sl_connections_slot(a5),d7	*the number of connections
	subq.l	#1,d7
resolve_loop:
**get connection id
	push	a0
	push	d7
	lsl.l	#2,d7
	add.l	d7,a0
	move.l	(a0),d0
	pop	d7
	pop	a0
;	move.l	0(a0,d7.l*4),d0	*connid

	movem.l	d7/a0,-(sp)	*save counter and connection list
	clr.w	-(sp)
**findsym
	move.l	d0,-(sp)	*connid
	pea	symbol_name(pc)	*as pascal string
	pea	sym_addr(pc)	*address returned
	pea	sym_class(pc)	*type of symbol - code, data, tv
	move.w	#$0005,-(sp)
	dc.w 	$aa5a		*findsym	
	move.w	(sp)+,d0
**end of findsym

	movem.l	(sp)+,d7/a0	
	tst.w	d0
	beq.s	got_sym1		*found in this frag
	subq.l	#1,d7
	bge.s	resolve_loop
**print can't import xxxx
	save_all
	lea	symbol_name(pc),a0
	lea	report_name(pc),a1
	clr.l	d0
	move.b	(a0)+,d0
	subq.l	#1,d0
csn:	move.b	(a0)+,(a1)+
	dbra	d0,csn
	move.b	#13,(a1)+
	clr.b	(a1)
	lea	fatal_import_text(pc),a0
	bsr	printit
	st	link_e_flag(a5)
	restore_all
	moveq	#0,d0
	rts			*not found
got_sym1:
	addq.l	#1,d7		*make real file id (-1 for array indexing)
	move.l	d7,d0		*return file id
	rts_	"cpf_resolve_import"
	

********************

print_frag_stats:
	tst.l	cxf_quiet_flag(a5)
	bne	skip_pfs
**first lets show some info...
	lea	frag_text(pc),a0
	bsr	printit
	move.l	pef_file_size(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit
	lea	code_text(pc),a0
	bsr	printit
	
	lea	code_text(pc),a0
	move.l	pc(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit

	lea	data_size(pc),a0
	bsr	printit
	move.l	pef_data_size(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit

	lea	toc_size(pc),a0
	bsr	printit
	move.l	pef_toc_size(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit

	lea	data_less_toc(pc),a0
	bsr	printit
	move.l	pef_data_size(a5),d0
	sub.l	pef_toc_size(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit
	
	
	tst.l	pef_bss_size(a5)
	beq.s	nil_bss
	lea	bss_size(pc),a0
	bsr	printit
	move.l	pef_bss_size(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit
	bra.s	done_bss
nil_bss:
	lea	bss_unused(pc),a0
	bsr	printit
done_bss:
	lea	reloc_text(pc),a0
	bsr	printit	
	move.l	reloc_end(a5),d0
	sub.l	reloc_start(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit
	
	lea	crcr_text(pc),a0
	bsr	printit
skip_pfs:
	rts_	"cxf_print_frag_stats"
	
	
***********
skip_ram:
**send cxf end message to front end
;	lea	cxf_end_eddie(pc),a0
;	bsr	send_string_to_front
	
	lea	create_frag(pc),a0
	bsr	printit			*write to disk
;	lea	linking_text(pc),a0
;	bsr	printit
	
; **********************************************************************
; removed test linking 'cause it broke anvil with the carbon import!!!!!
;
;	no_test_link ever

;	lea	ntl_carbon(pc),a0
;	bsr	printit

	bra	frag_okd
;
; **********************************************************************
*	 
*	 tst.w	 is_ppc(a5)
*	 beq.s	 no_test_link
*	 bsr	 test_frag	 *test link to dll's
*
*	 move.l	d0,-(sp)
*	 
*	 clr.w	 -(sp)
*	 pea	 conn_id(pc)
*	 move.w	#$0004,-(sp)	 *close connection
*	 dc.w 	 $aa5a
*	 move.w	(sp)+,d0
*
*	 move.l	(sp)+,d0
*	 tst.l	 d0
*	 beq.s	 frag_okd
*	 rts
*no_test_link:
*	 lea	 ntl(pc),a0
*	 bsr	 printit
frag_okd:
	bsr	print_frag_stats
;	lea	writing_v4(pc),a0
;	bsr.l	printit
**frag in source_buff



	clr.l	d0
	rts_	"cpf_write_pef_frag"



******************************************************************************
**sort exports by master hash index
sort_exports:
	save_all
	move.l	export_hash_data(a5),a0
**we should do this by swapping pointers, but there you go...
	move.l	number_of_globs_present(a5),d0
	move.l	d0,d7	*number of items
	cmpi.l	#1,d0	*only one or none?
	ble.s	sorted		*yes, done
	move.l	a0,a3	*save table start
bubba:
	clr.l	d5	*done flag
	moveq.l	#1,d6	*table position (+1 for artificial 1 entry=exit)
	move.l	a3,a0	*reset to top of table
bubba_loop:
	move.l	a0,a2	*save
**compare this index with next
	move.l	(a0),d0
	cmp.l	20(a0),d0
	ble.s	no_swap
	moveq	#1,d5	*did a swap
**swap this 20 bytes with next
	lea	temp_data(pc),a4
	move.l	(a0),(a4)+
	move.l	4(a0),(a4)+
	move.l	8(a0),(a4)+
	move.l	12(a0),(a4)+
	move.l	16(a0),(a4)+
	
	move.l	20(a0),(a0)
	move.l	24(a0),4(a0))
	move.l	28(a0),8(a0)
	move.l	32(a0),12(a0)
	move.l	36(a0),16(a0)
	
	lea	temp_data(pc),a4
	move.l	(a4),20(a0)
	move.l	4(a4),24(a0)
	move.l	8(a4),28(a0)
	move.l	12(a4),32(a0)
	move.l	16(a4),36(a0)
no_swap:
	addq.l	#1,d6
	lea	20(a2),a0	*next item
	cmp.l	d6,d7	*at bottom of list
	bne.s	bubba_loop
	tst.l	d5
	bne	bubba
sorted:
	restore_all
	rts_	"sort_exports"
align_pef_section:
	move.l	d4,d0
	andi.l	#%1111,d0
	beq.s	aligned
	clr.b	(a0)+
	addq.l	#1,d4
	addq.l	#1,d7
	bra.s	align_pef_section
aligned:
	rts_	"align_pef_section"
	
**must be a c type string!
send_string_to_front:
not_send12:
	rts_	"cxf_send_string_to_frontend"
copy_c_str_for_send:
	move.b	(a1)+,(a0)+
	bne.s	copy_c_str_for_send
	rts_	"cxf_copy_c"


**copies a1 to a0. count in d0.l
copy:	tst.l	d0
	beq.s	copy_end
cop_loop:
	move.b	(a1)+,(a0)+
	subq.l	#1,d0
	bne.s	cop_loop
copy_end:
	rts_	"cxf_copy"


c_to_p_str:	clr.l	d0
do_p_loop:	move.b	(a0)+,d1
	beq.s	ctopend
	addq.l	#1,d0	counter		
	move.b	d1,0(a1,d0.l)	save byte in p string
	bra.s	do_p_loop
ctopend:	move.b	d0,(a1)
	rts
			
**data

;file_header:	 dc.w	 $01df	 *f_magic
;	 dc.w	 4	 *f_nscns
;	 dc.l	 0	 *f_timdat
;	 dc.l	 0	 *f_symptr
;	 dc.l	 0	 *f_nsyms
;	 dc.w	 72	 *f_opthdr
;	 dc.w	 $1003	 *f_flags
;	 
;aux_header:
;	 dc.w	 $10b	 *o_mflag
;	 dc.w	 1	 *o_vstamp
;o_tsize:	 ds.l	 1	 *text size
;o_dsize:	 ds.l	 1	 *data size
;o_bsize:	 ds.l	 1	 *bss size
;o_entry:	 ds.l	 1	 *va of entry point function descriptor in data section
;o_text_start:	 ds.l	 1	 *va of text section
;o_data_start:	 ds.l	 1	 *va of data section
;o_toc:	ds.l	 1	 	 *va of toc in data sect (same as start of data)
;	 dc.w	 1	 	 *section number of entry point
;	 dc.w	 3	 	 *section number of text
;	 dc.w	 1	 	 *section number of data
;	 dc.w	 1	 	 *section number of toc=data
;	 dc.w	 4	 	 *section number of loader
;	 dc.w	 2	 	 *section number of bss
;	 dc.w	 2	 	 *align code 4
;	 dc.w	 3	 	 *align data 8	 
;	 dc.w	 $314c	 	 *single use
;	 dc.w	 0	 	 *o_resv1
;	 dc.l	 0	 	 *o_maxstack
;	 dc.l	 0	 	 *o_maxdata
;	 dc.l	 0,0,0	 	 *o_resv2
;data_header:
;	 dc.l	 $2e646174
;	 dc.l	 $61000000	 *.data
;	 dc.l	 0	 	 *phys addr
;	 dc.l	 0	 	 *va
;dh_size:
;	 ds.l	 1	 	 *size
;	 dc.l	 $100	 	 *file offset (physical)
;	 dc.l	 0	 	 *section reloc info
;	 dc.l	 0	 	 *offset to section line number entries
;	 dc.w	 0	 	 *s_nreloc
;	 dc.w	 0	 	 *s_nlnno
;	 dc.l	 $40	 	 *data
;bss_header:
;	 dc.l	 $2e627373
;	 dc.l	 $00000000	 *.bss
;bh_phys:
;	 ds.l	 1	 	 *phys addr
;bh_va:
;	 ds.l	 1	 	 *va
;bh_size:
;	 ds.l	 1	 	 *xcoff_bss_size
;	 dc.l	 0	 	 *file offset (physical)
;	 dc.l	 0	 	 *section reloc info
;	 dc.l	 0	 	 *offset to section line number entries
;	 dc.w	 0	 	 *s_nreloc
;	 dc.w	 0	 	 *s_nlnno
;	 dc.l	 $80	 	 *bss
;
;text_header:
;	 dc.l	 $2e746578
;	 dc.l	 $74000000	 *.text
;th_phys:
;	 ds.l	 1	 	 *phys addr
;	 ds.l	 1	 	 *va
;th_size:
;	 ds.l	 1	 	 *size
;	 ds.l	 1	 	 *file offset (physical)
;	 dc.l	 0	 	 *section reloc info
;	 dc.l	 0	 	 *offset to section line number entries
;	 dc.w	 0	 	 *s_nreloc
;	 dc.w	 0	 	 *s_nlnno
;	 dc.l	 $20	 	 *text
;loader_header:
;	 dc.l	 $2e6c6f61
;	 dc.l	 $64657200	 *.loader
;	 dc.l	 0	 	 *phys addr
;	 dc.l	 0	 	 *va	 - note zero for loader
;lh_size:
;	 ds.l	 1	 	 *size
;	 ds.l	 1	 	 *file offset (physical)
;	 dc.l	 0	 	 *section reloc info
;	 dc.l	 0	 	 *offset to section line number entries
;	 dc.w	 0	 	 *s_nreloc
;	 dc.w	 0	 	 *s_nlnno
;	 dc.l	 $1000	 	 *loader
;	 align	 	 
key_text:	dc.b	13,"***ready. press any key to execute code in ram***",13,0
execute_text:	dc.b	"executing powerpc code in ram through the mixed mode manager.",13,13,13,0
writing_to_ram:	dc.b	"***good assembly***",13
	dc.b	13,"cxf end.",13,"creating fragment",13,0
create_frag:	dc.b	13,"PEF compiler end.",13,0
linking_text:	dc.b	"test linking with macintosh shared libraries.",13,0
cant_run:	dc.b	"**error** can't run powerpc code in ram on a non powerpc machine.",13,0
ntl:	dc.b	"**Advice** Unable to test link with",13,"shared libraries because this is",13,"not a PowerMac.",13,0

ntl_carbon:	dc.b	"**Advice** Unable to test link with",13,"shared libraries because you are",13,"doing a carbon app.",13,0

test_name:	dc.b	4,"test"
frag_text:	
	
	dc.b	"Fragment linked ok.",13
	dc.b	13,"Fragment statistics:"
frag_size:	dc.b	13,"total size: ",0
code_text:	dc.b	13,"code sect:  ",0
data_size:	dc.b	13,"data sect:  ",0
bss_size:	dc.b	13," bss size:  ",0
toc_size:	dc.b	13," toc size:  ",0
data_less_toc:	dc.b	13," data size: ",0
reloc_text:	dc.b	13,"reloc size: ",0
bytes_text:	dc.b	" bytes.",0
crcr_text:	dc.b	13,13,0		
	even
conn_id:	ds.l	1	*conn_id goes here
main_addr:	ds.l	1	*start addr goes here
bss_unused:	dc.b	13," bss size:  empty.",0
cxf_err_name:	ds.b	256	*error
dll_was:	dc.b	13,"if this is a system shared library",13,"(such as quicktime),"
	dc.b	" please ensure it is in the",13,"extensions folder.",13
	dc.b	"if it is a general purpose shared library",13,"- for example a sprocket,"
	dc.b	" then either",13,"place it in the extensions folder or",13,"place a copy in both anvil's"
	dc.b	13,"and the targets' folder.",13,0
	
cr_text:	dc.b	13,0
comma_text:	dc.b	", ",0
dot_crcr_text:	dc.b	".",13,13,0

using:	dc.b	13,"Using following shared libraries:",13		   	   
	dc.b	"CarbonLib",0

	even

wxf_text:	dc.b	"PPC static link end.",13
	dc.b	"PEF Compiler v2.10.",13,0
	align
fatal_import_text:	dc.b	"fatal: can't import a symbol. check you have added the",13
	dc.b	"correct shared libraries to the project.",13
	dc.b	"symbol name is: "
report_name:	ds.b	300
	align
my_time:	ds.l	2
	align
temp_data:	ds.l	8
	align
fixed_lib_name:	pstring	"CarbonLib"
	dc.b	0
	align
sym_addr:	ds.l	1
sym_class:	ds.l	1
	
connection_error:
	dc.b	"***error*** during link of code to shared libraries.",13
	dc.b	"error was ",0
param_err_text:	
	dc.b	"-50.",13
	dc.b	"parameter error.",13,13,0
fnf_text:
	dc.b	"-2804",13
	dc.b	"fragment (or shared library) not found.",13,"fragment name is: ",0
urs_textpre:
	dc.b	"-2807",13,0
urs_text:
	dc.b	13,"can't resolve an import symbol.",13,13,0
me_text:	
	dc.b	"-2809",13
	dc.b	"not enough memory for internal bookkeeping.",13,13,0
order:
	dc.b	"-2812",13
	dc.b	"order error during user initialisation function.",13,13,0
old:
	dc.b	"-2813",13
	dc.b	"your shared library is too old.",13,13,0 
new:	dc.b	"-2814",13								
	dc.b	"your shared library is too new.",13,13,0
circ_text:
	dc.b	"-2815",13
	dc.b	"circularity in required initialisation order.",13,13,0
conn_text:
	dc.b	"-2817",13
	dc.b	"error connecting to fragment (something is wrong, but the system linker "
	dc.b	"doesn't know what).",13,13,0
init_text:
	dc.b	"-2818",13
	dc.b	"initialisation procedure did not return noerr.",13,13,0
corrupt_text:
	dc.b	"-2820",13
	dc.b	"fragment corrupt (recognised format).",13,13,0
	align
unk_text:
	dc.b	"error number not known.",13
	dc.b	"unknown error.",13,13,0
	align
symbol_name:	ds.b	1024
	align
cant_resolve_text:	cstring	"***error*** '"
	align
crcrtext1:	dc.b	"' is not exported in any of the shared",13,"libraries being linked to.",13,"please ensure you have added",13,"the correct shared libraries to",13,"the project.",13,13,0
	align
	global	write_pef,close_connections,resolve_import
	global	symbol_name
	extern	printit
	extern	app_dead,fsp_setinfo,wait_key,printnum,p_to_c
