**we need to assign imports to libraries in groups, so we end up with a list
**of imports by library, from 0 upwards, we also need a parallel list which states
**the ranges for a given library, for example:
**32,54,87 means
**labels 0-32 are in lib 0, 33-54 are in lib 2 and 55-87 are in lib 3
**slibs import list is an array of 255 buckets (the max number of libs we can cope with)
**as an import is tied up to a library the relevent bucket in slibs_import_list is incremented
**as an impoort is tied to a library, we insert it at slibs_import_list pos for this bucket and
**move all the others up.
**example:
**i0 is found in slib 2
**i1 is found in slib 0
**i2 is found in slib 2
**i3 is found in slib 1
**i4 is found in slib 0
**i5 is found in slib1
**i0 in slib 2 goes at slib_bucket_0+slib_bucket_1_slib_bucket_2
*=0+0+0=0, sb2 is inc'd to 1. i0
**i1 in slib 0 goes at slib_bucket_0
**=0, remainder moved up, sb0 is inc'd to 1. i1,i0
**i2 in slib 2 goes in slib_bucket_0+sb1+sb2
**=1+0+1=2. sb2 is inc'd to 2. i1,i0,i2
**i3 in slib 1 goes at sb0+sb1
**=1+0=1. sb1 is inc'd to 1. i1,i3,i0,i2
**i4 in slib 0 goes in sb0
**=1, rest is moved up, sb0 is inc'd to 2. i1,i4,i3,i0,i2
**i5 in slib 1 goes in sb0+sb1=
**=2+1=3, rest is moved up, sb1 is inc'd to 2. i1,i4,i3,i5,i0,i2
**so we have a list of imports that reads: i1,i4,i3,i5,i0,i2
**                                         0  0  1  1  2  2
**the slibs_import_list reads:
**2 2 2
**meaning that import for lib 0 end at 2, imports for lib 1 end at 2+2, imports for
**lib 2 end at 2+2+2
**should do it...

**We need to assign imports to libraries in groups, so we end up with a list
**of imports by library, from 0 upwards, we also need a parallel list which states
**the ranges for a given library, for example:
**32,54,87 means
**labels 0-32 are in lib 0, 33-54 are in lib 2 and 55-87 are in lib 3
**Slibs import list is an array of 255 buckets (the max number of libs we can cope with)
**As an import is tied up to a library the relevent bucket in slibs_import_list is incremented
**As an impoort is tied to a library, we insert it at slibs_import_list pos for this bucket and
**move all the others up.
**example:
**i0 is found in slib 2
**i1 is found in slib 0
**i2 is found in slib 2
**i3 is found in slib 1
**i4 is found in slib 0
**i5 is found in slib1
**i0 in slib 2 goes at slib_bucket_0+slib_bucket_1_slib_bucket_2
*=0+0+0=0, SB2 is inc'd to 1. i0
**i1 in slib 0 goes at slib_bucket_0
**=0, remainder moved up, SB0 is inc'd to 1. i1,i0
**i2 in slib 2 goes in slib_bucket_0+SB1+SB2
**=1+0+1=2. SB2 is inc'd to 2. i1,i0,i2
**i3 in slib 1 goes at SB0+SB1
**=1+0=1. SB1 is inc'd to 1. i1,i3,i0,i2
**i4 in slib 0 goes in SB0
**=1, rest is moved up, SB0 is inc'd to 2. i1,i4,i3,i0,i2
**i5 in slib 1 goes in SB0+sb1=
**=2+1=3, rest is moved up, SB1 is inc'd to 2. i1,i4,i3,i5,i0,i2
**So we have a list of imports that reads: i1,i4,i3,i5,i0,i2
**                                         0  0  1  1  2  2
**The slibs_import_list reads:
**2 2 2
**meaning that import for lib 0 end at 2, imports for lib 1 end at 2+2, imports for
**lib 2 end at 2+2+2
**Should do it...
sort_imports_by_lib:
	lea	slibs_imports_buckets(a5),a2
	move.l	#255,d0
clear_buckets:
	clr.l	(a2)+
	dbra	d0,clear_buckets

	move.l	toc_names_table(a5),a1	*the master list
	move.l	a1,a3			*save position in master list
	clr.l	d1		*dll used counter	
	move.l	slibs_handle(a5),a1
	move.l	a1,d0
	beq	no_slibs
	
	move.l	(a1),a1
	clr.l	d7
	move.w	(a1)+,d7	*number of slibs
	move.l	d7,number_of_extra_sls(a5)


**find out how many imports there are
	clr.l	d7
	move.l	toc_names_table(a5),a1	*the master list
find_how_many:
	tst.l	(a1)
	beq.s	got_how_many
	addq.l	#1,d7
	lea	32(a1),a1
	bra.s	find_how_many
got_how_many:
	move.l	d7,real_number_of_imports(a5)
	beq	no_slibs
*get mem for new list
**a lib included will cause link to be re-run, so we need to dispose and re-alloc

	tst.l	new_toc_names_table(a5)
	beq.s	first_time_through	*Guess how linkPPC runs...
	move.l	new_toc_names_table(a5),a0
	OSDisposePtr	a0
first_time_through:
	move.l	d7,d6
	addq.l	#1,d6	*plus 1 for safety
	lsl.l	#5,d6	*each is 32 bytes
	move.l	d6,d0
	OSNewPtr	d0,a0
	move.l	a0,new_toc_names_table(a5)
	OSGetMemErr	d0
	tst.w	d0
	bmi	end_no_cleanup
been_here_before:
	lea	slibs_imports_buckets(a5),a2
	move.l	d7,(a2)	*if no extras than all in lib 0
	move.l	number_of_extra_sls(a5),d6
	beq	no_slibs_copy	*all imports in slib 0 (interfacelib) - no sorting necessary

	st	link_e_flag(a5)
	lea	fatal_libs_text(pc),a0
	bsr	printit
	moveq	#-1,d0		*return error
	bra.s	no_slibs

*	 clr.l	 (a2)	 *remove all cause we're going to sort 'em
*
***build list of connections to slibs
*	 clr.l	 sl_connections_slot(a5)
***first connect to InterfaceLib	
*	 clr.w	 -(sp)	 	 	 *oserr
*	 pea	interface_lib_name(pc)	*libname
*	 move.l	#"pwpc",-(sp)	 	 *archtype
*	 move.l	#1,-(sp)	 *loadfrag
***Calc connection ID slot
*	 lea	sl_connections(a5),a3
*	 move.l	sl_connections_slot(a5),d0
*	 lsl.l	 #2,d0
*	 add.l	 d0,a3
*	 move.l	a3,-(sp)	 *connecton_id	 
*	 pea	main_addr(pc)	 *start addr goes here
*	 pea	cxf_err_name(pc)	 *error		 	 
*	 move.w	#$0001,-(sp)
*	 dc.w 	 $AA5A
*	 move.w	(sp)+,d0	 *error
*	 tst.w	 d0
*	 bne	fatal_to_IF	*error, so skip it
*	 move.l	slibs_handle(a5),a1
*	 OSHLock	a1
*	 move.l	slibs_handle(a5),a1
*	 move.l	(a1),a1
*	 addq.l	#2,a1	 *skip number of libs
*	 move.l	a1,lib_names_pointer(a5)
*	 addq.l	#1,sl_connections_slot(a5)
*
*connect_loop:
*	 move.l	lib_names_pointer(a5),a2
*	 move.l	a2,a0	 	 	 *file name
*	 lea	bracks_express(a5),a1	 *make p string
***copy pstring to a1
*	 clr.l	 d0
*	 move.b	(a0),d0
*	 move.b	(a0)+,(a1)+
*	 subq.l	#1,d0
*cpp:
*	 move.b	(a0)+,(a1)+
*	 dbra	 d0,cpp
*	 addq.l	#1,a0	 *skip options byte at end of name!
*	 move.l	a0,lib_names_pointer(a5)	 *pointing to next shared lib name with a bit of luck.	    
*	 clr.w	 -(sp)	 	 	 *oserr
*	 pea	bracks_express(a5)	*libname
*	 move.l	#"pwpc",-(sp)	 	 *archtype
*	 move.l	#1,-(sp)	 *loadfrag
***Calc connection ID slot
*	 lea	sl_connections(a5),a3
*	 move.l	sl_connections_slot(a5),d0
*	 lsl.l	 #2,d0
*	 add.l	 d0,a3
*	 move.l	a3,-(sp)	 *connecton_id	 
*	 pea	main_addr(pc)	 *start addr goes here
*	 pea	cxf_err_name(pc)	 *error		 	 
*	 move.w	#$0001,-(sp)
*	 dc.w 	 $AA5A
*	 move.w	(sp)+,d0	 *error
*	 tst.w	 d0
*	 bne	skip_import_resolve	*error, so skip it
*	 addq.l	#1,sl_connections_slot(a5)		 
*	 move.l	number_of_extra_sls(a5),d0
*	 subq.l	#1,d0
*	 move.l	d0,number_of_extra_sls(a5)
*	 bne	connect_loop
***now we have a list of connections -  their order is the same as the list of filenames - the order that sls are loaded.
***copy import to symbol_name
*	 clr.l	 search_index(a5)
*
*	 move.l	sl_connections_slot(a5),d0
***resolve and sort
*searchNsort:
*	 move.l	toc_names_table(a5),a0
*	 move.l	search_index(a5),d0
*	 cmp.l	 real_number_of_imports(a5),d0
*	 bge.s	 sorted
*	 lsl.l	 #5,d0	 *x32
*	 add.l	 d0,a0	 *to source import
*	 lea	symbol_name(pc),a1
*	 bsr	c_to_p
*	 bsr	resolve_import	*lib in d0 on return
***now we insert at right place and inc right bucket
*	 bsr	insert_and_bucket
*	 addq.l	#1,search_index(a5)
*	 bra	searchNsort
*	 
*sorted:
*	 bsr	close_connections
	
no_slibs:
	move.l	slibs_handle(a5),a1
	OSHUnlock	a1

	rts_	"sort_imports_by_lib"
end_no_cleanup:
	st	link_e_flag(a5)
	lea	fatal_mem_text(pc),a0
	bsr	printit
	moveq	#-1,d0		*return error
	bra.s	no_slibs

*skip_import_resolve:
*	 st	link_e_flag(a5)
***copy lib name to report_name as C string
*	 lea	bracks_express(a5),a0
*	 lea	report_name(pc),a1
*	 clr.l	 d0
*	 move.b	(a0)+,d0
*	 subq.l	#1,d0
*cln:	 move.b	(a0)+,(a1)+
*	 dbra	 d0,cln
*	 move.b	#13,(a1)+
*	 clr.b	 (a1)
*	 
*	 lea	fatal_lib_text(pc),a0
*	 bsr	printit
*	 moveq	 #-1,d0		 *return error
*	 bra.s	 no_slibs
*	 
*fatal_to_IF:
*	 st	link_e_flag(a5)
*	 lea	fatal_IF_text(pc),a0
*	 bsr	printit
*	 moveq	 #-1,d0		 *return error
*	 bra.s	 no_slibs

no_slibs_copy:	*come here if there is just one lib (IFLib) and wwe
**just need to copy from toc_names_table to new_toc_names_table
	move.l	real_number_of_imports(a5),d0
	move.l	new_toc_names_table(a5),a1
	move.l	toc_names_table(a5),a0
cop:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	subq.l	#1,d0
	bne.s	cop
	clr.l	(a1)	*last lab is empty		
	bra	no_slibs

**inserts import at right place in list, sorted according to lib number
**lib number in d0
*insert_and_bucket:
*	 lea	slibs_imports_buckets(a5),a2
*	 sub.l	 #1,d0
*	 move.l	d0,d2	 *save bucket
***find insert point
*	 clr.l	 d1	*insert position in new array
*fis:	 	 *accum buckets from zero to the bucket
*	 tst.l	 d0
*	 bmi.s	 got_insert	*so we don't always insert at the TOP!!!!!
*	 add.l	 (a2),d1	*insert pos
*	 addq.l	#4,a2
*	 subq.l	#1,d0
*	 bra.s	 fis
*got_insert:
***inc bucket
*	 lea	slibs_imports_buckets(a5),a2
*	 addq.l	#1,(a2,d2.l*4)
***mul32
*	 lsl.l	 #5,d1
***shove new list down in memory to make space for this import
*	 move.l	new_toc_names_table(a5),a0
*	 add.l	 d1,a0	 *from here
*	 move.l	a0,a3	 *save insert point
*	 move.l	a0,a1
*	 lea	32(a1),a1	 *to here
***calc size to move
*	 move.l	real_number_of_imports(a5),d2	 *complete size of list
*	 lsl.l	 #5,d2	 *is now
*	 add.l	 new_toc_names_table(a5),d2	*end of table as real addr
*	 sub.l	 a1,d2	 *size to move
*	 beq.s	 last_slot_no_move	 *save an OS call on last entry
*	 OSBlockMove	a0,a1,d2
*last_slot_no_move:
**copy import name to a3 and pad to 32 with 0
*	 lea	symbol_name(pc),a0
*	 move.l	a3,a1	 
*	 clr.l	 d0
*	 move.b	(a0)+,d0
*	 subq.l	#1,d0
*	 move.l	#32,d2	*clear count
*cn:	move.b	(a0)+,(a1)+
*	 subq.l	#1,d2
*	 dbra	 d0,cn
*cl:
* 	 cmpi.l	#0,d2
* 	 beq.s	 cl_end
* 	 clr.b	 (a1)+
* 	 subq.l	#1,d2
* 	 bra.s	 cl
*cl_end:
*	 rts_	 "PEF_insert_and_bucket"
fatal_mem_text:	pstring	"Fatal Error in LinkPPC - not enough memory to Link"
	align	
fatal_libs_text:	pstring	"Fatal Error - Can't add shared libs to a Carbon project"
	align
	global	sort_imports_by_lib
	
	extern	printit,c_to_p_str,close_connections,resolve_import
	extern	c_to_p
	extern_data	symbol_name