*****************************************************************
*****************************************************************
*DOC:	Write_XCOFF_Frag.S		     			*
*Auth:	SB							*
*Date:	12/11/95		  	  	  	  	*
*TABS:	8		  	  	  	  		*
*****************************************************************
**See doc "External library calls"
**NOTE a0 is used as the "FILE" pointer and should not be touched!
Write_XCOFF:

	lea	wxf_text(pc),a0
	bsr	printit
	move.l	rs_counter(a5),d0	*round up bss to nearest 4
mod44:	move.l	d0,d1
	andi.w	#%11,d1
	beq.s	mod44_ok
	addq.l	#1,d0		*file size
	bra.s	mod44	
mod44_ok:	
	move.l	d0,xcoff_bss_size(a5)
done_message:
**First copy file header
	move.l	source_buff(a5),a0	*this is where we make the file
	lea	$100(a0),a0		*The headers will go in this space
**Now lets make the data section
	clr.l	d7	*size counter
	clr.l	d4	*file size counter
**First the pointer to the BSS section (The size of the data section goes in here!)
	move.l	a0,a4	*save pointer pos
	clr.l	(a0)+	*pointer to bss goes here (size of data section really)
	addq.l	#4,d7
	addq.l	#4,d4
**First do the toc for imported symbols
**a0 is pointing to the start of the data section
	move.w	total_imports_num(a5),d0
	beq.s	no_imports
	subq.l	#1,d0		*the old dbra ploy...
	
import_loop:
	clr.l	(a0)+
	addq.l	#4,d7
	addq.l	#4,d4
	dbra	d0,import_loop
no_imports:	
**NOW do the data entries
	move.l	data_item_count(a5),d0
	beq.s	no_data20
	move.l	a0,a2		*save start of data table so we can calc offsets in a bit
	subq.l	#1,d0
	move.l	data_item_offsets(a5),a1	*point to the offsets
store_data_offsets:
	move.l	(a1)+,(a0)+			*store this offset
	addq.l	#4,d7
	addq.l	#4,d4
	dbra	d0,store_data_offsets
no_data20:
**now do the code entries
	move.l	toc_code_count(a5),d0
	beq.s	no_data30
	move.l	a0,code_pointers_va(a5)	*so we can get back and add data size
	subq.l	#1,d0
	move.l	toc_code_offsets(a5),a1
store_code_offsets:
	move.l	(a1)+,(a0)+
	addq.l	#4,d7
	addq.l	#4,d4
	dbra	d0,store_code_offsets			
no_data30:
**now create function descriptors for the exports
;	tst.l	export_all_flag(a5)
;	bne.s	export_all
;	clr.l	number_of_globs_present(A5)
export_all:
	move.l	number_of_globs_present(a5),d6
	beq.s	skip_exports_fds
	move.l	a0,export_fds_start(a5)	*so we can come back and add data and bss size
	move.l	d7,va_of_exports(a5)

	move.l	libraries_h(a5),a1
	move.l	(a1),a1		*32 bytes a throw - code offset in 28-32 - upper byte is to be ignored. 
create_efd_loop:
**get code addr
	move.l	28(a1),d0
	andi.l	#0xffffff,d0	*8 meg limit
	addi.l	#64,d0
	move.l	d0,(a0)+	*Code offset - may need to add on 64? Yes.
	clr.l	(a0)+		*toc pointer
	clr.l	(A0)+		*Pascal link rubbish
	add.l	#12,d7
	add.l	#12,d4
	lea	32(a1),a1
	subq.l	#1,d6
	bgt.s	create_efd_loop
skip_exports_fds:
	move.l	d7,xcoff_toc_size(a5)
	move.l	d4,xcoff_va_of_entry(a5)	*save va of entry point

**now we have to export the start of the code
**the entry is going to be size of data plus size of bss (0x10) plus size of data (mod 4)
	move.l	d7,d6
	add.l	xcoff_bss_size(a5),d7	*plus bss
	add.l	#12,d7	*plus 12 bytes for func desc
	add.l	#12,d4	*file size	
	add.l	data_buffer_index(a5),d7
**make d0 mod 4
mod42:	move.l	d7,d1
	andi.w	#%11,d1
	beq.s	mod42_ok
	addq.l	#1,d4		*file size
	addq.l	#1,d7		*becasue it will be padded (I hope!)
	bra.s	mod42	
mod42_ok:
;	move.l	main_entry(a5),d1
;	bclr	#31,d1	
	clr.l	d1
	add.l	d1,d7	*pc of entry point
;	add.l	#64,d7	*acct for our header
	move.l	d7,(a0)+	*here we need to add the offset of the code start (was d7)
	clr.l	(a0)+	*entries toc
	clr.l	(a0)+	*entries frame	
	sub.l	xcoff_bss_size(a5),d7	*minus bss is data size	
	move.l	d7,(a4)	*Pointer to bss (for our global data)
	move.l	d6,d7	*restore to previous before toc calcs	
	ADD.L	#12,d7



**now splat the data across
	move.l	data_buffer(a5),a1
	move.l	data_buffer_index(a5),d0
	sub.l	d0,a1			*back to start of buffer	
	tst.l	d0
	beq.s	no_data	
copy_data:
	move.b	(a1)+,(a0)+
	addq.l	#1,d4
	addq.l	#1,d7
	subq.l	#1,d0
	bne.s	copy_data
**pad out
mod41:	move.l	d7,d1
	andi.w	#%11,d1
	beq.s	mod4_ok
	addq.l	#1,d7
	addq.l	#1,d4		*file size
	clr.b	(a0)+	*pad byte
	bra.s	mod41	
mod4_ok:
no_data:
;	nop
	move.l	d7,xcoff_data_size(a5)	*save size of dat section for header


**now add data size to data pointers so they are correct
	move.l	xcoff_toc_size(a5),d6		*toc size 
	add.l	#12,d6				*plus entry point is total size of toc
*
	move.l	data_item_count(a5),d0
	beq.s	no_data1
	subq.l	#1,d0
calc_data_offsets:
	add.l	d6,(a2)+			*add data size to offset
;	subq.l	#4,d6
	dbra	d0,calc_data_offsets
**PHEW!

no_data1:
	move.l	code_pointers_va(a5),a2
**now add data size to code pointers so they are correct

	move.l	xcoff_data_size(a5),d6		*toc size 
	add.l	xcoff_bss_size(a5),d6
	add.l	#64,d6
;	add.l	#12,d6				*plus entry point is total size of toc
**calc offsets and sub 4 from d6 as we go
	move.l	toc_code_count(a5),d0
	beq.s	no_data2
	subq.l	#1,d0
calc_code_offsets:
	add.l	d6,(a2)+			*add data size (and our boot code!) to offset
;	subq.l	#4,d6
	dbra	d0,calc_code_offsets
**PHEW!

no_data2:
**V5 Go back and add bss+data size to export code pointer in fds
	
	move.l	number_of_globs_present(a5),d0
	beq.s	skip_exports_fds1
	move.l	export_fds_start(a5),a1		*back to start of exports fds
	move.l	xcoff_data_size(a5),d6		*toc size 
	add.l	xcoff_bss_size(a5),d6		*total data section size
add_data_to_fds_loop:
	add.l	d6,(a1)	*added to code ptr
	lea	12(a1),a1	*next code pointer in exports fds	
	subq.l	#1,d0
	bne.s	add_data_to_fds_loop
skip_exports_fds1:
**Finally save va to text (data+bss)
	add.l	xcoff_bss_size(a5),d7	*plus bss is code va
	move.l	d7,xcoff_code_va(a5)	*save
	bra.s	done_toc
	rts_	"CXF_xcoff_make_toc"

done_toc:
		
**Now lets write the code (pc(a5) is length of code)
	MOVE.L	CODE_START(A5),A1	*a1->code
	sub.l	#64,a1			*For our loader
**insert our loader
	move.l	#0x60000000,(A1)+	*nop
	move.l	#0x60000000,(A1)+	*nop
					*we want a b entry instruction, and as soon as I can find the
					*book we'll have one...
	move.l	#0x48000000,d0		*0x48xxxxxx
	add.l	#64-8,d0		*account for the two previous instructions

	move.l	main_entry(a5),d1
	bclr	#31,d1
	bclr	#0,d1
	bclr	#1,d1			*must be quad and this is quicker than an and.l inst.
	add.l	d1,d0
	move.l	d0,(A1)+
	move.l	#"Mjol",(A1)+
	move.l	#"QQD4",(A1)+
	move.l	#" Mjh",(a1)+
	move.l	#"iutp",(A1)+
	move.l	#"gu 2",(a1)+
	move.l	#"008.",(a1)+		*our (C) message			

	move.l	pc(a5),d0
;	add.l	#64,d0		*acct for our 64 byte bit at the start
	add.l	d0,d4		*file size
	MOVE.L	CODE_START(A5),A1	*a1->code
	sub.l	#64,a1			*For our loader
	bsr	copy
	move.l	pc(a5),d0
mod4:	move.l	d0,d1
	andi.w	#%11,d1
	beq.s	mod_ok
	addq.l	#1,d0
	addq.l	#1,d4		*file size
	bra.s	mod4	
mod_ok:	move.l	d0,xcoff_code_size(a5)
	bra.s	done_text
	rts_	"CXF_xcoff_Move_code"

done_text:
	clr.l	d2		*offset to lib string table
	clr.l	d3		*loader size counter
**now we can write the loader section
	move.l	#1,(a0)+	*Loader version
	addq.l	#4,d4		*file size
	addq.l	#4,d3
	addq.l	#4,d2
	clr.l	d0
	move.w	total_imports_num(a5),d0	*number of symbols in symbol table
;	ext.l	d0
	
	add.l	number_of_globs_present(a5),d0	*v5 - number of named exports
	move.l	d0,(a0)+	*l_nsyms
	addq.l	#4,d4
	addq.l	#4,d3
	addq.l	#4,d2
	add.l	#3,d0		*for the entry and toc and pointer to BSS
	add.l	data_item_count(a5),d0
	add.l	toc_code_count(a5),d0
	move.l	number_of_globs_present(a5),d1
	add.l	d1,d0		*v5 - number of exports = 2 relos per export
	move.l	d0,(a0)+	*number of relos - l_nreloc
	addq.l	#4,d4
	addq.l	#4,d3
	addq.l	#4,d2
	move.l	d0,d7
	move.l	a0,save_length_of_files(a5)	*(save address so we can fill it in later)
	move.l	#18,(a0)+	*length of files list
	addq.l	#4,d4
	addq.l	#4,d3		
	addq.l	#4,d2
	move.l	a0,save_number_of_libs(a5)	*save address so we can fill it in later
	move.l	#2,(a0)+	*2 files as a default (0,0,0 and interfacelib)
	addq.l	#4,d4
	addq.l	#4,d3
	addq.l	#4,d2
	move.l	a0,a4
	clr.l	(a0)+		*offset to loader string table will go here later(d2)
	addq.l	#4,d4
	addq.l	#4,d3	
	addq.l	#4,d2
	clr.l	(a0)+		*length of string table
	clr.l	(a0)+		**offset to string table
	addq.l	#8,d4
	addq.l	#8,d3	
	addq.l	#8,d2
**Now the loadr symbol table
	move.l	toc_names_table(a5),a2		*names
	move.l	long_labels(a5),a6		*the names go here
;	move.l	toc_offsets_table(a5),a3	*va offsets	
	move.w	total_imports_num(a5),d0
	beq.s	no_imports2			*no imported labels to ID
	clr.l	long_labels_counter(a5)
copy_labs:
**see if label is greater than 8 bytes long
	tst.b	8(a2)
	beq.s	short_label			*label can go in table
**here the label has to go in the loader string table
	clr.l	(a0)+
	move.l	long_labels_counter(a5),d7
	addq.l	#2,d7			**Offset to start of string in table
	move.l	d7,(a0)+
	addq.l	#8,d4
	addq.l	#8,d3	
	addq.l	#8,d2

	clr.l	d7			*length counter
	move.l	a6,a1			*store start
	move.l	a2,-(sp)		*save start of label
	addq.l	#2,a6			*skip over size
copy_lab:
	move.b	(a2)+,d1
	beq.s	done_lab
	move.b	d1,(a6)+
	addq.l	#1,d7		*label length
	bra.s	copy_lab
done_lab:
	addq.l	#1,d7		*plus 1 for zero term and two for length field
	move.w	d7,(A1)		*store length at start of lab
	addq.l	#2,d7		*plus  2 for size field
	clr.b	(a6)+	
	add.l	d7,long_labels_counter(a5)	*this is the size of the string table
	move.l	(sp)+,a2
	lea	32(a2),a2	*poin to next label
	bra.s	done_label
short_label:
	move.l	0(a2),(a0)+		*first 4 bytes
	move.l	4(a2),(a0)+		*second 4 bytes
	addq.l	#8,d4
	addq.l	#8,d3	
	addq.l	#8,d2
	lea	32(a2),a2			  
done_label:
	clr.l	(a0)+			*va is zero for imported	
	move.l	#$400a,(a0)+		*import funct desc
;	move.l	#1,(a0)+		*file 1
	move.l	#1,(a0)+		*File unknown? - 411 replaces above line
	clr.l	(a0)+
	add.l	#16,d4
	add.l	#16,d3
	add.l	#16,d2
	subq.w	#1,d0
	bne.s	copy_labs
no_imports2:

**v5 -exports lable table
;Exporting a Named Function Descriptor
;
;Make this addition to the loader symbol table:
;  l_value = virtual address of entry point's function descriptor
;  l_scNum = 1  (.data section's section number)
;  l_smtype = $11
;  l_smclas = $0A
;  l_ifile = 0
**see if label is greater than 8 bytes long
	move.l	number_of_globs_present(a5),d0
	beq	no_exports2			*no exported labels to ID
	move.l	va_of_exports(A5),d5	*first fd of exports

	move.l	libraries_h(a5),a2
	move.l	(a2),a2		*32 bytes a throw - code offset in 28-32 - upper byte is to be ignored. 
copy_labse:
;	bra	short_labele
	tst.b	8(a2)
	beq.s	short_labele			*label can go in table
**here the label has to go in the loader string table
	clr.l	(a0)+
	move.l	long_labels_counter(a5),d7
	addq.l	#2,d7			**Offset to start of string in table
	move.l	d7,(a0)+
	addq.l	#8,d4
	addq.l	#8,d3	
	addq.l	#8,d2

	clr.l	d7			*length counter
	move.l	a6,a1			*store start
	move.l	a2,-(sp)		*save start of label
	addq.l	#2,a6			*skip over size
copy_labe:
	move.b	(a2)+,d1
	beq.s	done_labe
	move.b	d1,(a6)+
	addq.l	#1,d7		*label length
	bra.s	copy_labe
done_labe:
	addq.l	#1,d7		*plus 1 for zero term and two for length field
	move.w	d7,(A1)		*store length at start of lab
	addq.l	#2,d7		*plus  2 for size field
	clr.b	(a6)+	
	add.l	d7,long_labels_counter(a5)	*this is the size of the string table
	move.l	(sp)+,a2
	lea	32(a2),a2	*poin to next label
	bra.s	done_labele

short_labele:

	move.l	(A2),(a0)+		*first 4 bytes
	move.l	4(a2),(a0)+		*second 4 bytes
	addq.l	#8,d4
	addq.l	#8,d3	
	addq.l	#8,d2
	lea	32(a2),a2			  
done_labele:
	move.l	d5,(A0)+		*va of fd
	add.l	#12,d5			*point to next va of export fd
	move.l	#$0001110a,(a0)+	*scnum=1,smtype=11,smclas=a
;	move.l	#1,(a0)+		*file 1
	move.l	#0,(a0)+		*ifile=0
	clr.l	(a0)+			*parm=0
	add.l	#16,d4
	add.l	#16,d3
	add.l	#16,d2
	subq.l	#1,d0
	bne.s	copy_labse

no_exports2:
**now the relocation table (12 bytes each, va of data,symbol number (starting at 3) and type

	clr.l	(a0)+	   *entry of pointer to BSS
	move.l	#2,(a0)+	*bss!!!!
	move.l	#$1f000001,(a0)+
	add.l	#12,d4			*file size
	add.l	#12,d3
	add.l	#12,d2

	moveq	#4,d7		*data va (imports etc)	
	moveq	#3,d6		*label counter
	clr.l	d0
	move.w	total_imports_num(a5),d0
	beq.s	no_imports3	*no imported labels to reloc
copy_imps_reloc:
	move.l	d7,(a0)+
	move.l	d6,(a0)+	*label table position for imports only!
	move.l	#$1f000001,(a0)+	
	add.l	#12,d4			*file size
	add.l	#12,d3
	add.l	#12,d2
	addq.l	#1,d6			*symbol index
	addq.l	#4,d7			*va
	subq.w	#1,d0
	bne.s	copy_imps_reloc
no_imports3:
**now do the data pointers
	move.l	data_item_count(a5),d0
	beq.s	no_data3	*no data pointers to reloc
copy_data_reloc:
	move.l	d7,(a0)+
	move.l	#1,(a0)+	*data section
	move.l	#$1f000001,(a0)+	
	add.l	#12,d4			*file size
	add.l	#12,d3
	add.l	#12,d2
;	addq.l	#1,d6			*symbol index
	addq.l	#4,d7			*va
	subq.l	#1,d0
	bne.s	copy_data_reloc
no_data3:
**now do the code pointers
	move.l	toc_code_count(a5),d0
	beq.s	no_data4	*no data pointers to reloc
copy_code_reloc:
	move.l	d7,(a0)+	*va
	clr.l	(a0)+	   *text section
	move.l	#$1f000001,(a0)+	
	add.l	#12,d4			*file size
	add.l	#12,d3
	add.l	#12,d2
	addq.l	#4,d7			*va
	subq.l	#1,d0
	bne.s	copy_code_reloc
no_data4:
**V5 relocate exports
;Relocating a Function Descriptor
;
;1. Add an entry to the loader relocation table for the first 4-byte word, which 
;   is a reference to the .text section:
;     l_vaddr  = virtual address of the descriptor's first 4-byte word
;     l_symndx = 0      (.text section's symbol number)
;     l_rtype  = $1F00  (unsigned, 32-bit, R_POS)
;     l_rsecnm = 1      (.data section's section number)
;2. Add an entry to the loader relocation table for the second 4-byte word, 
;   which is a reference to the .data section:
;     l_vaddr  = virtual address of the descriptor's second 4-byte word
;     l_symndx = 1      (.data section's symbol number)
;     l_rtype  = $1F00  (unsigned, 32-bit, R_POS)
;     l_rsecnm = 1      (.data section's section number)

;	add.l	#12,d7	*v5 for exports
	
	move.l	number_of_globs_present(a5),d0
	beq.s	no_exports3			*no exported labels to ID
reloc_exports_loop:
	move.l	d7,(a0)+	*fd code
	clr.l	(a0)+		*in code section
	move.l	#0x1f000001,(A0)+
	addq.l	#4,d7		*va of toc ptr in fd
	move.l	d7,(a0)+	*fd data ptr to toc
	move.l	#1,(a0)+	*in data section
	move.l	#0x1f000001,(A0)+
	addq.l	#8,d7		*skip va of 3rd entry (link frame) 
	add.l	#24,d4
	add.l	#24,d3	
	add.l	#24,d2
	subq.l	#1,d0
	bne.s	reloc_exports_loop
no_exports3:
**End of reloc exports

	move.l	d7,(a0)+	*entry
	clr.l	(a0)+		*code
	move.l	#$1f000001,(a0)+
	addq.l	#4,d7
	move.l	d7,(a0)+	*entry
	move.l	#1,(a0)+	*data (toc)
	move.l	#$1f000001,(a0)+
	add.l	#24,d4
	add.l	#24,d3	
	add.l	#24,d2
		
**now the file table
	move.l	d2,(a4)+			*offset to lib files (I think...)
	add.l	#18,d2		*size of default libs files
	add.l	#18,d3
	add.l	#18,d4
	move.l	long_labels_counter(a5),(a4)+	*size of long labs
	clr.b	(a0)+
	clr.b	(a0)+
	clr.b	(a0)+			*first lib default libpath
	
	clr.b	(a0)+			*second lib is interface (always)
	move.l	#"Inte",(a0)+
	move.l	#"rfac",(a0)+
	move.l	#"eLib",(a0)+
	clr.w	(a0)+			*phew, what a masterly piece of coding! Ahem...

	clr.l	d1		*dll used counter	
	move.l	slibs_handle(a5),a1
	move.l	a1,d0
	beq.s	no_slibs
	move.l	(a1),a1
	clr.l	d7
	move.w	(a1)+,d7	*number of slibs
	beq.s	no_slibs
	dec.w	d7
		
;	save_all
;	lea	using(pc),a0
;	bsr.l	printit
;	restore_all
;**now check for other libs
;	 moveq	 #7,d7	 	 	 *bit counter for dll_flags1
;Check_next_lib:
;	 lea	 dll_names(pc),a1	 *each entry is 20 bytes
;	 move.b	dll_flags1(a5),d6	 *the flags 1=yes
;	 btst	 d7,d6
;	 beq.s	 not_this_lib
next_slib:
	clr.l	d0
	move.b	(A1)+,d0		*we get them as pascal strings
	beq.s	wot_slib
	subq.w	#1,d0
	clr.b	(a0)+			*default path
	addq.l	#1,d2
	addq.l	#1,d3
	addq.l	#1,d4
;	 move.l	d7,d5
;	 muls	 #20,d5
;	 lea	 0(a1,d5.l),a1	 	 *point to right name
copy_lib:
	addq.l	#1,d2			*inc size
	addq.l	#1,d3
	addq.l	#1,d4
	move.b	(a1)+,(a0)+
	dbra	d0,copy_lib
	inc.l	a1	*skip flag byte from Anvil
	clr.w	(a0)+			*term C string and third path

	addq.l	#2,d2			*inc size
	addq.l	#2,d3
	addq.l	#2,d4
	inc.l	d1			*Inc lib count
wot_slib:
	dbra	d7,next_Slib
	
;	save_all
;;	 tst.l	 d1
;;	 beq.s	 no_comma
;	 move.l	d5,-(sp)
;	 lea	 comma_text(pc),a0
;	 bsr.l	 printit
;	 move.l	(sp)+,d5
;no_comma:
;	 lea	 dll_names(pc),a1
;	 lea	 0(a1,d5.l),a0	 	 *print dll name
;	 bsr.l	 printit
;	 restore_all
;	 addq.l	#1,d1
;	 addq.l	#1,d2
;	 addq.l	#1,d3
;	 addq.l	#1,d4
;
;not_this_lib:
;	 dbra	 d7,check_next_lib
;**v4.11 - new shared libs
;**now check for libs
;	 moveq	 #7,d7	 	 	 *bit counter for dll_flags1
;Check_next_lib2:
;	 lea	 dll_names2(pc),a1	 *each entry is 20 bytes
;	 move.b	dll_flags2(a5),d6	 *the flags 1=yes
;	 btst	 d7,d6
;	 beq.s	 not_this_lib2
;	 clr.b	 (a0)+	 	 	 *default path
;	 addq.l	#1,d2
;	 addq.l	#1,d3
;	 addq.l	#1,d4
;	 move.l	d7,d5
;	 muls	 #20,d5
;	 lea	 0(a1,d5.l),a1	 	 *point to right name
;copy_lib2:
;	 addq.l	#1,d2	 	 	 *inc size
;	 addq.l	#1,d3
;	 addq.l	#1,d4
;
;	 move.b	(a1)+,(a0)+
;	 bne.s	 copy_lib2
;	 clr.b	 (a0)+
;	 save_all
;;	 tst.l	 d1
;;	 beq.s	 no_comma
;	 move.l	d5,-(sp)
;	 lea	 comma_text(pc),a0
;	 bsr.l	 printit
;	 move.l	(sp)+,d5
;no_comma2:
;	 lea	 dll_names2(pc),a1
;	 lea	 0(a1,d5.l),a0	 	 *print dll name
;	 bsr.l	 printit
;	 restore_all
;	 addq.l	#1,d1
;	 addq.l	#1,d2
;	 addq.l	#1,d3
;	 addq.l	#1,d4
;
;not_this_lib2:
;	 dbra	 d7,check_next_lib2
;
;
;**End of dll copies
;	 save_all
;	 lea	 dot_crcr_text(pc),a0
;	 bsr.l	 printit
;	 restore_all
*****
no_slibs:
	move.l	d2,(a4)+		*offset to lst.
	move.l	save_length_of_files(a5),a1
	move.l	d2,(a1)+
	addq.l	#2,d1			*For default and I/F lib
	move.l	d1,(a1)			*number of dlls

	
**now we have to copy the label string table

	move.l	long_labels(a5),a1
	move.l	long_labels_counter(a5),d0
	beq.s	no_longs
copy_longs:
	move.b	(a1)+,(a0)+
	subq.l	#1,d0
	bne.s	copy_longs				
no_longs:
;	add.l	#20,d3			*size of loader stuff
	add.l	long_labels_counter(a5),d3
	move.l	d3,xcoff_loader_size(a5)
;	add.l	#$120,d4		*file size (account for header)
	add.l	#$100,d4
**now we have to go back and fill in the lengths...
	add.l	long_labels_counter(a5),d4
	move.l	d4,xcoff_file_size(a5)	*save physical file size
	bra.s	make_headers
	rts_	"CXF_Xcoff_make_loader"
make_headers:

**Things we have to fill in...
**Aux header
**1. o_tsize - code size
**2. o_dsize - data size
**3. o_bsize - bss size
**4. o_entry - va of entry point function descriptor
**5. 0_text_start - va of text section (=data_size)
**6. o_data_start - va of data
**7. o_toc - same as 6
	move.l	xcoff_code_size(a5),d0
	lea	o_tsize(pc),a1
	move.l	d0,(a1)+
	move.l	xcoff_data_size(a5),d0
	move.l	d0,(a1)+		*data size
	move.l	xcoff_bss_size(a5),(a1)+		*bss size
	move.l	xcoff_va_of_entry(a5),(a1)+	*va of entry
	move.l	xcoff_data_size(a5),d0
	add.l	xcoff_bss_size(a5),d0
	move.l	d0,(a1)+			*va of text
	clr.l	(a1)+	   	   	   *va of data (is zero as data is first)
	clr.l	(a1)+	   	   	   *va of toc (is at start of data)
**now the headers
**bss
	lea	bh_phys(pc),a1	*phys addr is data size
	move.l	xcoff_data_size(a5),(a1)+
	move.l	xcoff_data_size(a5),(a1)+
	move.l	xcoff_bss_size(a5),(a1)+	*globals size from Fant
;	clr.l	(a1)+
**data	
	lea	dh_size(pc),a1
	move.l	xcoff_data_size(a5),(a1)+
**text:	
	lea	th_phys(pc),a1		*address is data size + bss size
	move.l	xcoff_data_size(a5),d0
	add.l	xcoff_bss_size(a5),d0
	move.l	d0,(a1)+		*phys addr
	move.l	d0,(a1)+		*va of text
	lea	th_size(pc),a1
	move.l	xcoff_code_size(a5),(a1)+			
	add.l	#$100,d0
	sub.l	xcoff_bss_size(a5),d0	*sub bss cause this is physical offset
	move.l	d0,(a1)+		*file offset
**loader - note we dont add on bss as we want the physical address of the loader.
	move.l	xcoff_code_size(a5),d0
	add.l	xcoff_data_size(a5),d0	*+Data = size
	add.l	#$100,d0		*+header
	lea	lh_size(pc),a1
	move.l	xcoff_loader_size(a5),(a1)+
	move.l	d0,(a1)+			*loader phys offset
	bra.s	copy_header
	rts_	"CXF_xcoff_make_headers"
copy_header:		
**now lets move the headers
**First copy file header
	move.l	source_buff(a5),a0	*this is where we make the file
	lea	file_header(pc),a1
	moveq	#20,d0
	bsr	copy		*copy header
**Copy aux header
	lea	aux_header(pc),a1
	move.l	#72,d0
	bsr	copy				
**copy data header
	lea	data_header(pc),a1
	moveq	#40,d0
	bsr	copy
	
**copy bss header
	lea	bss_header(pc),a1
	moveq	#40,d0
	bsr	copy
	
**Copy text header
	lea	text_header(pc),a1
	moveq	#40,d0
	bsr	copy

**Copy loader header
	lea	loader_header(pc),a1
	moveq	#40,d0
	bsr	copy
	clr.l	(a0)+		*pad before text	
	bra.s	write_xcoff_now
	rts_	"CXF_Xcoff_copy_headers"
write_xcoff_now:
**Send cxf end message to front end

;	lea	cxf_start_eddie(pc),a0
;	bsr	send_string_to_front

**SHIT - big change for 411!!!
**Ok, problem - the loader symbol table specifies that each entry must specifically tell the loader
**which library is associated with an import (Yuck!) Previosuly we were specifying 1 (InterfaceLib) for all imports.
**This means we must load all the shared libraries indicated by the loader import file ID's, and then test every import
**to see which library it links to! Shit!
**we can handle upto 64 shared libs - a5 globs sl_connections
**point to list of shared libs
	move.l	source_buff(a5),a0	*The frag
	move.l	a0,a1
	lea	20+72+40+40+40(a0),a0	*pointing to loader header
	move.l	16(a0),d6		*number of shared libraries in list - l_nimpid
	lea	20(a0),a0		*file offset to loader data
	move.l	(a0),d0
	add.l	d0,a1			*a1 points to loader header
	move.l	4(a1),d7		*number of entries in loader symbol table we have to check (wont be many due to
					*superb linker design :-)
	move.l	d7,number_of_symbols_to_resolve(a5)
	move.l	16(a1),d6		*number of shared libraries in list - l_nimpid
;	cmpi.l	#2,d6			*any additional ones?
;	beq	skip_import_resolve	*no, normal fant link
	subq.l	#1,d6			*number of extra shared libs
	move.l	d6,number_of_extra_sls(a5)	
	move.l	20(a1),d5		*offset to list of files
	move.l	28(a1),d4		*offset to loader string table
	move.l	a1,a2
	add.l	d4,a2
	move.l	a2,loader_string_table_ptr(a5)	*symbols longer than 8 chars basically (wake up at the back!)
	
	lea	32(a1),a2		*points to symbol table probs...
	move.l	a2,loader_symbol_table_ptr(a5)
					* I am impressed shitless by the quality of commenting going on here...
					* This could be because
					* a) Stu has grown up.
					* b) He hasn't a clue what he's doing...
						
	move.l	a1,a2			*copy loader header
	add.l	d5,a2			*a2->file names
	addq.l	#3,a2			*skip default - point to i/flib name
**now get connections to all libraries (and iflib)
**we never use 1st and third strings - so first string is 0 (null c string) and last string is zero.

	move.l	a2,lib_names_pointer(a5)
	clr.l	sl_connections_slot(a5)
connect_loop:
	move.l	lib_names_pointer(a5),a2
	addq.l	#1,a2			*skip path
	move.l	a2,a0			*file name
	lea	bracks_express(a5),a1	*make p string
	bsr.l	c_to_p_str		*in bracks express
	addq.l	#1,a0			*skip member name (we dont use it)
	move.l	a0,lib_names_pointer(a5)	*pointing to next shared lib name with a bit of luck.	   
	clr.w	-(sp)			*oserr
	pea	bracks_express(a5)	*libname
	move.l	#"pwpc",-(sp)		*archtype
	move.l	#1,-(sp)	*loadfrag
**Calc connection ID slot
	lea	sl_connections(a5),a3
	move.l	sl_connections_slot(a5),d0
	lsl.l	#2,d0
	add.l	d0,a3
	move.l	a3,-(sp)	*connecton_id	
	pea	main_addr(pc)	*start addr goes here
	pea	cxf_err_name(pc)	*error			
	move.w	#$0001,-(sp)
	dc.w 	$AA5A
	move.w	(sp)+,d0	*error
	tst.w	d0
	bne	skip_import_resolve	*error, so skip it
	addq.l	#1,sl_connections_slot(a5)		
	move.l	number_of_extra_sls(a5),d0
	subq.l	#1,d0
	move.l	d0,number_of_extra_sls(a5)
	bne	connect_loop
**now we have a list of connections -  their order is the same as the list of filenames - the order that sls are loaded.
**now we have to search each shared lib for each import
**the imports are at 	

	move.l	number_of_symbols_to_resolve(a5),d7	*counter
	beq	thankyou_salvo!				*no symbols to resolve!
	
	move.l	loader_symbol_table_ptr(a5),a0	*each entry is 24 bytes
**we need to get into the situation whereby we have a symbol name.
**we can pass this to a subroutine that checks each lib to see if it is defined.
**it returns a file index refd to 1, where 1 is interfacelib etc.
**This finally gives us the ability to report which import is not defined - HURAAH! Wanted that for months.
**first find out if label is greater than 8 bytes
do_resolve:
**Check if it's an export and don't resolve it!
	cmpi.b	#0x11,14(a0)
	beq.s	cant_resolve	*export!
	tst.b	(a0)	*will be zero if so
	beq.s	long_name
	move.l	a0,a3		*Save symbol table pos
	lea	symbol_name(pc),a1
	bsr.l	c_to_p_str	*into a1
	move.l	a3,a0		*restore sym table pos
	bra.s	got_sym
long_name:
**get offset into loader_string_table
	move.l	a0,a3	*save symbol table position
	move.l	4(a0),d0	*the offset
	move.l	loader_string_table_ptr(a5),a0
	add.l	d0,a0		*the label
	lea	symbol_name(pc),a1
	bsr.l	c_to_p_str	*into a1
	move.l	a3,a0		*resotre symbol table position
got_sym:	
	movem.l	d7/a0,-(sp)
	bsr	resolve_import
	movem.l	(sp)+,d7/a0
	tst.l	d0
	bne.s	got_file_id
**error - unresolved import
	save_all
	lea	cant_resolve_text(pc),a0
	bsr	printit
	lea	symbol_name(pc),a0
	lea	bracks_express(a5),a1
	bsr.l	p_to_c			*lib function
	lea	bracks_express(a5),a0
	bsr	printit
	lea	crcrtext(pc),a0
	bsr	printit
	restore_all
	bra.s	cant_resolve
got_file_id:
	move.l	d0,16(a0)		*insert correct file id
cant_resolve:
	lea	24(a0),a0		*next symbol
	subq.l	#1,d7
	bne	do_resolve
**Finally close connections
thankyou_salvo!:
	bsr	close_connections
**End of BIG change
skip_import_resolve:	
;	BTST	#4,OPTION_FLAGS(a5)	RUN IN MAC RAM?
;	Beq	skip_ram		*no
	bra	skip_ram
***********RUN IN RAM
;	 tst.w	 is_ppc(a5)	 	 *machine ppc?
;	 beq.s	 no_run_in_ram
;	 lea	 linking_text(pc),a0
;	 bsr.l	 printit
;
;	 bsr	 test_frag
;	 tst.l	 d0
;	 beq.s	 frag_ok
;	 rts
;no_run_in_ram:
;	 lea	 cant_run(pc),a0
;	 bsr.l	 printit
;	 rts
;
;	 
;frag_ok:
;	 bsr	 print_frag_stats
;	 LEA KEY_TEXT(PC),A0
;	 BSR.L PRINTIT 		 *PRESS ANY KEY TO START EXECUTION
;	 BSR.l WAIT_KEY
;	 LEA EXECUTE_TEXT(PC),A0
;	 BSR.L PRINTIT
;
;**now find out if run in ram or write as sa
;	 lea	 stop_here(pc),a0
;	 move.l	a0,-(sp)	 	 *stop here please
;	 lea	 main_addr(pc),a0
;	 move.l	(a0),d0		 *pointer to TV
;	 lea	 proc_pointer(pc),a1
;	 move.l	d0,(a1)
;**now go through mixed mode to run
;	 dc.w	 $aafe	 	 *mixedmodemagic trap
;	 dc.b	 7	 	 *version of mixed mode
;	 dc.b	 0	 	 *selectors (not used here)
;	 dc.l	 0	 	 *res1
;	 dc.b	 0	 	 *res2
;	 dc.b	 0	 	 *selector info
;	 dc.w	 0	 	 *number of routines (array index!)
;**Procinforec
;	 dc.l	 0	 	 *procinfo 0=no parameters, see IM PPC sys s/w
;	 dc.b	 0	 	 *resvd
;	 dc.b	 1	 	 *ppc (68k=0)
;	 dc.w	 4	 	 *Routine flags 4=native + 2=needs init + 1=offset
;
;proc_pointer:
;	 ds.l	 1	 	 *proc pointer (to transition vector actually!)
;	 dc.l	 0	 	 *resvd
;	 dc.l	 0	 	 *resvd
;
;stop_here:
;	 nop
;	 nop
;	 nop
;	 nop
;	 clr.w	 -(sp)
;	 pea	 conn_id(pc)
;	 move.w	#$0004,-(sp)	 *close connection
;	 dc.w 	 $AA5A
;	 move.w	(sp)+,d0
;	 rts_	 "PPC_RUN_IN_RAM"


test_frag:
	clr.w	-(sp)
	move.l	source_buff(a5),d0
	move.l	d0,-(sp)
	move.l	xcoff_file_size(a5),-(sp)
	pea	test_name(pc)
	move.l	#1,-(sp)	*loadfrag
	pea	conn_id(pc)	*conn_id goes here
	pea	main_addr(pc)	*start addr goes here
	pea	cxf_err_name(pc)	*error			
	move.w	#$0003,-(sp)
	dc.w 	$AA5A		*getmemfragment
	move.w	(sp)+,d0
	tst.w	d0
	bne.s	report_frag_error
	ext.l	d0		*V4.04
	rts_	"CXF_Test_frag"
report_frag_error:
	move.w	d0,-(sp)	*save error
	lea	connection_error(pc),a0
	bsr	printit
	move.w	(sp)+,d0
	cmpi.w	#-50,d0
	beq.s	param_error
	cmpi.w	#-2804,d0
	beq.s	frag_not_found
	cmpi.w	#-2807,d0
	beq.s	unresolved_syms
	cmpi.w	#-2809,d0
	beq.s	mem_err
	cmpi.w	#-2810,d0
	beq.s	mem_err
	cmpi.w	#-2812,d0
	beq.s	order_err
	cmpi.w	#-2813,d0
	beq.s	too_old
	cmpi.w	#-2814,d0
	beq.s	too_new
	cmpi.w	#-2815,d0
	beq.s	circ	
	cmpi.w	#-2817,d0
	beq.s	conn_err
	cmpi.w	#-2821,d0
	beq.s	init_err
	cmpi.w	#-2820,d0
	beq.s	corrupt_err
	bra.s	unk_err	
param_error:
	lea	param_err_text(pc),a0
	bra.s	print_ferror
frag_not_found:
	lea	fnf_text(pc),a0
	bsr	printit
	lea	cxf_err_name(pc),a0
	clr.l	d0
	move.b	(a0)+,d0
	clr.b	0(a0,d0.w)	*amke C str
	bsr	printit
	lea	dll_was(pc),a0
	bsr	printit
	moveq	#-1,d0
;	bset	#7,flags(a5)	*error detected flag
	st	global_err(a5)
	rts
unresolved_syms:
	lea	urs_text(pc),a0
	bra.s	print_ferror
mem_err:
	lea	me_text(pc),a0
	bra.s	print_ferror
order_err:
	lea	order(pc),a0
	bra.s	print_ferror
too_old:
	lea	old(pc),a0
	bra.s	print_ferror
too_new:
	lea	new(pc),a0
	bra.s	print_ferror
circ:	lea	circ_text(pc),a0
	bra.s	print_ferror
conn_err:
	lea	conn_text(pc),a0
	bra.s	print_ferror
init_err:
	lea	init_text(pc),a0
	bra.s	print_ferror
corrupt_err:
	lea	corrupt_text(pc),a0
	bra.s	print_ferror									
unk_err:
	lea	unk_text(pc),a0
print_ferror:
	bsr	printit
	moveq	#-1,d0
;	bset	#7,flags(a5)	*error detected flag
	st	global_err(a5)
	rts_	"CXF_Report_frag_error"
***Minor stuff
copy_symbol:
	move.b	(a0)+,d0
	move.b	d0,(a1)+
	bne.s	copy_symbol
	rts_	"CXF_copy_sym"	
symbol_name:	ds.b	1024
	align
cant_resolve_text:	cstring	"***Error*** '"
	align
crcrtext:	dc.b	"' is not exported in any of the shared",13,"libraries being linked to.",13,"Please ensure you have added",13,"the correct shared libraries to",13,"the project.",13,13,0
	align
**This routine closes all open dll connections
close_connections:
	lea	sl_connections(a5),a0	*the connections
;	rts
	move.l	sl_connections_slot(a5),d7	*the number of connections
	subq.l	#1,d7
cc_loop:
	move.l	0(a0,d7.l*4),the_connection(a5)	*connID
	movem.l	d7/a0,-(sp)	*save counter and connection list
	clr.w	-(sp)
	pea	the_connection(a5)
;	move.l	d0,-(sp)	*connID
	move.w	#$0004,-(sp)
	dc.w 	$AA5A
	move.w	(sp)+,d0
	movem.l	(sp)+,d7/a0	
	subq.l	#1,d7
	bge.s	cc_loop
	rts_	"CXF_close_conn"
	
**This routine checks with each dll to see if the label in symbol_name is exported by this lib
**list of connection ID's in sl_connections
**number of connections in number_of_extra_sls(a5)
resolve_import:
	lea	sl_connections(a5),a0	*the connections
	move.l	sl_connections_slot(a5),d7	*the number of connections
	subq.l	#1,d7
resolve_loop:
**get connection id

	move.l	0(a0,d7.l*4),d0	*connID
	movem.l	d7/a0,-(sp)	*save counter and connection list
	clr.w	-(sp)
**Findsym
	move.l	d0,-(sp)	*connID
	pea	symbol_name(pc)	*as pascal string
	pea	sym_addr(pc)	*address returned
	pea	sym_class(pc)	*type of symbol - code, data, tv
	move.w	#$0005,-(sp)
	dc.w 	$AA5A		*FindSym	
	move.w	(sp)+,d0
**End of findsym

	movem.l	(sp)+,d7/a0	
	tst.w	d0
	beq.s	got_sym1		*found in this frag
	subq.l	#1,d7
	bge.s	resolve_loop
	moveq	#0,d0
	rts			*not found
got_sym1:
	addq.l	#1,d7		*make real file ID (-1 for array indexing)
	move.l	d7,d0		*return file id
	rts_	"CXF_resolve_import"
sym_addr:	ds.l	1
sym_class:	ds.l	1
	
connection_error:
	dc.b	"***Error*** during link of code to shared libraries.",13
	dc.b	"Error was ",0
param_err_text:	
	dc.b	"-50.",13
	dc.b	"Parameter error.",13,13,0
fnf_text:
	dc.b	"-2804",13
	dc.b	"Fragment (or shared library) not found.",13,"Fragment name is: ",0
urs_text:
	dc.b	"-2807",13
	dc.b	"Can't resolve an import symbol.",13,13,0
me_text:	
	dc.b	"-2809",13
	dc.b	"Not enough memory for internal bookkeeping.",13,13,0
order:
	dc.b	"-2812",13
	dc.b	"Order error during user initialisation function.",13,13,0
old:
	dc.b	"-2813",13
	dc.b	"Your shared library is too old.",13,13,0 
new:	dc.b	"-2814",13								
	dc.b	"Your shared library is too new.",13,13,0
circ_text:
	dc.b	"-2815",13
	dc.b	"Circularity in required initialisation order.",13,13,0
conn_text:
	dc.b	"-2817",13
	dc.b	"Error connecting to fragment (Something is wrong, but the system linker "
	dc.b	"doesn't know what).",13,13,0
init_text:
	dc.b	"-2818",13
	dc.b	"Initialisation procedure did not return noErr.",13,13,0
corrupt_text:
	dc.b	"-2820",13
	dc.b	"Fragment corrupt (recognised format).",13,13,0
	align
unk_text:
	dc.b	"Error number not known.",13
	dc.b	"Unknown error.",13,13,0
	even
print_frag_stats:
	tst.l	cxf_quiet_flag(a5)
	bne	skip_pfs
**First lets show some info...
	lea	frag_text(pc),a0
	bsr	printit
	move.l	xcoff_file_size(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit
	lea	code_text(pc),a0
	bsr	printit
	
	lea	code_text(pc),a0
	move.l	pc(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit

	lea	data_size(pc),a0
	bsr	printit
	move.l	xcoff_data_size(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit

	lea	Toc_size(pc),a0
	bsr	printit
	move.l	xcoff_toc_size(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit

	lea	data_less_toc(pc),a0
	bsr	printit
	move.l	xcoff_data_size(a5),d0
	sub.l	xcoff_toc_size(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit
	
	
	tst.l	xcoff_bss_size(a5)
	beq.s	nil_bss
	lea	bss_size(pc),a0
	bsr	printit
	move.l	xcoff_bss_size(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit
	bra.s	done_bss
nil_bss:
	lea	bss_unused(pc),a0
	bsr	printit
done_bss:
	lea	reloc_text(pc),a0
	bsr	printit	
	move.l	xcoff_loader_size(a5),d0
	bsr.l	printnum
	lea	bytes_text(pc),a0
	bsr	printit
	
	lea	crcr_text(pc),a0
	bsr	printit
skip_pfs:
	rts_	"CXF_Print_frag_stats"
	
	
***********
skip_ram:
**Send cxf end message to front end
;	lea	cxf_end_eddie(pc),a0
;	bsr	send_string_to_front
	
	lea	create_frag(pc),a0
	bsr	printit			*write to disk
	lea	linking_text(pc),a0
	bsr	printit
	tst.w	is_ppc(a5)
	beq.s	no_test_link

	bsr	test_frag	*test link to dll's

	move.l	d0,-(sp)
	clr.w	-(sp)
	pea	conn_id(pc)
	move.w	#$0004,-(sp)	*close connection
	dc.w 	$AA5A
	move.w	(sp)+,d0

	move.l	(sp)+,d0
	tst.l	d0
	beq.s	frag_okd
	rts
no_test_link:
	lea	ntl(pc),a0
	bsr	printit
frag_okd:
	bsr	print_frag_stats
;	LEA	writing_V4(PC),A0
;	BSR.L	PRINTIT
**Frag in source_buff


;**now check if linking or SA
;	 tst.w	 building?(a5)	 *doing a build already?
;	 beq.s	 doing_sa
;	 LEA	 OP_NAME(a5),A1	*FILE NAME
;	 lea	 build_output_Fsspec(a5),a0	 *use builds o/p folder
;	 bsr.l	 make_temp_Fsspec
;	 lea	 temp_Fsspec(a5),a0	   
;	 bra.s	 done_fss
;doing_sa:
;	 LEA	 OP_NAME(a5),A1	*FILE NAME
;	 lea	 assembler_output_FSspec(a5),a0	*folder name and Fsspec
;	 bsr.l	 make_Temp_Fsspec
;done_fss:
;	 lea	 temp_Fsspec(a5),a0
;	 move.l	source_buff(a5),a1	 *the frag (I hope!)	 
;	 MOVE.L	xcoff_file_size(a5),D1	*LENGTH (ISH)
;	 MOVE.L	#"APPL",SCRATCH_1(A5)	 *FILE TYPE
;	 clr.w	 scratch_2(a5)	 	 *created flag
;	 BSR.L	 WRITE_File_not_Fant	 *IN DATA FORK :-)
;	 tst.l	 d0
;	 bge.s	 write_ok1
;	 bsr.l	 report_disk_error
;	 moveq	 #-1,d0
;	 rts	 
;write_ok1:
;	 tst.w	 scratch_2(a5)
;	 beq.s	 not_new
;	 bsr	 creating
;**Set creator
;	 lea	 temp_Fsspec(a5),a0
;	 move.l	#"FPCS",d0
;	 move.l	#"APPL",d1	 *Fant PowerPC Standalone
;	 bsr.l	 FSp_setinfo
;not_new:
;
;	 lea	 temp_Fsspec(a5),a0
;	 tst.l	 new_creator(a5)	*rel V4.15 - PPC set creator!
;	 beq.s	 no_creator
;	 move.l	new_creator(a5),d0
;	 bra.s	 done_creator
;	 
;no_creator:	 move.l	#"FPCS",d0	 creator FROM 378 FOR 379
;done_creator:	 
;	 move.l	#"APPL",d1	   
;	 bsr.l	 Fsp_setinfo
;
;	 lea	 writing_fragresources(pc),a0
;	 bsr.l	 printit	
;	 move.w	#-2,scratch_3(a5)	 counter
;
;open_res:
;	 clr.w	 -(sp)	  
;	 pea	 temp_Fsspec(a5)
;	 move.b	#3,-(sp)	 *exclusive r/w
;	 move.w	#$d,d0
;	 dc.w	 _highlevelFSdispatch	 
;	 move.w	(sp)+,d0
;	 TST.W	 D0
;	 BGE.S	 RF_EXISTS
;	 clr.w	 -(sp)
;	 dc.w	 _reserror
;	 move.w	(sp)+,d0
;	 cmpi.w	#-49,d0
;	 bne.s	 write_endm	 
;	 beq.l	 file_open_err	 *in write_mac_loader
;
;	 bra.s	 app_is_totalled
;**NOW WE HAVE THE RESOURCE FORK OPEN AND WAITING
;**we need to DELETE AND WRITE size,code 0, code 1.
;RF_EXISTS:
;	 move.w	d0,scratch_1(a5)
;	 MOVE.W	D0,-(SP)
;	 DC.W	 USERESFILE
;	 
;	 btst	 #7,flags4(a5)
;	 bne.s	 no_cfrg		 	 	 *416	 
;	 LEA	 my_cfrg(PC),A3
;	 MOVEQ	 #0,D6	 cfrg must be id 0
;	 MOVE.L	#"cfrg",D7
;	 MOVE.l	#84,D2	SIZE IS 84 BYTES
;	 LEA	 MY_cfrg_name(PC),A1	 NAME SIZE DATA
;	 BSR	 WRITE_RSRC	 D0=0, CREATED, D0=-1=EXISTS
;no_cfrg:
;	 LEA	 SIZE_CODE(PC),A3
;	 MOVEQ	 #-1,D6	SIZE RESOURCE IS NMBER -1
;	 MOVE.L	#"SIZE",D7
;	 MOVEQ	 #10,D2	SIZE IS 10 BYTES
;	 LEA	 MY_SIZE(PC),A1	NAME SIZE DATA
;	 BSR	 WRITE_RSRC	 D0=0, CREATED, D0=-1=EXISTS
;
;WRITE_ENDM:
;	 MOVE.W	SCRATCH_1(A5),-(SP)	 RES FILE REFNUM
;	 DC.W	 CLOSERESFILE
;	 
;**COME HERE IF FILE EXISTS ALREADY (SO WE DONT WASTE TIME)
;NO_RES:

	clr.l	d0
	rts_	"CXF_Write_xcoff_frag"
;app_is_totalled:
;	 lea	 app_dead(pc),a0
;	 bsr.l	 printit
;	 bra	 write_endm

******************************************************************************
**MUST be a C type string!
send_string_to_front:
;	 tst.w	 integrated(a5)	*LIDE?
;	 beq.s	 not_send12
;	 move.l	a0,a1	 	 	 	 *String to send
;;	 move.l	comms_buffer_Addr(A5),a0	*Send unregistered message to Eddie
;	 lea	 comms_buffer(a5),a0
;	 move.w	#1,(a0)		 	 *Dstr uses C strings so we don't need a size
;	 move.b	#2,2(a0)	 	 *to eddie
;	 move.l	#"Dstr",3(A0)	 	 *Display string
;	 lea	 7(a0),a0
;	 bsr.s	 copy_c_str_for_send
; 	 bsr.l	 send_and_wait
not_send12:
	rts_	"CXF_Send_string_to_frontend"
copy_c_str_for_send:
	move.b	(a1)+,(a0)+
	bne.s	copy_c_str_for_send
	rts_	"CXF_Copy_c"


**Copies a1 to a0. Count in d0.l
copy:	tst.l	d0
	beq.s	copy_end
cop_loop:
	move.b	(a1)+,(a0)+
	subq.l	#1,d0
	bne.s	cop_loop
copy_end:
	rts_	"CXF_Copy"


C_TO_P_STR:	CLR.L	D0
DO_P_LOOP:	MOVE.B	(A0)+,D1
	BEQ.S	CTOPEND
	ADDQ.L	#1,D0	COUNTER		
	MOVE.B	D1,0(A1,D0.L)	SAVE BYTE IN P STRING
	BRA.S	DO_P_LOOP
CTOPEND:	MOVE.B	D0,(A1)
	RTS
	DC.B	"C_TO_P_S"
			
**Data
;my_cfrg_name:	 dc.b	 13,"Fantasms cfrg"
;	 even
;my_cfrg:
;	 dc.l	 0
;	 dc.l	 0
;	 dc.l	 1	 *vers
;	 dc.l	 0
;	 dc.l	 0
;	 dc.l	 0
;	 dc.l	 0
;	 dc.l	 1	 *1 descriptor
;	 
;	 dc.l	 "pwpc"
;	 dc.l	 0
;	 dc.l	 0	 *curent vers
;	 dc.l	 0	 *oldest def vers
;	 dc.l	 0	 *default stack size
;	 dc.w	 0	 *app lib directory
;	 dc.b	 1	 *type of frag
;	 dc.b	 1	 *on disk
;	 dc.l	 0	 *offset
;	 dc.l	 0	 *whole fork
;	 dc.l	 0
;	 dc.l	 0
;	 dc.w	 52	 *length of this record
;	 dc.b	 9,"FANTASMV4"
	
**************

file_header:	dc.w	$01df	*f_magic
	dc.w	4	*f_nscns
	dc.l	0	*f_timdat
	dc.l	0	*f_symptr
	dc.l	0	*f_nsyms
	dc.w	72	*f_opthdr
	dc.w	$1003	*f_flags
	
aux_header:
	dc.w	$10b	*o_mflag
	dc.w	1	*o_Vstamp
o_tsize:	ds.l	1	*text size
o_dsize:	ds.l	1	*Data size
o_bsize:	ds.l	1	*Bss size
o_entry:	ds.l	1	*VA of entry point function descriptor in data section
o_text_start:	ds.l	1	*VA of text section
o_data_start:	ds.l	1	*VA of data section
o_toc:	ds.l	1		*VA of toc in data sect (Same as start of data)
	dc.w	1		*section number of entry point
	dc.w	3		*section number of text
	dc.w	1		*Section number of data
	dc.w	1		*section number of toc=data
	dc.w	4		*section number of loader
	dc.w	2		*Section number of bss
	dc.w	2		*align code 4
	dc.w	3		*align data 8	
	dc.w	$314c		*Single use
	dc.w	0		*o_resv1
	dc.l	0		*o_maxstack
	dc.l	0		*o_maxdata
	dc.l	0,0,0		*o_resv2
data_header:
	dc.l	$2e646174
	dc.l	$61000000	*.data
	dc.l	0		*phys addr
	dc.l	0		*VA
dh_size:
	ds.l	1		*size
	dc.l	$100		*File offset (physical)
	dc.l	0		*section reloc info
	dc.l	0		*offset to section line number entries
	dc.w	0		*s_nreloc
	dc.w	0		*s_nlnno
	dc.l	$40		*data
bss_header:
	dc.l	$2e627373
	dc.l	$00000000	*.bss
bh_phys:
	ds.l	1		*phys addr
bh_va:
	ds.l	1		*VA
bh_size:
	ds.l	1		*xcoff_bss_size
	dc.l	0		*File offset (physical)
	dc.l	0		*section reloc info
	dc.l	0		*offset to section line number entries
	dc.w	0		*s_nreloc
	dc.w	0		*s_nlnno
	dc.l	$80		*bss

text_header:
	dc.l	$2e746578
	dc.l	$74000000	*.text
th_phys:
	ds.l	1		*phys addr
	ds.l	1		*VA
th_size:
	ds.l	1		*size
	ds.l	1		*File offset (physical)
	dc.l	0		*section reloc info
	dc.l	0		*offset to section line number entries
	dc.w	0		*s_nreloc
	dc.w	0		*s_nlnno
	dc.l	$20		*text
loader_header:
	dc.l	$2e6c6f61
	dc.l	$64657200	*.loader
	dc.l	0		*phys addr
	dc.l	0		*VA	- note zero for loader
lh_size:
	ds.l	1		*size
	ds.l	1		*File offset (physical)
	dc.l	0		*section reloc info
	dc.l	0		*offset to section line number entries
	dc.w	0		*s_nreloc
	dc.w	0		*s_nlnno
	dc.l	$1000		*loader
	align		
key_text:	dc.b	13,"***Ready. Press any key to execute code in RAM***",13,0
execute_text:	dc.b	"Executing PowerPC code in RAM through the Mixed Mode Manager.",13,13,13,0
writing_to_ram:	dc.b	"***Good assembly***",13
	dc.b	13,"CXF End.",13,"Creating fragment",13,0
create_frag:	dc.b	13,"CXF End.",13,"Creating fragment.",13,0
linking_text:	dc.b	"Test linking with Macintosh shared libraries.",13,0
cant_run:	dc.b	"**ERROR** Can't run PowerPC code in RAM on a non PowerPC machine.",13,0
ntl:	dc.b	"**ADVICE** Unable to test link with",13,"shared libraries because this is",13,"not a PowerMac.",13,0

test_name:	dc.b	4,"TEST"
frag_text:	
	
	dc.b	"Fragment linked OK.",13
	dc.b	13,"Fragment statistics:"
frag_size:	dc.b	13,"Total size: ",0
code_text:	dc.b	13,"Code sect:  ",0
data_size:	dc.b	13,"Data sect:  ",0
bss_size:	dc.b	13," BSS size:  ",0
toc_size:	dc.b	13," TOC size:  ",0
data_less_toc:	dc.b	13," Data size: ",0
reloc_text:	dc.b	13,"Reloc size: ",0
bytes_text:	dc.b	" bytes.",0
crcr_text:	dc.b	13,13,0		
	even
conn_id:	ds.l	1	*conn_id goes here
main_addr:	ds.l	1	*start addr goes here
bss_unused:	dc.b	13," BSS size:  Empty.",0
cxf_err_name:	ds.b	256	*error
dll_was:	dc.b	13,"If this is a System shared library",13,"(such as QuickTime),"
	dc.b	" please ensure it is in the",13,"Extensions folder.",13
	dc.b	"If it is a general purpose shared library",13,"- for example a Sprocket,"
	dc.b	" then either",13,"place it in the Extensions folder or",13,"place a copy in both Anvil's"
	dc.b	13,"and the targets' folder.",13,0
	
cr_text:	dc.b	13,0
comma_text:	dc.b	", ",0
dot_crcr_text:	dc.b	".",13,13,0

using:	dc.b	13,"Using following shared libraries:",13		   	   
	dc.b	"InterfaceLib",0
	even
;dll_names:
;	 dc.b	 "SpeechLib",0,0,0,0,0,0,0,0,0,0,0	 *bit 0 of dll_flags
;	 dc.b	 "SoundLib",0,0,0,0,0,0,0,0,0,0,0,0	 *bit 1
;	 dc.b	 "ObjectSupportLib",0,0,0,0
;	 dc.b	 "AppleScriptLib",0,0,0,0,0,0
;	 dc.b	 "ThreadsLib",0,0,0,0,0,0,0,0,0,0	 *bit 4
;	 dc.b	 "StdCLib",0,0,0,0,0,0,0,0,0,0,0,0,0
;	 dc.b	 "MathLib",0,0,0,0,0,0,0,0,0,0,0,0,0
;	 dc.b	 "QuickTimeLib",0,0,0,0,0,0,0,0	*20 bytes each
;**v4.11
;dll_names2:
;	 dc.b	 "ControlStripLib",0,0,0,0,0	 	 *bit 0 of dll_flags2
;	 dc.b	 "DisplayLib",0,0,0,0,0,0,0,0,0,0
;	 dc.b	 "InputSprocketLib",0,0,0,0
;	 dc.b	 "NetSprocketLib",0,0,0,0,0,0	 	 *bit 3
;	 dc.b	 "DrawSprocketLib",0,0,0,0,0
;	 dc.b	 "SoundSprocketLib",0,0,0,0	 	 *bit 5
;	 dc.b	 "DragLib",0,0,0,0,0,0,0,0,0,0,0,0,0
;	 even
wxf_text:	dc.b	"PPC static link end.",13,13,"Running CXF V2.90 - [day$]/[month$]/[year$].",13,0
	align
	global	write_xcoff
	extern	printit
	extern	app_dead,fsp_setinfo,wait_key,printnum,p_to_c