*******************************************************************************
*Project:       Eddie (LIDE)                                                  *
*Author:        SB                                                            *
*Filename:      chroma_ppc.s                                                  *
*Version:       V1.60 (Auto)                                                  *
*Date started:  2:36:27 on 29th November 1996                                 *
*Rev. History:                                                                *
*                                                                             *
*                                                                             *
*******************************************************************************
***************************************************************************
	swg_off
	proc_ppc
plug_assm_chroma:
	entry
	mflr r0
	stw r0,8(sp)		*Store link register on the stack
	stmw r10,-88(sp)	*Save r10-r31
	stwu sp,-64+88(sp)	*Skip over the stack space
	lwz r30,(rtoc)		*Load global data (bss) pointer (first entry in TOC)
	stw r2,20(sp)		*Save RTOC;
**This is chroma 68k/ppc
zero:	reg	r27
bss:	reg	r30				*off to right jump point
**************************************************************
;main	(long argc,*argv) //argv is a sturcture
**Argv comes in r4
**Set up various bit
	
	li	`zero,0
	stw	r4,command_save(`bss)
	lwz	r5,(r4)	*callback
	lwz	r10,16(r4)	*Command
	stw	r5,callback(`bss)

	lwz	r20,20(r4)	*terec
	lwz	r22,24(r4)	*text to print
	lwz	r26,28(r4)	*a6
	lwz	r5,32(r4)	*chroma_colours
	lwz	r6,36(r4)
	stw	r5,chroma_colours(`bss)
	stw	r6,fg_colour(`bss)
**is it an init call
**1=init, 2=tidy up, 3=chroma
	cmpwi	cr5,r10,100

	cmpwi	cr2,r10,1
	cmpwi	cr3,r10,2
	cmpwi	cr4,r10,6
	beq	cr5,do_chroma_1
	beq	cr2,do_init
	nop
	beq	cr3,clean_up
	nop
	beq	cr4,do_prefs
	b	fragment_out
do_chroma_1:
	bl	do_chroma
	b	fragment_out

**must be init
do_init:
	global	do_init
**Create an UPP
	lwz	r3,callback(`bss)
	li	r4,%11000001
	li	r5,0
	Xcall	NewRoutineDescriptor
	stw	r3,Anvil_UPP(`bss)
	li	r3,256
	Xcall	NewHandleClear
	cmpwi	r3,0
	beq	fault		*need to move this
	stw	r3,my_pb_h(`bss)
	b	fragment_out

**Get prefs
do_prefs:
	global	do_prefs

	lis	r3,"my"
	ori	r3,r3,"PF"
	li	r4,128
	Xcall	Get1Resource
	cmpwi	r3,0
	mr r21,r3		*handle to prefs
	beq	fault
	
	lwz	r22,(r21)
	lwz	r11,(r22)	*the pref :-)
	cmpwi	r11,0
	beq	normal_chroma
	lbz	r3,prefs_flags(`bss)
	ori	r3,r3,4	*set bit two
	stb	r3,prefs_flags(`bss)
	b	done_init

normal_chroma:
	lbz	r3,prefs_flags(`bss)
	andi	r3,r3,%11111011
	stb	r3,prefs_flags(`bss)
done_init:
	mr	r3,r21
	Xcall	ReleaseResource
	lwz	r3,my_pb_h(`bss)
	Xcall	HLock
	lwz	r20,my_pb_h(`bss)
	lwz	r20,(r20)
	li	r3,4
	stw	r3,(r20)	*command to Anvil
**Call Anvil
	lwz	r3,Anvil_UPP(`bss)	
	li	r4,%11000001
	mr	r5,r20
	Xcall	CallUniversalProc

	b	fragment_out

clean_up:
	global	clean_up
**we do nothing
	b	fragment_out	

fault:	b	skip_error
fragment_out:
	li	r3,0	*no error
skip_error:
	lwz	r4,command_save(`bss)
	stw	r3,(r4)

	lwz r0,64+8+88(sp)	*Get saved link register
	mtlr r0
	addi sp,sp,64+88		*Reset stack pointer
	lmw r10,-88(sp)			*Restore r10-r31
	blr
	global	fragment_out
;***MODE SWITCH CODE TO PPC
;univ_pointer:	 DC.H	 $AAFE	 	 *MIXEDMODEMAGIC TRAP
;	 DC.B	 7	 	 *VERSION OF MIXED MODE
;	 DC.B	 0	 	 *
;	 dc.h	 0	 	 *RES1
;	 DC.B	 0	 	 *RES2
;	 DC.B	 0	 	 *SELECTOR INFO
;	 DC.H	 0	 	 *NUMBER OF ROUTINES (ARRAY INDEX!)
;**Routine record
;proc_info:	data
;	 DC.H	 %0	 	 
;	 DC.B	 0	 	 *RESVD
;
;	 DC.B	 0	 	 *PPC (68K=0)
;	DC.H	0		*ROUTINE FLAGS

proc_pointer:	DS.W	1		*PROC POINTER
	DC.W	0		*RESVD
	DC.W	0		*RESVD	
	
**Check chroma state
do_chroma:
	sub_in
**Check which table to use
	swg_low
	lhz	r3,chroma_state_w(r26)
	cmpwi	r3,1		*68k?
	swg_off
	lwz	r24,chroma_words_8(rtoc)
	beq	done_tablec		*yup
not_68kc:
	lwz	r24,ppc_chroma_words_8(rtoc)
done_tablec:
	lhz	r17,ed_scroll_h_l(r20)	*h scroll bar
	cmpw	r17,`zero
	beq	no_disp
	sub	r22,r22,r17		*rewind to start of line
	bl	get_width

	mullw	r17,r17,r13		*X offset
	lhz	r3,ed_curs_x(r20)
	sub	r3,r3,r17
	sth	r3,ed_curs_x_save(`bss)
	lhz	r4,ed_curs_y(r20)
	Xcall	MoveTo
no_disp:
;	mr	r21,r20
	bl	get_width
	mr	r17,r13			*save font width
	stw	r22,line_save(`bss)	*save line pos
	stb	`zero,rewind_flag(`bss)
sc1:
;	mr	r20,r21
	la	r23,my_word1+1(`bss)	*was +1
;	dcbz	r0,r23
	li	r15,0			*counter
	lbz	r10,(r22)
	cmpwi	r10,0x22	*Quotes?
	beq	str_copy
pl1:
	lbz	r10,(r22)
	addi	r22,r22,1

**We have the character in r10, we need to check it against a list of
**terminators
	cmpwi	cr2,r10,0
	cmpwi	cr3,r10,13
	cmpwi	cr4,r10," "
	cmpwi	cr5,r10,9
	cmpwi	cr6,r10,"("
	nop
;	cmpwi	cr7,r10,"."
	beq	cr2,got_word		*endded in zero
	nop
	beq	cr3,got_wordcr
	nop
	beq	cr4,got_word
	nop
	beq	cr5,got_word
	nop
	beq	cr6,got_word
;	nop
;	beq	cr7,got_word
	addi	r15,r15,1	*byte sized counter
	andi.	r15,r15,0xff
	stb	r10,(r23)
	addi	r23,r23,1
	bne	pl1
	b	bigger1
**here we're in a string so copy to end
str_copy:
	stb	r10,(r23)
	addi	r23,r23,1
	addi	r22,r22,1
	addi	r15,r15,1
str1:	lbz	r10,(r22)
	cmpwi	r10,0
	addi	r22,r22,1
	beq	got_word
	cmpwi	r10,13
	beq	got_wordcr
	cmpwi	r10,0x22
	beq	got_word
	stb	r10,(r23)
	addi	r23,r23,1
	addi	r15,r15,1
	andi.	r15,r15,0xff
	bne	str1
**Fall through if overflow
bigger1:
	stb	`zero,(r23)
	la	r23,my_word1(`bss)
	li	r3,255
	stb	r3,(r23)
	bl	chroma
	la	r3,my_word1(`bss)
	Xcall	DrawString
	b	skip_pr
terms:	dc.b	32,9,"(."	*4 of them


got_wordcr:
	stb	`zero,(r23)
	la	r23,my_word1+1(`bss)
	stb	r15,-1(r23)
;	addi	r23,r23,1
	bl	chroma_cr

;	lbz	r3,rewind_flag(`bss)
;	cmpwi	r3,0
	la	r3,my_word1(`bss)
;	bne	do_rewind
	Xcall	DrawString
do_cr1:
	bl	do_cr
	b	pl_end
got_wordrew:
	li	r3,1
	stb	r3,rewind_flag(r5)
got_word:
	inc	r15
	cmpwi	cr2,r15,1
	cmpwi	cr3,r10," "
	stb	r10,(r23)
	addi	r23,r23,1
	la	r23,my_word1+1(`bss)
	stb	r15,-1(r23)
;	inc	r23
	bne	cr2,not_1_char
**Check for space run
	bne	cr3,no_chrome
	inc r23
space_loop:
	lbz	r3,(r22)
	li	r4,0
	cmpwi	r3," "
	inc	r22
	inc	r15
	beq	space_loop
;	bne	no_run
;run:
;	b	 space_loop
***********
no_run:
	dec	r22
	dec	r15
;	la	r23,my_word1(`bss)
;	mr	r20,r21
	mullw	r3,r15,r17	*font width
;	mr r3,r15
;	li	r4,0
	Xcall	Move		*relative move
**If proper chroma set default colour back
	lbz	r3,prefs_flags(`bss)
	andi.	r3,r3,%100	*bit 2, cr0
	lbz	r3,comment?(`bss)
	cmpwi	cr2,r3,0	*comment?
	beq	skip_pr	*not_prop2 - from andi.
	lwz	r3,fg_colour(`bss)
	bne	cr2,not_prop2	*yes comment
	Xcall	RGBForeColor	*no comment
not_prop2:
	b	skip_pr
not_1_char:
	bl	chroma
	lbz	r3,rewind_flag(`bss)
	cmpwi	r3,0
	beq	no_chrome
do_rewind:
;	lbz	r3,k_chroma_flag(`bss)
;	cmpwi	r3,0
;	lhz	r3,ed_curs_x_save(`bss)
;	bne	not_cr20	*if k_chroma 1 then x_curs_save
;	
;	lhz	r3,ed_curs_x(r20)
;	b	done_cr
not_cr20:
	lhz	r3,ed_curs_x_save(`bss)
done_cr:
	lhz	r4,ed_curs_y(r20)
	Xcall	MoveTo
	lwz	r22,line_save(`bss)
	bl	print_line_bw_chroma_entry
	stb	`zero,rewind_flag(`bss)
	b	pl_end
no_chrome:
	la	r3,my_word1(`bss)
	Xcall	DrawString
	lbz	r3,prefs_flags(`bss)
	andi.	r3,r3,%100	*bit 2
	lbz	r3,comment?(`bss)
	cmpwi	cr2,r3,0	*in a comment
	stb	`zero,rewind_flag(`bss)
	bne	skip_pr		*proper chroma
	beq	cr2,skip_pr	*in a comment!
	bl	print_line_bw_chroma_entry
	b	pl_end
skip_pr:
	lbz	r10,-1(r22)
	cmpwi	r10,0
	bne	sc1				*Do it all again
pl_end:
	stb	`zero,comment?(`bss)
	sub_out	*bye

***************************************************
do_cr:
	sub_in
;	mflr	r29
	lhz	r4,ed_lineheight(r20)
	lhz	r3,ed_curs_y(r20)
	li	r5,4
	add	r4,r4,r3
	sth	r4,ed_curs_y(r20)
	sth	r5,ed_curs_x(r20)
	lhz	r3,ed_curs_x_save(`bss)
	Xcall	MoveTo
	lhz	r5,chroma_state_w(r26)
	lwz	r3,fg_colour(`bss)
	cmpwi	cr7,r5,0
	stb	`zero,comment?(`bss)
	beq	cr7,pw_end	*chroma proper?
	Xcall	RGBForeColor
pw_end:
	sub_out
;	mtlr	r29
*****************************************************
****************************************************************	
print_line_BW:
	lhz	r17,ed_scroll_h_l(r20)	*h scroll bar
	cmpw	r17,`zero
	beq	no_disp1
	sub	r22,r22,r17		*rewind to start of line
	bl	get_width
	lhz	r3,ed_curs_x(r20)
	mullw	r17,r17,r13		*X offset
	sub	r3,r3,r17
	sth	r3,ed_curs_x_save(`bss)
	lhz	r4,ed_curs_y(r20)
	Xcall	MoveTo
no_disp1:	bl	print_line_bw_chroma_entry
	sub_out
	
print_line_bw_chroma_entry:
	sub_in
	la	r23,our_string+1(`bss)
	li	r10,0
	li	r15,0
pl_loop:
	lbz	r11,(r22)
	cmpwi	cr2,r11,0
	cmpwi	cr3,r11,13
	inc r22
	beq	cr2,termed_in_zero
	beq	cr3,termed_in_cr
	inc r10
	andi.	r10,r10,0xff
	stb	r11,(r23)
	inc r23
	bne	pl_loop
wrapped!:
	lbz	r11,(r22)
	cmpwi	r11,0
	cmpwi	cr2,r11,13	*1
	inc r22
	beq	wrapped_zero
	bne	cr2,wrapped!	*1
wrapped_cr:
	li	r15,1
wrapped_zero:
	li	r10,-1
termed_in_zero:
	la	r23,our_string(`bss)
	stb	r10,(r23)
	mr	r3,r23
	Xcall	DrawString
	cmpwi	cr7,r15,0
	beq	cr7,print_line_end
	bl	do_cr

print_line_end
	sub_out
termed_in_cr:
	li	r15,1
	b	termed_in_zero
	
***************************************************
get_width:
	lhz	r13,ed_txsize(r20)
;	mr	r3,r13			*copy
	andi.	r3,r13,1		*get zero bit
	srwi	r13,r13,1
	beq	no_add
	addi	r13,r13,2
	blr
no_add:
	addi	r13,r13,1
	blr
	

**************************************************************
chroma_cr:
	global	chroma_cr
	sub_in
	mr	r28,r22
	mr	r29,r23
	lbz	r3,comment?(`bss)
	cmpwi	r3,0
	lbz	r3,0(r23)
	lbz	r10,-1(r23)		*length of string
	cmpwi	cr2,r3,";"
	cmpwi	cr3,r3,"*"
	bne	end_chroma		*we're in a comment
**Check for start comment
	beq	cr2,got_colorc		*Comment found
	beq	cr3,got_colorc
***********
**WE use r10-r17 as d0-d7
**       r20-r25 as a0-a4
	cmpwi	r10,0	
	la	r22,word_2(`bss)	*build upper case word here
	dcbz	r0,r22
	mtctr	r10
	ble	end_chroma		*word is too short to test
;	subi	r23,r23,1	*for pre-inc
	subi	r22,r22,1
clpcr:
	lbz	r11,(r23)
	cmpwi	cr2,r11,"a"
	cmpwi	cr3,r11,"z"
	addi	r23,r23,1
	lbz	r3,comment?(`bss)
	blt	cr2,no_convertcr
	bgt	cr3,no_convertcr
	subi	r11,r11,32
no_convertcr:
	stbu	r11,1(r22)
	bdnz	clpcr
******
	cmpwi	cr4,r3,0
	addi	r22,r22,1
	lbz	r3,-1(r22)
	bne	cr4,in_comment_no_labels1		*we're in a comment
	cmpwi	r3,":"
	beq	found_lab
in_comment_no_labels1:
	stw	`zero,(r22)
	stw	`zero,4(r22)					*term word
;**Check which table to use
;	 lhz	 r3,chroma_state_w(r26)
;	 cmpwi	 r3,1	 	 *68k?
;	 lwz	 r22,chroma_words_8(rtoc)
;	 beq	 done_tablec		 *yup
;not_68kc:
;	 lwz	 r22,ppc_chroma_words_8(rtoc)
;done_tablec:
	mr	r22,r24		*chroma table
	la	r23,word_2(`bss)
	lwz	r14,(r23)
	lwz	r15,4(r23)
skip_8cr:
	lwz	r10,(r22)
;	addi	r22,r22,4
	lwz	r12,4(r22)
	cmpwi	r10,0
	cmpw	cr2,r14,r10
	cmpw	cr3,r15,r12
	beq	end_8cr
	addi	r22,r22,10	*Skip colour half
	lhz	r13,-2(r22)				*get colour	
	lwz	r3,chroma_colours(`bss)
	bne	cr2,skip_8cr
	bne	cr3,skip_8cr
	slwi	r13,r13,3				*each colour entry is 8 bytes
	add	r3,r3,r13
	Xcall	RGBForeColor
end_8cr:
end_chromacr:
	mr	r22,r28
	mr	r23,r29

	sub_out


**************************
	
**************************************************************
chroma:
	sub_in
	mr	r28,r22
	mr	r29,r23
	lbz	r4,comment?(`bss)
	lbz	r3,0(r23)
	cmpwi	r4,0
	cmpwi	cr2,r3,";"
	cmpwi	cr3,r3,"*"
	lbz	r10,-1(r23)		*length of string
	bne	end_chroma		*we're in a comment
**Check for start comment
	beq	cr2,got_colorc
	nop
	beq	cr3,got_colorc
***********
**WE use r10-r17 as d0-d7
**       r20-r25 as a0-a4

	subic.	r10,r10,1	*different from dbra
	la	r22,word_2(`bss)	*build upper case word here
	dcbz	r0,r22	
	mtctr	r10
	ble	end_chroma		*word is too short to test
;	subi	r23,r23,1	*for pre-inc
	subi	r22,r22,1
clp:
	lbz	r11,(r23)
	addi	r23,r23,1
	cmpwi	cr2,r11,"a"
	cmpwi	cr3,r11,"z"
	lbz	r3,comment?(`bss)	*May as well load this in here...
	blt	cr2,no_convert
	bgt	cr3,no_convert
	subi	r11,r11,32
no_convert:
	stbu	r11,1(r22)
	bdnz	clp
******
	cmpwi	cr4,r3,0		*Comment?
	addi	r22,r22,1
	lbz	r3,-1(r22)
	cmpwi	cr2,r3,":"
	bne	cr4,in_comment_no_labels		*we're in a comment
	beq	cr2,found_lab
in_comment_no_labels:
						*These are from below in_comment_no_labels
	stw	`zero,(r22)
	stw	`zero,4(r22)					*term word

	mr	r22,r24		*Chroma table
	la	r23,word_2(`bss)
	lwz	r14,(r23)
	lwz	r15,4(r23)
skip_8:
	lwz	r10,(r22)
;	addi	r22,r22,4
	lwz	r12,4(r22)
	cmpwi	r10,0
	cmpw	cr2,r14,r10
	cmpw	cr3,r15,r12
	addi	r22,r22,10	*Skip colour half
	beq	end_8
	lhz	r13,-2(r22)					*get colour
	lwz	r3,chroma_colours(`bss)
	bne	cr2,skip_8
	bne	cr3,skip_8	*not found	
	slwi	r13,r13,3					*each colour entry is 8 bytes
	add	r3,r3,r13
	Xcall	RGBForeColor
end_8:
end_chroma:
	mr	r22,r28
	mr	r23,r29
	sub_out
	global	chroma

got_color1:
	lwz	r22,chroma_colours(`bss)
	slwi	r13,r13,3					*each colour entry is 8 bytes
	add	r3,r22,r13
	Xcall	RGBForeColor
	b	end_8
	
got_colorc:
	lwz	r4,chroma_colours(`bss)
	la	r3,16(r4)		*Comments colour
	Xcall	RGBForeColor
	li	r3,1
	stb	r3,comment?(`bss)
	b	end_chroma
found_lab:
	li	r13,1
	b	got_color1

**********************************************************
	align	8
chroma_words_8: data
	dc.b	"SP)",0,0,0,0,0
	dc.h	0
	dc.b	"MOVEM",0,0,0
	dc.h	0
	dc.b	"BSR",0,0,0,0,0
	dc.h	1
	dc.b	"BRA",0,0,0,0,0
	dc.h	1
	dc.b	"BNE",0,0,0,0,0
	dc.h	1
	dc.b	"BEQ",0,0,0,0,0
	dc.h	1
	dc.b	"BLT",0,0,0,0,0
	dc.h	1
	dc.b	"BGT",0,0,0,0,0
	dc.h	1
	dc.b	"BGE",0,0,0,0,0
	dc.h	1
	dc.b	"BLE",0,0,0,0,0
	dc.h	1
	dc.b	"BMI",0,0,0,0,0
	dc.h	1

	dc.b	"BSR.S",0,0,0
	dc.h	1
	dc.b	"BRA.S",0,0,0
	dc.h	1
	dc.b	"BNE.S",0,0,0
	dc.h	1
	dc.b	"BEQ.S",0,0,0
	dc.h	1
	dc.b	"BLT.S",0,0,0
	dc.h	1
	dc.b	"BGT.S",0,0,0
	dc.h	1
	dc.b	"BGE.S",0,0,0
	dc.h	1
	dc.b	"BLE.S",0,0,0
	dc.h	1
	dc.b	"BMI.S",0,0,0
	dc.h	1

	dc.b	"RTS",0,0,0,0,0
	dc.h	1
	dc.b	"RTS_",0,0,0,0
	dc.h	1
	dc.b	"PEA",0,0,0,0,0
	dc.h	0
	dc.b	"PUSH",0,0,0,0
	dc.h	0
	dc.b	"POP",0,0,0,0,0
	dc.h	0
	dc.b	"DC.B",0,0,0,0
	dc.h	7
	dc.b	"DC.W",0,0,0,0
	dc.h	7
	dc.b	"DC.L",0,0,0,0
	dc.h	7
	dc.b	"DC.H",0,0,0,0
	dc.h	7

	dc.b	"DS.B",0,0,0,0
	dc.h	7
	dc.b	"DS.W",0,0,0,0
	dc.h	7
	dc.b	"DS.H",0,0,0,0
	dc.h	7
	dc.b	"DS.L",0,0,0,0
	dc.h	7


	dc.b	"RS.B",0,0,0,0
	dc.h	7
	dc.b	"RS.H",0,0,0,0
	dc.h	7
	dc.b	"RS.W",0,0,0,0
	dc.h	7
	dc.b	"RS.L",0,0,0,0
	dc.h	7
	
	DC.B	"REG",0,0,0,0,0
	DC.H	7
	dc.b	"EXTERN",0,0
	dc.h	3
	dc.b	"GLOBAL",0,0
	dc.h	3
	dc.b	"PUBLIC",0,0
	dc.h	3
	dc.b	"EQU",0,0,0,0,0
	dc.h	7
	dc.b	"MACRO",0,0,0
	dc.h	4
	dc.b	"ENDM",0,0,0,0
	dc.h	4
	dc.b	"EVEN",0,0,0,0
	dc.h	4
	dc.b	"DEBUG",0,0,0
	dc.h	5

	dc.b	"IF",0,0,0,0,0,0
	dc.h	4
	dc.b	"ENDIF",0,0,0
	dc.h	4
	DC.B	"IFNE",0,0,0,0
	DC.H	4
	DC.B	"IFEQ",0,0,0,0
	DC.H	4
	DC.B	"IFGT",0,0,0,0
	DC.H	4
	DC.B	"IFLE",0,0,0,0
	DC.H	4
	DC.B	"IFLT",0,0,0,0
	DC.H	4
	DC.B	"IFGE",0,0,0,0
	DC.H	4
	dc.b	"ELSE",0,0,0,0
	dc.h	4
	dc.b	"LINK",0,0,0,0
	dc.h	0
	dc.b	"UNLK",0,0,0,0
	dc.h	0
	dc.b	"BCC",0,0,0,0,0
	dc.h	1
	dc.b	"BCS",0,0,0,0,0
	dc.h	1
	dc.b	"BPL",0,0,0,0,0
	dc.h	1
	dc.b	"BMI",0,0,0,0,0
	dc.h	1
	dc.b	"BHI",0,0,0,0,0
	dc.h	1
	dc.b	"BLS",0,0,0,0,0
	dc.h	1
	dc.b	"BVC",0,0,0,0,0
	dc.h	1
	dc.b	"BVS",0,0,0,0,0
	dc.h	1

	dc.b	"BCC.S",0,0,0
	dc.h	1
	dc.b	"BCS.S",0,0,0
	dc.h	1
	dc.b	"BPL.S",0,0,0
	dc.h	1
	dc.b	"BMI.S",0,0,0
	dc.h	1
	dc.b	"BHI.S",0,0,0
	dc.h	1
	dc.b	"BLS.S",0,0,0
	dc.h	1
	dc.b	"BVC.S",0,0,0
	dc.h	1
	dc.b	"BVS.S",0,0,0
	dc.h	1
	dc.b	"BSR.L",0,0,0
	dc.h	1
	dc.b	"DBRA",0,0,0,0
	dc.h	1

	dc.b	"ENDC",0,0,0,0
	dc.h	4
	dc.b	"SET",0,0,0,0,0
	dc.h	7
	dc.b	"CSTRING",0
	dc.h	4
	dc.b	"PSTRING",0
	dc.h	4
	dc.b	"UNTIL",0,0,0
	dc.h	4
	dc.b	"REPEAT",0,0
	dc.h	4

	dc.b	"ALIGN",0,0,0
	dc.h	4

	dc.b	"XDEF",0,0,0,0
	dc.h	3
	dc.b	"XREF",0,0,0,0
	dc.h	3
	dc.b	"DEF",0,0,0,0,0
	dc.h	3
	DC.B	"IFC",0,0,0,0,0
	DC.H	4
	DC.B	"IFNC",0,0,0,0
	DC.H	4
	DC.B	"IFD",0,0,0,0,0
	DC.H	4
	DC.B	"IFND",0,0,0,0
	DC.H	4
	DC.B	"INCLUDEH"
	DC.H	4
	DC.B	"INCLUDE",0
	DC.H	4
	
**new for Anvil
	dc.b	"SECTION",0
	dc.h	4
	dc.b	"TRON",0,0,0,0
	dc.h	4
	dc.b	"TROFF",0,0,0
	dc.h	4
	dc.b	"DEREF",0,0,0
	dc.h	4
	dc.b	"UNTIL_LE"
	dc.h	4
	dc.b	"UNTIL_GT"
	dc.h	4
	dc.b	"BEEP",0,0,0,0
	dc.h	4
	dc.b	"PRINT",0,0,0
	dc.h	4
	dc.b	"GOTOXY",0,0
	dc.h	4
	dc.b	"PAUSE",0,0,0
	dc.h	4
	dc.b	"EQU$",0,0,0,0
	dc.h	4
	dc.b	"LEFT$",0,0,0
	dc.h	4
	dc.b	"MID$",0,0,0,0
	dc.h	4
	dc.b	"RIGHT$",0,0
	dc.h	4
	dc.b	"CONCAT$",0
	dc.h	4
	dc.b	"LEN",0,0,0,0,0
	dc.h	4
	dc.b	"BIN$",0,0,0,0
	dc.h	4
	dc.b	"STR$",0,0,0,0
	dc.h	4
	dc.b	"CHR$",0,0,0,0
	dc.h	4
	dc.b	"CLRLOG",0,0
	dc.h	4
	dc.b	"PRINTLOG"
	DC.H	4
	DC.B	"LOCAL.B",0
	DC.H	7
	DC.B	"LOCAL.H",0
	DC.H	7
	DC.B	"LOCAL.W",0
	DC.H	7
	DC.B	"LOCAL.L",0
	DC.H	7

	dc.w	$0

	align	8
ppc_chroma_words_8: data
	dc.b	"CMPWI",0,0,0
	dc.h	1
	DC.B	"CMPW",0,0,0,0
	DC.H	1
	dc.b	"RTOC)",0,0,0
	dc.h	0

	dc.b	"`BSS)",0,0,0
	dc.h	0

	dc.b	"BLR",0,0,0,0,0
	dc.h	1

	dc.b	"SP)",0,0,0,0,0
	dc.h	0	


***V1.4 add cmp
	dc.b	"CMPI",0,0,0,0
	DC.H	1
	DC.B	"CMPDI",0,0,0
	DC.H	1
	DC.B	"CMPD",0,0,0,0
	DC.H	1
	DC.B	"CMPLI",0,0,0
	DC.H	1
	DC.B	"CMPLWI",0,0
	DC.H	1
	DC.B	"CMPL",0,0,0,0
	DC.H	1
	DC.B	"CMPLW",0,0,0
	DC.H	1
	DC.B	"CMPLD",0,0,0
	DC.H	1	
***END OF 1.4

	DC.B	"BL",0,0,0,0,0,0
	DC.H	1
	dc.b	"B",0,0,0,0,0,0,0
	dc.h	1	
	dc.b	"BNE",0,0,0,0,0
	dc.h	1
	dc.b	"BEQ",0,0,0,0,0
	dc.h	1
	dc.b	"BLT",0,0,0,0,0
	dc.h	1
	dc.b	"BGT",0,0,0,0,0
	dc.h	1
	dc.b	"BGE",0,0,0,0,0
	dc.h	1
	dc.b	"BLE",0,0,0,0,0
	dc.h	1
	dc.b	"BNL",0,0,0,0,0
	dc.h	1
	dc.b	"BNG",0,0,0,0,0
	dc.h	1
	dc.b	"BC",0,0,0,0,0,0
	dc.h	1
**new for Anvil
	dc.b	"BCL",0,0,0,0,0
	dc.h	1
	dc.b	"BCLR",0,0,0,0
	dc.h	1
	dc.b	"BCLRL",0,0,0
	dc.h	1
	dc.b	"BCCTR",0,0,0
	dc.h	1
	dc.b	"BCCTRL",0,0
	dc.h	1

	dc.b	"BNEL",0,0,0,0
	dc.h	1
	dc.b	"BEQL",0,0,0,0
	dc.h	1
	dc.b	"BLTL",0,0,0,0
	dc.h	1
	dc.b	"BGTL",0,0,0,0
	dc.h	1
	dc.b	"BGEL",0,0,0,0
	dc.h	1
	dc.b	"BLEL",0,0,0,0
	dc.h	1
	dc.b	"BNLL",0,0,0,0
	dc.h	1
	DC.B	"BNGL",0,0,0,0
	DC.H	1

	dc.b	"BNELR",0,0,0
	dc.h	1
	dc.b	"BEQLR",0,0,0
	dc.h	1
	dc.b	"BLTLR",0,0,0
	dc.h	1
	dc.b	"BGTLR",0,0,0
	dc.h	1
	dc.b	"BGELR",0,0,0
	dc.h	1
	dc.b	"BLELR",0,0,0
	dc.h	1
	dc.b	"BNLLR",0,0,0
	dc.h	1
	DC.B	"BNGLR",0,0,0
	DC.H	1

	dc.b	"BNECTR",0,0
	dc.h	1
	dc.b	"BEQCTR",0,0
	dc.h	1
	dc.b	"BLTCTR",0,0
	dc.h	1
	dc.b	"BGTCTR",0,0
	dc.h	1
	dc.b	"BGECTR",0,0
	dc.h	1
	dc.b	"BLECTR",0,0
	dc.h	1
	dc.b	"BNLCTR",0,0
	dc.h	1
	DC.B	"BNGCTR",0,0
	DC.H	1
	
	dc.b	"BNELRL",0,0
	dc.h	1
	dc.b	"BEQLRL",0,0
	dc.h	1
	dc.b	"BLTLRL",0,0
	dc.h	1
	dc.b	"BGTLRL",0,0
	dc.h	1
	dc.b	"BGELRL",0,0
	dc.h	1
	dc.b	"BLELRL",0,0
	dc.h	1
	dc.b	"BNLLRL",0,0
	dc.h	1
	DC.B	"BNGLRL",0,0
	DC.H	1
	dc.b	"BNE+",0,0,0,0
	dc.h	1
	dc.b	"BEQ+",0,0,0,0
	dc.h	1

	dc.b	"BNE-",0,0,0,0
	dc.h	1
	dc.b	"BEQ-",0,0,0,0
	dc.h	1

	dc.b	"BGE-",0,0,0,0
	dc.h	1
	dc.b	"BGE+",0,0,0,0
	dc.h	1

	dc.b	"BLE-",0,0,0,0
	dc.h	1
	dc.b	"BLE+",0,0,0,0
	dc.h	1

	dc.b	"BLT-",0,0,0,0
	dc.h	1
	dc.b	"BLT+",0,0,0,0
	dc.h	1

	dc.b	"BGT-",0,0,0,0
	dc.h	1
	dc.b	"BGT+",0,0,0,0
	dc.h	1

	dc.b	"BC",0,0,0,0,0,0
	dc.h	1
	DC.B	"BDNZ",0,0,0,0
	DC.H	1
	
	dc.b	"PEA",0,0,0,0,0
	dc.h	0
	dc.b	"PUSH",0,0,0,0
	dc.h	0
	dc.b	"POP",0,0,0,0,0
	dc.h	0
	dc.b	"DC.B",0,0,0,0
	dc.h	7
	dc.b	"DC.W",0,0,0,0
	dc.h	7
	dc.b	"DC.L",0,0,0,0
	dc.h	7
	dc.b	"DC.H",0,0,0,0
	dc.h	7

	dc.b	"DS.B",0,0,0,0
	dc.h	7
	dc.b	"DS.W",0,0,0,0
	dc.h	7
	dc.b	"DS.H",0,0,0,0
	dc.h	7
	dc.b	"DS.L",0,0,0,0
	dc.h	7


	dc.b	"RS.B",0,0,0,0
	dc.h	7
	dc.b	"RS.H",0,0,0,0
	dc.h	7
	dc.b	"RS.W",0,0,0,0
	dc.h	7
	dc.b	"RS.L",0,0,0,0
	dc.h	7

	DC.B	"REG",0,0,0,0,0
	DC.H	7
	dc.b	"EXTERN",0,0
	dc.h	3
	dc.b	"GLOBAL",0,0
	dc.h	3
	dc.b	"PUBLIC",0,0
	dc.h	3
	dc.b	"EQU",0,0,0,0,0
	dc.h	7
	dc.b	"MACRO",0,0,0
	dc.h	4
	dc.b	"ENDM",0,0,0,0
	dc.h	4
	dc.b	"EVEN",0,0,0,0
	dc.h	4
	dc.b	"DEBUG",0,0,0
	dc.h	5
	dc.b	"ILLEGAL",0
	dc.h	5
	dc.b	"IMPORT",0,0
	dc.h	7

	dc.b	"IF",0,0,0,0,0,0
	dc.h	4
	dc.b	"ENDIF",0,0,0
	dc.h	4
	DC.B	"IFNE",0,0,0,0
	DC.H	4
	DC.B	"IFEQ",0,0,0,0
	DC.H	4
	DC.B	"IFGT",0,0,0,0
	DC.H	4
	DC.B	"IFLE",0,0,0,0
	DC.H	4
	DC.B	"IFLT",0,0,0,0
	DC.H	4
	DC.B	"IFGE",0,0,0,0
	DC.H	4
	
	DC.B	"IFC",0,0,0,0,0
	DC.H	4
	DC.B	"IFNC",0,0,0,0
	DC.H	4
	DC.B	"IFD",0,0,0,0,0
	DC.H	4
	DC.B	"IFND",0,0,0,0
	DC.H	4
	dc.b	"ELSE",0,0,0,0
	dc.h	4
	
	DC.B	"INCLUDEH"
	DC.H	4
	DC.B	"INCLUDE",0
	DC.H	4
	
	dc.b	"ENDC",0,0,0,0
	dc.h	4
	dc.b	"SET",0,0,0,0,0
	dc.h	7
	dc.b	"CSTRING",0
	dc.h	4
	dc.b	"PSTRING",0
	dc.h	4
	dc.b	"UNTIL_NE"
	dc.h	4
	DC.B	"UNTIL_EQ"
	DC.H	4
	dc.b	"REPEAT",0,0
	dc.h	4

	dc.b	"ALIGN",0,0,0
	dc.h	4
**new for Anvil

	dc.b	"SECTION",0
	dc.h	4
	dc.b	"TRON",0,0,0,0
	dc.h	4
	dc.b	"TROFF",0,0,0
	dc.h	4
	dc.b	"DEREF",0,0,0
	dc.h	4
	dc.b	"UNTIL_LE"
	dc.h	4
	dc.b	"UNTIL_GT"
	dc.h	4
	dc.b	"BEEP",0,0,0,0
	dc.h	4
	dc.b	"PRINT",0,0,0
	dc.h	4
	dc.b	"GOTOXY",0,0
	dc.h	4
	dc.b	"PAUSE",0,0,0
	dc.h	4
	dc.b	"EQU$",0,0,0,0
	dc.h	4
	dc.b	"LEFT$",0,0,0
	dc.h	4
	dc.b	"MID$",0,0,0,0
	dc.h	4
	dc.b	"RIGHT$",0,0
	dc.h	4
	dc.b	"CONCAT$",0
	dc.h	4
	dc.b	"LEN",0,0,0,0,0
	dc.h	4
	dc.b	"BIN$",0,0,0,0
	dc.h	4
	dc.b	"STR$",0,0,0,0
	dc.h	4
	dc.b	"CHR$",0,0,0,0
	dc.h	4
	dc.b	"CLRLOG",0,0
	dc.h	4
***

	dc.b	"XDEF",0,0,0,0
	dc.h	3
	dc.b	"XREF",0,0,0,0
	dc.h	3
	dc.b	"DEF",0,0,0,0,0
	dc.h	3
	dc.b	"XCALL",0,0,0
	dc.h	4

	dc.b	"TIDY_UP",0
	dc.h	4
	dc.b	"START_UP"
	dc.h	4
	
	dc.b	"ENTRY",0,0,0
	dc.h	4
	dc.b	"TOC_ROUT"
	dc.h	4
	dc.b	"DEBUGGER"
	dc.h	5
	dc.b	"PRINTLOG"
	DC.H	4
	DC.B	"CMPLDI",0,0
	DC.H	1
	DC.B	"SWG_OFF",0
	DC.H	4
	DC.B	"SWG_LOW",0
	DC.H	4
	DC.B	"SWG_MED",0
	DC.H	4
	DC.B	"SWG_HIGH",0
	DC.H	4
	DC.B	"LOCAL.B",0
	DC.H	7
	DC.B	"LOCAL.H",0
	DC.H	7
	DC.B	"LOCAL.W",0
	DC.H	7
	DC.B	"LOCAL.L",0
	DC.H	7
		
	dc.w	$0
	align 8	
	global	plug_assm_chroma