*******************************************************************************
*Project:       Anvil                                                         *
*Author:        Stu                                                           *
*Filename:      ppc_example.s                                                 *
*Version:       V1.00 (Auto)                                                  *
*Date started:  9:29:23 on 8th May 1997                                       *
*Rev. History:                                                                *
*                                                                             *
*                                                                             *
*******************************************************************************
*A very simple Anvil plug in ppc assm

	
	entry				*must have an entry!
plug_ppc_example:
	mflr r0
	stw r0,8(sp)		*Store link register on the stack
	stmw r10,-88(sp)	*Save r10-r31
	stwu sp,-64+88(sp)	*Skip over the stack space
	lwz r30,(rtoc)		*Load global data (bss) pointer (first entry in TOC)
	stw r2,20(sp)		*Save RTOC;
zero:	reg	r27
bss:	reg	r30				*off to right jump point
**************************************************************
;main	(long argc,*argv) //argv is a sturcture
**Argv (message parameter block) comes in r4, argc (in r3) is ignored
**Set up various bits
	Debug		*so's we can see it working. Comment this out when happy.
	li	`zero,0		*for quick clears
	stw	`zero,our_error_to_anvil(`bss)	*default zero error return
	stw	r4,command_pb(`bss)	*save the pb from Anvil. Our error must go in here on return
	lwz	r5,(r4)	*callback address is first parameter in pb from Anvil
	stw	r5,callback(`bss)	*save it so we can send messages
	lwz	r10,16(r4)	*The Command from Anvil
**Any parameters associated with the command are passed in 20(r4) onwards
**1=init, 2=tidy up, 4=A_itsyou, 6=userchangedprefs etc
**go to right routine to handle command
	cmpwi	r10,A_Init
	beq	do_init
	cmpwi	r10,A_Cleanup
	beq	do_clean_up
	cmpwi	r10,A_Itsyou	*Selected in plug menu? (If this is a plug)
	beq	do_wevebeenselected
	cmpwi	r10,A_Prefschanged
	beq	do_prefs
**any other commands you handle etc
*   ...
**Unknown command
	b	fragment_out
************************************************************
**Handle the command
************************************************************
do_init:
**Check our local initted flag, so we don;t do it more than once :-)
	lwz	r3,we_have_initted(`bss)
	cmpwi	r3,1
	beq	fragment_out			*we've initted already
**Create an UPP so we can call Anvil
	lwz	r3,callback(`bss)	*address of routine (the CCP)
	li	r4,%11000001		*calling convention
	li	r5,0
	Xcall	NewRoutineDescriptor
	stw	r3,Anvil_UPP(`bss)	*our upp for the CCP
**Get a 256 block for our messages to Anvil
	li	r3,256
	Xcall	NewHandleClear
	cmpwi	r3,0
	beq	fault		*need to move this
	stw	r3,my_pb_h(`bss)	*save in a global
	li	r3,1
	stw	r3,we_have_initted(`bss)	*set a flag that tells us we've initted already
	b	fragment_out

*************************************************************
*************************************************************
do_clean_up:
**We don't do anything here in this example
**but you would dispose of any stuff you didn't need anymore
**E.g. a translator ditches any memory it was using during translation
	b	fragment_out
*************************************************************
*************************************************************

**here the user has selected us in the plugs menu, so do whatever you want
**we'll show a dialog with a message in it.
do_wevebeenselected:
**Show user a hi message in a dialog box
**get locked pointer to 256 byte parameter block
	lwz	r3,my_pb_h(`bss)	*handle to 256 bytes
	Xcall	HLock			*important when calling Anvil
	lwz	r20,my_pb_h(`bss)
	lwz	r20,(r20)			*deref handle

**Set up message
	li	r3,A_show_string
	stw	r3,(r20)	*The command to Anvil
	lwz	r3,my_string(rtoc)
	stw	r3,4(r20)	*The string to display
	lwz	r3,my_name(rtoc)
	stw	r3,8(r20)	*The name of this tool for the title of the dialog box
**Call Anvil
	lwz	r3,Anvil_UPP(`bss)		*upp for CCP we made in init.
	li	r4,%11000001			*calling convention
	mr	r5,r20
	Xcall	CallUniversalProc	*go to CCP
	
	lwz	r3,my_pb_h(`bss)	*handle to our 256 byte message block
	Xcall	HUnlock			*be nice

	b	fragment_out
my_string:	cstring	"Testing 123.."
	align
my_name:	pstring	"PPC test plug"
	align

**************************************************************
**************************************************************
do_prefs:	**User changed prefs, so read them and set up
	lis	r3,"my"
	ori	r3,r3,"PF"
	li	r4,128
	Xcall	Get1Resource
	cmpwi	r3,0
	beq	fault		*didn't get resource
	
	mr r21,r3		*handle to prefs
	lwz	r22,(r21)
	lwz	r11,(r22)	*we'll read the first int32 into r11, might be a checkbox for example
**read and act on other prefs as appropriate
**release myPF 128
	mr	r3,r21
	Xcall	ReleaseResource	*must do this, else user won't be able to change prefs anymore!
	b	fragment_out

	
	
************************************************************
*end of processing                                         *
************************************************************

************************************************************
**on error, save it in a global variable, so we can return it
fault:	lwz	r4,callback(`bss)
	stw	r3,our_error_to_anvil(`bss)

**at the end
fragment_out:
	lwz	r3,our_error_to_anvil(`bss)
	lwz	r4,command_pb(`bss)	*the pb from Anvil
	stw	r3,0(r4)			*return error in first entry in parameter block
skip_error:
	lwz r0,64+8+88(sp)	*good bye
	mtlr r0
	addi sp,sp,64+88		*Reset stack pointer
	lmw r10,-88(sp)			*Restore r10-r31
	blr					*back to Anvil
