	include	PM_equates.def
	include	drag.lxt
************************************************************************
*WINDOW CONTROLLER V4.10			       *
*Date: 260795 - SB			       *
************************************************************************
**Checked for volatile regs across OS calls - 2302 040997

**windows are controlled with a window_record.

**Each window record is layed out as follows:
*window_ptr  - 4 bytes - ptr to window record - 0
*scroll_rect - 8 bytes - scroll rectangle     - 4
*view_rect   - 8 bytes  - view rectangle      -12
*te_handle   - 4 bytes  - handle of terecord  -20
*v_scroll_h  - 4 bytes - handle of scroll controller - 24
*current_top - 4 bytes - current top line of window  - 28
*lines_in_folder - 2 bytes - number of lines in view - 32
*Oldclickloop - 4 bytes - the old click procedure - 34
*H_SCROLL_RECT - 8 BYTES - HORIZ SCROLL RECT - 38
*H_SCROLL_H: - 4 BYTES - HANDLE OF H SCROLL CONTROL - 46
*old_word_break: - 4 bytes - address of old wordbreak routine - 50
*FSSpec - 70 bytes
*dirty  - 1 byte
*prefs:	equ	125	byte
*bookmark:	equ	126	long
*t_width:	equ	130	word
*t_state:	equ	132	word

*total       = 134 bytes


AWINDID:	EQU	128	RESOURCE ID NUMBER

DESTRECT:	EQU	0
LINEHIEGHT:	EQU	24
status_height:	equ	14	*how close bottom of text is to status bar
*********************************************************************
**Find window searches windows_records for the active_window_ptr.
**returns d0=-1 if not found, else 0 and a6 -> record
find_window:

	qmove.l	a6,-(sp)	*save in case of fail
	qmove.l	windows_records_h(a5),a6
	qmove.l	(a6),a6
	move.l	active_window(a5),d0
	beq.s	fw_failed	*NO window
	qmove.l	#number_of_windows-1,d1
fw_1:	cmp.l	(a6),d0
	beq.s	got_window_rec
	lea	w_rec_size(a6),a6	*next window_rec
	qdbra	d1,fw_1

fw_failed:
**Now try emergency "get_front_window" ploy
	qmove.l	windows_records_h(a5),a6
	qmove.l	(a6),a6
qmflag:	set	0
	OSFrontWindow	d0
	beq.s	fwf	
	qmoveq	#number_of_windows-1,d1
fw_2:	cmp.l	(a6),d0
	beq.s	got_window_rec
	lea	w_rec_size(a6),a6	*next window_rec
	qdbra	d1,fw_2

fwf:
	qmove.l	(sp)+,a6
	moveq	#-1,d0
	rts_	"fwf"
got_window_rec:
	addq.l	#4,sp			*Current window a6 is on stack
	clr.l	d0
	rts_	"Find_window"		a6 points to record

**Find window external searches windows_records for the external window ref specified in d0.
**returns d0=-1 if not found, else 0 and a6 -> record
find_window_external:
	qmove.l	a6,-(sp)	*save in case of fail
	tst.l	d0
	beq.s	fwe_nf
	qmove.l	windows_records_h(a5),a6
	qmove.l	(a6),a6
	qmoveq	#number_of_windows-1,d1	*check em all
fwe_1:	cmp.l	window_ref(a6),d0
	beq.s	got_window_rece
	lea	w_rec_size(a6),a6	*next window_rec
	qdbra	d1,fwe_1
fwe_nf:
	moveq	#-1,d0
	qmove.l	(sp)+,a6
	rts_	"fwe_nf"
got_window_rece:
	clr.l	d0
	addq.l	#4,sp
	rts_	"Find_window_ext"
	even

**Find window_d0 searches windows_records for d0.
**returns d0=-1 if not found, else 0 and a6 -> record
find_window_d0:	
	qmove.l	a6,-(sp)
	tst.l	d0
	beq.s	fwd_nf	
	qmove.l	windows_records_h(a5),a6
	qmove.l	(a6),a6
	tst.l	d0
	beq	fw_failed	*NO window

	qmove.l	#number_of_windows-1,d1
fw_1d:	cmp.l	(a6),d0
	beq	got_window_rec
	lea	w_rec_size(a6),a6	next window_rec
	qdbra	d1,fw_1d
**not found
fwd_nf:
	qmove.l	(sp)+,a6
	move.l	#-1,d0
	rts_	"Find_window_d0"		a6 points to record

**Count_windows returns number of active windows
count_windows:	
	qmove.l	a6,-(sp)	
	qmove.l	windows_records_h(a5),a6
	qmove.l	(a6),a6
	qmoveq	#0,d0	*window counter
	qmove.l	#number_of_windows-1,d1
fw_1e:	tst.l	(a6)
	beq	no_window
	addq.l	#1,d0
no_window:
	lea	w_rec_size(a6),a6	next window_rec
	qdbra	d1,fw_1e
	
	qmove.l	(sp)+,a6
	rts_	"Find_window_d0"		a6 points to record

**get mem for windows
init_windows:
	qmove.l	#w_rec_size*number_of_windows,d0
	bsr.l	getmem	library function
	qmove.l	d0,windows_records_h(a5)
	bsr.l	lockmem	*we have to lock these else we get all
				*sorts of grief (believe me!)
	clr.w	window_counter(a5)	counter of windows..
	qmove.l	a0,a6
	qmove.l	(a6),a6	*dummy a6 for now
	rts_	"Init_windows"


*******************
set_win_bg_colour:
;not available in carbon
	ifeq	CARBON
	lea	colours(a5),a0
	OSGetAuxWin	d0,a0,d0
	tst.b	d0
	beq.s	no_colours
**colours(a5) now has the handle of the aux win colour table
	qmove.l	colours(a5),a0	      *handle to colour table
	qmove.l	(a0),a0		        	*pointer to colour table
	qmove.l	8(a0),a0		*Handle to actual colour table
	qmove.l	(a0),a0		        	*pointer to colour table - seed, flags, size,table at 8
	lea	white(a5),a1
	qmove.l	(a1)+,10(a0)
	qmove.w	(a1)+,14(a0)	*item 1, item 5 is title bar colour WE WANT
	else
	;d0 contains window ptr
	lea	white(a5),a0
	bsr	set_window_content_colour
;	qmove.l	#15,d1
;	bsr.l	set_theme_window_background
;EXTERN_API( OSStatus )
;SetWindowContentColor           (WindowRef              window,
;                                 const RGBColor *       color);
; 	 lea	 white(a5),a0
; 	 Xcall	 SetWindowContentColor d0,a0,d0
       endif
       
no_colours:
	rts_	"Set_Win_bg_C"
	extern set_window_content_colour
*************************setup list window**********************
	
**needs window ID type in d0. 0=close, 1=closable
**needs d1=size for text		
setup_find_window:
	qmove.l	d1,new_window_handle_size(a5)
	qmove.w	d0,-(sp)
	lea	growbytes(a5),a0
	OSMaxMem	a0,d0
;	lea	growbytes(a5),a0
;	dc.w	_maxmem	compact the heap
	qmove.w	(sp)+,d0

	qmove.l	#-1,old_start(a5)
**Find an empty window slot
	qmove.w	#1,kbd_lock(a5)	lock out kbd (unlocked in activate)
	qmove.l	windows_records_h(a5),a6
	qmove.l	(a6),a6
	qmoveq	#number_of_windows-1,d7	counter
;	subq.l	#1,d7
find_empty_slotf:
	tst.l	0(a6)
	beq.s	w_okf
	add.l	#w_rec_size,a6
	qdbra	d7,find_empty_slotf
fiw_failedf:	 moveq	 #-1,d0	error
	rts_	"Setup_find_window"
	
w_okf:	 qmove.w	d0,-(sp)	 save type

	add.w	#1,window_counter(a5)	
	clr.w	curtop(a6)
**get 256 bytes for wind_rec
;	qmove.l	#256,d0
;	bsr.l	getmem
**handle in a0
;	bsr.l	lockmem
;	qmove.l	(a0),a0
;	qmove.l	a0,d1
	clr.l	d1	;let system allocate memory
;	clr.l	d2
	qcmove.w	(sp)+,d2	get wind type
done_wtypef:
	qcmove.w	#150,d0
	btst	#0,prefs_flags3(a5)	*if black
	beq.s	not_black_finder
	addq.w	#1,d0
not_black_finder:
	qmoveq	#0,d2
	OSGetNewCWindow	d0,d1,d2,d0

;	OSGetNewCWindow	d2,d0,d1,d0
;	CLR.L	-(SP)	this is the debug window
;	move.w	#150,d2
;	btst	#0,prefs_flags3(a5)	*if black
;	beq.s	not_black_finder
;	addq.w	#1,d2
;not_black_finder:
;	MOVE.W	d2,-(SP)	RESOURCE NUMBER
;	move.l	d0,-(sp)	pointer to where record will go
;	clr.l	-(SP)	BEHIND
;	DC.W	_GETNEWCWINDOW
;done_windowf:	
;	move.l	(sp)+,d0
	
	qmove.l	d0,window_ptr(a6)
	qmove.l	d0,active_window(a5)	so we know which is active
	qmove.l	d0,find_window_id(a5)	so sys knows
**set wstate_data_big so we dont have to call movewindow which buggers the state flag
	ifeq	CARBON
	qmove.l	window_ptr(a6),a0
	qmove.l	130(a0),a0	*handle to wstatedata
	qmove.l	(a0),a0
**Std state at 8(a0)
	qmove.w	toolbar_bottom(a5),8(a0)
	add.w	#6,8(a0)
	endif
	
	qmove.w	#2,window_type(a6)
	bsr	set_win_bg_colour			*Set up the BG colour	
	
**first move
;	move.l	window_ptr(a6),-(sp)
	lea	find_rect(a5),a2
	qcmove.w	2(a2),d7
	lea	monitor_rect(a5),a1
**check window isn't off left
	qcmove.w	2(a1),d5
	cmp.w	d5,d7
	bge.s	left_ok1
	clr.l	d7
	qmove.w	d5,d7
left_ok1:
**check window isnt off right
	qcmove.w	6(a1),d5
	cmp.w	d5,d7
	ble.s	right_ok1
	clr.l	d7
	qmove.w	d5,d7
	sub.w	#500,d7
right_ok1:
	qmove.l	d7,d1
	qmoveq	#0,d2
	qcmove.w	(a2),d2
	qmove.l	window_ptr(a6),d0
;	move.w	d7,-(sp)		*left
;	move.w	0(a2),-(sp)		*top
;	clr.b	-(sp)		*front
;	dc.w	_movewindow
	qmoveq	#0,d3
	OSMoveWindow	d0,d1,d2,d3
**now size

;	move.l	window_ptr(a6),-(sp)
	lea	find_rect(a5),a1	
	qcmove.w	6(a1),d1		*right
	sub.w	2(a1),d1		*-left=width
;	move.w	d0,-(sp)
	qcmove.w	4(a1),d2		*bott
	sub.w	(a1),d2		*-top=height
	qmoveq	#0,d3
	qmove.l	window_ptr(a6),d0
	OSSizeWindow	d0,d1,d2,d3

;	move.l	window_ptr(a6),-(sp)
;	dc.w	_showwindow
	qmove.l	window_ptr(a6),d0
	OSShowWindow	d0
	qmove.w	#0,kbd_lock(a5)	enable keys

	qmove.l	window_ptr(a6),d0
	OSSetPortWindowPort	  d0
	qmove.l	#font_number,d0
	OSTextFont	d0
	qcmove.w	font_size(a5),d0
	OSTextSize	d0
	qmove.l	#1,d0
	OSTextMode	d0

**COPY PORT RECT TO vSCROLLRECT
	extern	get_windowrect_local_coords
	qmove.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	

	lea	carbon_temp_rect(a5),a0

;	lea	portrect(a0),a0	point to portrect
	lea	h_scroll_rect(a6),a3	horiz scroll
	lea	scroll_rect(a6),a1
	lea	view_rect(a6),a2	
	qmove.l	(a0),(a1)
	qmove.l	4(a0),4(a1)	copy port to vscroll
**and to h scroll
	qmove.l	(a0),(a3)	topleft
	qmove.l	4(a0),4(a3)	bottom right
**and to viewrect
	qmove.l	(a0),(a2)
	qmove.l	4(a0),4(a2)	and viewrect
**calc h scroll control size
	qcmove.w	bottom(a3),d0
	sub.w	#sbarwidth,d0
	qmove.w	d0,top(a3)
	sub.w	#sbarwidth-1,right(a3)
	cmpi.w	#1,window_type(a6)
	bne.s	skip_labs1
	sub.w	#16,right(a3)	*a10
**calc scroll bar size
skip_labs1:
	qcmove.w	right(a1),d0	right
	sub.w	#sbarwidth,d0	-15
	qmove.w	d0,left(a1)	set left=right-15
	sub.w	#sbarwidth-1,bottom(a1)	
**SET NEW CONTROL FOR V SCROLL
;	OSNewControl	window_ptr(a6),scroll_rect(a6),null_string(pc),#1,#0,#0,#0,#16,v_scroll_h(a6)
	
;	 CLR.L	 -(sp)
	qmove.l	window_ptr(a6),d0
	lea	scroll_rect(a6),a0
	qmove.l	a0,d1
	lea	EWnull_string(pc),a1
	qmove.l	a0,d2
	qmove.l	#1,d3
	qmove.l	#0,d4
	qmove.l	d4,d5
	qmove.l	d4,d6
	qmoveq 	#16,d7
	OSNewControl	d0,d1,d2,d3,d4,d5,d6,d7,d0
	qmove.l	d0,v_scroll_h(a6)	
;	clr.l	-(sp)
;	 DC.W	 _NEWCONTROL
;	 move.l	(sp)+,v_scroll_h(a6)
	cmpi.w	#"PJ",window_type(a6)
	beq.s	no_h4

**SET NEW CONTROL FOR H SCROLL
;	OSNewControl	window_ptr(a6),h_scroll_rect(a6),null_string(pc),#1,#0,#0,#KMAXDOCWIDTH/2,#16,h_scroll_h(a6)
;	 CLR.L	 -(SP)
	qmove.l	window_ptr(a6),d0
	lea	h_scroll_rect(a6),a0
	qmove.l	a0,d1
	lea	EWnull_string(pc),a1
	qmove.l	a1,d2
	qmove.l	#1,d3
	qmove.l	#0,d4
	qmove.l	d4,d5
	qmove.l	d4,d6
	qmoveq 	#16,d7
	OSNewControl	d0,d1,d2,d3,d4,d5,d6,d7,d0
	move.l	d0,h_scroll_h(a6)	
;	clr.l	-(sp)
;	 DC.W	 _NEWCONTROL
	
;	MOVE.L	(SP),H_SCROLL_H(a6)
;	MOVE.W	#KMAXDOCWIDTH/2,-(SP)
;	DC.W	_SETCTLMAX
no_h4:
**NOW GET TE HANDLE
	qmove.l	#20000,d0
	OSNewHandleClear	d0,a0
	move.l	a0,d0
	beq	no_text_mem_f
	clr.l	-(sp)
	pea	view_rect(a6)
	pea	view_rect(a6)
	bsr	new_tenew	needs handle to buffer in a0
	
	qmove.l	(sp)+,te_handle(a6)
	tst.l	te_handle(a6)	if tenew failed
	beq	no_text_mem_f	then error
	qmove.l	te_handle(a6),d0
	OSMoveHHi	d0
;	move.l	te_handle(a6),a0
;	dc.w	_moveHHi
	qmove.l		te_handle(a6),d0
	OSHLock	d0
;	move.l	te_handle(a6),a0
;	dc.w	_hlock					*ONCE AND FOR ALL!
	qmove.l	te_handle(a6),a0
	qmove.l	(a0),te_handle_ptr(a6)	      *Faster Eddie!
	lea	growbytes(a5),a0
	OSMaxMem	a0,d0
;	dc.w	_purgespace	see if we've over cooked it!
;	move.l	a0,d0	contig
	cmpi.l	#40*1024,d0
	ble	no_text_mem_f
	qmove.l	te_handle(a6),-(sp)
	bsr	new_teactivate
	
	qmove.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0	record
	qmove.l	ed_clikloop(a0),old_click_loop(a6)	save off old pointer
	lea	my_click(pc),a1
	qmove.l	a1,ed_clikloop(a0)	insert our click proc
	bsr.l	draw_grow
	clr.b	dirty(a6)
	lea	w_fsspec(a6),a3	point to FSSpec
	clr.l	(a3)
**Now copy name into FSspec
	qmove.l	window_ptr(a6),d0
	lea	temp_string(a5),a1
	OSGetWTitle	d0,a1
;	move.l	window_ptr(a6),-(sp)
;	pea	temp_string(a5)
;	dc.w	_getWtitle
	lea	w_fsspec(a6),a3	point to FSSpec
	lea	temp_string(a5),a0
;	clr.l	d0
	qcmove.b	(a0),d0
;	lea	6(a3),a3	point to Name
	addq.l	#6,a3

cnlf:	qmove.b	(a0)+,(a3)+
	qdbra	d0,cnlf
	clr.l	bookmark(a6)
	clr.w	chroma_state_w(a6)	*USE no chroma! - 1.6
	qmove.w	#8,tab_width_w(a6)	*Oops
	qmove.l	window_ptr(a6),a0
	bsr.l	setview
;	 bsr	 adjust_menus
	qmove.l	window_ptr(a6),d0
	OSSelectWindow	d0
;	move.l	window_ptr(a6),-(sp)
;	dc.w	_selectwindow		*bring to front
	clr.l	d0	
	rts_	"setup_find_window"
	
	even
no_text_mem:

	qmove.l	active_window(a5),temp_string(a5)	*save windptr in case newmem fails	 
	qmove.l	temp_string(a5),active_window(a5)
	bsr	close_window_999	emergency close the wind we opened.
	clr.l	active_window(a5)	*prevent updates
	lea	mem_fail_w(pc),a0
	qmove.l	#1000,d0
	qmoveq	#60,d1	x
	qmoveq	#90,d2	y
	bsr.l	do_alert_3d_no_updates
	OSFrontWindow	d0
	qmove.l	d0,active_window(a5)

;	clr.l	-(sp)
;	dc.w	_frontwindow
;	move.l	(sp)+,active_window(a5)
	lea	growbytes(a5),a0
	OSMaxMem	a0,d0
;	lea	growbytes(a5),a0
;	dc.w	_maxmem
	clr.w	new_window_type(a5)
	moveq	#-2,d0

	rts_	"Set_up_find_window_failed"
	EVEN
no_text_mem_f:
	clr.l	find_window_id(a5)	so sys knows
	bra	no_text_mem
**************
get_window_number:			*not used
	qmove.l	windows_records_h(a5),a1
	qmove.l	(a1),a1
	qmove.l	#0,d0	*counter
	qmoveq	#number_of_windows-1,d1
	qmove.l	window_ptr(a6),d2
gwn_loop:	cmp.l	(a1),d2
	beq.s	got_windy
	addq.l	#1,d0
	lea	w_rec_size(a1),a1	next window_rec
	qdbra	d1,gwn_loop
	moveq	#-1,d0
got_windy:	rts_	"Get_Window_No."
	even
	
*****************my_click
**THis routine is called when we are selecting text in window and scroll
**This routine controls the scroll bars when doing so. - NOT USED
my_click:	rts_	"My_wordbreak"
	even

***Setctrl sets the vertical controller value to the current INSERTION VALUE
**This is the call back proc for teclick as well :-)
setctrl:
	cmpi.w	#"PJ",window_type(a6)
	beq	proj!

	bsr	find_window
	qmove.l	0(a6),a4
	OSSetPortWindowPort	  a4
	qmove.l	(a6),a0
	bsr.l	get_windowrect_local_coords
;	OSGetWindowPort a4,a4
	
;	move.l	a4,-(sp)
;	dc.w	_setport
	OSNewRgn	a3
;	clr.l	-(sp)
;	dc.w	_newrgn
;	move.l	(sp)+,a3	get handle

	OSGetClip	a3	
;	move.l	a3,-(Sp)
;	dc.w	_getclip	set up clip

;	lea	0x10(a4),a0
	lea	carbon_temp_rect(a5),a0
	OSClipRect	a0	
;	pea	$10(a4)	portrect
;	dc.w	_Cliprect	to window port size
	
**
	bsr	find_window	

	qmove.l	te_handle_ptr(a6),a0
	
	qcmove.w	ed_nlines(a0),d0	lines
	qmove.l	ed_htext(a0),a1	htext
	qmove.l	(a1),a1	text
	move.l	ed_telength(a0),d3
	beq.s	not_cr_last
	add.l	d3,a1	eot
	cmpi.b	#13,-1(a1)	if ends in cr
	bne.s	not_cr_last
	addq.l	#1,d0	lines=lines-1
not_cr_last:	
**Calc page height
	qcmove.w	ed_scroll_v_b(a0),d1
	sub.w	ed_scroll_v_t(a0),d1
	sub.w	d1,d0	*lines in a page
	bge.s	ctl_ok
	qmoveq	#0,d0
ctl_ok:	clr.l	d3
	qmove.w	d0,d3	copy max
	qmove.l	v_scroll_h(a6),d1	
	exg	d1,d0
	OSSetMaxCtl	d0,d1
;	move.l	v_scroll_h(a6),-(sp)
;	move.w	d0,-(sp)
;	dc.w	_setmaxctl	can move memory

	qmove.l	te_handle_ptr(a6),a0	hence...
;	move.l	(a0),a0
	
	qcmove.w	ed_scroll_v_t(a0),d0	(viewrect.top
**NOw add on cursor pos - convert to line
vallt:	
	qmove.l	v_scroll_h(a6),d1
	exg	d0,d1
	OSSetCtlValue	d0,d1
;	MOVE.L	V_SCROLL_h(a6),-(SP)
;	MOVE.W	d0,-(SP)
;	DC.W	_SETCTLVALUE
	qmove.l	v_scroll_h(a6),d0
	qmove.l	#0,d1
	OSHiliteControl	d0,d1

	qmove.l	v_scroll_h(a6),d0
	OSShowControl	d0
;	clr.l	d1
;	qmove.l	v_scroll_h(a6),d0
;	OSHiliteControl	d0,d1
;	move.l	v_scroll_h(a6),-(sp)
;	dc.w	_showcontrol
	
***now we have to check for horiz scrolling
	cmpi.w	#"PJ",window_type(a6)
	beq	no_h2

	qmove.l	te_handle_ptr(a6),a0	hence...
;	move.l	(a0),a0
	qcmove.w	ed_scroll_h_l(a0),d0
val_h_ok:	cmpi.l	#kmaxdocwidth/2,d0
	ble.s	max_h_ok
	qmove.l	#kmaxdocwidth/2,d0
max_h_ok:
**calc h right
;	clr.l	d1
	qcmove.w	ed_viewrect+6(a0),d1	right
	sub.w	ed_viewrect+2(a0),d1	left

	qbsr	get_width
	divs	d3,d1
	andi.l	#$ffff,d1
;	clr.l	d2
	qcmove.w	ed_scroll_h_l(a0),d2
	add.w	d1,d2
	qmove.w	d2,ed_scroll_h_r(a0)
	move.l	h_scroll_h(a6),d1
	exg	d0,d1
	OSSetCtlValue	d0,d1	
;	move.l	h_scroll_h(a6),-(sp)
;	move.w	d0,-(sp)
;	dc.w	_setctlvalue
	qmove.l	v_scroll_h(a6),d0
	qmove.l	#0,d1
	OSHiliteControl	d0,d1
	qmove.l	h_scroll_h(a6),d0
	OSShowControl	d0
;	clr.l	d1
;	qmove.l	h_scroll_h(a6),d0
;	OSHiliteControl	d0,d1

;	move.l	h_scroll_h(a6),-(sp)
;	dc.w	_showcontrol
no_h2:
	OSSetClip	a3	
;	move.l	a3,-(sp)
;	dc.w	_setclip
	OSDisposeRgn	a3
;	move.l	a3,-(sp)
;	dc.w	_Disposergn
proj!:	rts_	"Setctrl"

	
***************************************************************
asetvscroll:	bsr	find_window
	bmi.s	no_setscroll

	qmove.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	qcmove.w	ed_nlines(a0),d0	nlines
	
	qmove.l	ed_htext(a0),a1	htext
	qmove.l	(a1),a1	text
	move.l	ed_telength(a0),d3
	beq.s	not_cr_last1	;prevent an access violation in carbon
	
	add.l	d3,a1	eot
	cmpi.b	#13,-1(a1)	if ends in cr
	bne.s	not_cr_last1
	addq.l	#1,d0	lines=lines+1
not_cr_last1:	
	
	sub.w	lines_in_folder(a6),d0
;	tst.w	d0
	bge.s	alinesok
	qmoveq	#0,d0
alinesok:
	qmove.l	v_scroll_h(a6),d1
	exg	d0,d1
	OSSetMaxCtl	d0,d1
;	MOVE.L	V_SCROLL_h(a6),-(SP)
;	MOVE.W	d0,-(SP)
;	DC.W	_SETMAXctl
no_setscroll:	clr.l	d0
	rts_	"setvscl"

	
***************************************************************
*******************************************************************************
ide_wind_update:
	bsr	find_window	get current window ptr
;	tst.w	d0
	bge.s	wind_update
	rts_	"ide_wind_update"
wind_update:

	bsr	find_window_d0	get record for this windowptr
	tst.w	d0
	bge.s	aupdate_1
	rts_	"wind_update"
	
aupdate_1:

;	MOVE.L	window_ptr(a6),-(SP)	do_content enters here
;	DC.W	_SETPORT
	qmove.l	window_ptr(a6),d0
	OSSetPortWindowPort	  d0
	qmove.l	#font_number,d0	*Anv2.2
	OSTextFont	d0
	qcmove.w	font_size(a5),d0
	OSTextSize	d0
	qmove.l	#1,d0
	OSTextMode	d0

	qmove.l	window_ptr(a6),d0
	OSBeginUpdate	d0
;	MOVE.L	window_ptr(a6),-(SP)
;	DC.W	_BEGINUPDATE
	qmove.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	


	lea	carbon_temp_rect(a5),a0

;	lea	portrect(a0),a0
	OSClipRect	a0
;	pea	portrect(a0)
;	dc.w	_cliprect

	lea	white(a5),a0
	OSRGBBackColor	a0
;	pea	white(a5)
;	dc.w	_rgbbackcolor

***********
**redraw status frame
	qmove.l	te_handle_ptr(a6),a0
	qmove.l	a0,-(sp)
	
;	move.l	ed_inport(a0),a2
;	pea	$10(a2)	clip to portrect
;	dc.w	_cliprect
	cmpi.w	#"PJ",window_type(a6)
	beq.s	not_update_proj	*file - project_window.s

	qmove.l	(sp),a0
;	qmove.l	ed_inport(a0),a2
;	move.l	(a6),a2
;	lea	carbon_temp_rect(a5),a1
;	OSGetPortBounds	a2,a1
;	lea	carbon_temp_rect(a5),a0
;	qmove.l	24(a2),d0
;	OSEraseRgn	a0
not_update_proj:


	qmove.l	(sp),a0	*te handle ptr
**calc status rect
;	lea	EWstatus_rect(pc),a1
;	move.l	ed_inport(a0),a2
;	add.l	#$10,a2	port rect
;	move.w	bottom(a2),0(a1)	top y
;	move.w	left(a2),2(a1)	      left
;	move.w	right(a2),6(a1)	right
;	move.w	0(a1),4(a1)	top to bottom
;	sub.w	#sbarwidth,4(a1)	correct bottom
;	sub.w	#sbarwidth+13,0(a1)	correct top	
;	sub.w	#sbarwidth,6(a1)	right+4
;
;	tst.w	dialog_active(a5)
;	bne	skip_bar	*dont draw if dialog active
	
;	tst.w	in_background(a5)	 
;	beq		skip_bar	dont draw if in BG

not_in_bg:
;	qmove.l	active_window(a5),d0
;	cmp.l	window_ptr(a6),d0
;	bne.s	done_fill	*these three may need to be left in


do_grey:
;	move.w	#1,stat_now(a5)
;	bsr	do_status_line_update

**erase cd rect
;	bsr	erase_cd_display	*also unlocks tehandle
;	bsr.l	clear_delta_values
	addq.l	#4,sp	*old pointer
	qmove.l	te_handle_ptr(a6),a0
	qmove.l	a0,-(sp)
	qmove.l	ed_inport(a0),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	

	lea	carbon_temp_rect(a5),a0
;	lea	0x10(a2),a0
	OSClipRect	a0
;	pea	$10(a2)	clip to portrect
;	dc.w	_cliprect
	OSFrontWindow	d0
	cmp.l	window_ptr(a6),d0
	beq.s	draw_fg_ctrls	*dont do if not front window

	bsr.l	draw_grow_bgd
	cmpi.w	#"PJ",window_type(a6)
	beq.s	no_h32
	qmove.l	h_scroll_h(a6),d0
	qmove.l	#255,d1
	OSHiliteControl	d0,d1
no_h32:
	qmove.l	v_scroll_h(a6),d0
	qmove.l	#255,d1
	OSHiliteControl	d0,d1
	bra.s	done_wctrls

draw_fg_ctrls:
	bsr.l	draw_grow
	cmpi.w	#"PJ",window_type(a6)
	beq.s	no_h31
	qmove.l	h_scroll_h(a6),d0
	qmove.l	#0,d1
	OSHiliteControl	d0,d1
no_h31:
	qmove.l	v_scroll_h(a6),d0
	qmove.l	#0,d1
	OSHiliteControl	d0,d1

done_wctrls:


done_fill:	move.l	(sp),a0
;	qmove.l	ed_inport(a0),a2
;	lea	0x10(a2),a0
	qmove.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	


	lea	carbon_temp_rect(a5),a0

;	lea	portrect(a0),a0
	OSClipRect	a0
;	pea	$10(a2)	clip to portrect
;	dc.w	_cliprect

	lea	black(a5),a0
	OSRGBForeColor	a0
;	pea	black(a5)
;	dc.w	_rgbforecolor
	qmove.l	(sp),a0
**do normal update stuff	

	qmove.l	v_scroll_h(a6),d0
	OSDraw1Control	d0
;	MOVE.L	v_scroll_h(a6),-(SP)
;	DC.W	_DRAW1CONTROL
	cmpi.w	#"PJ",window_type(a6)
	beq.s	no_h18
	qmove.l	h_scroll_h(a6),d0
	OSDraw1Control	d0
no_h18:
;no_scrollies_in_bg:
	qmove.l	(sp)+,a0
no_mess:
	
sb_ent:	
	qmove.l	ed_inport(a0),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	

	lea	carbon_temp_rect(a5),a0
;	lea	0x10(a2),a0
	OSClipRect	a0
;	pea	$10(a2)	clip to portrect
;	dc.w	_cliprect
	lea	black(a5),a0
	OSRGBForeColor	a0
	qmove.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	


	lea	carbon_temp_rect(a5),a0
;	lea	portrect(a0),a0
	OSClipRect	a0

	qmove.l	#font_number,d0	*Anv2.2
	OSTextFont	d0
	qcmove.w	font_size(a5),d0
	OSTextSize	d0
	qmove.l	#1,d0
	OSTextMode	d0

;	pea	portrect(a0)
;	dc.w	_cliprect


	qmove.l	a6,-(sp)	*must save this!
	qmove.l	window_ptr(a6),a0	*come here if dialog_active
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	


	
	pea	carbon_temp_rect(a5)
	
;	pea	portrect(a0)
	qmove.l	te_handle(a6),-(sp)
	bsr	new_teupdate
	qmove.l	(sp)+,a6
	qmove.l	window_ptr(a6),d0
	OSEndUpdate	d0
;	MOVE.L	WINDow_PTR(a6),-(SP)
;	DC.W	_ENDUPDATE
;	tst.w	in_background(a5)
;	beq.s	no_DONT_DO_IT!
;	move.l	arrow_curs_h(a5),-(sp)
;	dc.w	_setccursor
;no_dont_do_it!:
	clr.l	d0
no_update
	qmove.l	te_handle(a6),a0
	rts_	"wind_update"
skip_bar:

	qmove.l	(sp)+,a0	*1.6 removes  icon
	bra	sb_ent
	

;draw_grow_bgd:
;	 move.l	window_ptr(a6),a0
;	 lea	 portrect(a0),a0
;	 lea	 grow_rect(pc),a1
;	 move.l	(a0),(a1)
;	 move.l	4(a0),4(a1)
;	 
;	 move.w	4(a1),(a1)	 bot to top
;	 sub.w	 #sbarwidth,(a1)	top
;	 move.w	6(a1),2(a1)	 right to left
;	 sub.w	 #sbarwidth,2(a1)	 new left
;	 debug	 
;	 clr.l	 -(sp)
;	 move.w	#129,-(sp)
;	 dc.w	 $aa1e	getcicon
;	 move.l	(sp)+,d7	 handle
;	 beq.s	 no_mem_for_icon	
;	 clr.l	 -(sp)
;	 pea	 grow_rect(pc)
;	 move.l	d7,-(sp)
;	 dc.w	 $aa1f
;	 move.l	(sp)+,d0
;	 
;	 clr.l	 -(sp)
;	 move.l	d7,-(sp)
;	 dc.w	 $aa25
;	 move.l	(sp)+,d0
;no_mem_for_icon:
;	 rts_	 "DR_grow_BG"


**needs windowptr in d0
find_window_U:	move.l	windows_records_h(a5),a6
	qmove.l	(a6),a6

	move.w	window_counter(a5),d1
	beq.s	fwu_failed	no windows!
fwu_1:	cmp.l	(a6),d0
	beq.s	got_window_recu
	lea	w_rec_size(a6),a6	next window_rec
	dbra	d1,fwu_1
fwu_failed:	moveq	#-1,d0
	rts_	"fwu_failed"
got_window_recu:
	clr.l	d0
	rts_	"Find_windowU"


*********************************************************************************
**NEEDS CODE IN d0
**assumes a6 points to current window record
**this is a call back proc for the scroll bar controller.
**we need a4 to point to the window record, so we get it from
**callback_rec_store
	if	PPC
vscrollproc:	toc_routine
	else
vscrollproc:
	endif
	if	PPC
	mflr	r5
	stwu	r5,-4(sp)	*push rts onto stack
	save_all
cw1:	set	check_writes	*Gotta switch off check_writes here
check_writes:	set	0
	qmove.l	d0,a0	*Control handle, code in d0
	qmove.l	d1,d0	*The item
	qpush1	a0
	lea	a5_store(pc),a0
	qmove.l	(a0),a5		*Get our a5!
check_writes:	set	cw1
	qmove.l	4(a0),a6	*and our a6
	qpop1	a0
	else
	move.l	(sp)+,d1
	move.w	(sp)+,d0	the code (c params)
	move.l	(sp)+,a0	*the control
	move.l	d1,-(sp)
	save_all
	endif
	save_all
	qmove.l	(a6),a0
	OSSetPortWindowPort	a0
	qmove.l	(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0
;	lea	0x10(a1),a0
	OSClipRect	a0
	restore_all
	tst.w	d0
	beq	vscroll_quit	*v1.61 changes

**treat as an interupt routine!
**pagesize = ((**teh).viewrect.bottom-(**teh).viewrect.top) / (**teh).lineheight - 1;
acode_ok:
;	movem.l	d3/a3-a6,-(sp)	     save
;	save_all	
	qmove.l	callback_rec_store(pc),a6	get record pointer
	qmove.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0	**teh
;	clr.l	d1
;	clr.l	d2
	qcmove.w	ed_scroll_v_b(a0),d1
	qcmove.w	ed_scroll_v_t(a0),d2
	sub.l	d2,d1	d1=pagesize
	clr.l	d5
	qmove.w	d1,d5	save page size
**case inupbutton: 
**	scrollamt = -1;
**	break;
	qmove.l	#0,d2
	cmpi.w	#20,d0
	bne.s	not_a_up
	cmp.w	#0,ed_scroll_v_t(a0)
	beq	hit_bottom
	qmoveq	#-1,d2	scrollamt
	bra.s	got_amt
not_a_up:	cmpi.w	#21,d0
	bne.s	not_a_dn
;	clr.l	d2
	qcmove.w	ed_nlines(a0),d2
	addq.l	#1,d2			*watch this one!
	cmp.w	ed_scroll_v_b(a0),d2
	beq	hit_bottom

	qmove.l	#1,d2
	bra.s	got_amt
not_a_dn:	cmpi.w	#22,d0	page up
	bne.s	not_a_pu
	clr.l	d2
	qmove.w	d1,d2	page size
	neg.w	d2	-scrollamt
	bra.s	got_amt
not_a_pu:	cmpi.w	#23,d0
	bne.s	got_amt
	clr.l	d2
	qmove.w	d1,d2	page size

**	oldctl = getctlvalue(thecontrol);
got_amt:
	
	qmove.w	d2,-(sp)	save amount
	qmove.l	v_scroll_h(a6),d0
	OSGetCtlValue	d0,d1
;	CLR.W	-(SP)
;	MOVE.L	V_SCROLL_h(a6),-(SP)
;	DC.W	_GETCTLVALUE	get current ctl value (top of page value)
;	MOVE.W	(SP)+,d1	CONTROLLER VALUE

	qcmove.w	(sp),d2
**	setctlvalue(thecontrol, oldctl+scrollamt);
	
	add.w	d2,d1	oldctl+scrollamt
	bge.s	top_ok	stop control going -ve!
	qmove.l	#0,d1
top_ok:
bot_ok:	
	andi.l	#0xffff,d1
	qmove.l	#0,d7
	qmove.w	d1,d7	save ctrl value (new)
	qmove.l	v_scroll_h(a6),d0
	OSSetCtlValue	d0,d1
;	MOVE.L	V_SCROLL_h(a6),-(SP)
;	MOVE.W	d1,-(SP)
;	DC.W	_SETCTLVALUE	set new control value
	qcmove.w	(sp)+,d2	*lets not go in with a misaligned stack!

	qmove.l	d2,-(sp)
	qmove.l	te_handle(a6),-(sp)
	qmove.w	d2,-(sp)	v amount
	clr.w	-(sp)	h amount
	qmove.w	d7,-(sp)	controller value
	bsr.l	new_te_scroll
;	debug
	qmove.l	(sp)+,d2
	cmpi.w	#1,d2	*if delta was +-1, then do highlight
	bgt.s	hit_bottom
	cmpi.w	#-1,d2
	blt.s	hit_bottom
	bsr.l	check_for_highlight
hit_bottom:
;	movem.l	(sp)+,d3/a3-a6	     restore a4
;	restore_all
vscroll_quit:
	restore_all
	if	PPC
	rts
	else	
;	move.l	d1,a0
;	jmp	(a0)
	rts_	"vscrlproc"
	endif
**this is a call back proc for the scroll bar controller.
**we need a4 to point to the window record, so we get it from
**callback_rec_store
	if	PPC
hscrollproc:	toc_routine
	else
hscrollproc:
	endif
	if	PPC
	mflr	r5
	stwu	r5,-4(sp)	*push rts onto stack
cw1:	set	check_writes	*Gotta switch off check_writes here
check_writes:	set	0
	move.l	d0,a0	*Control handle, code in d0
	qmove.l	d1,d0	*The item
	save_all
	push	a0
	lea	a5_store(pc),a0
	move.l	(a0),a5		*Get our a5!
check_writes:	set	cw1
	move.l	4(a0),a6	*and our a6
	pop	a0
	else
	move.l	(sp)+,d1
	move.w	(sp)+,d0	the code (c params)
	move.l	(sp)+,a0	*the control
	move.l	d1,-(sp)
	save_all
	endif
	tst.w	d0
	beq	hscroll_quit

**note we use seprate routines for each control in an attempt to keep the 
**speed up (everybody else uses multipurpose routines)

**treat as an interupt routine!
hcode_ok:
	save_all
	move.l	callback_rec_store(pc),a6	get record pointer
	move.l	te_handle_ptr(a6),a0

**case inleft button: 
**	scrollamt = -1;
**	break;
	qmove.l	#0,d2
	cmpi.w	#20,d0
	bne.s	not_left
**check if we're at zero already
	tst.w	ed_scroll_h_l(a0)
	beq	max_left
	qmoveq	#-4,d2	scrollamt
	bra.s	got_amth
not_left:	cmpi.w	#21,d0
	bne.s	not_right
	qmoveq	#4,d2
	bra.s	got_amth
not_right:
	cmpi.w	#22,d0	page left
	bne.s	not_pleft
;	clr.l	d2
	qcmove.w	ed_viewrect+6(a0),d2	right
	sub.w	ed_viewrect+2(a0),d2	hpage
	qbsr	get_width	get font width in d3
	divs	d3,d2
	andi.l	#$ffff,d2
	neg.w	d2	-ve sil vous plait
	bra.s	got_amth
not_pleft:	cmpi.w	#23,d0
	bne.s	got_amth
;	clr.l	d2
	qcmove.w	ed_viewrect+6(a0),d2	right
	sub.w	ed_viewrect+2(a0),d2	hpage
	qbsr	get_width	get font width in d3
	divs	d3,d2

**	oldctl = getctlvalue(thecontrol);
got_amth:
	qmove.w	d2,-(sp)
	qmove.l	h_scroll_h(a6),d0
	OSGetCtlValue	d0,d1
;	CLR.W	-(SP)
;	MOVE.L	H_SCROLL_h(a6),-(SP)
;	DC.W	_GETCTLVALUE
;	MOVE.W	(SP)+,d1	CONTROLLER VALUE
	
	qcmove.w	(sp)+,d2	*number of chars
**	setctlvalue(thecontrol, oldctl+scrollamt);
	add.w	d2,d1	oldctl+scrollamt
	bge.s	new_ok
**here new value is less than zero, so we need to alter delta accordingly.
**asssume d1 was  5 and delta is -10. 5+-10=-5, so invert new, and add to delta=
**_-5=5. -10+5=-5
	neg.w	d1
	add.w	d1,d2	just like the old days...
	qmoveq	#0,d1
new_ok:	cmpi.w	#kmaxdocwidth/2,d1
	ble.s	max_ok
**here new value is greater than max, so we need to alter delta accordingly.
**assume d1 was 165., max is 170 and delta is 10. 165+10=175. so subtract max from new
**to give new delta.
	sub.w	#kmaxdocwidth/2,d1
	sub.w	d1,d2
	qcmove.w	#kmaxdocwidth/2,d1
max_ok:	movem.w	d1/d2,-(sp)	save amount
	qmove.l	h_scroll_h(a6),d0
	OSSetCtlValue	d0,d1

;	MOVE.L	H_SCROLL_h(a6),-(SP)
;	 MOVE.W	d1,-(SP)
;	 DC.W	 _SETCTLVALUE
**now calc left and right values from window width and control value
	movem.w	(sp)+,d1/d2	get amount back

**d2 is scroll delta either +/-, from this we can adjust the cursor
;	move.l	a4,a6	*a6->windowrec

	move.l	te_handle_ptr(a6),a0

	clr.l	d6
	qmove.w	d2,d6
	neg.w	d6	invert direction
	qbsr	get_width
	muls	d3,d6	get as a pix off
	add.w	d6,ed_curs_x(a0)	adjust x curs
	add.w	d2,ed_scroll_h_l(a0)	d2 will be -ve
	tst.w	ed_scroll_h_l(a0)
	bge.s	left_ok
	clr.w	ed_scroll_h_l(a0)
left_ok:	cmp.w	#kmaxdocwidth/2,ed_scroll_h_l(a0)	comp right with max
	ble.s	right_ok
	qmove.w	#kmaxdocwidth/2,ed_scroll_h_l(a0)
right_ok:
**now update right hand side so we know when to autoscroll :-) (tit stu!)
;	clr.l	d0
	qcmove.w	ed_viewrect+6(a0),d0	right rect
	sub.w	ed_viewrect+2(a0),d0	-left rect
	
	divs	d3,d0	char width
	andi.l	#$ffff,d0
	add.w	ed_scroll_h_l(a0),d0	+left
	qmove.w	d0,ed_scroll_h_r(a0)	=right
	
	qmove.l	a0,d7
;	debug
	OSNewRgn	a3
	qmove.l	d7,a0
	lea	ed_viewrect(a0),a0

**a0=rect, d6=pix amount

	qmove.l	#0,d2	*y amount
	OSScrollRect	a0,d6,d2,a3
;	OSEraseRect	a0
;	pea	ed_viewrect(a0)
;	dc.w	_eraserect
;	OSInvalRgn	a3
	push	a3
	OSSetClip	a3
	qmove.l	d7,a0
	bsr	redraw_all_scroll_clip_set
	pop	a3
	OSDisposeRgn	a3
	
;	bsr	redraw_all_scroll
max_left:
	restore_all
hscroll_quit:
	restore_all
	rts_	"h_scroll_proc"
	
	
*************************************************************************************	
do_content:
	OSFrontWindow	d0
	qmove.l	d0,active_window(a5)
;	clr.l	-(sp)
;	dc.w	_FrontWindow
;	move.l	(sp)+,active_window(a5)

	bsr	find_window	make a6-> window record
	bmi	do_cont_end	wind not found
	qmove.l	te_handle(a6),a0
	qmove.l	window_ptr(a6),d0
	OSSetPortWindowPort	  d0
;	move.l	window_ptr(a6),-(sp)
;	dc.w	_setport	easy?
	lea	event_rec(a5),a0	in events
	qmove.l	10(a0),d7	where the mouse is  (for debug purps)
	lea	mouse_glbtoloc(a5),a0
	qmove.l	d7,(a0)
	OSGlobalToLocal	a0	
;	move.l	a0,-(sp)
;	dc.w	_globaltolocal	make mouse coords local to window
	
;	 CLR.W	 -(SP)
	lea	mouse_glbtoloc(a5),a0
	qmove.l	(a0),d0	where(local)
	qmove.l	window_ptr(a6),d1
	lea	what_control(pc),a0
;;	debug
	OSFindControl	d0,d1,a0,d0
;	DC.W	_FINDCONTROL
;	 MOVE.W	(SP)+,d0	 WHICH PART OF SCROLL BAR
	bne	anot_select
**Wait for either the mouse to come up or start a drag
	cmp.w	#"PJ",window_type(a6)
	beq	not_a_drag_operation	*its the project window!
**is mouse over pop-up button?
	qmove.l	mouse_glbtoloc(a5),d0
	qmove.l	te_handle_ptr(a6),a0
	lea	ed_viewrect(a0),a1
;	lea	portrect(a0),a0
;	lea	grow_size_struct(pc),a1
;	qmove.l	(a0),(a1)
;	qmove.l	4(a0),4(a1)
;	qmove.w	4(a1),(a1)	*bott to top
;	sub.w	#16,(a1)	*-16 is new top
;	sub.w	#16,6(a1)	*right - 16 is new right
;	qmove.w	6(a1),2(a1)	*right to left
;	sub.w	#16,2(a1)
	OSPtInRect	d0,a1,d0
	tst.b	d0	
	beq	not_a_drag_operation	*not in viewrect

	cmpi.w	#1,window_type(a6)
	beq	is_drag
	cmpi.w	#"LG",window_type(a6)
	beq	is_drag
	bra	not_a_drag_operation
is_drag:

	lea	event_rec(a5),a0
	qmove.l	10(a0),d0	*global mouse point
	OSWaitMouseMoved	d0,d0
	tst.b	d0
	beq	not_a_drag_operation
**is there a selection in the window?
**And is the mouse over it?
;	move.l	te_handle_ptr(a6),a0
;	 qmove.l	ed_selstart(a0),d0
;	 qmove.l	ed_selend(a0),d1
;	 cmp.l	 d0,d1
;	 beq	 not_a_drag_operation
	bsr.l	is_mouse_over_selection
	tst.l	d0
	beq	not_a_drag_operation
**Check if the option key is down
	cmpi.w	#"LG",window_type(a6)
	beq.s	clear_option	*no add if log window
	lea	event_rec(a5),a0
	qcmove.w	14(a0),d1	modifiers (keyboard or mouse in menu)
	btst	#11,d1
	beq.s	clear_option
	qmove.l	#1,drag_option_key(a5)
	qmove.l	arrow_curs_plus_h(a5),d0
	OSSetCCursor	d0
	bra.s	done_option
clear_option:
	clr.l	drag_option_key(a5)
	qmove.l	arrow_curs_h(a5),d0
	OSSetCCursor	d0

done_option:
**get the region of the outline of the icon

	lea	the_text_drag(a5),a0
	OSNewDrag	a0,d0
	tst.w	d0
	bne	not_a_drag_operation	*error
	qmove.l	(a6),start_drag_port(a5)
	clr.l	old_drag_caret_loc(a5)
**now we need to get the text as compressed tab data
	qmove.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0		        	*terec
**get length of selection
	qmove.l	ed_selend(a0),d0
	qmove.l	ed_selstart(a0),d6	*save start
	sub.l	ed_selstart(a0),d0	*size
	qmove.l	d0,d7		        	*compress needs size in d7
	qmove.l	ed_htext(a0),a0
	qmove.l	a0,-(sp)
	OSHLock	a0			*lock src text
	qmove.l	(sp)+,a2	*a2->ed_htext (handle)

	qmove.l	(a2),a2
	add.l	d6,a2		        *a2->start of text
	qmove.l	a2,scratch_3(a5)
	qmove.l	d7,d0	copy size 
	OSNewHandleClear	d0,a0
	move.l	a0,d0	
	bne	te_space_size_ok
	bra	not_a_drag_operation	*outta mem
te_space_size_ok:
	qmove.l	d0,drag_comp_text_h(a5)	*destr handle
	OSHLock	a0			*lock dest text
	qmove.l	scratch_3(a5),a2
	
	qmove.l	drag_comp_text_h(a5),a0
	qmove.l	(a0),a0		        	*where its going to

	bsr.l	compress_tabs_copy
		
**check length wil lfitr in a word!
	qmove.l	d0,d7	*size of compressed tab data
	qmove.l	d7,drag_comp_text_size(a5)
	qmove.l	te_handle_ptr(a6),a0		*terec
	qmove.l	ed_htext(a0),d0
	OSHUnlock	d0			*unlock src text

**

**into a handle
	move.l	the_text_drag(a5),d0
	qmove.l	#1,d1	*item ref
	qmove.l	#"TEXT",d2	*flavor - promise hfs
	qmove.l	drag_comp_text_h(a5),a0
	qmove.l	(a0),d3		        *ptr to data
	qmove.l	d7,d4	*size
	qmove.l	#0,d5	*flags
	OSAddDragItemFlavor	d0,d1,d2,d3,d4,d5,d0
	tst.w	d0
	beq	flav_add_ok
	move.l	the_text_drag(a5),d0
	OSDisposeDrag	d0,d0
	bra	not_a_drag_operation
flav_add_ok:
	OSNewRgn	a0
	qmove.l	a0,text_drag_rgn(a5)
	
	qmove.l	text_drag_rgn(a5),d0
	qmove.l	the_text_drag(a5),d1
	bsr.l	get_text_drag_region
	tst.l	d0
	beq.s	got_rgn
	qmove.l	the_text_drag(a5),d0
	OSDisposeDrag	d0,d0
	bra	not_a_drag_operation

got_rgn:
	
	qmove.l	the_text_drag(a5),d0
	lea	event_rec(a5),a0
	qmove.l	text_drag_rgn(a5),d2
	OSTrackDrag	d0,a0,d2,d0
	qmove.l	drag_comp_text_h(a5),a0
	OSDisposeHandle	a0	*goodbye to tabs compressed text
	qmove.l	the_text_drag(a5),d0
	OSDisposeDrag	d0,d0
	bra	dc_end	
no_drag:

not_a_drag_operation:

************This is click in text
**GET ADDRESS OF TEREC.VIEWRECT
	cmpi.w	#"SL",window_type(a6)
	beq	do_shared_lib_click
	cmpi.w	#3,window_type(a6)
	beq	do_finder_window	*its a single line list window!
	qmove.l	find_window_id(a5),d0
	cmp.l	active_window(a5),d0
	beq	do_finder_window		*click in find window

	qmove.l	error_window(a5),d0
	cmp.l	active_window(a5),d0
	beq	click_in_error	*Click in error window	
;	MOVE.L	a0,-(SP)	ADDRESS OF TEREC.VIEWRECT

**Calculate if it's a double click
;	 save_all
;	 
;	 CLR.L	 -(SP)
;	 DC.W	 _TICKCOUNT
;	 MOVE.L	(SP)+,d7	 *Save time
;
;	 move.l	d7,d6		         *copy
;	 add.l	 #10,d7	*double click finish time
;**Nopw we have to wait until either double click time is up or mouse button comes up.
;**OR the mouse moves (for selection)
;**If it comes up, we have to see if it goes down and up again within the double click time
;
;button_loop:	 	 
;	 CLR.L	 -(SP)
;	 DC.W	 _TICKCOUNT
;	 MOVE.L	(SP)+,d0	 *Save time
;	 cmp.l	 d7,d0
;	 bgt.s	 done_dc		 *timer ran out
;**check for mouse move
;	 clr.b	 -(sp)
;	 dc.w	 _stilldown
;	 tst.b	 (sp)+
;	 beq.s	 wait_du	*button up
;	 bra.s	 button_loop
;	 
;**button is released, so check for down up
;wait_du:
;	 CLR.L	 -(SP)
;	 DC.W	 _TICKCOUNT
;	 MOVE.L	(SP)+,d0	 *Save time
;	 cmp.l	 d7,d0
;	 bgt.s	 done_dc		 *timer ran out
;	 clr.b	 -(sp)
;	 dc.w	 _button
;	 tst.b	 (sp)+
;	 beq.s	 wait_du
;**Button has gone down, wait for it to come up
;wait_up:
;	 CLR.L	 -(SP)
;	 DC.W	 _TICKCOUNT
;	 MOVE.L	(SP)+,d0	 *Save time
;	 cmp.l	 d7,d0
;	 bgt.s	 done_dc		 *timer ran out
;	 clr.b	 -(sp)
;	 dc.w	 _stilldown
;	 tst.b	 (sp)+
;	 bne.s	 wait_up
;**Here button is up for second time
;	 CLR.L	 -(SP)
;	 DC.W	 _TICKCOUNT
;	 MOVE.L	(SP)+,d0	 *Save time
;	 cmp.l	 d7,d0
;	 bgt.s	 done_dc		 *timer ran out
;	 move.b	#1,double(a5)	 *set double click flag
;not_double_click:
;done_dc:	 	 	 
;	restore_all
**we need double set accordingly here
	cmp.w	#"PJ",window_type(a6)
	beq	its_the_project_click	*its the project window!
**Check if in poupfuncs area
	qmove.l	mouse_glbtoloc(a5),d0
	move.l	(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0

;	lea	portrect(a0),a0
	lea	grow_size_struct(pc),a1
	qmove.l	(a0),(a1)
	qmove.l	4(a0),4(a1)
	qmove.w	4(a1),(a1)	*bott to top
	sub.w	#16,(a1)	*-16 is new top
	sub.w	#16,6(a1)	*right - 16 is new right
	qmove.w	6(a1),2(a1)	*right to left
	sub.w	#16,2(a1)
	OSPtInRect	d0,a1,d0
	tst.b	d0	
	beq.s	not_popupfuncs
	bsr.l	do_popup_funcs	*file
	bra	do_cont_end_check_status
not_popupfuncs:
	move.l	te_handle_ptr(a6),a0
	move.l	ed_telength(a5),d0
	beq	dc_end	**Wot text? V2.00 (Crash bug fix)
;	move.l	(a0),a0
	qmove.l	ed_selstart(a0),d0
	cmp.l	ed_selend(a0),d0
	beq.s	no_selection
;	move.l	a0,-(sp)
	qmove.l	#-1,old_start(a5)
	bsr.l	colour_selection	remove old hilite
;	move.l	(sp)+,a0
	move.l	te_handle_ptr(a6),a0
**test for shift key!
**V1.4 - shiftclick
**Check if shift key is down for block selection - 4.1
	qcmove.w	key_modifiers(a5),d0	*Check for shift click
	lsr.l	#8,d0
	btst	#1,d0
	bne.s	no_selection

	qmove.l	ed_selstart(a0),ed_selpoint(a0)
	qmove.l	ed_selstart(a0),ed_selend(a0)
;	move.l	ed_selstart(a0),old_start(a5)
no_selection:

	qmove.l	mouse_glbtoloc(a5),d0
	lea	ed_viewrect(a0),a0
	OSPtInRect	d0,a0,d0
;	CLR.B	-(SP)
;	MOVE.L	MOUSE_GLBTOLOC(a5),-(SP)
;	pea	ed_viewrect(a0)
;	DC.W	_PTINRECT
;	MOVE.B	(SP)+,d0
	tst.b	d0	
	beq	do_cont_end_check_status
	
	move.l	te_handle_ptr(a6),a0
;	clr.l	d0
;	clr.l	d1
	qcmove.w	mouse_glbtoloc(a5),d1	y
	qcmove.w	mouse_glbtoloc+2(a5),d0	mouse coords rel.
**first find line
	movem.l	d0/d1,-(sp)	save mouse
	bsr	delete_caret
	movem.l	(sp)+,d0/d1
	qmove.l	te_handle_ptr(a6),a0
	divs	ed_lineheight(a0),d1	make line
	andi.l	#$ffff,d1				*Just result
	add.w	ed_scroll_v_t(a0),d1	make real line
	cmp.w	ed_nlines(a0),d1
	ble.s	line_ok
	qcmove.w	ed_nlines(a0),d1
line_ok:	move.l	ed_linestarts(a0),a1
	move.l	(a1),a1	its a handle!!!!!!!
	lsl.l	#2,d1	times 4
	add.l	d1,a1	point to text
	qmove.l	(a1),d2	start of line
**
	move.l	ed_htext(a0),a2
	move.l	(a2),a2
	add.l	d2,a2
**

	tst.b	option_key?(a5)		*Hyperlinking
	beq.s	not_hyper
	bsr.l	hyper_link	*in file hyperlink.s
	bra	dc_end
not_hyper:
**now do x offset
	qmove.l	d0,d5	save it

	qbsr	get_width	in d3
	divs	d3,d5	x off in chars
	ext.l	d5
	add.w	ed_scroll_h_l(a0),d5	account for scroll
**now_check_length of line
	tst.l	4(a1)
	bne.s	normal_line
**This is last line
	qmoveq	#-1,d7
	
	qmove.l	ed_htext(a0),a2
	qmove.l	(a2),a2
	add.l	(a1),a2	point to yer actual text

find_len_last_line:
	addq.l	#1,d7
	tst.b	(a2)+
	bne.s	find_len_last_line
	bra.s	got_length
	
normal_line:	qmove.l	4(a1),d7
	sub.l	(a1),d7	length in chars
	subq.l	#1,d7	account for cr!
got_length:	cmp.l	d7,d5
	ble.s	length_ok
	qmove.l	d7,d5
length_ok:	
**
	move.l	ed_htext(a0),a2
	move.l	(a2),a2
	add.l	d2,a2
**
	add.l	d5,d2
	tst.b	double(a5)	*double click hlite word?
	bne	do_double	*yes

**d2=start of line in chars
**d5=x offset in chars
**now check if theres a tab in reach (backwards)
**first calc tab offset

	
	qmove.l	d5,d0	
	divs	tab_width_w(a6),d0
	swap	d0	*x mod tab
	beq.s	  no_tabette	
	qmove.l	#0,d1	*back counter
	move.l	ed_htext(a0),a2
	move.l	(a2),a2

	add.l	d2,a2	*->text
find_tabette:	cmpi.b	#9,-(a2)
	beq.s	got_a_tab
	cmpi.b	#32,(a2)
	bne.s	no_tabette
	addq.l	#1,d1
	dbra	d0,find_tabette
	bra.s	no_tabette
got_a_tab:	addq.l	#1,d1
	sub.l	d1,d2	*subtract offset to tab
	sub.l	d1,d5
no_tabette:
**V1.4 - shiftclick
**Check if shift key is down for block selection - 4.1
	qcmove.w	key_modifiers(a5),d0	*Check for shift click
	lsr.l	#8,d0
	btst	#1,d0
	beq.s	no_selclick

**d2 is new click point
	move.l	te_handle_ptr(a6),a0
	qmove.l	ed_selstart(a0),d0

	cmp.l	d0,d2	*is point >=start?

	bge.s	gt_start
gt_end:
	qmove.l	d2,ed_selpoint(a0)
	qmove.l	d2,ed_selstart(a0)
	qmove.l	d2,ed_selend(a0)	*dont handle upwards block selects!
	bra.s	done_selclick	
gt_start:	

	
	qmove.l	d2,ed_selpoint(a0)
	qmove.l	d2,ed_selend(a0)
	qmove.l	d2,old_start(a5)
	save_all
	bsr.l	colour_selection
	restore_all
	move.l	te_handle_ptr(a6),a0

	qmove.l	d2,old_start(a5)
	
	bra.s	done_selclick	
no_selclick:
	qmove.l	d2,ed_selpoint(a0)
	qmove.l	d2,ed_selstart(a0)
	qmove.l	d2,ed_selend(a0)
	qmove.l	d2,old_start(a5)
done_selclick:
**now calc real curs_x
	sub.w	ed_scroll_h_l(a0),d5	line x-scroll
	muls	d3,d5	time font width
	addq.w	#4,d5	plus 4
	qmove.w	d5,ed_curs_x(a0)
	qmove.l	a0,-(sp)
	qmove.l	te_handle(a6),-(sp)
	bsr	set_curs	make new cursor coords
	bsr.l	do_auto_scroll	scroll if neccessary

**1.4
	qmove.l	(sp)+,a0
	qcmove.w	key_modifiers(a5),d0	*Check for shift click
	lsr.l	#8,d0
	btst	#1,d0
	bne.s	no_select	

	OSStillDown	d0
;	clr.b	-(sp)
;	dc.w	_stilldown
;	move.b	(sp)+,d0	1 if butt down
	move.l	te_handle_ptr(a6),a0

	tst.b	d0
	beq.s	no_select
	bsr	delete_caret
	qmove.w	ed_curs_x(a0),d0
	qmove.l	d0,-(sp)
;	qcmove.w	#7,d0
;	bsr.l	play_a_sound	go beep to indicate selection
	qmove.l	te_handle_ptr(a6),a0
	bsr	do_select_enter
	qmove.l	te_handle_ptr(a6),a0
	qmove.l	(sp)+,d0
	qmove.l	d0,ed_curs_x(a0)
no_select:	qmove.w	#1,ed_update_scroll(a0)	tell idle to update scroll bars
	bsr.l	do_status_line
**160 for normal mac caret - remember current column
	bsr	find_line	*in d2
	qmove.l	ed_selpoint(a0),d1
	sub.l	d2,d1
	qmove.w	d1,last_known_column(a5)

dc_end:
	clr.l	d0
	rts_	"te_click"

dc_error:
	lea	no_word_error(pc),a1
	bsr.l	draw_status_message
	moveq	#1,d0
	OSSysBeep	d0
	
	move.l	#30,d0	*1/2 sec delay
	bsr	my_delay
	
	bra.s	dc_end
**Double mouse click
**d2 is cursor pos
do_double:
	clr.b	shift_sel(a5)(a5)
	move.l	ed_htext(a0),a2
	move.l	(a2),a2	*text
	tst.b	(a2)
	beq	dc_end	**wot text?  Anvil 2
	move.l	ed_telength(a5),d0
	beq	dc_end	**Wot text?	
	qmove.l	d2,d0	*start sel
**make sure we'ere not on a space, tab or brakets or quotes!
**LXT change
	qpush1	a3
	qmove.l	a2,a3
	add.l	d0,a3
	qcmove.b	0(a3),d3
	qpop1	a3
**end change	    
;	move.b	(a2,d0.l),d3
	cmpi.l	#32,d3
	beq	dc_error
	cmpi.l	#9,d3
	beq	dc_error
	cmpi.l	#13,d3
	beq	dc_error	*Not on cr!

	
	cmpi.l	#"(",d3
	beq.s	dc_error
	cmpi.l	#")",d3
	beq	dc_error
	cmpi.l	#"*",d3
	beq	dc_error
	cmpi.l	#"/",d3
	beq	dc_error
	cmpi.l	#"+",d3
	beq	dc_error
	cmpi.l	#"-",d3
	beq	dc_error
	cmpi.l	#0x2c,d3
	beq	dc_error
	cmpi.l	#";",d3
	beq	dc_error
	cmpi.l	#0x22,d3
	beq	dc_error
	cmpi.l	#"{",d3
	beq	dc_error
	cmpi.l	#"}",d3
	beq	dc_error

find_start:
**LXT change
	qpush1	a3
	move.l	a2,a3
	add.l	d0,a3
	qcmove.b	(a3),d3
	qpop1	a3
**end change
;	move.b	0(a2,d0.l),d3	     *character
	tst.b	d3
	beq	got_start_zero	*Anvil 1.1 - so can dc to first char of file
	cmpi.l	#"(",d3
	beq	got_start
	cmpi.l	#"=",d3	*added for C
	beq	got_start
	cmpi.l	#">",d3	*added for C
	beq	got_start
	cmpi.l	#"<",d3	*added for C
	beq	got_start
	cmpi.l	#"!",d3	*added for C
	beq.s	got_start
	cmpi.l	#"&",d3	*added for C
	beq.s	got_start

	cmpi.l	#")",d3
	beq.s	got_start
	cmpi.l	#"*",d3
	beq.s	got_start
	cmpi.l	#"/",d3
	beq.s	got_start
	cmpi.l	#"+",d3
	beq.s	got_start
	cmpi.l	#"-",d3
	beq.s	got_start
	cmpi.l	#0x2c,d3
	beq.s	got_start
	cmpi.l	#";",d3
	beq.s	got_start
	cmpi.l	#0x22,d3
	beq.s	got_start
	cmpi.l	#"{",d3
	beq.s	got_start
	cmpi.l	#"}",d3
	beq.s	got_start

	cmpi.l	#13,d3
	beq.s	got_start
	cmpi.l	#9,d3
	beq.s	got_start
	cmpi.l	#32,d3
	beq.s	got_start
	subq.l	#1,d0
	beq.s	got_start_zero	*Anvil 1.1
	bra	find_start
got_start:
	addq.l	#1,d0
got_start_zero:
	qmove.l	d0,ed_selstart(a0)	*store start sel
	qmove.l	d0,ed_selpoint(a0)	*initially at the start of the word
	qmove.l	d0,ed_selend(a0)
	qmove.l	d0,old_start(a5)
	qmove.l	d0,scratch(a5)
**now find end of slection
	qmove.l	ed_telength(a0),d4	*eof!
find_end:
**LXT change
	qpush1	a3
	move.l	a2,a3
	add.l	d2,a3
	qcmove.b	(a3),d3
	qpop1	a3
**End change
;	move.b	0(a2,d2.l),d3
	tst.b	d3
	beq	got_end
	cmpi.l	#13,d3
	beq	got_end
	cmpi.l	#9,d3
	beq	got_end
	cmpi.l	#32,d3
	beq	got_end
	cmpi.l	#"=",d3	*added for C
	beq	got_end
	cmpi.l	#">",d3	*added for C
	beq	got_end
	cmpi.l	#"<",d3	*added for C
	beq	got_end
	cmpi.l	#"!",d3	*added for C
	beq	got_end
	cmpi.l	#"&",d3	*added for C
	beq	got_end

	cmpi.l	#"(",d3
	beq.s	got_end
	cmpi.l	#")",d3
	beq.s	got_end
	cmpi.l	#"*",d3
	beq.s	got_end
	cmpi.l	#"/",d3
	beq.s	got_end
	cmpi.l	#"+",d3
	beq.s	got_end
	cmpi.l	#"-",d3
	beq.s	got_end
	cmpi.l	#0x2c,d3
	beq.s	got_end
	cmpi.l	#";",d3
	beq.s	got_end
	cmpi.l	#0x22,d3
	beq.s	got_end
	cmpi.l	#"{",d3
	beq.s	got_end
	cmpi.l	#"}",d3
	beq.s	got_end
	cmpi.l	#":",d3
	beq.s	got_end
	cmpi.l	#".",d3
	beq.s	got_end
	cmpi.l	#"!",d3
	beq.s	got_end
	cmpi.l	#"?",d3
	beq.s	got_end
	
	cmp.l	d2,d4
	beq.s	got_end
	addq.l	#1,d2
	bra	find_end	
got_end:
	qmove.l	d2,ed_selend(a0)
	bsr.l	colour_selection
	save_all
	bsr	calculate_cursor_xy
	restore_all
	qmove.l	scratch(a5),old_start(a5)
	bra	dc_end
	rts_	"Do_double_click"

its_the_project_click:
	qmove.l	te_handle_ptr(a6),a0
	lea	ed_viewrect(a0),a0
	lea	EWtemp_rect(pc),a1
	qmove.l	(a0)+,(a1)
	qmove.l	(a0)+,4(a1)
	add.w	#15,4(a1)	*take account of bottom bar
	qmove.l	mouse_glbtoloc(a5),d0
	lea	EWtemp_rect(pc),a0
	OSPtInRect	d0,a0,d0
;	CLR.B	-(SP)
;	MOVE.L	MOUSE_GLBTOLOC(a5),-(SP)
;	pea	temp_rect(pc)
;	DC.W	_PTINRECT
;	MOVE.B	(SP)+,d0
	tst.b	d0	
	beq	do_cont_end_check_status
	bsr.l	project_click	*in porject-window.s
	move.l	te_handle_ptr(a6),a0
	qmove.l	ed_htext(a0),d0
	OSHUnlock	d0
;	dc.w	_hunlock
	qmove.l	proj_buffer_h(a5),d0
	OSHUnlock	d0
;	dc.w	_hunlock

	rts_	"Its_the_project_click"
	
do_shared_lib_click:
**Check if current BUILD project is PPC
	move.l	build_proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	p_phs4(a0),d0	*will be L lang lang x
	lsr.l	#8,d0
	cmpi.w	#"PP",d0		*for powerPC
	beq.s	sok1
	qmove.l	#1002,d0
	lea	not_ppc_text(pc),a0
	qmoveq	#25,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d
	bra	sl_click_end
sok1:
	move.l	te_handle_ptr(a6),a0
	qmove.l	mouse_glbtoloc(a5),d0
	lea	ed_viewrect(a0),a0
	OSPtInRect	d0,a0,d0
;	CLR.B	-(SP)
;	MOVE.L	MOUSE_GLBTOLOC(a5),-(SP)
;	pea	ed_viewrect(a0)
;	DC.W	_PTINRECT
;	MOVE.B	(SP)+,d0	
	beq	do_find_end

	move.l	te_handle_ptr(a6),a0
;	clr.l	d1
;	clr.l	d0
	qcmove.w	mouse_glbtoloc(a5),d1	y
	qcmove.w	mouse_glbtoloc+2(a5),d0	mouse coords rel.
;	ext.l	d1
;	ext.l	d0
	divs	ed_lineheight(a0),d1	make line
	andi.l	#$ffff,d1
	add.w	ed_scroll_v_t(a0),d1	make real line
	qcmove.w	ed_nlines(a0),d2
	subq.w	#1,d2	 
	cmp.w	d2,d1
	ble.s	line_oksl
	clr.l	d1
	qmove.w	d2,d1
	
line_oksl:	move.l	ed_linestarts(a0),a1
	move.l	(a1),a1	its a handle!!!!!!!
	lsl.l	#2,d1	times 4
	add.l	d1,a1	point to text

	qmove.l	(a1),d2	start of line (text pos)
	qmove.l	d2,d7	*save start of text
	qmove.l	4(a1),d3	start of next line
	qmove.l	ed_selstart(a0),d0
	cmp.l	ed_selend(a0),d0
	beq.s	no_old_hilitesl
	movem.l	d2/d3/d4/d5/d6/d7,-(sp)
	bsr	redraw_all_scroll
	movem.l	(sp)+,d2/d3/d4/d5/d6/d7
no_old_hilitesl:
	qmove.l	d2,ed_selpoint(a0)
	qmove.l	d2,ed_selstart(a0)
	subq.l	#1,d3
	qmove.l	d3,ed_selend(a0)
	qmove.l	d7,-(sp)
	bsr	redraw_all_scroll
	qmove.l	(sp)+,d7
	qmove.l	ed_htext(a0),d0
	OSHLock	d0
;	dc.w	_HLock
	qmove.l	te_handle_ptr(a6),a0
	qmove.l	ed_htext(a0),a1	
	qmove.l	(a1),a1
	add.l	d7,a1	*point to the actual text
	qmove.l	a1,a0
	lea	slib_text(a5),a1
	qmove.l	#256,d2
	OSBlockMoveData	a0,a1,d2
;	dc.w	_blockmove
	move.l	te_handle_ptr(a6),a0
	qmove.l	ed_htext(a0),d0
	OSHUnlock	d0
;	dc.w	_HUnLock

	bsr.l	add_shared_lib	*in project_file_management.s
	qmove.b	#1,must_rebuild4(a5)	*force a phase 4 build on first build

sl_click_end:
	rts_	"shared_libs_window_click"
**************FInder window click******************************
click_in_error:

	qmove.l	#1,spare14(a5)	*show error string in sb
do_finder_window:
	tst.b	global_in_progress(a5)
	beq.s	finder_finished
	qmove.l	#10,d0	
	OSSysBeep	d0
;	move.w	   #10,-(sp)
;	dc.w	_sysbeep
	bra	do_find_end1

finder_finished:
	qmove.l	te_handle_ptr(a6),a0
no_selectionf:
	qmove.l	mouse_glbtoloc(a5),d0
	lea	ed_viewrect(a0),a0
	OSPtInRect	d0,a0,d0
;	CLR.B	-(SP)
;	MOVE.L	MOUSE_GLBTOLOC(a5),-(SP)
;	pea	ed_viewrect(a0)
;	DC.W	_PTINRECT
;	MOVE.B	(SP)+,d0	
	beq	do_find_end1

	move.l	te_handle_ptr(a6),a0
	qcmove.w	mouse_glbtoloc(a5),d1	y
	qcmove.w	mouse_glbtoloc+2(a5),d0	mouse coords rel.
	ext.l	d1
	ext.l	d0
	divs	ed_lineheight(a0),d1	make line
	andi.l	#$ffff,d1
	add.w	ed_scroll_v_t(a0),d1	make real line
	qcmove.w	ed_nlines(a0),d2
	subq.w	#1,d2	 
	cmp.w	d2,d1
	ble.s	line_okf
	clr.l	d1
	qmove.w	d2,d1
	
line_okf:	 qmove.l	ed_linestarts(a0),a1
	qmove.l	(a1),a1	its a handle!!!!!!!
	lsl.l	#2,d1	times 4
	add.l	d1,a1	point to text

	qmove.l	(a1),d2	start of line (text pos)
	qmove.l	d2,d7	*save start of text
	qmove.l	4(a1),d3	start of next line
	qmove.l	ed_selstart(a0),d0
	cmp.l	ed_selend(a0),d0
	beq.s	no_old_hilite
	movem.l	d2/d3/d4/d5/d6/d7,-(sp)
	bsr	redraw_all_scroll
	movem.l	(sp)+,d2/d3/d4/d5/d6/d7
no_old_hilite:
	qmove.l	d2,ed_selpoint(a0)
	qmove.l	d2,ed_selstart(a0)
;	subq.l	#1,d3
	qmove.l	d3,ed_selend(a0)
	qmove.l	d7,-(sp)
	bsr	redraw_all_scroll
	qmove.l	(sp)+,d7

	qmove.l	ed_htext(a0),a1
	qmove.l	a0,-(sp)	*we have to lock ed_htext cause selectwindow moves mem
	qmove.l	a1,d0
	OSHLock	d0
;	dc.w	_hlock
	qmove.l	(sp)+,a0
	qmove.l	ed_htext(a0),a1
	qmove.l	a1,finder_text_h(a5)	*save handle so we can unlock it later (mother of all bugs!!!!!)
	
	qmove.l	(a1),a1
	add.l	d7,a1	*point to the actual text

**now interpret the text...
**layout of finder line is 
**Filename Line = xxx. Text string.
**So we can search until we find "Line". That is the end of the filename.
**BBedit relies on specific chars, which is naff.
**Look for Line
	reset_locals
	local.b	the_string,300
	local.l	the_string_pos,1
global_hyper_load:
	save_all
	bsr.l	delete_caret	
	restore_all
	reserve_locals	a4
	qmove.l	a1,a2	start of line
	cmpi.l	#"****",(a2)	*not a jumpable object?
	beq	not_jumpable
        cmpi.b	#"#",(a2)
        beq	not_jumpable

	lea	the_string(a4),a2
	qmove.l	#200,d2
	OSBlockMoveData	a1,a2,d2
	lea	the_string(a4),a1
	move.l	a1,a2
	
LFL:	cmpi.l	#"Line",(a1)
	beq.s	got_line
	addq.l	#1,a1
	bra.s	LFL
got_line:

	qmove.l	a1,the_string_pos(a4)	save text pos
	subq.l	#1,a1	*end of filename
	qmove.l	a1,d0
	sub.l	a2,d0	*length of filename
	qmove.l	d0,d1
	lea	temp_string(a5),a3
	qmove.b	d1,(a3)+	*length byte
	andi.w	#$ff,d1
	beq.s	no_copy2		*no file name
	subq.w	#1,d1
copy:
	qcmove.b	(a2)+,d0		*copy file name to temp-string
	qbsr.l	toupper			*make filename upper case
	qmove.b	d0,(a3)+
	qdbra	d1,copy
no_copy2:
**See if window is loaded already
**now find name that matches
	move.l	windows_records_h(a5),a1
	move.l	(a1),a1
	lea	w_fsspec(a1),a1	* ->FSspec
	addq.l	#6,a1	* ->Name

	qmove.l	#0,d7
search_loop:

	lea	temp_string(a5),a0
	qmove.l	a1,a2	*save wrec pos
**Copy filename to temp_string6(a5) whilst making upper case
	qcmove.b	(a1)+,d1
	lea	temp_string6(a5),a3	*temp string 3 is in use!
	qmove.b	d1,(a3)+	*length byte
	andi.w	#$ff,d1
	beq.s	no_copy20
	subq.w	#1,d1
copy1:
	qcmove.b	(a1)+,d0		*copy file name to temp-string6
	qbsr.l	toupper			*make filename upper case
	qmove.b	d0,(a3)+
	qdbra	d1,copy1
no_copy20:
	lea	temp_string6(a5),a1
;	clr.l	d0
	qcmove.b	(a0),d0
	addq.l	#1,d0	account for count byte
	qbsr.l	strncmp
	move.l	a2,a1	*restore
	tst.l	d0
	beq.s	found_it!
	lea	w_rec_size(a1),a1
	addq.l	#1,d7
	cmp.l	#number_of_windows,d7
	beq.s	not_found	*file is not open
	bra.s	search_loop

found_it!:
	sub.l	#w_fsspec,a2
	subq.l	#6,a2
	qmove.l	(a2),active_window(a5)
	qmove.l	(a2),d0
	OSSelectWindow	d0
	bra	window_open

not_found:
	tst.b	doing_project_search(a5)	*if 1, fsspec in fs_temp
	bne	proj_found1
**Find file in proj and decode alias to fsspec
**name in temp_string
	lea	temp_string(a5),a0
	bsr.l	find_file_given_name
	tst.w	d0
	bmi	not_in_proj
	lea	sizeof_file_entry(a1),a0	*point to first alias
	lea	scratch_1(a5),a1
;	clr.l	d2
	qcmove.w	4(a0),d2		*size of alias
	OSPtrToHand	a0,a1,d2	*data, size, result in a0
;	dc.w	_PtrToHand
	move.l	scratch_1(a5),a0
**get fsspec for first source entry
	push	a4
	bsr.l	my_resolve_simple	*temp_string3=fsspec if found, error in d0
	pop	a4
	qpush1	d0
	qmove.l	scratch_1(a5),d0
	OSDisposeHandle	d0
;	dc.w	_Disposehandle
	qpop1	d0
	tst.w	d0
	bmi.s	not_in_proj
	lea	temp_string3(a5),a0
	lea	temp_string2(a5),a1
	qmoveq	#74,d2
	OSBlockMoveData	a0,a1,d2
;	dc.w	_BlockMove
	bra	got_fshl1	
not_in_proj:
;Cionameptr:	 equ	 18	long
;Ciovrefnum:	 equ	 22	word
;Ciodrdirid:	 equ	 48	long
**We have to make an FSSpec from the current window...
;	clr.w	-(sp)
	bsr.l	find_window
	bmi.s	no_wind20
	lea	w_fsspec(a6),a0
	tst.l	2(a0)
	beq.s	no_dirID
	qcmove.w	(a0),d0
;	move.w	d0,-(sp)
	qmove.l	2(a0),d1
;	move.l	2(a0),-(sp)	*make save folder same as windows dirid
	bra.s	done_folder
no_dirID:
no_wind20:	*finally try default folder
	qcmove.w	current_vrefnum(a5),d0
	qmove.l	current_parid(a5),d1
;	move.w	current_vrefnum(a5),-(sp)	  vrefnum
;	move.l	current_parID(a5),-(sp)	dirID
done_folder:
	lea	temp_string(a5),a0	*name
	lea	temp_string2(a5),a1	*here

	OSMakeFSspec	d0,d1,a0,a1,d0
;	pea	temp_string(a5)
;	pea	temp_string2(a5)	*FSSpec will go here
;	moveq	#1,d0
;	dc.w	$aa52	*makeFSspec
;	move.w	(sp)+,d0
	bmi	no_such_file
	bra.s	got_fshl1
proj_found1:
	lea	fs_temp(a5),a0
	lea	temp_string2(a5),a1
	qmoveq	#74,d2
	OSBlockMoveData	a0,a1,d2
;	dc.w	_BlockMove
got_fshl1:
	lea	temp_string2(a5),a0
	subq.l	#6,a0
	qmove.b	#1,auto_switch(a5)
	qmove.l	long_var1(a5),-(sp)
	push	a4
	bsr	auto_entry	  
	bsr.l	check_rebuild
	pop	a4
	qmove.l	(sp)+,long_var1(a5)

window_open:
	bsr	find_window
	bmi	no_selectf
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0
;	move.l	0(a6),-(sp)
;	dc.w	_setport
**Got a hilight aleady?
	move.l	te_handle_ptr(a6),a0
	qmove.l	ed_selstart(a0),d0
	cmp.l	ed_selend(a0),d0
	beq.s	no_sel_on_jmp
	save_all
	qmove.l	ed_selend(a0),d1
	bsr.l do_hilite	remove old hilite
	restore_all
no_sel_on_jmp:
		

**now we have to get the line number from
	qpush1	a0
	qmove.l	finder_text_h(a5),d0
	OSHUnlock	d0
;	dc.w	_hunlock
	qpop1	a0	

	qmove.l	the_string_pos(a4),a1
	addq.l	#7,a1	*skip "line = "
**pointing to number, so we call convert-to_num which needs a pascalstring in a0
**we get the length by looking for the full stop
	qmove.l	#0,d0
	qmove.l	a1,a2	copy start
	lea	temp_string(a5),a0
	addq.l	#1,a0
find_len:
	qcmove.b	(a1)+,d1
	cmpi.b	#0x2c,d1
	beq.s	skip_comma	  
	cmpi.b	#".",d1
	beq.s	got_dot
	addq.l	#1,d0
	qmove.b	d1,(a0)+
skip_comma:
	bra.s	find_len
got_dot:
**length now in d0

	lea	temp_string(a5),a0
	qmove.b	d0,(a0)
**Error string in a1, termed in d or 0
	lea	temp_string3(a5),a0
	qmove.l	#"    ",(a0)+
	qmove.l	#"Erro",(a0)+
	qmove.l	#"r/wa",(a0)+
	qmove.l	#"rnin",(a0)+
	qmove.w	#"g:",(a0)+
	qmoveq	#0,d1
**Copy error string
	qmoveq.l	#0,d0
ces:	addq.b	#1,d1
	beq.s	got_es	*max 255 chars
	move.b	(a1)+,d0
	beq.s	got_es
	cmpi.l	#13,d0
	beq.s	got_es
	qmove.b	d0,(a0)+
	bra.s	ces
got_es:	clr.b	(a0)
	lea	temp_string3(a5),a1
	clr.w	displaying_error(a5)	*So we can printit
**if window is find window then dont copy string to status line
	move.l	spare14(a5),d0	*1 here means show string in sb
	beq.s	no_mess12
	bsr.l	dsm
	qmove.w	#1,displaying_error(a5)	*lock up dsm
	qmove.l	#0,spare14(a5)	*for next call

**Now convert line number
no_mess12:
	lea	temp_string(a5),a0
	bsr.l	convert_to_num	*in do_goto_dialog, returns d0

	qmove.l	d0,-(sp)	*save number
	bsr	find_window	*setup a6 to point ot windd
	qmove.l	(sp)+,d7	*get line number
	tst.w	d0
	bmi	no_selectf
	subq.l	#1,d7	*correct for lines from 1
	move.l	te_handle_ptr(a6),a0
	move.l	ed_linestarts(a0),a1
	move.l	(a1),a1
	lsl.l	#2,d7	*line number times 4 for access
**LXT change
	qpush1	a3
	qmove.l	a1,a3
	add.l	d7,a3
	qmove.l	(a3),d0
	qpop1	a3
**End change
;	move.l	0(a1,d7.l),d0	     *text start of line
	qmove.l	d0,ed_selstart(a0)
	qmove.l	d0,ed_selend(a0)
	qmove.l	d0,ed_selpoint(a0)
	qmove.l	d0,d6
**1.6 - highlight it
	qmove.l	ed_htext(a0),a1
	qmove.l	(a1),a3		        *->text
**LXT change
	qpush1	a1
	move.l	a3,a1
	add.l	d6,a1
	qcmove.b	(a1),d0
	qpop1	a1	
**End change
;	move.b	0(a3,d6.l),d0
	cmpi.b	#13,d0
	bne.s	no_inc
	addq.l	#1,d6		*So caret isn't in front of cr!
no_inc:
	qmove.l	d6,ed_selpoint(a0)
	qmove.l	d6,ed_selstart(a0)
	qmove.l	d6,ed_selend(a0)
**1.6 change - hilite found word
	qmove.l	d6,d2	*do double needs selpoint in d2
	qmove.l	a0,-(sp)
	bsr.l	highlight_to_end
	qmove.l	(sp)+,a0
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0
;	move.l	0(a6),-(sp)
;	dc.w	_setport
**Link found

	qmove.l	te_handle_ptr(a6),a0
	bsr.l	do_auto_scroll	
	lea	link_found_text(pc),a1
	bsr.l	draw_status_message
  
no_selectf:
	clr.l	d0
do_find_end:
	unlk	a4
do_find_end1:
	rts_	"Do_finder_window"
	
not_jumpable:
	movem.l	d2/d3/d4/d5/d6/d7,-(sp)
	bsr	redraw_all_scroll
	movem.l	(sp)+,d2/d3/d4/d5/d6/d7		*clear hilite
	qmove.l	te_handle_ptr(a6),a0
	qmove.l	ed_selpoint(a0),ed_selstart(a0)
	qmove.l	ed_selpoint(a0),ed_selend(a0)
	qmove.l	#1,d0
	OSSysBeep	d0
	lea	not_jumpable_text(pc),a1
	bsr.l	dsm
	qmove.l	#30,d0
	bsr	my_delay
	bra.s	no_selectf
	bra.l	draw_status_message

	
no_such_file:

	qmove.l	a0,-(sp)
	qmove.l	finder_text_h(a5),d0
	OSHUnlock	d0
;	dc.w	_hunlock
	qmove.l	(sp)+,a0


	lea	cant_find_file(pc),a1
	bsr.l	draw_status_message
	lea	cant_find_file(pc),a0
	bsr.l	simple_speak
	qmove.w	#message_delay,message_delay_counter(a5)
dont_status1:

	clr.l	d0
	unlk	a4
	rts_	"no_such_file"

**ticks.l delay in d0
my_delay:
	push	d0
	OSTickCount	d7
	popq	d0
	add.l	d0,d7
dwait:	
	OSTickCount	d0
	cmp.l	d0,d7
	bgt.s	dwait	*wait for 1 tick to elapse
	rts_	"my_delay"

***********************DO_SELECT*******************************
do_select:			*-\/
	bsr.l	getkey_turbo
	qcmove.w	6(a0),d0	*check for ctrl key
	btst	#3,d0
	bne.s	no_delay	*ctrl is pressed
	
**wait for 1 tick if flags3(1) is set
	btst	#3,prefs_flags3(a5)
	beq.s	no_delay
	OSTickCount	d7
	addq.l	#2,d7
wait_select:	
	OSTickCount	d0
	cmp.l	d0,d7
	bgt.s	wait_select	*wait for 1 tick to elapse

no_delay:
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	qmove.l	a0,-(sp)
	lea	mouse_glbtoloc(a5),a0
	OSGetMouse	a0
;	pea	mouse_glbtoloc(a5)
;	dc.w	_getmouse
	qmove.l	(sp),a0

	qmove.l	mouse_glbtoloc(a5),d0
	lea	ed_viewrect(a0),a0
	OSPtInRect	d0,a0,d0
;	CLR.B	-(SP)
;	move.l	mouse_glbtoloc(a5),-(sp)
;	pea	ed_viewrect(a0)
;	DC.W	_PTINRECT
;	MOVE.B	(SP)+,d0
	qmove.l	(sp)+,a0

*********Mouse button still down - selecting text.
**needs mouse_glbtoloc y/x set up
**cursor keys and shift come in here as well!
do_select_enter:
;	clr.l	d1
	qmove.l	#0,d0
	qcmove.w	mouse_glbtoloc(a5),d1	y

	move.w	mouse_glbtoloc+2(a5),d0	mouse coords rel.
;	tst.w	d0
**Check for -ve x
;	tst.w	d0
	bge.s	x_ok
	qmove.l	#0,d0
x_ok:	tst.w	d1
	bgt	inside_top
**Scroll down 1
	tst.w	ed_scroll_v_t(a0)
	bne.s	not_tof
	qmoveq	#7,d1
	bra	inside_bottom
not_tof
	
	movem.l	d0/d1,-(sp)
	qmove.l	a0,-(sp)
;	move.w	ed_lineheight(a0),d0
;	lea	ed_viewrect(a0),a0
;	OSScrollRect	a0,#0,d0,#0
	tst.l	doing_drag(a5)
	beq.s	drag11
	push	a0

	qmove.l	the_text_drag(a5),d7
	OSHideDragHilite	d7,d0
	pop	a0
drag11:
	qcmove.w	ed_lineheight(a0),d2	*Dist scroll down
	lea	ed_viewrect(a0),a0	rect
	qmove.l	a0,d0
	qmoveq	#0,d1	dh
;	move.w	d0,-(sp)	dv
	qmoveq	#0,d3	no region
	OSScrollRect	d0,d1,d2,d3
;	dc.w	_scrollrect
	qmove.l	(sp),a0
	subq.w	#1,ed_scroll_v_t(a0)
	subq.w	#1,ed_scroll_v_b(a0)
	bsr	draw_v_scroll
	qcmove.w	ed_lineheight(a0),d0
	qmove.w	d0,ed_curs_y(a0)	move cursor down into view area
	qmove.w	#x_start,ed_curs_x(a0)
	qcmove.w	ed_scroll_v_t(a0),d0	for squirt line
	bsr	squirt_line_off		line number in d0
	qmove.l	(sp),a0
	qcmove.w	ed_scroll_v_t(a0),d0	for squirt line
	bsr	squirt_line_nd_off	line number in d0

	qmove.l	(sp),a0
	bsr.l	check_for_highlight

	tst.l	doing_drag(a5)
	beq.s	drag12	
	move.l	(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0

;	lea	portrect(a0),a0
	OSClipRect	a0
	qmove.l	the_text_drag(a5),d7	
	lea	highlight_region_handle(a5),a0
	qmove.l	(a0),d1
	qmoveq	#1,d2
	OSShowDragHilite	d7,d1,d2,d0
drag12:
	

	qmove.l	(sp)+,a0
	movem.l	(sp)+,d0/d1
	qmoveq	#7,d1	new y
	bra	calc_for_top
	
inside_top:	cmp.w	ed_viewrect+4(a0),d1
	blt	inside_bottom	see if y is greater than window	
	qcmove.w	ed_nlines(a0),d2
	cmp.w	ed_scroll_v_b(a0),d2
	beq	inside_bottom	or if greater than max number of lines
;	clr.l	d0
	qcmove.w	ed_scroll_v_b(a0),d0
	cmp.w	ed_nlines(a0),d0
	bgt	inside_bottom

	movem.l	d0/d1,-(sp)
	tst.l	doing_drag(a5)
	beq.s	drag13
	push	a0

	qmove.l	the_text_drag(a5),d7
	OSHideDragHilite	d7,d0
	pop	a0
drag13:
	qmove.l	a0,-(sp)

	qcmove.w	ed_lineheight(a0),d0
	neg.w	d0
	lea	ed_viewrect(a0),a0
	qmove.l	d0,d2
	qmove.l	a0,d0
	qmove.l	#0,d1
	qmove.l	d1,d3
	OSScrollRect	d0,d1,d2,d3

;	pea	ed_viewrect(a0),-(sp)	scroll rect
;	clr.w	-(sp)	dh
;	move.w	ed_lineheight(a0),d0
;	neg.w	d0
;	move.w	d0,-(sp)	dv
;	clr.l	-(sp)	no region
;	dc.w	_scrollrect
	qmove.l	(sp),a0

	addq.w	#1,ed_scroll_v_t(a0)
	addq.w	#1,ed_scroll_v_b(a0)
	bsr	draw_v_scroll
;	clr.l	d0
	qcmove.w	ed_lineheight(a0),d0
	sub.w	d0,ed_curs_y(a0)
	qcmove.w	ed_scroll_v_b(a0),d0	bott
	sub.w	ed_scroll_v_t(a0),d0	lines/page
	addq.w	#1,d0
	muls	ed_lineheight(a0),d0	pix

	qmove.w	d0,ed_curs_y(a0)	calc bottom line of wind
	qmove.w	#x_start,ed_curs_x(a0)
;	clr.l	d0
	qcmove.w	ed_scroll_v_b(a0),d0
	bsr	squirt_line_off		line number in d0
	qmove.l	(sp),a0
	qcmove.w	ed_scroll_v_b(a0),d0	for squirt line
	bsr	squirt_line_nd_off	line number in d0

	bsr.l	check_for_highlight

	tst.l	doing_drag(a5)
	beq.s	drag14	
	move.l	(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0
;	lea	portrect(a0),a0
	OSClipRect	a0

	qmove.l	the_text_drag(a5),d7	
	lea	highlight_region_handle(a5),a0
	qmove.l	(a0),d1
	qmoveq	#1,d2
	OSShowDragHilite	d7,d1,d2,d0
drag14:
	qmove.l	(sp)+,a0
	movem.l	(sp)+,d0/d1
	qcmove.w	ed_viewrect+4(a0),d1	new y
	subq.l	#7,d1

inside_bottom:
	
**now calc text pos
**first find line
	ext.l	d1
	ext.l	d0

	divs	ed_lineheight(a0),d1	make line
	andi.l	#$ffff,d1
	add.w	ed_scroll_v_t(a0),d1	make real line
	cmp.w	ed_nlines(a0),d1
	ble.s	sel_line_ok
;	clr.l	d1
	qcmove.w	ed_nlines(a0),d1
sel_line_ok:	move.l	ed_linestarts(a0),a1
	qmove.l	(a1),a1	its a handle!!!!!!!
	lsl.l	#2,d1	times 4
	add.l	d1,a1	point to text
	qmove.l	(a1),d2	start of line
**now do x offset
	ext.l	d0
	qmove.l	d0,d5	save it
	qbsr	get_width	in d3
	divs	d3,d5	x off in chars
	andi.l	#$ffff,d5
	add.w	ed_scroll_h_l(a0),d5	account for scroll
**now_check_length of line
	tst.l	4(a1)
	bne.s	sel_normal_line
**This is last line
	qmoveq	#-1,d7
	qmove.l	ed_htext(a0),a2
	qmove.l	(a2),a2
	add.l	(a1),a2	point to yer actual text
sel_find_len_last_line:
	addq.l	#1,d7
	tst.b	(a2)+
	bne.s	sel_find_len_last_line
	bra.s	sel_got_length
	
sel_normal_line:	qmove.l	4(a1),d7
	sub.l	(a1),d7	length in chars
	subq.l	#1,d7	account for cr!
sel_got_length:	
	cmp.l	d7,d5
	blt.s	sel_length_ok

	qmove.l	d7,d5
sel_length_ok:	
	add.l	d5,d2	
***********************
**d2=start of line in chars
**d5=x offset in chars
**now check if theres a tab in reach (backwards)
**first calc tab offset

	
	qmove.l	d5,d0	
	divs	tab_width_w(a6),d0
	swap	d0	*x mod tab
	tst.w	d0
	beq.s	no_tabette1	
	qmove.l	#0,d1	*back counter
	qmove.l	ed_htext(a0),a2
	qmove.l	(a2),a2
	add.l	d2,a2	*->text
find_tabette1:	cmpi.b	#9,-(a2)
	beq.s	got_a_tab1
	cmpi.b	#32,(a2)
	bne.s	no_tabette1
	addq.l	#1,d1
	dbra	d0,find_tabette1
	bra.s	no_tabette1
got_a_tab1:	addq.l	#1,d1
	sub.l	d1,d2	*subtract offset to tab
	sub.l	d1,d5
no_tabette1:
******************
	tst.l	doing_drag(a5)
	bne	no_sel_loop	*get out if we are dragging

	qmove.l	ed_selpoint(a0),d1	original click point
	cmp.l	d2,d1
	bgt.s	new_point_less	current is less than start
**here current is more than start

	qmove.l	d1,ed_selstart(a0)
	qmove.l	d2,ed_selend(a0)
	bra.s	done_sel_st_end
**here current is less than start
new_point_less:

	qmove.l	d1,ed_selend(a0)
	qmove.l	d2,ed_selstart(a0)
done_sel_st_end:

	bsr.l	colour_selection	*file
no_change:	bra	no_change_t

**********Calculations for up select scrolling
calc_for_top:
	
**now calc text pos
**first find line
	ext.l	d1	mouse y
	ext.l	d0	mouse x

	divs	ed_lineheight(a0),d1	make line
	andi.l	#$ffff,d1
	add.w	ed_scroll_v_t(a0),d1	make real line
	cmp.w	ed_nlines(a0),d1
	ble.s	sel_line_ok_t
;	clr.l	d1
	qcmove.w	ed_nlines(a0),d1
sel_line_ok_t:	move.l	ed_linestarts(a0),a1
	move.l	(a1),a1	its a handle!!!!!!!
	lsl.l	#2,d1	times 4
	add.l	d1,a1	point to text
	qmove.l	(a1),d2	start of line
**now do x offset

	ext.l	d0
	qmove.l	d0,d5	save it
	qbsr	get_width	in d3
	divs	d3,d5	x off in chars
	andi.l	#$ffff,d5
	add.w	ed_scroll_h_l(a0),d5	account for scroll
**now_check_length of line
	tst.l	4(a1)
	bne.s	sel_normal_line_t
**This is last line
	qmoveq	#-1,d7
	move.l	ed_htext(a0),a2
	move.l	(a2),a2
	add.l	(a1),a2	point to yer actual text
sel_find_len_last_line_t:
	addq.l	#1,d7
	tst.b	(a2)+
	bne.s	sel_find_len_last_line_t
	bra.s	sel_got_length_t
	
sel_normal_line_t:	qmove.l	4(a1),d7
	sub.l	(a1),d7	length in chars
	subq.l	#1,d7	account for cr!
sel_got_length_t:	
	cmp.l	d7,d5
	blt.s	sel_length_ok_t

	qmove.l	d7,d5
sel_length_ok_t:	
	add.l	d5,d2	
	tst.l	doing_drag(a5)
	bne	no_sel_loop	*get out if we are dragging

	qmove.l	ed_selpoint(a0),d1	original click point
	cmp.l	d2,d1
	bgt.s	new_point_less_t	current is less than start
**here current is more than start

	qmove.l	d2,ed_selstart(a0)
	qmove.l	d1,ed_selend(a0)
	bra.s	done_sel_st_end_t
**here current is less than start
new_point_less_t:

	qmove.l	d2,ed_selend(a0)
	qmove.l	d1,ed_selstart(a0)
done_sel_st_end_t:
	tst.l	doing_drag(a5)
	bne.s	no_sel_loop
	bsr.l	colour_selection	*file
no_change_t:
	tst.l	doing_drag(a5)
	bne	no_sel_loop
	qmove.l	a0,-(sp)
	OSStillDown	d0
;	clr.b	-(sp)
;	dc.w	_stilldown
;	move.b	(sp)+,d0	1 if butt down
	qmove.l	(sp)+,a0
	tst.b	d0
	bne	do_select	-^

***********End of v scroll selection	
done_down:
	qmove.l	ed_selpoint(a0),d0	*ed_selstart(a0) make new start
	qmove.l	old_start(a5),d1	*ed_selend(a0)
	cmp.l	d0,d1
	bge.s	range_ok
	exg	d0,d1
range_ok:	
	qmove.l	d0,ed_selstart(a0)
	qmove.l	d1,ed_selend(a0)
	qmove.l	#-1,old_start(a5)

no_sel_loop:
	rts_	"Do_select"
draw_v_scroll:

	push	a0
	OSFrontWindow	d0
	cmp.l	(a6),d0
	bne	wind_in_bg
	qmove.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0
;	lea	portrect(a0),a0
	OSClipRect	a0

	qmove.l	(sp),a0
	qcmove.w	ed_scroll_v_t(a0),d1
	qmove.l	v_scroll_h(a6),d0
	OSSetCtlValue	d0,d1

	qmove.l	v_scroll_h(a6),d0
	qmove.l	#0,d1
	OSHiliteControl	d0,d1
	qmove.l	v_scroll_h(a6),d0
	OSShowControl	d0
wind_in_bg:
	pop	a0
	rts_	"draw_v_scroll"	
**CONTROL CODE IN d0
anot_select:
**FIND SCROLL BAR
	qmove.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	qpush1	d0
	qmove.l	ed_inport(a0),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0
;	lea	0x10(a2),a0
	OSClipRect	a0

	qpop1	d0

	qmove.l	what_control(pc),d1
	cmp.l	h_scroll_h(a6),d1
	beq	do_horiz
**handle vert sb thumb

	cmpi.w	#129,d0
	bne	anot_inthumb
**make a note of current top
	qmove.l	te_handle_ptr(a6),a0
	qmove.w	ed_scroll_v_t(a0),scratch_4(a5)
	
;	OSTrackControl	v_scroll_h(a6),mouse_glbtoloc(a5),#0,d0
;	CLR.W	-(sp)
	qmove.l	v_scroll_h(a6),d0
	qmove.l	mouse_glbtoloc(a5),d1
	qmove.l	#0,d2	no callback proc
	OSTrackControl	d0,d1,d2,d0
;	DC.W	_TRACKCONTROL
;	move.w	(Sp)+,d0
	qmove.l	v_scroll_h(a6),d0
	OSGetCtlValue	d0,d1
;	CLR.W	-(SP)
;	MOVE.L	V_SCROLL_h(a6),-(SP)
;	DC.W	_GETCTLVALUE	get current ctl value (top of page value)
;	MOVE.W	(SP)+,d1	CONTROLLER VALUE
	qmove.l	te_handle_ptr(a6),a0
	qcmove.w	scratch_4(a5),d2		*old top
;	move.l	(a0),a0
;	clr.l	d0
	qcmove.w	ed_scroll_v_b(a0),d0
	sub.w	ed_scroll_v_t(a0),d0	size in lines
	qmove.w	d1,ed_scroll_v_t(a0)
	cmp.w	d1,d2
	beq.s	no_vert_change
	add.w	d0,d1
	qmove.w	d1,ed_scroll_v_b(a0)
	
**Now clear view rect if not a proj window
	cmpi.w	#"PJ",window_type(a6)
	beq.s	no_erase13
;	move.l	a0,-(sp)

	lea	ed_viewrect(a0),a0
	OSEraseRect a0
;	pea	ed_viewrect(a0)
;	dc.w	_eraserect	erase window view
no_erase13:
	qmove.l	te_handle_ptr(a6),a0
	bsr	redraw_all_scroll	redraw at scroll
no_vert_change:
;	ADDQ.L	#2,SP
	bra.s	do_cont_end
	rts_	"thumb_v "

anot_inthumb:

;	move.l	a6,d1
	lea	callback_rec_store(pc),a0
	qmove.l	a6,(a0)
**LXT change
	if	PPC
	qmove.l	vscroll_upp(a5),a0
**Save a5 in our filter proc!
	lea	a5_store(pc),a1
	qmove.l	a5,(a1)
	qmove.l	a6,4(a1)	*Save our regs we need in filter proc
	else
	lea	vscrollproc(pc),a0
	endif

;	OSTrackCOntrol	v_scroll_h(a6),mouse_glbtoloc(a5),a0,d0
;	CLR.W	-(SP)
	qmove.l	v_scroll_h(a6),d0
	qmove.l	mouse_glbtoloc(a5),d1
;	lea	vscrollproc(pc),a0	vert scroller routine (see above)
	OSTrackControl	d0,d1,a0,d0
;	dc.w	_trackcontrol	see you in vscrollproc
;	addq.l	#2,sp
do_cont_end:
	clr.l	d0
	rts_	"notthumv"
do_cont_end_check_status:

not_status_click:
	qmove.l	te_handle_ptr(a6),a0

	qmove.l	ed_inport(a0),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0
;	lea	0x10(a2),a0
	OSClipRect	a0
;	pea	$10(a2)	clip to portrect
;	dc.w	_cliprect

	clr.l	d0
	rts_	"notthumv"


**control horiz scroll bar
do_horiz:
	cmpi.w	#"PJ",window_type(a6)
	beq	its_the_project_click	*not really hscroll at all
	cmpi.w	#129,d0
	bne	not_inthumb
	qmove.l	h_scroll_h(a6),d0
	OSGetCtlValue	d0,d7
;	CLR.W	-(SP)
;	MOVE.L	h_SCROLL_h(a6),-(SP)
;	DC.W	_GETCTLVALUE	get current ctl value (top of page value)
;	MOVE.W	(SP)+,d7	OLD CONTROLLER VALUE
	qmove.l	d7,-(sp)


;	OSTrackControl	h_scroll_h(a6),mouse_glbtoloc(a5),#0,d0

;	CLR.W	-(SP)
	qmove.l	h_scroll_h(a6),d0
	qmove.l	mouse_glbtoloc(a5),d1
	qmove.l	#0,d2	no callback proc
	OSTrackControl	d0,d1,d2,d0
;	DC.W	_TRACKCONTROL
;	move.w	(Sp)+,d0
	qmove.l	h_scroll_h(a6),d0
	OSGetCtlValue	d0,d1
		
;	CLR.W	-(SP)
;	MOVE.L	h_SCROLL_h(a6),-(SP)
;	DC.W	_GETCTLVALUE	get current ctl value (top of page value)
;	MOVE.W	(SP)+,d1	CONTROLLER VALUE
	qmove.l	(sp)+,d7	*old controller value
	
**we have the old control value in d7, so d7-d1=delta
	qmove.l	te_handle_ptr(a6),a0
	sub.w	d1,d7	this is delta
	beq.s	no_h_thumb
	qbsr	get_width
	ext.l	d7
	muls	d3,d7	delta cursor
	
	add.w	d7,ed_curs_x(a0)	update curs
	qcmove.w	ed_scroll_h_r(a0),d0
	sub.w	ed_scroll_h_l(a0),d0	size in lines
	qmove.w	d1,ed_scroll_h_l(a0)
	add.w	d0,d1
	qmove.w	d1,ed_scroll_h_r(a0)
**Now clear view rect
	lea	ed_viewrect(a0),a0
	OSEraseRect	a0
;	pea	ed_viewrect(a0)
;	dc.w	_eraserect	erase window view
	qmove.l	te_handle_ptr(a6),a0

	bsr	redraw_all_scroll	redraw at scroll
no_h_thumb:
	
;	ADDQ.L	#2,SP
	bra.s	dh_end
not_inthumb:	qmove.l	a6,d1
	lea	callback_rec_store(pc),a0
	qmove.l	a6,(a0)
**LXT change
	if	PPC
	qmove.l	hscroll_upp(a5),a0
**Save a5 in our filter proc!
	lea	a5_store(pc),a1
	qmove.l	a5,(a1)
	qmove.l	a6,4(a1)	*Save our regs we need in filter proc
	else
	lea	hscrollproc(pc),a0
	endif

;	lea	hscrollproc(pc),a0
;	OSTrackControl	h_scroll_h(a6),mouse_glbtoloc(a5),a0,d0

;	CLR.W	-(SP)
	qmove.l	h_scroll_h(a6),d0
	qmove.l	mouse_glbtoloc(a5),d1
;	lea	hscrollproc(pc),a0	routine to use
	OSTrackControl	d0,d1,a0,d0
;;	clr.l	-(sp)
;	DC.W	_TRACKCONTROL	see you in hscrollproc :-)
;	ADDQ.L	#2,SP
	
dh_end:
	rts_	"do_horiz"

		
amygrow:
	qmove.l	news_curs_h(a5),d0
	OSSetCCursor	d0
;	move.l	news_curs_h(a5),-(sp)
;	dc.w	_setccursor
	bsr	find_window
	bmi	agw_end	window not found
	qmove.l	window_ptr(a6),d0
	OSSetPortWindowPort	  d0
;	MOVE.L	WINDow_PTR(a6),-(SP)
;	DC.W	_SETPORT	
**GROWWINDOW
**here
	bsr	get_monitor_rect
**Calcualte height and width allowable
	lea	grow_size_struct(pc),a1
	lea	monitor_rect(a5),a0
	qmove.w	#100,(a1)	*min height
	qmove.w	4(a0),4(a1)	*max height
	qmove.w	#250,2(a1)	*min width - important for project window!
	qmove.w	6(a0),6(a1)	*max width
	qmove.l	window_ptr(a6),d0
qmflag:	set	0
	OSGrowWindow	d0,d7,a1,d0	*d0.w=width
	beq	agw_end	wasnt moved

**SIZEWINDOW
	qmove.l	d0,d7
	qmove.l	d7,d0
	qmove.l	te_handle_ptr(a6),a0
	qbsr	get_width
	clr.l	d1
	qmove.w	d0,d1	*width
	divs	d3,d1
	muls	d3,d1
	qmove.w	d1,d0
	addq.w	#1,d0
	qmove.l	d0,-(sp)	*save new bottomright
	
	bsr.l	deactivate_for_resize
	qmove.l	(sp)+,d0	*restore new bottom right
	qmove.l	d0,d1
	qmove.l	d0,d2
	swap	d2		*other coord
	qmove.l	window_ptr(a6),d0
	qmoveq	#-1,d3
	OSSizeWindow	d0,d1,d2,d3
	save_all
	cmpi.w	#1,window_type(a6)
	bne.s	no_save_pos	*not a doc window
	bsr.l	save_wind_size
	bra.s	done_save_size
no_save_pos:
**must be an Anvil window
**check for find or build window
	qmove.l	error_window(a5),d0
	cmp.l	window_ptr(a6),d0
	bne.s	not_e_window
	bsr.l	save_build_size
	bra.s	done_save_size
not_e_window:
	qmove.l	find_window_id(a5),d0
	cmp.l	window_ptr(a6),d0
	bne.s	not_find_window
	bsr.l	save_find_size
	bra.s	done_save_size
not_find_window:
	cmpi.w	#"LG",window_type(a6)
	bne.s	not_log_w
	bsr.l	save_log_size
	bra.s	done_save_size
not_log_w:
	bsr	save_wind_size
	
done_save_size:
	restore_all
	bra.s	resize_window	*this code is copied so windows aren't saved on open
resize_ent:	
**Make right multiple of font width
	qmove.l	te_handle_ptr(a6),a0
	qbsr	get_width
	clr.l	d1
	qmove.w	d0,d1
	divs	d3,d1
	muls	d3,d1
	qmove.w	d1,d0
	subq.w	#2,d0

	qmove.l	d0,-(sp)	*save new bottomright
	bsr.l	deactivate_for_resize
	qmove.l	(sp)+,d0	*restore new bottom right
resize_ent1:
	qmove.l	d0,d1
	qmove.l	d0,d2
	swap	d2		*other coord
	qmove.l	window_ptr(a6),d0
	qmoveq	#-1,d3
	OSSizeWindow	d0,d1,d2,d3
;	MOVE.L	WINDow_PTR(a6),-(SP)
;	MOVE.W	d0,-(SP)
;	SWAP	d0
;	MOVE.W	d0,-(SP)
;	move.b	#-1,-(SP)	*add to update region
;	DC.W	_SIZEWINDOW
resize_window:

;getwindowregion (handle)
;	qmove.l	(a6),d0
;	qmove.l	#33,d1	;content region
	
;	qmove.l	window_ptr(a6),a0
;	lea	102+0x10(a0),a0 *->content region (handle)
;	qmove.l	(a0),a0

;	qmove.l	(a0),a0		        *is now

	qmove.l	window_ptr(a6),a1
	lea	carbon_temp_rect(a5),a0
	move.l	#40,d1	;content region
	OSGetWindowBounds	a1,d1,a0,d0	;in global coords
;	lea	carbon_temp_rect(a5),a1
;	OSGetPortBounds	a0,a1
	lea	carbon_temp_rect(a5),a0
	qcmove.w	0(a0),d0	;was 2
	qcmove.w	2(a0),d1	;was 4
	cmp.w	toolbar_bottom(a5),d0
	bgt.s	window_pos_ok

	qcmove.w	toolbar_bottom(a5),d2
	add.l	#10,d2
	qmove.l	window_ptr(a6),d0
	qmove.l	#1,d3
	OSMoveWindow	d0,d1,d2,d3
;	move.l	window_ptr(a6),-(sp)
;	move.w	d1,-(sp)	*x - hide windows title bar
;	move.w	d0,-(sp)	*top of window at bottom of menu
;	move.b	#1,-(sp)	*bring to font
;	dc.w	_movewindow
	bsr.l	clear_delta_values
;	bsr.l	erase_cd_display
window_pos_ok:

	move.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	

	lea	carbon_temp_rect(a5),a0
;	lea	portrect(a0),a0
	OSClipRect	a0
	cmpi.w	#"PJ",window_type(a6)
	bne.s	not_proj1

	move.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0

	qmove.l	(a6),d0

	OSInvalWindowRect	d0,a0

test1:
	move.l	window_ptr(a6),a0

not_proj1:
******************
	move.l	te_handle_ptr(a6),a1
;	move.l	(a1),a1	te_rec
	move.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	

	lea	carbon_temp_rect(a5),a0

;	lea	portrect(a0),a0
	move.l	te_handle_ptr(a6),a1
	lea	ed_viewrect(a1),a2
	qmove.l	(a0),(a2)
	qmove.l	4(a0),4(a2)
	sub.w	#sbarwidth+0,6(a2)	right
	sub.w	#sbarwidth+0,4(a2)	bottom
;	sub.w	#status_height,4(a2)	status line
	qmove.l	a1,-(sp)	save terec
	qmove.l	a2,d0
	qmove.l	#0,d1
	qmove.l	#2,d2
	OSInsetRect	d0,d1,d2


;	bsr.l	draw_grow
	qmove.l	(sp)+,a2	get terec
;	lea	ed_viewrect(a2),a1
;	qmove.w	#4,2(a1)	*inset left margin by 4
**linesinfolder=((**ateh).vierect.bottom-(**ateh)viewrect.top)/(**ateh.linehieght)
**if project, we need to use a iffernet calculation
	cmpi.w	#"PJ",window_type(a6)
	beq.s	recalc_proj
	qmove.w	ed_viewrect+bottom(a2),d0	veiwrect.bottom
	ext.l	d0
	sub.w	ed_viewrect+top(a2),d0	      veiwrect.bottom-viewrect.top
	clr.l	d1
	qmove.w	d0,d1

	divs	ed_lineheight(a2),d0	/linehieght=lineinfolder
**v130 - if remainder is zero, then sub 1
	qmove.l	d0,d1
	swap	d1
	tst.w	d1
	bne.s	page_ok
	subq.w	#1,d0
page_ok:
**
**Calc viewrect bottom from lines in folder
	qmove.w	d0,lines_in_folder(a6)

	qcmove.w	ed_scroll_v_t(a2),d1
	add.w	d0,d1
	subq.w	#1,d1
	qmove.w	d1,ed_scroll_v_b(a2)	update scroll bar
	ext.l	d0
	muls	ed_lineheight(a2),d0	*linehieght*linesinfolder
	add.w	ed_viewrect+top(a2),d0	      
	addq.w	#1,d0
vr_ok:
	qmove.w	d0,ed_viewrect+bottom(a2)	this is easy!
	bra	done_calc
recalc_proj:
	bsr.l	calc_proj_vscroll
done_calc:
**movecontrol
	qmove.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	

	lea	carbon_temp_rect(a5),a0

;	lea	portrect(a0),a0
	qcmove.w	right(a0),d1
	sub.l	#15,d1
	cmpi.w	#"PJ",window_type(a6)
	bne.s	not_pj1
	qcmove.w	#20,d2	*top
	bra.s	done_pj1
not_pj1:
	qmove.l	#-1,d2	*top
done_pj1:

	qmove.l	v_scroll_h(a6),d0
	OSMoveControl	d0,d1,d2
**if it is a project wiindow then we need to fill the area above the sb in grey
;	cmpi.w	#"PJ",window_type(a6)
;	bne.s	not_pj3
;	bsr	fill_above_vbar	*grey area above vert sb in proj window

;not_pj3:

	cmpi.w	#"PJ",window_type(a6)
	beq.s	no_h7

	qmove.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0

;	lea	portrect(a0),a0
	qcmove.w	#-1,d1
	qcmove.w	bottom(a0),d2
	sub.w	#15,d2
	cmpi.w	#1,window_type(a6)
	bne.s	no_routines2
	add.w	#width_of_lang_bar,d1	*3d56
no_routines2:
	qmove.l	h_scroll_h(a6),d0
	OSMoveControl	d0,d1,d2

no_h7:

**SIZECONTROL	
	qmove.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0

;	lea	portrect(a0),a0
	qcmove.w	bottom(a0),d2
	sub.w	#13,d2	*would be -14 but top of sb is at -1
	cmpi.w	#"PJ",window_type(a6)
	bne.s	not_pj2
	sub.w	#20,d2	*top
not_pj2:

	qmove.l	v_scroll_h(a6),d0
	qmove.l	#sbarwidth,d1
	
	OSSizeControl	d0,d1,d2
	qmove.l	v_scroll_h(a6),d0
	qmove.l	#0,d1
	OSHiliteControl	d0,d1
	
	qmove.l	v_scroll_h(a6),d0
	OSShowControl	d0	


	cmpi.w	#"PJ",window_type(a6)
	beq.s	no_h8

	qmove.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0

;	lea	portrect(a0),a0
	qcmove.w	right(a0),d0
	sub.w	#13,d0
	cmpi.w	#1,window_type(a6)
	bne.s	no_routines1
	sub.w	#16,d0	*510a10
	sub.w	#width_of_lang_bar,d0	*3d56

no_routines1:
	qmove.l	h_scroll_h(a6),d1
	qmove.l	#sbarwidth,d2
	exg	d0,d1
	OSSizeControl	d0,d1,d2

no_h8:
	bsr.l	draw_grow

**R=**VSCROLL.CONTRLRECT
	qmove.l	v_scroll_h(a6),a0
;	qmove.l	(a0),a0
;	add.l	#controlrect,a0	points to control rect for scroll bar


	lea	carbon_temp_rect(a5),a1
	OSGetControlBounds	a0,a1
	lea	carbon_temp_rect(a5),a0
	
	lea	ar(pc),a1
	qmove.l	(a0),(a1)
	qmove.l	4(a0),4(a1)
	lea	ar(pc),a0
	ifeq	CARBON
	OSValidRect	a0
	else
	qmove.l	window_ptr(a6),d0	
	OSValidWindowRect	d0,a0
	endif
	bsr	setctrl
	qmove.w	#1,stat_now(a5)

**blank out status rect and a bit

	move.l	te_handle_ptr(a6),a0
	move.l	ed_inport(a0),a0	*weird
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a2
;	add.l	#$10,a2	port rect
	lea	EWstatus_rect(pc),a1	  	  	  *Erase status and just above to make sure we don't have text above status
	qmove.w	bottom(a2),0(a1)	top y
	qmove.w	left(a2),2(a1)	      left
	qmove.w	right(a2),6(a1)	right
	qmove.w	0(a1),4(a1)	top to bottom
	qmove.l	te_handle_ptr(a6),a0
;	clr.l	d0
	qcmove.w	ed_lineheight(a0),d0
	sub.w	d0,0(a1)
	sub.w	#sbarwidth-1,4(a1)	correct bottom
	sub.w	#sbarwidth+13,0(a1)	correct top	
	sub.w	#sbarwidth,6(a1)	right+4
	subq.w	#1,0(a1)		*for line

	lea	white(a5),a0
	OSRGBBackColor	a0
;	Xcall	Debugger
	lea	EWstatus_rect(pc),a0
	OSEraseRect	a0
	qmove.l	(a6),d0	
	lea	EWstatus_rect(pc),a0
	OSInvalWindowRect	d0,a0


agw_end:
**Now erase the right hand 1 pixel width side of window
**Set bg colour
	lea	white(a5),a0
	OSRGBForeColor	a0

**Draw a line from top right of view rect+1 to bottom right of view rect+1
	qmove.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0

;	lea	portrect(a0),a0
	OSClipRect	a0

	move.l	te_handle_ptr(a6),a0
;	lea		ed_viewrect(a0),a1
;	move.l	a1,-(sp)
**moveto takes x,y
;	 qcmove.w	 6(a1),d0	 *right
;	 qcmove.w	 (a1),d1
;	 OSMoveTo	 d0,d1
;	 qmove.l	(sp)+,a1
;	 
;	 qcmove.w	 6(a1),d0
;	 qcmove.w	 4(a1),d1
;	 OSLineTo	 d0,d1

	cmpi.w	#"PJ",window_type(a6)
	beq	size_saved	*dont bother with selection code if PJ

	lea	black(a5),a0
	OSRGBForeColor	a0
		
	save_all
	move.l	(a6),a0
	OSSetPortWindowPort	a0
	restore_all
	
	move.l	te_handle_ptr(a6),a0
	lea	ed_viewrect(a0),a0
	OSClipRect	a0	 clip the view window
**If there is a selection then erase all
	move.l	te_handle_ptr(a6),a0
	qmove.l	ed_selstart(a0),d0
	cmp.l	ed_selend(a0),d0
	beq.s	no_selection1
**Is the selection in view?
	bsr	find_line_d0	*start line in d2
	qmove.l	d2,d7
	qmove.l	ed_selend(a0),d0
	bsr	find_line_d0	*end line in d2
**if start>bottm then not in view
;	cmp.l	d2,d7
;	beq.s	no_selection1	*Same line
**if end>top then not in view
	cmp.w	ed_scroll_v_t(a0),d2	*compare end with top
	blt.s	no_selection1
	cmp.w	ed_scroll_v_b(a0),d7	*Copmare startsel with bottom
	bgt.s	no_selection1



	lea	ed_viewrect(a0),a0
	qmove.l	(a6),d0

	OSInvalWindowRect	d0,a0
	qmove.l	te_handle_ptr(a6),a0
	
no_selection1:
;	bsr	redraw_all_scroll
	qmove.l	#-1,old_start(a5)	we are not selecting with mouse!
	bsr.l	colour_selection	do old hilite

**now see if its a find or build window
	qmove.l	error_window(a5),d0
	cmp.l	window_ptr(a6),d0
	bne.s	not_error_window
	bsr.l	save_build_size
	bra.s	done_ss
not_error_window:
	qmove.l	find_window_id(a5),d0
	cmp.l	window_ptr(a6),d0
	bne.s	size_saved		*not find window
	bsr.l	save_find_size
	bra.s	done_ss
size_saved:
done_ss:

	clr.l	d0

	rts_	"do_grow"

*****************************************************************************************
erase_status:
	move.l	te_handle_ptr(a6),a0
	move.l	window_ptr(a6),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a0
	OSClipRect	a0
	
	move.l	te_handle_ptr(a6),a0
	move.l	ed_inport(a0),a0
	bsr.l	get_windowrect_local_coords	;in Carbon_Interfaces	
	lea	carbon_temp_rect(a5),a2
	lea	EWstatus_rect(pc),a1	  	  	  *Erase status and just above to make sure we don't have text above status
	
;	add.l	#$10,a2	port rect
	qmove.w	bottom(a2),0(a1)	top y
	qmove.w	left(a2),2(a1)	      left
	qmove.w	right(a2),6(a1)	right
	qmove.w	0(a1),4(a1)	top to bottom
	sub.w	#sbarwidth-1,4(a1)	correct bottom
	sub.w	#sbarwidth+13,0(a1)	correct top	
	sub.w	#sbarwidth,6(a1)	right+4
	subq.w	#1,0(a1)		*for line

	lea	white(a5),a0
	OSRGBForeColor	a0
	
	lea	EWstatus_rect(pc),a0
	OSPaintRect	a0	fill interior with white
	rts_	"Erase_Status16"
	
**************************************************************
close_all_windows:
	qmoveq	#number_of_windows-1,d7	counter
caw_loop:	qmove.l	d7,d0
	movem.l	d7/a0,-(sp)
	bsr	set_current
	tst.l	d0
	bmi.s	wasnt_one
	bsr	find_window
;	tst.l	d0
	bmi.s	wasnt_one
	bsr	close_window
;	bsr	close_it
	tst.b	abort_shutdown(a5)	*set if a file save is cancelled
	bne	abort_ca
	clr.l	0(a6)	no window_ptr
wasnt_one:	movem.l	(sp)+,d7/a0
	qdbra	d7,caw_loop
	clr.l	active_window(a5)	
no_winds:
	rts_	"Close_all_windows"
abort_ca:
	movem.l	(sp)+,d7/a0
	bra	no_winds
	
********Close it closes the current active window and looks for
**another to activate
close_it:
	clr.b	done_save_ask(a5)
	bsr	find_window
	cmpi.w	#1,window_type(a6)
	bne.s	not_dirty1
	tst.b	dirty(a6)
	beq.s	not_dirty1
	bsr	do_dirty_save
	qmove.b	#1,done_save_ask(a5)
	cmpi.w	#3,d0	*cancel?
	beq	close_canx
	
not_dirty1:
**1.5
**Is it the find window?
	qmove.l	find_window_id(a5),d0
	cmp.l	active_window(a5),d0
	bne.s not_finder		  *click in find window
	tst.b	doing_a_global_search(a5)
	beq.s	not_finder	*Its ok to close, we are not searching
**This is the finder, and we are doing a search, so beep
cant_close:
	qmove.l	#1,d0
	OSSysBeep	d0

	lea	ew_cant_close_at_this_time(pc),a0
	bsr.l	simple_speak
	lea	cant_close_this_window(pc),a1
	bsr.l	dsm
	qmove.l	#30,d0
	bsr	my_delay
close_canx:
	bsr	find_window	set up a6
	moveq	#-1,d0
	rts_	"close_canx"
not_finder:
	tst.b	doing_build(a5)
	beq.s	no_build20
	cmpi.w	#"PJ",window_type(a6)
	beq	cant_close
no_build20:
	qmove.l	error_window(a5),d0
	cmp.l	(a6),d0
	bne.s	not_error
	clr.l	error_window(a5)
	clr.w	current_error_line(a5)
not_error:
	bsr.s	close_window
	tst.w	quit_tool(a5)	   *tell code we are shutting down
	bne.s	shutting_down
	clr.l	0(a6)	no window_ptr
shutting_down:
	subq.w	#1,window_counter(a5)
**now find active window and make current
	OSFrontWindow	d0
	beq.s	no_current

got_wind:	qmove.l	d0,active_window(a5)
	bsr	find_window	set up a6
	tst.w	d0
	bmi.s	no_current
	clr.l	d0
	rts_	"got_wind"

no_current:	clr.l	active_window(a5)
	qmove.l	#0,a6
	moveq	#-1,d0
	rts_	"Close_it"

	
close_window:
	qmove.l	find_window_id(a5),d0
	cmp.l	active_window(a5),d0
	beq	close_finder

	
	cmp.w	#"PJ",window_type(a6)
	beq.s	not_dirty
	cmp.w	#"LG",window_type(a6)
	beq.s	not_dirty
	cmp.w	#"SL",window_type(a6)
	beq.s	not_dirty		
	tst.b	dirty(a6)
	beq.s	not_dirty
	bsr	do_dirty_save
	cmpi.w	#3,d0
	beq	cw_canx1	*canx
not_dirty:
	cmp.w	#"SL",window_type(a6)
	bne.s	not_close_shared_lib
	clr.l	slib_window(a5)
not_close_shared_lib:
;	bsr	find_window
;	bmi	no_wind_to_close

;	bsr	get_window_menu_item	*In menus,returns d7
;	tst.w	d7
;	bmi.s	error
**Now remove window from windows menu
;	addq.w	#1,d7
;	qmove.l	windowsmenu(a5),d0
;	OSDelMenuItem	d0,d7
;error:	
	clr.w	displaying_error(a5)

**If it's the project window, then we scroll it up the screen
	clr.l	d6	*wasn't a project
	cmp.w	#"PJ",window_type(a6)
	bne	not_pjw

**CLose project
	bsr.l	scroll_pj_off	*in proj_window.s
**remove project buffer
	move.l	w_proj_ref(a6),d0	*Was proj_buff_h!!!!!!
	beq.s	eh?
	OSDisposeHandle	d0
	qmoveq	#0,d0
	qmove.l	d0,w_proj_ref(a6)
	qmove.l	d0,proj_buffer_h(a5)
eh?:
**Now remove name from project switch menu
	qmove.l	(a6),d0
	lea	temp_string(a5),a1
	OSGetWTitle	d0,a1
	qmove.l	project_switch_h(a5),d0
qmflag:	set	0
	OSCountMenuItems	d0,d5	     *Number of entries in menu
	beq	nah	*menu is empty????????
**now compare menu strings with window title
	clr.w	d7	*counter
find_name:
	clr.l	d1
	qmove.w	d7,d1
	addq.l	#1,d1
	lea	temp_string2(a5),a0
	qmove.l	project_switch_h(a5),d0
	OSGetMenuItem	d0,d1,a0

**String in temp_string2
**Coonvert to C strings
	lea	temp_string2(a5),a0
	lea	temp_string(a5),a1
;	clr.l	d0
	qcmove.b	(a0)+,d0

	clr.b	0(a0,d0.l)
	qcmove.b	(a1)+,d0

	clr.b	0(a1,d0.l)
*Now either can have a bullet in front of it, so ignore that
	cmpi.b	#165,(a0)
	bne.s	nope1
	addq.l	#1,a0
nope1:
	cmpi.b	#165,(a1)
	bne.s	nope2
	addq.l	#1,a1
nope2:
	bsr.l	strcmp	*LIB func.
	tst.w	d0
	beq.s	got_nm
	addq.w	#1,d7
	cmp.w	d7,d5
	bne.s	find_name
got_nm:
	addq.w	#1,d7
	qmove.l	project_switch_h(a5),d0
	OSDelMenuItem	d0,d7
	moveq	#1,d6	*was a project
	bra.s	not_lo20
nah:
not_pjw:
	cmpi.w	#"LG",window_type(a6)
	bne.s	not_lo20
	clr.l	log_window(a5)	*logsgone
not_lo20:

	move.l	te_handle_ptr(a6),a2
;	move.l	(a2),a2
	qmove.l	ed_linestarts(a2),d0
	OSDisposeHandle	d0	remove starts array
	move.l	te_handle_ptr(a6),a2
	qmove.l	ed_htext(a2),d0
	OSDisposeHandle	d0	and text buffer
	qmove.l	te_handle(a6),d0
	OSDisposeHandle	d0	and finally whole record
	clr.l	te_handle_save(a5)	*so we dont unlock it later
	qmove.l	window_ptr(a6),d0
	OSDisposeWindow	d0

	move.l	0(a6),d0
	beq.s	no_bye
	move.l	d0,a0		        *now find the handle
	OSRecoverHandle	a0,a0
	qpush1	a0

	OSGetMemErr	d0
	qpop1	a0
	tst.w	d0
	bne.s	no_bye	*yes

	OSDisposeHandle	a0

no_bye:

	clr.w	curtop(a6)
	lea	growbytes(a5),a0
	OSMaxMem	a0,d0

no_wind_to_close:
	lea	w_fsspec(a6),a3	point to FSSpec
	clr.l	(a3)	*Wipe Vref
	clr.l	4(a3)	*Wipe file ref
	clr.l	8(a3)	*wipe start of name
	clr.l	12(a3)
	lea	w_from_project(a6),a3
	clr.l	(a3)
	
	clr.l	window_ptr(a6)
	clr.w	copies(a6)	*3fc1 bug fix
	clr.l	active_window(a5)	tis shut
**if was a project then..
	tst.l	d6
	beq.s	wasnt_proj
	qmoveq	#1,d6
	bsr.l	switch_project	*this will set a6!
	save_all
	bsr.l	close_error_window
	restore_all

wasnt_proj:
**Set status line
;	lea	status_string(pc),a1
;	bsr.l	draw_status_message

	clr.l	d0
cw_canx1:
	rts_	"Close_window"
	
close_finder:
	qmove.l	active_window(a5),d0
	OSHideWindow	d0
	bsr	find_window
	bmi	no_wind_to_closef

	move.l	te_handle(a6),a2
	move.l	(a2),a2
	qmove.l	ed_linestarts(a2),d0
	OSDisposeHandle	d0	remove starts array
	move.l	te_handle(a6),a2
	move.l	(a2),a2
	qmove.l	ed_htext(a2),d0
	OSDisposeHandle	d0
;	dc.w	_disposehandle	and text buffer
	qmove.l	te_handle(a6),d0
	OSDisposeHandle	d0
;	dc.w	_disposehandle	and finally whole record
	clr.l	te_handle_save(a5)	*so we dont unlock it later
	qmove.l	window_ptr(a6),d0
	OSDisposeWindow	d0
	move.l	0(a6),d0
	beq.s	no_bye1
	qmove.l	d0,a0		        *now find the handle
	OSRecoverHandle	a0,a0
	qpush1	a0
;	dc.w	_recoverhandle
	OSGetMemErr	d0
	qpop1	a0
	tst.w	d0
	bne.s	no_bye1	*yes
	OSDisposeHandle	a0
no_bye1:
	

	clr.w	curtop(a6)
	lea	growbytes(a5),a0
	OSMaxMem	a0,d0
no_wind_to_closef:
	clr.l	window_ptr(a6)
	clr.l	active_window(a5)	tis shut
	clr.l	find_window_id(a5)
	clr.l	d0
	rts_	"close_finder"
	
close_window_999:
	qmove.l	active_window(a5),d0
	OSHideWindow	d0
	bsr	find_window
	bmi	no_wind_to_close
	move.l	te_handle(a6),a2
	move.l	a2,d0
	beq	no_te
	
	move.l	(a2),a2
	move.l	ed_linestarts(a2),a0
	move.l	a0,d0
	beq.s	no_ls
	push	a2
	OSDisposeHandle	d0
;	dc.w	_disposehandle	remove starts array
	pop	a2
no_ls:	move.l	ed_htext(a2),a0
	move.l	a0,d0
	beq.s	no_text
	OSDisposeHandle	d0
;	dc.w	_disposehandle	and text buffer
no_text:	move.l	te_handle(a6),a0
	move.l	a0,d0
	beq.s	no_te
	OSDisposeHandle	d0
;	dc.w	_disposehandle	and finally whole record
	clr.l	te_handle_save(a5)	*so we dont unlock it later

no_te:
	move.l	window_ptr(a6),d0
	OSDisposeWindow	d0

	move.l	0(a6),d0
	beq.s	no_bye2
	move.l	d0,a0		        *now find the handle
;	dc.w	_recoverhandle
	OSRecoverHandle	a0,a0
	qpush1	a0
	OSGetMemErr	d0
	qpop1	a0
	tst.w	d0
	bne.s	no_bye2	*yes
	OSDisposeHandle	a0
;	dc.w	_disposehandle
no_bye2:

	clr.l	0(a6)	no window_ptr
	subq.w	#1,window_counter(a5)
	lea	growbytes(a5),a0
	OSMaxMem	a0,d0
	clr.l	d0
	rts_	"CW_999"

**set_current sets a window (0-max number of winds) as the active window
**needs d0 as the window
**returns d0=-1 bad window, else 0.
set_current:	tst.w	d0
	bmi.s	bad_window
	cmpi.w	#number_of_windows,d0
	bge.s	bad_window
	ext.l	d0
	move.l	windows_records_h(a5),a6
	move.l	(a6),a6
	mulu	#w_rec_size,d0
	add.l	d0,a6
	tst.l	(a6)
	beq.s	bad_window1
	qmove.l	(a6),active_window(a5)	      put window_ptr in active
	clr.l	d0
	rts_	"set_current_1"	
bad_window:	moveq	#-1,d0	*-1=end of windows
	rts
bad_window1:	moveq	#-2,d0	*-2=slot empty
	rts_	"Set_current"

**DO_ALERT NEDS RES ID IN d0 AND RETURNS BOX CLICKED IN d0
do_alert:
	
	qpush1	d0
	qmove.l	arrow_curs_h(a5),d0
	OSSetCCursor	d0
	lea	this_port(pc),a0
	OSGetPort	a0
	qpop1	d0	*alert number
	qmoveq	#0,d1
	OSAlert	d0,d1,d0
	qpush1	d0
	qmove.l	this_port(pc),d0
	OSSetPortWindowPort	  d0
	qpop1	d0
	rts_	"do_alert"
	
**get_video_rect gets the curent video port size in video_rect(pc)
get_monitor_rect:
	movem.l	d0/d2/a2,-(sp)
;	move.l	0x9ee,a3		**LOW_MEM! Gray_rgn
	OSGetGrayRgn	a3
	qmove.l	(a3),a3		        *pointer to rgn
	lea	monitor_rect(a5),a2
	qmove.l	2(a3),(a2)		*first word is size
	qmove.l	6(a3),4(a2)
	
	movem.l	(sp)+,d0/d2/a2
	rts_	"Get_monitor_rect"
get_main_monitor_rect:
	movem.l	d0/a2/a3,-(sp)
;	move.l	0x9ee,a3		**LOW_MEM! Gray_rgn
	OSGetMainDevice	a0

	move.l	a0,a2
	move.l	(a2),a0
	qmove.l	$22(a0),main_monitor_rect(a5)	; rob changed this from local to global
	qmove.l	$26(a0),main_monitor_rect+4(a5)
	movem.l	(sp)+,d0/a2/a3
	rts_	"Get_monitor_rect"
	

	
**DO_ALERT NEDS RES ID IN d0 AND RETURNS BOX CLICKED IN d0
	align	4
this_port:	ds.l	1
EWnull_string:	dc.b	0,0

**********************************************************************
*Make sure we get right sign on message

	if	powerf				*This is powerf
		ifeq	registered	*unreg version
no_message_text:	dc.b	"   Anvil V2.00 for PowerFantasm - "
			dc.b	"**DEMO** - please register.",0
			even

		else				*reg version
no_message_text:	dc.b	"   Project Manager (SMI 1.10) - "
			dc.b	"development version.",0
			even
		endif
	else					*This is fant
		ifeq	registered	*unreg
no_message_text:	dc.b	"   Anvil V1.00 for Fantasm - "
			dc.b	"***Demo version*** - please register.",0
			even

		else				*Fant registered
no_message_text:	dc.b	"   Anvil V1.00 for Fantasm (SMI 1.10) - "
			dc.b	"010197 release.",0
			even
		endif
	
	endif
	printlog	"End of pass!"
*************************************************************************
null_text:	dc.b	0,0
inactive_text:	dc.b	"Inactive...",0
	align
	
aoldhorizbar:	ds.b	8	old horiz scroll bar
ar:	ds.b	8	temp rect
	align	4
what_control:	ds.l	1	find control puts handle in here
	align	4
callback_rec_store:	ds.l	1	storage for rec ptr
	even
display_off:	pstring	"Hide track display"
	align
grow_size_struct:	ds.w	4	*for window growing
mem_fail_w:	dc.b	"   Not enough memory",13,
	dc.b	"     to open window.",0
	even
new_wind_rect:	dc.w	0,10,200,200
	even
ew_cant_close_at_this_time:	cstring	"Can't close this window right now because it is busy."
	align
cant_close_this_window:	cstring	"    You can't close this window at this time."
	align
cant_find_file:	dc.b	"   Can't find that file.",0
	even
link_found_text:	cstring	"   Hyperlink successful."
	align
not_ppc_text:	dc.b	"The active project is not a "
	dc.b	"PowerPC project. Can't add the shared library.",0
	align
	align	4
delay_result:	ds.l	1	tick count at end of delay
mouse_now:	ds.l	2
mouse_next:	ds.l	2

EWstatus_rect:	ds.w	4
status_delete_rect:	ds.w	4
;EWblue:	dc.w	0,0,56797
EWblue:	dc.w	0,0,0
;blue:	dc.w	0,0,0
light_grey:	dc.w	49071,49151,44091
;grey:	dc.w	$7777,$7777,$7777
dark_grey:	dc.w	$3333,$3333,$3333
aquamarine:	dc.w	$0000,$8888,$9999
EWtemp_rect:	ds.w	4
	align	4
proj_text:	cstring	"   Anvil Project."
	align
region:	ds.l	1
eddie_corrupt:	dc.b	28,"Anvil has been modified!"	
	even
status_string:	cstring	"   Anvil Ready"
	align	4
a5_store:	ds.l	2	*Storeage for our a5 and a6 in filter
	align
not_jumpable_text:	cstring	"   Can't jump to that reference."
	align
no_word_error:	cstring	"    No word to select."
	align

	public	asetvscroll,wind_update
	public	do_content,close_all_windows
	public	close_window,find_window_d0
	public	do_alert	
	global	init_windows,setctrl,no_text_mem
	global	resize_window
	public	amygrow,find_window
	public	set_current,ide_wind_update
	
	global	close_it,aupdate_1

;	global	draw_grow_bgd
	global	dark_grey,light_grey
	global	get_window_number
	global	setup_find_window,global_hyper_load,find_window_external
	global	resize_ent,get_monitor_rect,set_win_bg_colour	
	global	resize_ent1,erase_status,do_double
	global	do_select_enter,draw_v_scroll
	global	count_windows,get_main_monitor_rect,my_delay
	extern	draw_grow
	EXTERN	adjust_menus
	extern	new_tenew,new_teactivate,new_teupdate
	extern	new_te_scroll,squirt_line
	extern	get_width,delete_caret,do_auto_scroll,set_curs
	extern	print_line,do_status_line,do_dirty_save
	extern	find_line_number,redraw_all_scroll,do_alert_3d
	extern	rainbow	*events
	extern	colour_selection,check_for_highlight	*file
	extern	check_for_highlight_up
	extern	print_line_bw,get_window_menu_item,convert_to_num,auto_entry
	extern	hyper_link,caret_on,my_unlock,clear_delta_values,cd_show_time,erase_cd_display
	extern	chroma_line,calc_curs_xy,save_find_size,save_build_size,do_alert_3d_no_updates
	extern	calculate_cursor_xy,find_line,squirt_line_off,squirt_line_nd_off,deactivate_for_resize
	extern	find_line_d0,highlight_to_end,do_status_line_update,do_hilite
**Fant5
	extern	handle_cd_menu,scroll_pj_off,select_project,project_click,switch_project
	extern	simple_speak,add_shared_lib,find_file_given_name,my_resolve_simple
	extern	global_send_to_log
**5.1
	extern	draw_status_message,dsm,setview,do_popup_funcs
**5.2
	extern	save_log_size,draw_grow_bgd
**lib funcs
	extern	getmem,lockmem,strncmp,getkey_turbo,toupper
	extern	strcmp,io_led_drive,save_wind_size,play_a_sound
	extern	calc_proj_vscroll,draw_src_info,close_error_window
	extern	redraw_all_scroll_clip_set,get_text_drag_region,compress_tabs_copy
	extern	is_mouse_over_selection,check_rebuild,do_new_alert_3d,set_theme_window_background