


***************************************************
*Copy file.s
*Based on gen_copy by  Jerry LeVan
*   	 	 	 325 Boone Trail
*   	 	 	 Richmond Ky 40475
*Copy_file needs:
*a2 - source FSSpec
*a3 - dest FSSpec
************NO ERROR CHECKING*******************
*Method:
*checks for the output file. If exists deletes it.
*Creates output file - saves file refnum
*Get file refnum for source file.
*Open input data fork, open output data fork.
*Copy fork and close i/p and o/p.
*Open input resource fork, open outoput resource fork.
*Copy fork and close i/p nad o/p.
**get source attribs

*struct FInfo {
*0    OSType fdType;                      /*the type of the file*/
*4    OSType fdCreator;                   /*file's creator*/
*8    unsigned short fdFlags;             /*flags ex. hasbundle,invisible,locked, etc.*/
*10    Point fdLocation;                   /*file's location in folder*/
*14    short fdFldr;                       /*folder containing file*/

copy_buffer_size:	equ	24*1024
copy_file:

	movem.l	a2/a3,-(sp)

	lea	temp_string(a5),a1	*Where Finfo goes
;	tron
	OSFSpGetFInfo	a2,a1,d0
;	OSFSpGetFInfo	a1,a2,d0

**get copy buffer on sys heap

	qmove.l	#copy_buffer_size,d0

	OSNewHandleClear	d0,a0
	qmove.l	a0,a4	
	movem.l	(sp)+,a2/a3

	move.l	a0,d0
	beq	cf_failed	*couldnt get mem
	qmove.l	a4,-(sp)
	qmove.l	a3,a0
	push	a2
	bsr	delete_output	*get rid of the output file
	pop	a2
	qmove.l	a3,a0
	bsr	create_output
	qmove.l	(sp)+,a4

	push	a2
	bsr	copy_data
	pop	a2

	tst.w	d0
	bmi	cf_failed
	bsr	copy_res
	bmi	cf_failed	 
**now set attribs

	lea	temp_string2(a5),a1	*get attribs
	OSFSpGetFInfo	a3,a1,d0

	lea	temp_string2(a5),a1
	lea	temp_string(a5),a0
	qmove.l	#"tXTb",0(a1)	*set type
	qmove.l	#creator_type,4(a1)	*set creator
	qmove.w	8(a0),8(a1)	*set flags

	OSFSpSetFInfo	a3,a1,d0
	
	qmove.l	a4,d0
	OSDisposeHandle	d0
	clr.l	d0	  
	rts
cf_failed:
	move.l	a4,d0
	OSDisposeHandle	d0
	moveq	#-1,d0
	rts_	"Copy_file"

copy_data:
	global	copy_data
	qmove.l	a2,a0
	bsr	open_data_fork
	tst.w	d0
	bmi.s	cd_failed
;	clr.l	d6
	qcmove.w	refnum(a5),d6	*refnum of input file
	qmove.l	a3,a0
	bsr	open_data_fork
;	clr.l	d7
	qcmove.w	refnum(a5),d7
	tst.w	d0
	bge.s	cd_open_Ok
**Close input file
	qmove.w	d6,-(sp)
	bsr.l	fsclose
cd_failed:
	moveq	#-1,d0
	rts

cd_open_Ok:	
	bsr.s	  copy_a_fork	  *copy data fork
	qmove.w	d6,-(sp)
	bsr.l	fsclose
	qmove.w	d7,-(sp)
	bsr.l	fsclose
	rts_	"CopyData"


copy_res:
	global	copy_res
	qmove.l	a2,a0
	bsr	open_res_fork1
	tst.w	d0
	bmi.s	cr_failed
;	clr.l	d6
	qcmove.w	refnum(a5),d6	*refnum of input file
	qmove.l	a3,a0
	bsr	open_res_fork1
;	clr.l	d7
	qcmove.w	refnum(a5),d7
	tst.w	d0
	bge.s	cr_open_Ok
**Close input file
	qmove.w	d6,-(sp)
	bsr.l	fsclose
cr_failed:
	moveq	#-1,d0
	rts

cr_open_Ok:	
	bsr.s	  copy_a_fork	  *copy data fork
	qmove.w	d6,-(sp)
	bsr.l	fsclose
	qmove.w	d7,-(sp)
	bsr.l	fsclose
	pea	2(a3)	*output volume
	bsr.l	fsflushvol
	rts_	"CopyRes "

**d6=i/p ref
**d7=o/p ref
copy_a_fork:
	global	copy_a_fork

	qmove.w	d6,-(sp)	*refnum
	qmove.l	#copy_buffer_size,-(sp)	*size
	qmove.l	(a4),-(sp)	*buffer
	bsr.l	fsread	*size read in d1
	qmove.l	d0,scratch_1(a5)	*save error
	cmpi.w	#-39,d0
	beq.s	do_writed
	tst.w	d0
	bge.s	do_writed
	rts		*return error

do_writed:
**write
	qmove.w	d7,-(sp)
	qmove.l	d1,-(sp)
	qmove.l	(a4),-(sp)
	bsr.s	  fwrite
	tst.w	d0
	bmi.s	write_d_failed
	qmove.l	scratch_1(a5),d3
	cmpi.w	#-39,d3
	beq.s	caf_done	
	bra.s	copy_a_fork
caf_done:
	clr.l	d0
	rts
write_d_failed:
	moveq	#-1,d0
	rts_	"Copy_a_fork"
fwrite:
	qmove.l	(sp)+,d5
	qbsr.l	get_temp_pb	a0->temp pb
	qmove.l	(sp)+,32(a0)	buffer
	qmove.l	(sp)+,36(a0)	size
	qmove.w	(sp)+,24(a0)	refnum
	qmove.w	#64,44(a0)	posmode from current and write/read verify on
	OSPBWrite	a0,d0
;	DC.W	_WRITE
	qmove.l	d5,a0
	jmp	(a0)
	rts_	"Fwrite"
open_data_fork:
	lea	refnum(a5),a1
	qmove.l	#0,d1
	OSFSpOpenDF	a0,d1,a1,d0
	rts_	"open_data_fork"

open_res_fork1:
	lea	refnum(a5),a1
	qmove.l	#0,d1
	OSFSpOpenRF	a0,d1,a1,d0

	rts_	"Open_res_fork1"

create_output:
	qmove.l	#creator_type,d1
	qmove.l	#"TEXT",d2
	qmove.l	#0,d3
	OSFSpCreate	a0,d1,d2,d3,d0
	rts_	"Create_output"

delete_output:
	bsr.l	size_file	*see if file exists
	tst.l	d0
	bge.s	need_to_delete
	rts
need_to_delete:
	qmove.l	a3,a0
	bsr.l	fspdelete
	rts_	"Delete_output"

	global	copy_file
	extern	fsclose,fspdelete,size_file,fswrite,fsread,fsflushvol,get_temp_pb