	include	pm_equates.def

*******************************************************************************
*Project:       PowerFantasm/PM                                               *
*Author:        Lightsoft                                                     *
*Filename:      create_project.s                                              *
*Version:       5                                                             *
*Date started:  6:01:04 on 20th January 1997                                  *
*Rev. History:                                                                *
*                                                                             *
*                                                                             *
*******************************************************************************
**Project layout
**Compiler
**Assm
**Linker - LIDE ID's
**Returns either zero for OK or -1 for user cancelled
	if	registered	*registered
create_project:
	qmove.l	d_handle(a5),-(sp)
	tst.b	edit_project(a5)
	beq.s	create_1			*editing
	qmove.l	proj_buffer_h(a5),a0
	OSHLock	a0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	bra	edit_1
create_1:
**First lets get a buffer
	qmove.l	#40000,d0
	OSNewHandleClear	d0,a0
	move.l	a0,d0
	beq	memory_err
	qmove.l	a0,proj_buffer_h(a5)	*Save our handle
	OSHLock	a0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	#proj_file_version,p_file_vers(a0)	*Set version
;	move.l	a0,proj_buffer(a5)	*Save our pointer
	clr.l	proj_buffer_index(a5)
	qmove.l	#file_list_start,d0
	qmove.l	d0,(a0)		        *Files start at 8192 (1412 to 8192 is spare as at this date)
	subq.l	#4,d0
	qmove.l	d0,depend_offset(a0)	*offset to dependancies
	subq.l	#4,d0
	qmove.l	d0,miscgumf_offset(a0)	      *offset to misc gumph
**Set up offsets to files
	qmove.l	#76,output_file_offset(a0)
	qmove.l	#72,folders_offset(a0)
	qmove.l	#68,bin_offset(a0)	*wastebasket in Proj window	
	qmove.l	#64,notes_offset(a0)
	qmove.l	#60,vhl_offset(a0)
	qmove.l	#56,vhlh_offset(a0)
	qmove.l	#52,hl_offset(a0)
	qmove.l	#48,hlh_offset(a0)
	qmove.l	#44,source_offset(a0)
	qmove.l	#40,glob_offset(a0)
	qmove.l	#36,sinc_offset(a0)
	qmove.l	#32,obj_offset(a0)
	qmove.l	#28,libs_offset(a0)
	qmove.l	#24,slibs_offset(a0)
	qmove.l	#20,res_offset(a0)

	qmove.l	#16,homeless_offset(a0)
	qmove.l	#12,untitled2_offset(a0)	*spare2
	qmove.l	#8,untitled3_offset(a0)	*spare3
	qmove.l	#4,eof_offset(a0)	*End of file
	clr.l	p_build_number(a0)	*I know it's already zero but...
**Right, see doc Project File layout 220197 for details
**Skip right past offsets to files etc
edit_1:

**item 73 is executable
	tst.b	is_executable(a5)
	bne.s	set_exec
	qbclr	#0,p_misc_flags2(a0)	*not exec
	bra.s	done_exec
set_exec:
	qbset	#0,p_misc_flags2(a0)	*is exec
done_exec:
**item 77 is no header
	tst.b	no_header(a5)
	bne.s	set_nohead
	qbclr	#2,p_misc_flags2(a0)	*not no header
	bra.s	done_nohead
set_nohead:
	qbset	#2,p_misc_flags2(a0)	*no header
done_nohead:
**item 76 is has bundle
	tst.b	has_bundle(a5)
	bne.s	set_bund
	qbclr	#1,p_misc_flags2(a0)	*not exec
	bra.s	done_bund
set_bund:
	qbset	#1,p_misc_flags2(a0)	*is exec
done_bund:


**If editing and not merged, Check filename against old filename
	tst.b	edit_project(a5)
	beq.s	create_11			*creating
	qmove.w	#7,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	bne.s	create_11		*Merged!
	qmoveq	#10,d0
	bsr	get_item_text	*in temp string 2 as pstring

	lea	temp_string2(a5),a0
	lea	edit_filename_save(a5),a1
	clr.l	d0
	qmove.b	(a0),d0
	inc.b	d0
	qbsr.l	strncmp
	tst.l	d0
	beq.s	filename_not_changed
	bsr.l	change_target_name	*in edit_project_stuff
filename_not_changed:
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
create_11:
**Get items and translate
**Item 72 is phase1
	qmove.w	#72,d0
	bsr.l	get_item_value_menu	*in d2
	qmove.w	#72,d0
	qmove.l	a0,-(sp)
	bsr.l	get_class_for_item	*routine back trnaslates menu id to tool class in a0 as six xhars
	qmove.l	(sp)+,a1	*get project file
	qmove.l	(a0),p_phs1(a1)
	qmove.w	4(a0),p_phs1+4(a1)	*save phs2 class
	qmove.l	a1,a0

**Item 4 is compiler
	qmove.w	#4,d0
	bsr.l	get_item_value_menu	*in d2
	qmove.w	#4,d0
	qmove.l	a0,-(sp)
	bsr.l	get_class_for_item	*routine back trnaslates menu id to tool class in a0 as six xhars
	qmove.l	(sp)+,a1	*get project file
	qmove.l	(a0),p_phs2(a1)
	qmove.w	4(a0),p_phs2+4(a1)	*save phs2 class
	qmove.l	a1,a0
**Item 5 is assembler
	qmove.w	#5,d0
	bsr.l	get_item_value_menu	*in d2
	qmove.w	#5,d0
	qmove.l	a0,-(sp)
	bsr.l	get_class_for_item	*routine back trnaslates menu id to tool class in a0 as six xhars
	qmove.l	(sp)+,a1	*get project file
	qmove.l	(a0),p_phs3(a1)
	qmove.w	4(a0),p_phs3+4(a1)	*save phs2 class
	qmove.l	a1,a0

**Item 6 is linker
	qmove.w	#6,d0
	bsr.l	get_item_value_menu	*in d2
	qmove.w	#6,d0
	qmove.l	a0,-(sp)
	bsr.l	get_class_for_item	*routine back trnaslates menu id to tool class in a0 as six xhars
	qmove.l	(sp)+,a1	*get project file
	qmove.l	(a0),p_phs4(a1)
	qmove.w	4(a0),p_phs4+4(a1)	*save phs2 class
	qmove.l	a1,a0

**Item 68 is pb1
	qmove.w	#68,d0
	bsr.l	get_item_value_menu	*in d2
	qmove.w	#68,d0
	qmove.l	a0,-(sp)
	bsr.l	get_class_for_item	*routine back trnaslates menu id to tool class in a0 as six xhars
	qmove.l	(sp)+,a1	*get project file
	qmove.l	(a0),p_postb1(a1)
	qmove.w	4(a0),p_postb1+4(a1)	*save phs2 class
	qmove.l	a1,a0

**Item 69 is pb2
	qmove.w	#69,d0
	bsr.l	get_item_value_menu	*in d2
	qmove.w	#69,d0
	qmove.l	a0,-(sp)
	bsr.l	get_class_for_item	*routine back trnaslates menu id to tool class in a0 as six xhars
	qmove.l	(sp)+,a1	*get project file
	qmove.l	(a0),p_postb2(a1)
	qmove.w	4(a0),p_postb2+4(a1)	*save phs2 class
	qmove.l	a1,a0
**Item 70 is pb3
	qmove.w	#70,d0
	bsr.l	get_item_value_menu	*in d2
	qmove.w	#70,d0
	qmove.l	a0,-(sp)
	bsr.l	get_class_for_item	*routine back trnaslates menu id to tool class in a0 as six xhars
	qmove.l	(sp)+,a1	*get project file
	qmove.l	(a0),p_postb3(a1)
	qmove.w	4(a0),p_postb3+4(a1)	*save phs2 class
	qmove.l	a1,a0
**Item 71 is pb4
	qmove.w	#71,d0
	bsr.l	get_item_value_menu	*in d2
	qmove.w	#71,d0
	qmove.l	a0,-(sp)
	bsr.l	get_class_for_item	*routine back trnaslates menu id to tool class in a0 as six xhars
	qmove.l	(sp)+,a1	*get project file
	qmove.l	(a0),p_postb4(a1)
	qmove.w	4(a0),p_postb4+4(a1)	*save phs2 class
	qmove.l	a1,a0

**We're now at byte 80 which is debug on for new files - item 58
	if	debug_in_proj_window
	qmove.w	#58,d0
	bsr.l	get_item_value_menu	*in d2

	subq.w	#1,d2
	qmove.w	d2,d0
	cmp.b	p_debug(a0),d0
	beq.s	no_debug_change
**need to force a phase 4
	qbclr	#4,p_misc_flags(a0)
	qbclr	#0,p_misc_flags(a0)	*good last build - not - cross out target icon
	qbset	#7,p_misc_flags(a0)
	move.b	#1,debug_state_changed(a0)
no_debug_change:
	qmove.b	d0,p_debug(a0)
	else
	clr.b	p_debug(a0)
	endif
**Item 8 is linklibs
	qmove.w	#8,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	qmove.w	d2,d0
	qmove.b	d0,p_static(a0)
**Find out if merged or new
;	tst.b	edit_project(a5)
;	bne	edit_2			*editing

	qmoveq	#10,d0
	bsr	get_item_text	*in temp string 2 as pstring
 	lea	temp_string2(a5),a3
	cmp.l	#"PM_w",1(a3)	*Merged or new
	bne	is_not_merged
	cmp.l	#"ill_",5(a3)	*Merged or new
	bne	is_not_merged
	qmoveq	#1,d0
	qmove.b	d0,p_ismerged(a0)

	bra	is_not_merged	*CARBON
****************************************************
**Find out where user wants to merge this project with
;PROCEDURE CustomGetFile (fileFilter: FileFilterYDProcPtr;
;	 	 	 	 	 	 	 	 	 numTypes: Integer; 
;	 	 	 	 	 	 	 	 	 typeList: SFTypeList; 
;	 	 	 	 	 	 	 	 	 VAR reply: StandardFileReply; 
;	 	 	 	 	 	 	 	 	 dlgID: Integer;
;	 	 	 	 	 	 	 	 	 where: Point; 
;	 	 	 	 	 	 	 	 	 dlgHook: DlgHookYDProcPtr; 
;	 	 	 	 	 	 	 	 	 filterProc: ModalFilterYDProcPtr;
;	 	 	 	 	 	 	 	 	 activeList: Ptr; 
;	 	 	 	 	 	 	 	 	 activateProc: ActivateYDProcPtr;
;									yourDataPtr: UNIV Ptr);

*	 movem.l	d7/a1,-(sp)
*	 clr.l	 d0	 *File filter
*	 qmove.w	#-1,d1	*NUm type
*	 clr.l	 d2	 *Typelist
*	 lea	 temp_string3(a5),a0	 *Sfreply please
*	 qmove.w	#129,d3	*Dialog ID
*	 clr.l	 d4	 *Where
*	 clr.l	 d5	 *DLGHook
*	 clr.l	 d6	 *Modalfilter
*	 clr.l	 d7	 *Active list
*	 OSCustomGetFile	d0,d1,d2,a0,d3,d4,d5,d6,d7
*
*	 movem.l	(sp)+,d7/a1
*	 
*	 lea	 temp_string3(a5),a0
*	 tst.b	 (a0)
*	 beq	 return
***NOw make an alias to the file
*	 movem.l	d7/a1,-(sp)
*	 
*	 clr.l	 d0
*	 lea	 temp_string3+6(a5),a0	 *Fsspec
*	 lea	 merged_file_alias_h(a5),a1	 	 *handle to alias
*	 OSNewAlias	 d0,a0,a1,d0
*
*;	  clr.w	-(sp)
*;	  clr.l	-(sp)
*;	  pea	  temp_string3+6(a5)	  *Fsspec
*;	  pea	  merged_file_alias_h(a5)	 	  *handle to alias
*;	  moveq	#2,d0		  	  *make alias
*;	  dc.w	  _aliasdispatch
*;	  move.w	(Sp)+,d0	  *error
*
***Alias layout
***4 bytes user
***2 bytes size inc user and size
***data
*	 move.l	merged_file_alias_h(a5),a0	 *This is a handle to the alias
*	 move.l	(a0),a0
***Size is in bytes 4-7
*	 clr.l	 d0
*	 qmove.w	4(a0),d0	 *Size of record	
*	 movem.l	(sp)+,d7/a1
*	 bsr	 store_output_file	 *in project_file_management
***Now chage filename to my_proj
*	 lea	 temp_string3(a5),a3
*	 qmove.l	proj_buffer_h(a5),a0
*	 move.l	(a0),a0
*	 lea	 p_filename(a0),a1
*	 bsr	 copy_pstring
*
*;	  move.l	proj_buffer_h(a5),a0
*;	  move.l	(a0),a0	*get our pointer
*;	  lea	  p_filename(a0),a1
*;	  move.b	#10,(a1)+
*;	  move.l	#"my_p",(a1)+
*;	  move.l	#"roje",(a1)+
*;	  move.w	#"ct",(a1)+
*	 move.l	proj_buffer_h(a5),a0	 *get our pointer
*	 move.l	(a0),a0
*	 bra.s	 done_name	;end of CARBON

is_not_merged:

**Copy filename from item 10 (filename)
	tst.b	edit_project(a5)
	bne.s	edit_2		*don't change filename if editing, it'll be done already

	qmoveq	#10,d0
	bsr	get_item_text	*in temp string 2 as pstring
 	lea	temp_string2(a5),a3
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	lea	p_filename(a0),a1
	bsr	copy_pstring
	qmoveq	#0,d0		*IS NOT merged
	qmove.l	proj_buffer_h(a5),a0
	qmove.l	(a0),a0
	qmove.b	d0,p_ismerged(a0)
edit_2:
done_name:
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.w	#9,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	move.b	d2,p_ismerged(a0)
**Rescopier.l - RINT=internal=item 7 = 1=on, 2=off
	qmove.w	#7,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	move.w	d2,d0
	bne.s	res_off
	qmove.l	#"RINT",d0
	bra.s	done_res
res_off:
	qmove.l	#0,d0
done_res:
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	d0,p_rescopy(a0)
**type 11
	moveq	#11,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	qmove.l	1(a3),d0
	qmove.l	proj_buffer_h(a5),a0
	qmove.l	(a0),a0
	qmove.l	d0,p_type(a0)
	
**creator 12
	qmoveq	#12,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	qmove.l	1(a3),d0
	qmove.l	proj_buffer_h(a5),a0
	qmove.l	(a0),a0
	qmove.l	d0,p_creator(a0)
****restype 13
	qmoveq	#13,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	qmove.l	1(a3),d0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	d0,p_restype(a0)
**REsiD 14
	qmoveq	#14,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	clr.l	d0
 	qmove.b	(a3)+,d0
**LXT change
	push	a3
	add.w	d0,a3
	clr.b	(a3)
	popq	a3
**end change
;	clr.b	(a3,d0.w)	*Convert pascal to C string
 	bsr	get_dec
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0	*get our pointer
	qmove.l	d0,p_res_id(a0)

**105 is make code 0? 16
	qmove.w	#16,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	qmove.w	d2,d0
	qmove.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.b	d0,p_code0(a0)
**106 is make size res? 66
	qmove.w	#66,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	qmove.w	d2,d0
	qmove.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.b	d0,p_size(a0)
**107 is make cfrg 15
	qmove.w	#15,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	qmove.w	d2,d0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.b	d0,p_cfrg(a0)
**108 is make vers 67
	qmove.w	#67,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	qmove.w	d2,d0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.b	d0,p_vers(a0)
**109 to 11 is spare

**112 is filename256 - not actually used :-)
*368 is byte indicators for type of files
	clr.b	p_vhl_fti(a0)	*vhl
*369 and 370 is hl and headers
	cmpi.l	#"N   ",p_phs2(a0)	*This is N000
	beq.s	no_phase2
	st	p_hl_fti(a0)
	st	p_hlh_fti(a0)
no_phase2:
**371 is assembler source

	cmpi.l	#"N   ",p_phs3(a0)
	beq.s	no_phase3
**Create src and global incs
	st	p_src_fti(a0)
	st	p_globs_fti(a0)
	st	p_sinc_fti(a0)
no_phase3:
	st	p_obj_fti(a0)	*Object files
**374 is static libs - we always heve them
;	tst.b	p_static(a0)
;	bne.s	no_libs2
	st	p_libs_fti(a0)	*libs directory
;no_libs2:
**375 is res files
	st	p_res_fti(a0)
**376 is shared libs - only if ppc - try for CP or AP
	move.w	p_phs2(a0),d0	*try compiler
	beq.s	no_comp3
	cmpi.b	#"P",d0
	bne.s	done_shared_libs	*68k
	st	p_slibs_fti(a0)
	bra.s	done_shared_libs
no_comp3:
	move.w	p_phs3(a0),d0
	beq.s	done_shared_libs	*No ass?
	cmpi.b	#"P",d0
	bne.s	done_shared_libs
	st	p_slibs_fti(a0)
done_shared_libs:
**377 is notes
	st	p_notes_fti(a0)
	
**378-567 spare
**568 is size resource
**568 is size in BYTES - item 23
	qmoveq	#23,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	clr.l	d0
 	qmove.b	(a3)+,d0
**LXT change
	push	a3
	add.w	d0,a3
	clr.b	(a3)
	pop	a3
**end change
;	clr.b	(a3,d0.w)	*Convert pascal to C string
 	bsr	get_dec
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0	*get our pointer
	mulu	#1024,d0
	qmove.l	d0,p_size_size(a0)
**572 is size flags.w
	qmove.b	size_flags1(a5),p_size_flags(a0)
	qmove.b	size_flags2(a5),p_size_flags+1(a0)
**574 is spare 100 bytes
**Vers resource at 674
**version 59,60 and 61 - we need to convert them to real bcd which means subtracting "0"
	qmoveq	#59,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	clr.l	d0
 	qmove.b	1(a3),d0
	subi.b	#"0",d0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.b	d0,p_vers_vers(a0)
	
	qmoveq	#60,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	clr.l	d0
 	move.b	1(a3),d0
	subi.b	#"0",d0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.b	d0,p_vers_vers+1(a0)

	qmoveq	#61,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	clr.l	d0
 	qmove.b	1(a3),d0
	subi.b	#"0",d0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.b	d0,p_vers_vers+2(a0)

**release byte - item 62
	qmove.w	#62,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	qmove.w	d2,d0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.b	d0,p_vers_release(a0)
**Country code
	qmove.w	#63,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	qmove.w	d2,d0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.b	d0,p_vers_country(a0)
*679 is spare
*680 is short string - 64
	qmoveq	#64,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0 
	lea	p_vers_short(a0),a1
 	bsr	copy_pstring	*in misc_stuff_new.s
 	
*936 is long string - 65
	qmoveq	#65,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	lea	p_vers_long(a0),a1
	bsr	copy_pstring
**1192-1291 spare
**CFRG
*1292 is update level

	qmove.w	#48,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	clr.l	d0
	qmove.w	d2,d0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0

	qmove.l	d0,p_cfrg_upd(a0)
**1296 is current version
**There are four bytes - major, minor, development version and release stage.
**Due to a cock up in gesign, we support just major and minor revisions. The low
**Order two bytes are always set to zero.
	qmoveq	#49,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	clr.l	d0
	move.b	(a3),d1
	beq.s	got_vers	*none
	cmpi.b	#1,d1
	bne.s	2_digits
	qmove.b	1(a3),d0
	subi.b	#"0",d0
	lsl.w	#8,d0
	swap	d0
	bra.s	got_vers
2_digits:
	qmove.b	1(a3),d0
	subi.b	#"0",d0
	lsl.w	#8,d0
	qmove.b	2(a3),d0
	subi.b	#"0",d0
	swap	d0
got_vers:
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	d0,p_cfrg_cver(a0)
	
**1300 is oldest def version
**There are four bytes - major, minor, development version and release stage.
**Due to a cock up in gesign, we support just major and minor revisions. The low
**Order two bytes are always set to zero.
	qmoveq	#50,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	clr.l	d0
	move.b	(a3),d1
	beq.s	got_verso	*none
	cmpi.b	#1,d1
	bne.s	2_digitso
	qmove.b	1(a3),d0
	subi.b	#"0",d0
	lsl.w	#8,d0
	swap	d0
	bra.s	got_verso
2_digitso:
	qmove.b	1(a3),d0
	subi.b	#"0",d0
	lsl.w	#8,d0
	qmove.b	2(a3),d0
	subi.b	#"0",d0
	swap	d0
got_verso:
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	d0,p_cfrg_over(a0)
**Stack size in 1304
	qmoveq	#51,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	clr.l	d0
 	qmove.b	(a3)+,d0
**LXT change
	push	a3
	add.w	d0,a3
	clr.b	(a3)
	pop	a3
**end change
;	clr.b	(a3,d0.w)	*Convert pascal to C string
 	bsr	get_dec
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	muls	#1024,d0
	qmove.l	d0,p_cfrg_stk(a0)
	
**1308 is fragment library directory
	qmoveq	#52,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	clr.l	d0
 	move.b	(a3)+,d0
 	beq.s	zero_id
**LXT change
;	push	a3
;	add.w	d0,a3
;	clr.b	(a3)
;	pop	a3
**end change
	clr.b	(a3,d0.w)	*Convert pascal to C string
 	bsr	get_dec
zero_id:
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0	*get our pointer

	move.w	d0,p_cfrg_libdir(a0)
**1310 is type - 0 is lib, 1 is app, 2 is dropin
	move.w	#53,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.b	d2,p_cfrg_type(a0)
**1311 is location
	qmove.w	#54,d0
	bsr.l	get_item_value_menu	*in d2
	subq.w	#1,d2
	qmove.b	d2,p_cfrg_loc(a0)	*if d2=2 then the next 2 are res type and ID
	cmpi.b	#1,d2
	beq.s	restype_is_length
*1312 is resource type
**here the restype is the restype of the resource
	qmoveq	#55,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	1(a3),p_cfrg_restype(a0)
	bra.s	done_restype
restype_is_length:
	qmoveq	#55,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	clr.l	d0
 	move.b	(a3)+,d0
 	beq.s	zero_id2
**LXT change
;	push	a3
;	add.w	d0,a3
;	clr.b	(a3)
;	pop	a3
**end change
	clr.b	(a3,d0.w)	*Convert pascal to C string
 	bsr	get_dec
zero_id2:
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	d0,p_cfrg_restype(a0)
done_restype:

	qmoveq	#75,d0
	bsr	get_item_text	*in temp string 2 as pstring - resid of cfrg
 	lea	temp_string2(a5),a3
	clr.l	d0
 	move.b	(a3)+,d0
 	beq.s	zero_id3
**LXT change
;	push	a3
;	add.w	d0,a3
;	clr.b	(a3)
;	pop	a3
**end change
	clr.b	(a3,d0.w)	*Convert pascal to C string
 	bsr	get_dec
zero_id3:
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	d0,p_frag_res_id(a0)


	qmoveq	#56,d0
	bsr	get_item_text	*in temp string 2 as pstring - we know it's 4 chars as it's been sanitied
 	lea	temp_string2(a5),a3
	clr.l	d0
 	move.b	(a3)+,d0
 	beq.s	zero_id1
**LXT change
;	push	a3
;	add.w	d0,a3
;	clr.b	(a3)
;	pop	a3
**end change
	clr.b	(a3,d0.w)	*Convert pascal to C string
 	bsr	get_dec
zero_id1:
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	d0,p_cfrg_resid(a0)
	qmove.l	#"1320",1320(a0)	*reserved long - so I can spot it in a dump.
	
**Copy fragname from item 74 (fragname)
	qmoveq	#74,d0
	bsr	get_item_text	*in temp string 2 as pstring
 	lea	temp_string2(a5),a3
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	lea	p_frag_name(a0),a1
	bsr	copy_pstring

*TAadaah! Now that was boring!
**Now do secondary sanity check on actual project binary
	bsr.l	analyse_setup	*Secondary sanity check - file
	tst.l	d0
	bmi	return
	tst.b	edit_project(a5)
	bne	edit_3			*editing

cancelled:
got_filename:

**Now save project
**Move back to applications folder
	qmove.l	pm_dirid(a5),d0	*make save folder same as windows dirid
	OSPutCurDirStore	d0
	qmove.w	pm_vrefnum(a5),d0	*Got when we scanned for project setups
	neg.w	d0
	OSPutSFSaveDisk	d0

;	move.w	d0,$214
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
**WE have to append _prj to the filename

	lea	p_filename(a0),a1	*The filename
	clr.l	d0
	qmove.b	(a1),d0
	cmpi.b	#27,d0
	blt.s	we_can_append
	move.l	#"_Prj",27(a1)
	bra.s	done_append
we_can_append:

	inc.w	d0
	qmove.l	#"_Prj",0(a1,d0.w)
	addq.b	#4,(a1)
done_append:
	movem.l	d7/a1,-(sp)
;carbon
	lea	CPnew_proj_prompt(pc),a2
	move.l	a1,a3	;name
	lea	temp_string3(a5),a1
	move.l	a1,scratch_1(a5)	;where fsspec to go

	bl	ns_writeselector

*	 lea	 CPnew_proj_prompt(pc),a0	 *prompt
*	 move.l	a0,d0
*	 qmove.l	a1,d1	 	 	 *name is in a1
*	 lea	 temp_string3(a5),a2	 *Reply
*	 qmove.l	a2,d2
*	 qmove.w	#141,d3	*Dialog ID
*	 clr.l	 d4	 *Where
*;	 clr.l	 d5	 *DLGHook
*;	 clr.l	 d6	 *Modalfilter
*;	 clr.l	 d7	 *Active list
*;	 clr.l	 d5	 *Activate proc
*;	 clr.l	 d6	 *data pointer
*	 OSCustomPutFile	d0,d1,d2,d3,d4,d4,d4,d4,d4,d4
*;end carbon

;	pea	new_proj_prompt(pc)
;	 move.l	a1,-(sp)	 *name
;	 pea	 temp_string3(a5)	 *Reply
;
;	 move.w	#141,-(Sp)	 *Dialog ID
;	 clr.l	 -(sp)	 *Where
;	 clr.l	 -(sp)	 *DLGHook
;	 clr.l	 -(sp)	 *Modalfilter
;	 clr.l	 -(sp)	 *Active list
;	 clr.l	 -(sp)	 *Activate proc
;	 clr.l	 -(sp)	 *data pointer
;	 move.w	#7,-(sp)	 *Custom write file
;	 dc.w	 _pack3

	movem.l	(sp)+,d7/a1
	lea	temp_string3(a5),a0
	tst.b	(a0)
	beq	return
	save_volatile
	qmove.l	busy_curs_h(a5),d0
	Curs	d0
	restore_volatile

**Now we have to create the project folders and the output file
**then make an alias to it for the project file unless it's merged in whaich case we already
**have an output alias. In this case we make an alias to the output file and store it
**In the prject folder

**First save project file
**Check for _PRj at end
**WE have to append _prj to the filename

	lea	12(a0),a1	*The filename
	move.l	a1,a2
	clr.l	d0
	qmove.b	(a2),d0
	inc	d0
	subq.l	#4,d0
	bmi.s	no_proj
	add.l	d0,a2		        *point to end of filename
	cmpi.l	#"_Prj",(a2)
	beq.s	got_proj
no_proj:
	clr.l	d0
	qmove.b	(a1),d0
	cmpi.b	#27,d0
	blt.s	we_can_append1
	qmove.l	#"_Prj",27(a1)
	bra.s	done_append1
we_can_append1:
	inc.w	d0
	qmove.l	#"_Prj",0(a1,d0.w)
	addq.b	#4,(a1)
done_append1:
got_proj:
	lea	6(a0),a0		*FSSpec
	lea	proj_fsspec(a5),a1
	bsr.l	the_copy_fsspec
**2.2a3
**See if Anvil project binraries exists

	lea	proj_fsspec(a5),a0
	move.w	(a0),d0
	move.l	2(a0),d1
	lea	pb_name(pc),a0
	lea	build_proj_fsspec(a5),a1
	bsr.l	make_fsspec
	tst.w	d0
	bne.s	no_existing_project
**Show warning..
	qmove.w	#1002,d0	*yes/no box number
	lea	proj_exists_text(pc),a0
	qmoveq	#18,d1	*x
	qmoveq	#80,d2	*y
	bsr.l	do_new_alert_3d
	bra	return_and_clear

no_existing_project:
	lea	proj_fsspec(a5),a0
	lea	build_proj_fsspec(a5),a1
	bsr.l	the_copy_fsspec
**Now get rid of _prj in project file..
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a0
	subq.b	#4,p_filename(a0)	*easy!

**a1 is buffer, d0 is size
	bsr	calc_project_size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qmove.l	#"FEpj",creator(a5)
	lea	proj_fsspec(a5),a0	*Point to the fsspec	
	bsr.l	sys_write_file_set_type	*Write the project file
**Hurrah - thats our anchor set
**NExt, if project is to be created, we need to make a dummy project next right
**To the project file.

	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	tst.b	p_ismerged(a1)
	bne.s	merged	*We have it as an alias already, so dump it do disk
	bsr	create_dummy_app	*create the dummy - returns the fsspec in temp_string3

wasnt_merged:	
**NOw make an alias to the file relative to the project file!
	movem.l	d7/a1,-(sp)
;	clr.w	-(sp)
	lea	proj_fsspec(a5),a0		*relative to here - nope
;	clr.l	-(sp)			*NO relative
	lea	temp_string3(a5),a1	*Fsspec
	lea	scratch_1(a5),a2		*handle to alias
	OSNewAlias	a0,a1,a2,d0

**Alias layout
**4 bytes user
**2 bytes size inc user and size
**data
	move.l	scratch_1(a5),a0	*This is a handle to the alias
	move.l	(a0),a0
**Size is in bytes 4-7
	clr.l	d0
	qmove.w	4(a0),d0	*Size of record	
	movem.l	(sp)+,d7/a1

	bsr	store_output_file	*create the actual output file
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1

	bra.s	done_output
merged:
**Create an alias to the merged app if it is indeed an application
**Dont create alias to anything else!

	bsr	create_desktop_alias	*Asks user	
done_output:
**We make a folder by...?I.M.
*FUNCTION FSpDirCreate (spec: FSSpec; scriptTag: ScriptCode; 
*								VAR createdDirID: LongInt): OSErr;

	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	tst.b	p_vhl_fti(a1)
	beq.s	no_phase1
 	lea	very_high_level(pc),a3		*
	move.l	#"vhl ",folder_type(a5)		*For create folder to add to proj file
	bsr	create_folder_with_project	*

	lea	very_high_level_headers(pc),a3		*
	qmove.l	#"vhlh",folder_type(a5)		*For create folder to add to proj file
	bsr	create_folder_with_project	*
no_phase1:
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	tst.b	p_hl_fti(a1)
	beq.s	no_phs2

	lea	high_level(pc),a3		*
	qmove.l	#"hl  ",folder_type(a5)		* 
	bsr	create_folder_with_project	*
						* - These three only if a high level proj
	lea	high_level_headers(pc),a3	*
	move.l	#"hlh ",folder_type(a5)		* For create folder to add to proj file
	bsr	create_folder_with_project	*
no_phs2:	
	lea	waste(pc),a3		*
	qmove.l	#"bin ",folder_type(a5)		*For create folder to add to proj file
	bsr	create_folder_with_project	*

	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1

	tst.b	p_src_fti(a1)
	beq.s	no_phs3

	lea	low_level(pc),a3
	qmove.l	#"src ",folder_type(a5)		*For create folder to add to proj file
	bsr	create_folder_with_project	*Temp_alis_h is alias to folder
	
	lea	glob_level(pc),a3
	qmove.l	#"glob",folder_type(a5)		*For create folder to add to proj file
	bsr	create_folder_with_project	*Temp_alis_h is alias to folder

	lea	sinc_level(pc),a3
	qmove.l	#"sinc",folder_type(a5)		*For create folder to add to proj file
	bsr	create_folder_with_project	*Temp_alis_h is alias to folder
no_phs3:
	lea	obj_level(pc),a3
	qmove.l	#"obj ",folder_type(a5)		*For create folder to add to proj file
	bsr	create_folder_with_project	

	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
**We always have static libs folder
;	tst.b	p_static(a1)
;	bne.s	no_static_libs
	lea	lib_level(pc),a3
	qmove.l	#"lib ",folder_type(a5)		*For create folder to add to proj file
	bsr	create_folder_with_project
;no_static_libs:
	lea	res_level(pc),a3
	qmove.l	#"reso",folder_type(a5)		*For create folder to add to proj file
	bsr	create_folder_with_project	*MUST HAVE A RESOURCES folder
**check out linker class. If it's LPPxxx then we can generate a shared libs folder
**but delete the actual folder!
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qmove.l	p_phs4(a1),d0
	lsr.l	#8,d0	*just first 3 chars
	cmpi.l	#"LPP",d0
	bne.s	no_shared_libs
	lea	slib_level(pc),a3
	qmove.l	#"slib",folder_type(a5)		*For create folder to add to proj file
	bsr	create_folder_with_project
no_shared_libs:		
	lea	notes(pc),a3
	qmove.l	#"note",folder_type(a5)	*For create folder to add to proj file
	bsr	create_folder_with_project
edit_3:
**if editing, set p_misc_flags(4)
	tst.b	edit_project(a5)
	beq.s	edit_41			*editing
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qbclr	#6,p_misc_flags(a1)	*build must do post build run
	qbclr	#4,p_misc_flags(a1)
edit_41:
**NOW rewrite project file with project alias intact
**a1 is buffer, d0 is size

	bsr	calc_project_size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qmove.l	#"FEpj",creator(a5)
	lea	proj_fsspec(a5),a0	*Point to the fsspec	
	bsr.l	sys_write_file_set_type	*Write the project file

	move.l	(sp)+,d_handle(a5)
**Do we have a build tool?
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a1
	qbset	#1,can_build(a1)	*yes we have tools
	lea	temp_string4(a5),a1
	qmove.l	#"BUIL",(a1)
	qmove.w	#"Dx",4(a1)	*do we have a PPC/68k chroma?
	bsr.l	get_tool_entry	*returns address in (a3)
	tst.l	d0
	bmi.s	no_build1	*in case it's been removed?
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a1
	qbset	#2,can_build(a1)	*yes we have build
no_build1:
	clr.l	d0
	rts_	"Create_project"
	endif	of ifeq registered
**USr cancelled so ditch project
return:
	qmove.l	proj_buffer_h(a5),d0
	OSDisposeHandle	d0
	clr.l	proj_buffer_h(a5)	*So we can check whether we have a live one or not

	qmove.l	(sp)+,d_handle(a5)
	moveq	#-1,d0
	rts_	"Create_project"
return_and_clear:
	lea	proj_fsspec(a5),a0
	clr.l	(a0)	*no project
	bra.s	return
********************************************************************
**NEeeds name in a3, munges with name in Fsspec
create_folder_with_project:
**Copy fsspec to proj_fsspec(a5)
	lea	proj_fsspec(a5),a0	*Point to the fsspec
	qmove.w	(a0),d0
	qmove.l	2(a0),d1
**Name at 6(a0)
	lea	6(a0),a0		*Project name
**Copy project name to temp_string1(a5)
	lea	temp_string4(a5),a2
	clr.l	d2
	qmove.b	(a0)+,d2
	subq.b	#4,d2			*Get rid of _PRj
	qmove.b	d2,(a2)+
copy_nam2:
	qmove.b	(a0)+,(a2)+
	dbra	d2,copy_nam2
	clr.l	d2
	clr.l	d3
	clr.l	d4
	clr.l	d5
	lea	temp_string4(a5),a0	*PRoject name
	qmove.b	(a3),d2	*Length of name of folder
	qmove.b	(a0),d3	*Length of project name
	qmove.b	d3,d4	*Copied
	add.b	d2,d4
	cmpi.b	#31,d4
	blt.s	we_have_space
**WE do not have space
	inc a3		*point to first char of folder
	qmove.b	#31,d5
	sub.b	d2,d5	*OFfset we need
	qmove.b	#31,(a0)	*length
	add.l	d5,a0
	inc a0
	subq.b	#1,d2
	bra.s	copy_nam3
	
we_have_space:
	inc a3
	add.b	d2,(a0)	*inc length by foldername
	add.w	d3,a0	*Point to right place
	inc	a0	*oops
	subq.b	#1,d2
copy_nam3:
	move.b	(a3)+,(a0)+
	dbra	d2,copy_nam3
**Create a name for a0
	lea	temp_string4(a5),a0	*New name
	lea	temp_string2(a5),a1
	bsr.l	make_fsspec		*make fsspec at a1

	lea	temp_string2(a5),a0
	qmoveq	#-1,d1	*System script pse
	lea	CPp_dir(pc),a1	*Directory ID here
	OSFSpDirCreate	a0,d1,a1,d0
;	 OSerr
;	 pea	 temp_string2(a5)
;	 move.w	#-1,-(sp)	 *System script pse
;	 pea	 p_dir(pc)	 *Directory ID here
;	 move.w	#5,d0
;	 dc.w	 _highlevelFSdispatch	 *Fspdircreate
;	 OSerr_ret

**make an alias in temp_alias_h
;	clr.w	-(sp)
	clr.l	d0
	lea	temp_string2(a5),a0	*Fsspec
	lea	temp_alias_h(a5),a1	*handle to alias
	OSNewAlias	d0,a0,a1,d0
;	moveq	#2,d0			*Selector - make alias
;	dc.w	_aliasdispatch
;	move.w	(Sp)+,d0	*error
**if src or hl or obj don't delete
	qmove.l	folder_type(a5),d1
;	cmpi.l	#"src ",d1
;	beq.s	have_source		*check for a compiler, we dont need src if no compiler
	
;	cmpi.l	#"obj ",d1
;	beq.s	dont_delete_folder
;	cmpi.l	#"hl  ",d1
;	beq.s	have_hl
**Delete bin folder
delete_folder:
;	OSerr
	lea	temp_string2(a5),a0
	OSFSpDelete	a0,d0
;	move.w	#6,d0
;	dc.w	_highlevelFSdispatch	*Fspdelete
;	OSerr_ret
	bra.s	dont_delete_folder
;have_source:
;	move.l	proj_buffer_h(a5),a3
;	move.l	(a3),a3
;	tst.b	p_hl_fti(a3)
;	beq.s	delete_folder		*no hl tool, so we don't need src
;	bra.s	dont_delete_folder
;have_hl:
;	move.l	proj_buffer_h(a5),a3
;	move.l	(a3),a3
;	tst.b	p_vhl_fti(a3)
;	beq.s	delete_folder		*no vhl tool, so we don't need hl folder
	
dont_delete_folder:

**Now add to list of folders in project file

	move.l	temp_alias_h(a5),a0
	move.l	(a0),a0
	clr.l	d0
	qcmove.w	4(a0),d0	*Size of record	
	qmove.l	folder_type(a5),d1
	bsr	add_folder_alias
	qmove.l	temp_alias_h(a5),d0
	OSDisposeHandle	d0
;	dc.w	_disposehandle	

	rts_	"Create_folder_with_project"
	

calc_project_size:
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qmove.l	#eof_offset+4,d0
	add.l	eof_offset(a1),d0	*offset to eof
	rts_	"calc_project_size"

create_dummy_app:
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qmove.l	p_type(a1),creator(a5)	      *type
	qmove.l	p_creator(a1),creator2(a5)	*creator
	lea	proj_fsspec(a5),a0	*Point to the fsspec
	qmove.w	(a0),d0
	qmove.l	2(a0),d1
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a0
	lea	p_filename(a0),a0	*name
	lea	temp_string3(a5),a1
	bsr.l	make_fsspec		*make fsspec at a1
	
**a1 is buffer, d0 is size
	clr.l	d0	*want nothing in df
	lea	temp_string3(a5),a0
	move.l	a0,a1		        *We dont care whats written, so use the fsspec
	bsr.l	sys_w_file_set_type_creator
	
	rts_	"Create_dummy_app"

********************************************************************************
**merged_file_alias_h
**WE have a handle to the alias, so we need to create a file of
**type "adrp" - the creator must be the same as what it is pointing to.
**And only if the target is an application!
**This is a largish routine so we'll use a subroutine
create_desktop_alias:
**Get an fsspec to the thing
*FUNCTION ResolveAlias (fromFile: FSSpecPtr; alias: AliasHandle;
*			VAR target: FSSpec; 
*			VAR wasChanged: Boolean): OSErr;
	clr.l	d0	*Non relative
	qmove.l	merged_file_alias_h(a5),d1
	lea	temp_string3(a5),a0	*Gis he fsspec here
	lea	scratch_3(a5),a1	*Was changed
	OSResolveAlias	d0,d1,a0,a1,d0
;	OSerr
;	 clr.l	 -(sp)	 *Non relative
;	 move.l	merged_file_alias_h(a5),-(sp)
;	 pea	 temp_string3(a5)	 *Gis he fsspec here
;	 pea	 scratch_3(a5)		 *Was changed?
;	 debug
;	 moveq	 #3,d0		 	 *Selector - resolve alias
;	 dc.w	 _aliasdispatch	
;	 OSerr_ret	 *into d0
	lea	temp_string3(a5),a0
**Now get info
	lea	fs_temp(a5),a1	      *Where Finfo goes
	OSFSpGetFInfo	a0,a1,d0
;	OSerr
;	move.l	a0,-(sp)	*FSspec
;	move.l	a1,-(sp)	*where info to go
;	moveq	#7,d0
;	dc.w	_highlevelFSdispatch
;	OSerr_ret
	
	lea	fs_temp(a5),a1
	qmove.l	0(a1),d0	*set creator
	cmpi.l	#"APPL",d0
	bne	skip_alias
**ASk user
	qmove.w	#510,d0	*yes/no box number
	lea	create_alias(pc),a0
	qmoveq	#18,d1	*x
	qmoveq	#80,d2	*y
	bsr.l	do_new_alert_3d		    *1=ok	
	cmpi.l	#1,d0
	bne	skip_alias

	qmove.l	#"adrp",creator(a5)	*For sys_write_file_set_type_creator
	qmove.l	4(a1),creator2(a5)	*The creator we need
**Now lets make a file next to the anchor with the type adrp and creator
*Make an fsspec with the anchors vref etc and the filename from temp_string3
	lea	proj_fsspec(a5),a0	*Point to the fsspec
	qmove.w	(a0),d0
	qmove.l	2(a0),d1
	lea	temp_string3(a5),a0
	lea	6(a0),a0
**Add on alias
;	clr.l	d2
	qcmove.b	(a0),d2
	inc.b	d2
	cmpi.b	#25,d2
	bge.s	too_big
	
	addq.b	#6,(a0)	*_alias is 6 bytes
	qmove.l	#"_ali",(a0,d2.w)
	qmove.w	#"as",4(a0,d2.w)
	bra.s	done_alias
too_big:
	qmove.b	#31,(a0)
	qmove.l	#"_ali",25(a0)
	qmove.w	#"as",29(a0)
done_alias:
	lea	temp_string2(a5),a1
	bsr.l	make_fsspec		*make fsspec at a1
**Try to delete the file
	lea	temp_string2(a5),a0
	OSFSpDelete	a0,d0
;	OSerr
;	pea	temp_string2(a5)
;	moveq	#6,d0
;	dc.w	_highlevelFSdispatch	
;	OSerr_ret	*Dont care about this
**a1 is buffer, d0 is size
	clr.l	d0	*want nothing in df
	lea	temp_string2(a5),a0
	move.l	a0,a1		        *We dont care whats written, so use the fsspec
	bsr.l	sys_w_file_set_type_creator
**Now create alis alias
**Fsspopenresfork
*FUNCTION FSpOpenRF (spec: FSSpec; permission: SignedByte;
*		VAR refNum: Integer): OSErr;
	OSCurResFile	d0
;	clr.w	-(sp)
;	dc.w	_curResFile
;	move.w	(sp)+,d0	*dbg purps
	move.w	d0,pm_res_file(a5)	*So we can reset it in a mo...

	qmoveq	#3,d1	*premission
	lea	temp_string2(a5),a0
	OSFSpOpenResFile	a0,d1,d0
	qmove.w	d0,refnum(a5)
;	clr.w	-(sp)
;	pea	temp_string2(a5)
;	move.b	#3,-(sp)	permission - rw
;	moveq	#0xd,d0	openresfile (Res manager routine, not file!)
;	dc.w	_highlevelFSdispatch
;	move.w	(sp)+,refnum(a5)
**

	qcmove.w	refnum(a5),d0
	OSUseResFile	d0
;	dc.w	_UseResFile		*so driver gets the right bits
**Add alias
	move.l	merged_file_alias_h(a5),d0
	qmove.l	#"alis",d1
	clr.l	d2		*ID zero
	clr.l	d3		*NO name
	OSAddResource	d0,d1,d2,d3

;	move.l	merged_file_alias_h(a5),-(sp)
;	move.l	#"alis",-(Sp)
;	clr.w	-(sp)		*ID zero
;	clr.l	-(Sp)		*NO name
;	dc.w	_addresource
	
	qcmove.w	refnum(a5),d0
	OSUpdateResFile	d0

	qmove.w	refnum(a5),-(sp)
	bsr.l	fsclose	error in d0
**Important to detach it
	qmove.l	merged_file_alias_h(a5),d0
	OSDetachResource	d0

	qcmove.w	pm_res_file(a5),d0
	OSUseResFile	d0


**Now get info and set alias bit in finderinfo
	lea	temp_string2(a5),a0
	qmove.l	a0,-(sp)	*save FSspec
	lea	fs_temp(a5),a1	      *Where Finfo goes
	OSFSpGetFInfo	a0,a1,d0
;	clr.w	-(sp)
;	move.l	a0,-(sp)	*FSspec
;	move.l	a1,-(sp)	*where info to go
;	moveq	#7,d0
;	dc.w	_highlevelFSdispatch
;	move.w	(sp)+,d0
	move.l	(sp)+,a0
	lea	fs_temp(a5),a1	      	        *FDflags at 10(a1)
	qmove.w	8(a1),d0
	qbset	#15,d0			*IS alias
	qmove.w	d0,8(a1)
	OSFSpSetFInfo	a0,a1,d0	
;	clr.w	-(sp)
;	move.l	a0,-(sp)
;	move.l	a1,-(sp)
;	moveq	#8,d0
;	dc.w	_highlevelFSdispatch
;	move.w	(sp)+,d0

skip_alias:
	rts_	"Create_Desktop_alias"
*Expects an index in d0 and a tool class in d1 - i.e. C, A, L etc
*Finds the d0 occurence of d1 in the active tools list 
translate_tool:
	qmove.l	a0,-(sp)
	andi.l	#0xffff,d0
	qmove.l	d0,d2
	qmove.l	#0,d0
	tst.l	d2	*None selected in menu?
	beq.s	got_tool_id	*YUP, return zero
	lea	temp_tool(pc),a0
try_next:
	qmove.l	(a0)+,d3
	move.l	d3,d4		        *save type
	beq.s	not_found	*This is a major error and can't happen but just in case of programming errors...
	swap d3
	lsr.w	#8,d3	*Get class char
	cmp.b	d3,d1
	bne.s	try_next
	subq.l	#1,d2
	bne.s	try_next	*Not the one we're after
	qmove.l	d4,d0
got_tool_id:
	move.l	(sp)+,a0
	rts_	"translate_tool"
not_found:
	lea	tool_not_found(pc),a0
	OSDebugStr	a0
	move.l	(sp)+,a0
	rts_	"translate_tool"
**In temp_string2
get_item_text:	*Find edit box for item d0
	qmove.l	a0,-(sp)

	qmove.l	d_handle(a5),d1		        
	lea	CPitemtype(pc),a0			*word
	lea	CPitemhandle(pc),a1			*handle to item
	lea	CPitem_box(pc),a2			*The rectangle occupied by said item
	exg	d0,d1
	OSGetDialogItem	d0,d1,a0,a1,a2
	
	qmove.l	CPitemhandle(pc),d0		*find handle
	lea	temp_string2(a5),a0
	OSGetItemText	d0,a0
	move.l	(sp)+,a0
	rts_	"Get_item_text"
**Takes data in d0, size in d1
insert_into_proj:
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	proj_buffer_index(a5),d2
	cmpi.w	#1,d1
	beq.s	byte
	cmpi.w	#2,d1
	beq.s	word
**Must be 4 bytes
	qmove.l	d0,0(a0,d1.l)
	add.l	d1,proj_buffer_index(a5)
	rts
byte:
	qmove.b	d0,0(a0,d1.l)
	add.l	d1,proj_buffer_index(a5)
	rts

word:
	qmove.w	d0,0(a0,d1.l)
	add.l	d1,proj_buffer_index(a5)
	rts_	"Insert_into_proj"
	
**************************
memory_err:
	bsr.l	mem_err
	rts
CPitemtype:	ds.w	1
CPitemhandle:	ds.l	1
;box:	ds.w	4
CPitem_box:	ds.w	4
CPnew_proj_prompt:	pstring	"Create the project as..."
	align
merge_prompt:	pstring	"Select file to merge with..."
	align
CPp_dir:	ds.l	1
waste:	pstring	"_User"
	align
very_high_level:	pstring	"_VHL"
	align
very_high_level_headers:	pstring	"_VHL_Headers"
	align

high_level:	pstring	"_high_level"
	align
high_level_headers:	pstring "_HL_Headers"
	align
low_level:	pstring	"_Src"
	align	
obj_level:	pstring	"_Binaries"
	align
res_level:	pstring	"_Resources"
	align
glob_level:	pstring	"_Globincs"
	align
sinc_level:	pstring	"_Srcincs"
	align
	
notes:	pstring	"_Notes"
	align
lib_level:	pstring	"_Staticlibs"
	align
slib_level:	pstring	"_Sharedlibs"
	align
create_alias:	cstring	"Because the output is merged with another application, would you like an alias to the application next to your project file?"
	align
**This is a dummy tool list!	
temp_tool: dc.l	"C6C ","a6xx","APxx","APxx","L6xx","LPxx",0
	align
tool_not_found:	pstring	"Tool not found in create_project - it's OK to continue."
	align
proj_exists_text:	dc.b	"A project already exists "
	dc.b	"in the folder you want to create "
	dc.b	"the project in.",13,13
	dc.b	"Can't create the project in the "
	dc.b	"folder you chose."
	dc.b	0
	align
	
	if	registered
	global	create_project
	endif
	global	memory_err,get_item_text,calc_project_size,create_dummy_app
	extern	mem_err,get_item_value_menu	*in handle_new_proj
	extern	sys_write_file_set_type,store_output_file,get_dec,analyse_setup
	extern	the_copy_fsspec,make_fsspec,sys_w_file_set_type_creator,fsclose
	extern	do_alert_3d,copy_pstring,add_folder_alias
	extern	get_class_for_item,get_tool_entry,change_target_name
	extern	strncmp,do_new_alert_3d
	extern ns_writeselector
	
	extern_data	pb_name	