

**************************************************
*Eddie_adb.s									 *
*ADB handling for Eddie 130 onwards				 *
**************************************************

tickle_leds:
	rts		*Out for LXT
;	 lea	tick_leds(pc),a0
;	 bsr.a	 run_leds_core
;	 rts
run_leds:
	rts	*Out for LXT
;	 lea	leds_text(pc),a0
;	 bsr.s	 run_leds_core
;	 rts
	
;run_leds_core:
;**needs array in a0
;	 move.l	a0,-(sp)	 *save array
;**First save current
;	 bsr	find_extended	 *get first extended kbd, if htere is one
;	 	 	 	 	 	 *d0=0=no extended
;	 tst.w	 d0
;	 bne.s	 got_extended1
;	 addq.l	#4,sp
;	 rts
;got_extended1:
;**address of first extended kbd in d0 abd param_block set up
;**set all leds
;	 move.w	d0,d7	 *read leds needs it in d7
;	 bsr	read_leds	 *into adb_data_buffer
;	 lea	adb_data_buffer(pc),a0
;	 move.w	1(a0),leds_save(a5)
;	 move.l	(sp)+,a0	 	 *leds array
;rl_loop:
;	 move.b	(a0)+,d0
;	 bmi.s	 rl_end
;	 move.b	d0,led_number(a5)
;	 move.l	a0,-(sp)
;	 bsr.s	 splat_leds
;	 move.l	(sp)+,a0
;	 bra.s	 rl_loop
;rl_end:
;**restore leds
;**First save current
;	 bsr	find_extended	 *get first extended kbd, if htere is one
;	 	 	 	 	 	 *d0=0=no extended
;	 tst.w	 d0
;	 beq.s	 cant1
;**address of first extended kbd in d0 abd param_block set up
;**set all leds
;	 clr.l	 d7
;	 move.w	d0,d7	 *read leds needs it in d7
;	 bsr	read_leds	 *into adb_data_buffer
;	 lea	adb_data_buffer(pc),a0
;	 clr.l	 d5
;	 move.w	1(a0),d5
;	 clr.l	 d0
;	 move.w	leds_save(a5),d0
;	 andi.b	#%11111101,d5
;	 or.b	 d0,d5	 
;	 bsr	set_leds
;	 rts_	 "Run_leds"
;
;****************************************************************
;splat_leds:	
;	 bsr	find_extended	 *get first extended kbd, if htere is one
;	 	 	 	 	 	 *d0=0=no extended
;	 tst.w	 d0
;	 beq.s	 cant1
;**address of first extended kbd in d0 abd param_block set up
;**set all leds
;	 move.w	d0,d7	 *read leds needs it in d7
;	 bsr	read_leds	 *into adb_data_buffer
;	 lea	adb_data_buffer(pc),a0
;	 move.w	1(a0),d5
;	 clr.l	 d0
;	 move.b	led_number(a5),d0
;	 andi.b	#%11111000,d5
;	 or.b	 d0,d5	 
;	 bsr	set_leds
;**NOW LITTLE DELAY	
;	 lea	final_ticks(pc),a1
;	 move.l	#3,a0
;	 OSDelay	a0,a1
;;	 dc.w	 _delay
;cant1:
;	 rts_	 "Do_leds"
*****************************
do_leds:
	rts
;;	 debug
;	 save_all
;	 bsr	find_extended	 *get first extended kbd, if htere is one
;	 	 	 	 	 	 *d0=0=no extended
;	 tst.w	 d0
;	 beq.s	 cant
;**address of first extended kbd in d0 abd param_block set up
;**set all leds
;	 clr.l	 d7
;	 move.w	d0,d7	 *save address
;	 bsr	read_leds	 *into d0
;	 lea	adb_data_buffer(pc),a0
;	 clr.l	 d6
;	 clr.l	 d5
;	 move.w	1(a0),d6	 	 	 *save current value
;	 move.w	1(a0),d5
;	 bchg	 #0,d5	 	 	 	 *led on
;	 bsr	set_leds
;cant:
;	 restore_all
;	 rts_	 "Do_leds"
**************************************************
**************************************************
**Switch on scroll lock
led_on:
	rts
;	 save_all
;	 bsr	find_extended	 *get first extended kbd, if there is one
;	 	 	 	 	 	 *d0=0=no extended
;	 tst.w	 d0
;	 beq.s	 cant_lo
;**address of first extended kbd in d0 abd param_block set up
;**set all leds
;	 move.w	d0,d7	 *save address
;	 bsr	read_leds	 *into d0
;	 lea	adb_data_buffer(pc),a0
;	 clr.l	 d6
;	 clr.l	 d5
;	 move.w	1(a0),d6	 	 	 *save current value
;	 move.w	1(a0),d5
;	 bclr	 #2,d5	 	 	 	 *scroll lock led on
;	 bsr	set_leds
;**inc global on counter
;	 addq.w	#1,led_on_count(a5)	*so led off knows when to switch off
;cant_lo:
;	 restore_all
;	 rts_	 "led_on"

led_off:
	rts
;	 dec.w	 led_on_count(a5)	 *Check if all ons have finished
;	 tst.w	 led_on_count(a5)
;	 bgt.s	 no_off_yet	*Still bg tasks running
led_off_now:
;	 rts
;	 save_all
;	 bsr	find_extended	 *get first extended kbd, if htere is one
;	 	 	 	 	 	 *d0=0=no extended
;	 tst.w	 d0
;	 beq.s	 cant_lo
;**address of first extended kbd in d0 abd param_block set up
;**set all leds
;	 move.w	d0,d7	 *save address
;	 bsr	read_leds	 *into d0
;	 lea	adb_data_buffer(pc),a0
;	 clr.l	 d5
;	 clr.l	 d6
;	 move.w	1(a0),d6	 	 	 *save current value
;	 move.w	1(a0),d5
;	 bset	 #2,d5	 	 	 	 *scroll lock led off
;	 bsr	set_leds
;	 restore_all
;no_off_yet:
;	 rts_	 "led_on"
numlock_on:
;	 rts
;	save_all
;	bsr	find_extended	*get first extended kbd, if htere is one
						*d0=0=no extended
;	tst.w	d0
;	beq.s	cant_lo
**address of first extended kbd in d0 abd param_block set up
**set all leds
;	 move.w	ext_addr(a5),d7	*save address
;	 bsr.s	 read_leds	 *into d0
;	 lea	adb_data_buffer(pc),a0
;	 clr.l	 d5
;	 clr.l	 d6
;	 move.w	1(a0),d6	 	 	 *save current value
;	 move.w	1(a0),d5
;	 bclr	 #0,d5	 	 	 	 *numlock on
;	 bsr	set_leds
;;	 restore_All
;	 rts_	 "NLled_on"

numlock_off:
	rts
;	save_all
;	bsr	find_extended	*get first extended kbd, if htere is one
						*d0=0=no extended
;	tst.w	d0
;	beq	cant_lo
**address of first extended kbd in d0 abd param_block set up
**set all leds
;	 move.w	ext_addr(a5),d7	*save address
;	 bsr.s	 read_leds	 *into d0
;	 lea	adb_data_buffer(pc),a0
;	 clr.l	 d5
;	 clr.l	 d6
;	 move.w	1(a0),d6	 	 	 *save current value
;	 move.w	1(a0),d5
;	 bset	 #0,d5	 	 	 	 *numlock on
;	 bsr	set_leds
;;	 restore_All
;	 rts_	 "NLled_off"

****************************************************************
**Needs address in d7,returns led reg in adb_data_buffer(1...2) - 0 is byte count
read_leds:
	rts
	global	read_leds
**make op
;	 move.w	d7,d0
;	 lsl.b	 #4,d0	 	 *move address
;	 bset	 #3,d0
;	 bset	 #2,d0	 	 *talk
;	 bset	 #1,d0	 	 *reg 2
;	 lea	adb_pb(pc),a0	 *param block for adbop
;	 lea	adb_data_buffer(pc),a1
;	 clr.b	 (a1)	 	 *S we know when we've read
;	 if	68k
;	 move.l	a1,(a0)		     *pointer to data buffer
;	 clr.l	 4(a0)	 	 *no completion routine
;	 clr.l	 8(a0)	 	 *no completion data
;;	 dc.w	 _adbop
;	 move.l	d0,d1
;	 OSADBOp	a0,d1,d0
;	 else
;	 illegal
;	 move.l	d0,d3	 *command
;	 move.l	a1,d0	 *ptr to data buffer
;	 clr.l	 d1		 *no completion
;	 clr.l	 d2		 *no completion data
;	 OSADBOp	d0,d1,d2,d3,d0
;	 endif
;	 tst.b	 d0
;	 bmi.s	 read_leds	 *cammand queue full
;	 OSTickCount	d6
;	 addi.l	#60,d6		 *Give it max 2 secs
;
;wait_for_it:
;	 OSTickCount	d1		 *TIMER current
;	 cmp.l	 d1,d6
;	 blt.s	 bum_out
;
;	 lea	adb_data_buffer(pc),a1	*v1.4 - Somehow, a1 gets buggered, so I've moved it into loop
;	 	 	 	 	 	 	 	 *Hopefully this'll cure the 1.3 stuck in loop probs.
;	 	 	 	 	 	 	 	 *If not, I'll put a timer on it..well it didn't, so now its timer
;	 	 	 	 	 	 	 	 *time
;	 	 	 	 	 	 	 	 
;	 tst.b	 (a1)
;	 beq.s	 wait_for_it	*Guess whats going on here then...
;	 rts
;bum_out:
;	 lea	adb_data_buffer(pc),a1
;	 clr.l	 d6
;	 move.w	1(a0),d6	 	 	 *save current value
;	 bset	 #0,d6
;	 move.w	d6,1(a0)	 	 	 *clear out num lock led - never used
;	 rts_	 "Read_leds"
**needs 16 bit reg data in d5	
set_leds:
**make op
;	 move.w	d7,d0
;	 lsl.b	 #4,d0	 	 *move address
;	 bset	 #3,d0
;	 bclr	 #2,d0	 	 *listen
;	 bset	 #1,d0	 	 * to reg 2
;	 lea	adb_pb(pc),a0	 *param block for adbop
;	 lea	adb_data_buffer(pc),a1
;	 move.w	d5,1(a1)	 *the data for said reg
;	 move.b	#2,(a1)
;	 
;	 move.l	a1,(a0)		     *pointer to data buffer
;	 lea	my_comp(pc),a1
;	 if	68k
;	 move.l	a1,4(a0)	 	 *no completion routine
;	 lea	my_comp_data(pc),a1
;	 clr.b	 (a1)	 	 	 *clear completion routine flag
;	 move.l	a1,8(a0)	 	 *no optional data
;	 move.l	d0,d1
;	 OSADBOp	a0,d1,d0
;	 else
;	 move.l	d0,d3	 *command
;	 move.l	a1,d0	 *ptr to data buffer
;	 clr.l	 d1		 *no completion
;	 clr.l	 d2		 *no completion data
;	 OSADBOp	d0,d1,d2,d3,d0
;	 endif
;	 tst.b	 d0
;	 bmi.s	 set_leds	 *cammand queue full
;	 lea	my_comp_data(pc),a1	*completion routine sets this =1 
;wait_for_it_send:
;	 tst.b	 (a1)
;	 beq.s	 wait_for_it_send	 *Guess whats going on here then...
;
;	 rts_	 "Set_leds"	
			
find_extended:
	rts
;	 moveq	 #1,d7	 	 	 	 *index
;fe_loop:
;	 lea	adb_data_block(pc),a0
;	 clr.l	 d1
;	 move.w	d7,d1	 	     *index
;	 OSGetIndADB	a0,d1,d0
;;	 dc.w	 _getindadb	*returns in d1!
;
;	 lea	adb_data_block(pc),a0
;	 cmpi.b	#0x02,(a0)
;	 beq.s	 got_extended
;	 addq.w	#1,d7
;	 cmpi.w	#16,d7
;	 bne.s	 fe_loop		 	 *next device	 	 
;	 clr.l	 d0
;	 rts_	 "Find_extended"
;got_extended:
;	 move.w	d0,ext_addr(a5)	*address of exenteded kb
;	 rts
;my_comp:
;	 move.b	#1,(a2)		 *my comp data
;	 rts_	 "My_comp"
	
my_comp_data:	ds.w	1		*flag set by completion routine for send	
adb_data_block:		ds.b	 1	 	 *devtype
	ds.b	1		*original adb address
	ds.l	1		*handler
	ds.l	1		*data area
adb_data_buffer:	ds.b	12		*1st byte is count byte a la pascalish
	align
adb_pb:	ds.l	3		*PB for adbOP
tick_leds:	dc.b	%111,%011,%001,%000
	dc.b	%111,%011,%001,%000
	dc.b	%111,%011,%001,%000
	dc.b	0xff
	align
**bits 2-0 are leds - 0=on, 1=off
leds_text:	dc.b	0	*all on
	dc.b	%000,%100,%110
	dc.b	%111,%011,$001,%000
	dc.b	%111
	dc.b	$ff
	align
final_ticks:	ds.l	1

	global	do_leds,led_on,led_off,run_leds,tickle_leds,led_off_now
	global	numlock_off,numlock_on		