


**Sub long bcd (cd format) d2 from d3 and store result in d3
**assume it uses all data regs and no addr regs.
sub_long_bcd:
**Subtract d2 (r5) from d3 (r13) in cd format
**Convert both to 75th's
;	move.l	#0x715849,d3
;	move.l	#0x242855,d2

	qmove.l	d2,d0
	bsr	convert_to_75ths
	qmove.l	d0,d2
	qmove.l	d3,d0
	bsr	convert_to_75ths
	qmove.l	d0,d3
	sub.l	d2,d3	*result in 75ths
	qmove.l	d3,d0

	bsr	convert_75ths_to_cd
	move.l	d0,d3
	rts
convert_to_75ths:
**Change d0 (CD format) to 75ths
**Destroys d1,d4
	qmove.l	d0,d1
	lsr.l	#8,d0
	qmove.l	#0,d4
	qmove.b	d0,d4	*Seconds as bcd
	lea	bcd_to_dec_table1(pc),a0
	add.l	d4,a0
	qmove.b	(a0),d4	*seconds as hex
	mulu.l	#75,d4	*times frames/second

	lsr.l	#8,d0	*minutes as bcd
	lea	bcd_to_dec_table1(pc),a0
	add.l	d0,a0
	qmove.b	(a0),d0	*mins as hex
	mulu.l	#75*60,d0
	add.l	d4,d0
	andi.l	#0xff,d1
	lea	bcd_to_dec_table1(pc),a0
	add.l	d1,a0
	qmove.b	(a0),d1
	add.l	d1,d0	*time in frames
	rts_	"convert_to_75ths"
	
convert_75ths_to_cd:
**Takes a framew count in d0 and returns bcd in d0
**destroys d1,d4
	qmove.l	d0,d1
	divu.l	#75*60,d1	*frames per minute
	qmove.l	d1,d2	*as real number
	lea	dec_to_bcd_table1(pc),a0
	add.l	d1,a0
	qcmove.b	(a0),d1
	qmove.l	d1,d4	*minutes
	lsl.l	#8,d4
	lsl.l	#8,d4	*place minutes in right slot
	mulu.l	#75*60,d2
	sub.l	d2,d0	*Seconds and frames remaining

	qmove.l	d0,d1
	divu.l	#75,d1	*frames per second
	qmove.l	d1,d2	*as real number
	lea	dec_to_bcd_table1(pc),a0
	add.l	d1,a0
	qcmove.b	(a0),d1
	
	qmove.w	d1,d4	*secs
	lsl.w	#8,d4
	mulu.l	#75,d2
	sub.l	d2,d0	*frames remaining
	lea	dec_to_bcd_table1(pc),a0
	add.l	d0,a0
	qmove.b	(a0),d0
	or.l	d4,d0
	rts_	"convert_75ths_to_cd"

**old version
;	 sub.l	 d7,d7	 	  *Clear Z - what a pain - do I need this?
;
;	 sbcd	 d2,d3
;	 bcc.s	 no_sf_borrow	 *no 75th borrow result
;	 qmove.b	#$74,d0
;
;	 abcd	 d0,d3	 	         	 *Correct 75th
;	 qmove.b	d3,d7	 	         	 *store
;	 lsr.w	 #8,d2	 	 	 *get at secs
;	 lsr.w	 #8,d3
;	 bra.s	 done_sf_borrow
;no_sf_borrow:
;	 qmove.b	d3,d7
;	 lsr.w	 #8,d2
;	 lsr.w	 #8,d3	 	 	 *I'd like these shifts out
;done_sf_borrow:
;	 sbcd	 d2,d3
;	 bcc.s	 no_min_borrow
;	 qmove.b	#$59,d0
;	 abcd	 d0,d3	 	         	 *Correct
;no_min_borrow:
;	 swap	 d2		 	 	 *get at mins
;	 swap	 d3
;	 sbcd	 d2,d3	 	         	 *subtract mins
;	 swap	 d3		 	 	 *move mins to byte 2
;	 lsl.w	 #8,d3	 	 	 *move secs to byte 1
;	 qmove.b	d7,d3	 	         	 *move frame to byte 0
	rts_	"Sub_long_bcd"						*20 insts - want 14!		

**needs long time in ticks in d3, returns in d3 as BCD
calc_time_in_bcd:
	qmove.l	d3,d2		        *save
**calc mins
	divs	#75*60,d3
	qmove.b	d3,d0
	bsr	bin_to_bcd	*in d0
	qmove.l	#0,d7
	qmove.b	d0,d7
	swap	d7		*mins
	swap	d3
	ext.l	d3
	divs	#75,d3
	qmove.b	d3,d0
	bsr	bin_to_bcd
	qmove.b	d0,d7
	lsl.w	#8,d7
	swap	d3
	qmove.b	d3,d0
	bsr	bin_to_bcd
	qmove.b	d0,d7
	qmove.l	d7,d3	*time in bcd
	rts_	"calc_time_bcd"
	
**needs long bcd in d2, returns in d2
calc_time_in_ticks:
	push	d3
	qmove.b	d2,d0		        	*75ths
	bsr.s	bcd_to_bin			*in d0
	qmove.l	#0,d3
	qmove.b	d0,d3		        	*75ths
	extb.l	d3
	lsr.l	#8,d2
	qmove.b	d2,d0
	bsr.s	bcd_to_bin
	extb.l	d0
	muls	#75,d0			*sec*75
	add.l	d0,d3		        	*accum

	lsr.l	#8,d2
	qmove.b	d2,d0
	bsr.s	bcd_to_bin
	extb.l	d0
	muls	#75*60,d0			*secs*60*75
	add.l	d0,d3		        	*accum=total disk play time in 75ths
	qmove.l	d3,d2
	pop	d3
	rts_	"calc_time_ticks"

bcd_to_bin:

	qmove.b	d0,d1	*copy
	andi.b	#$f,d0	*units
	lsr.b	#4,d1
	andi.w	#$f,d1	*mask tens
	muls	#10,d1
	andi.l	#$ff,d1
	add.b	d1,d0
	rts_	"BCD_TO_BIN"
bin_to_bcd:

	extb.l	d0
	divs	#10,d0	*tens in lower, units in upper
	qmove.l	d0,d1
	swap d1
	lsl.b	#4,d0	*move tens
	or.b	d1,d0
	andi.l	#$ff,d0
	rts_	"BIN_TO_BCD"
	if	PPC
bcd_to_dec_table1:	data
	else
bcd_to_dec_table1:
	endif
	dc.b	0,1,2,3,4,5,6,7,8,9
	dc.b	0,0,0,0,0,0	*a-f
	dc.b	10,11,12,13,14,15,16,17,18,19
	dc.b	0,0,0,0,0,0	*a-f
	dc.b	20,21,22,23,24,25,26,27,28,29
	dc.b	0,0,0,0,0,0	*a-f
	dc.b	30,31,32,33,34,35,36,37,38,39
	dc.b	0,0,0,0,0,0	*a-f
	dc.b	40,41,42,43,44,45,46,47,48,49
	dc.b	0,0,0,0,0,0	*a-f
	dc.b	50,51,52,53,54,55,56,57,58,59
	dc.b	0,0,0,0,0,0	*a-f
	dc.b	60,61,62,63,64,65,66,67,68,69
	dc.b	0,0,0,0,0,0	*a-f
	dc.b	70,71,72,73,74,75,76,77,78,79
	dc.b	0,0,0,0,0,0	*a-f
	dc.b	80,81,82,83,84,85,86,87,88,89
	dc.b	0,0,0,0,0,0	*a-f
	dc.b	90,91,92,93,94,95,96,97,98,99
	dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1	*Don't really know why these are here...

**this one need 99 entries in hex
	if	PPC
dec_to_bcd_table1:	data
	else
dec_to_bcd_table1:
	endif
	dc.b	0,1,2,3,4,5,6,7,8,9
	dc.b	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19
	dc.b	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29
	dc.b	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39
	dc.b	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49
	dc.b	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59
	dc.b	0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69
	dc.b	0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79
	dc.b	0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89
	dc.b	0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99
	dc.b	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff

	global	sub_long_bcd,calc_time_in_bcd,calc_time_in_ticks
	global	bcd_to_bin,bin_to_bcd