

***************************************************************
*handle apple events
*020995 - Sb
*
;************************************************************
*
;Created: Monday, January 28, 1991 at 5:55 PM
;    AppleEvents.h
;    C Interface to the Macintosh Libraries
;
;
;        Copyright Apple Computer, Inc.    1989-1990
;        All rights reserved
;    
;
************************************************************/


typeBoolean	equ	"bool"
typeChar	equ	"TEXT"
typeSMInt	equ	"shor"
typeInteger	equ	"long"
typeSMFloat	equ	"sing"
typeFloat	equ	"doub"
typeLongInteger	equ	"long"
typeShortInteger	equ	"shor"
typeLongFloat	equ	"doub"
typeShortFloat	equ	"sing"
typeExtended	equ	"exte"
typeComp	equ	"comp"
typeMagnitude	equ	"magn"
typeAEList	equ	"list"
typeAERecord	equ	"reco"
typeTrue	equ	"true"
typeFalse	equ	"fals"
typeAlias	equ	"alis"
typeEnumerated	equ	"enum"
typeType	equ	"type"
typeAppParameters	equ	"appa"
typeProperty	equ	"prop"
typeFSS	equ	"fss "
typeKeyword	equ	"keyw"
typeSectionH	equ	"sect"
typeWildCard	equ	"****"

typeApplSignature	equ	"sign"
typeSessionID	equ	"ssid"
typeTargetID	equ	"targ"
typeProcessSerialNumber	equ	"psn "
typeNull	equ	"null"                 /*the type of null/nonexistent data*/

kCoreEventClass	equ	"aevt"

kAEOpenApplication	equ	"oapp"
kAEOpenDocuments	equ	"odoc"
kAEPrintDocuments	equ	"pdoc"
kAEQuitApplication	equ	"quit"

kAECreatorType	equ	"crea"
kAEQuitAll	equ	"quia"
kAEShutDown	equ	"shut"
kAERestart	equ	"rest"
kAEApplicationDied	equ	"obit"
keyProcessSerialNumber	equ	"psn "

keyErrorNumber	equ	"errn"
keyErrorString	equ	"errs"

kAEAnswer	equ	"ansr"

keyDirectObject	equ	"----"


* keyword used in install special handler */
keyPreDispatch	equ	"phac"           * PreHandler Accessor Call */
keySelectProc	equ	"selh"            * More selector Call */

* keywords used in attributes */
keyTransactionIDAttr	equ	"tran"
keyReturnIDAttr	equ	"rtid"
keyEventClassAttr	equ	"evcl"
keyEventIDAttr	equ	"evid"
keyAddressAttr	equ	"addr"
keyOptionalKeywordAttr	equ	"optk"
keyTimeoutAttr	equ	"timo"
keyInteractLevelAttr	equ	"inte"     /*this attribute is read only will be set in AESend*/
keyEventSourceAttr	equ	"esrc"       /* this attribute is read only */
keyMissedKeywordAttr	equ	"miss"     /* this attribute is read only */

* constants for use in AESendMode */

kAENoReply	equ	$00000001,            /* Sender doesn"t want a reply to event */
kAEQueueReply	equ	$00000002,         /* Sender wants a reply but won"t wait */
kAEWaitReply	equ	$00000003,          /* Sender wants a reply and will be waiting */

kAENeverInteract	equ	$00000010,      /* Server should not interact with user */
kAECanInteract	equ	$00000020,        /* Server may try to interact with user */
kAEAlwaysInteract	equ	$00000030,     /* Server should always interact with user where appropriate */

kAECanSwitchLayer	equ	$00000040,     /* Interaction may switch layer */

kAEDontReconnect	equ	$00000080,      /* don"t reconnect if there is a sessClosedErr from PPCToolbox */

* constants to be used in AESendPriority */

kAENormalPriority	equ	$00000000,     /* Post message at the end of event queue */

* special constants in generating events */

kAnyTransactionID	equ	0,              /* no transaction is in use */
kAutoGenerateReturnID	equ	-1,         /* AECreateAppleEvent will generate a session-unique ID */

* constant for use AESend */
kAEDefaultTimeout	equ	-1,             /* timeout value determined by AEM */
kNoTimeOut	equ	-2,                    /* wait until reply comes back, however long it takes */

* dispatch parameter to AEResumeTheCurrentEvent takes a pointer to a dispatch
*table, or one of these two constants */
kAENoDispatch	equ	0,
kAEUseStandardDispatch	equ	-1,

* Error messages in response to reading and writing event contents */
errAECoercionFail	equ	-1700,
errAEDescNotFound	equ	-1701,
errAECorruptData	equ	-1702,
errAEWrongDataType	equ	-1703,
errAENotAEDesc	equ	-1704
errAEBadListItem	equ	-1705,           /* Specified list item does not exist */
errAENewerVersion	equ	-1706,          /* Need newer version of AppleEvent Manager */
errAENotAppleEvent	equ	-1707,         /* The event is not in AppleEvent format */

* Error messages in response to sending/receiving a message */
errAEEventNotHandled	equ	-1708,       /* The AppleEvent was not handled by any handler */
errAEReplyNotValid	equ	-1709,         /* AEResetTimer was passed an invalid reply parameter */
errAEUnknownSendMode	equ	-1710,       /* Mode wasn"t NoReply, WaitReply, or QueueReply;     or Interaction level is unknown */
errAEWaitCanceled	equ	-1711,          /* In AESend, User cancelled out of wait loop for  reply or receipt */
errAETimeout	equ	-1712,               /* AppleEvent timed out */

errAENoUserInteraction	equ	-1713,     /* no user interaction allowed */
errAENotASpecialFunction	equ	-1714,   /* there is no special function with this keyword */
errAEParamMissed	equ	-1715,           /* a required parameter was not accessed */

errAEUnknownAddressType	equ	-1716,    /* The target address type is not known */
errAEHandlerNotFound	equ	-1717,       /* No handler in the dispatch tables fits the parameters to
                                       * AEGetEventHandler or AEGetCoercionHandler */

errAEReplyNotArrived	equ	-1718,       /* the contents of the reply you are accessing have not arrived yet */
errAEIllegalIndex	equ	-1719           /* Index is out of range in a put operation */

***********************************************************
handle_aevt:
	tst.w	in_background(a5)
	beq.s	no_curs	*Dont do timed backups in BG
	qmove.l	arrow_curs_h(a5),d0
	Curs	d0
no_curs:
	save_all

	lea	event_rec(a5),a0
	OSAEProcessAppleEvent	a0,d0
	restore_all
	rts_	"Handle_Aevt"
***Initialisation routine for handlers
install_ae_handlers:
	qmove.l	#"aevt",d0
	qmove.l	#"odoc",d1
	if	68k
	lea	ae_open(pc),a0
	else
	qmove.l	upp2(a5),a0
	endif
	qmove.l	a0,d2
	qmove.l	#0,d3
	qmove.l	#0,d4
	OSAEInstallEventHandler	d0,d1,d2,d3,d4,d0

	qmove.l	#"aevt",d0
	qmove.l	#"pdoc",d1
	if	68k
	lea	ae_pdoc(pc),a0
	else
	qmove.l	upp5(a5),a0
	endif
	qmove.l	a0,d2
	qmove.l	#0,d3
	qmove.l	#0,d4
	OSAEInstallEventHandler	d0,d1,d2,d3,d4,d0

	qmove.l	#"aevt",d0
	qmove.l	#"quit",d1
	if	68k
	lea	ae_quit(pc),a0
	else
	qmove.l	upp3(a5),a0
	endif
	qmove.l	a0,d2
	qmove.l	#0,d3
	qmove.l	#0,d4
	OSAEInstallEventHandler	d0,d1,d2,d3,d4,d0
	
	qmove.l	#"aevt",d0
	qmove.l	#"bild",d1
	if	68k
	lea	ae_build(pc),a0
	else
	qmove.l	upp6(a5),a0
	endif
	qmove.l	a0,d2
	qmove.l	#0,d3
	qmove.l	#0,d4
	OSAEInstallEventHandler	d0,d1,d2,d3,d4,d0

	qmove.l	#"aevt",d0
	qmove.l	#"bzap",d1
	if	68k
	lea	ae_zap(pc),a0
	else
	qmove.l	upp7(a5),a0
	endif
	qmove.l	a0,d2
	clr.l	d3
	clr.b	d4
	OSAEInstallEventHandler	d0,d1,d2,d3,d4,d0

	qmove.l	#"aevt",d0
	qmove.l	#"brun",d1
	if	68k
	lea	ae_brun(pc),a0
	else
	qmove.l	upp8(a5),a0
	endif
	qmove.l	a0,d2
	qmove.l	#0,d3
	qmove.l	#0,d4
	OSAEInstallEventHandler	d0,d1,d2,d3,d4,d0

	qmove.l	#"aevt",d0
	qmove.l	#"trun",d1
	if	68k
	lea	ae_run(pc),a0
	else
	qmove.l	upp9(a5),a0
	endif
	qmove.l	a0,d2
	qmove.l	#0,d3
	qmove.l	#0,d4
	OSAEInstallEventHandler	d0,d1,d2,d3,d4,d0

;	 qmove.l	#"aevt",d0
;	 qmove.l	#"cnfg",d1
;	 if	 68k
;	 lea	 ae_display_manager(pc),a0
;	 else
;	 move.l	upp13(a5),a0
;	 endif
;	 qmove.l	a0,d2
;	 clr.l	 d3
;	 clr.b	 d4
;	 OSAEInstallEventHandler	d0,d1,d2,d3,d4,d0

**If PPC, save a5 and a6 where handlers can get them
;	if PPC
	lea	my_a5(pc),a0
	qmove.l	a5,(a0)+
	qmove.l	a6,(a0)+
;	endif

***data handler
;	 move.l	#"aevt",d0
;	 move.l	#"odoc",d1
;	 lea	 ae_open(pc),a0
;	 move.l	a0,d2
;	 clr.l	 d3
;	 clr.b	 d4
;	 OSAEInstallEventHandler	d0,d1,d2,d3,d4,d0

***Ihub handler
;	clr.w	-(sp)
;	move.l	#"LIDe",-(sp)
;	move.l	#"Ihub",-(sp)	*i am the hub!
;	pea	lide_hub_calling(pc),-(sp)
;	clr.l	-(sp)
;	clr.b	-(sp)
;	move.w	#$91f,d0	*installevent handler
;	dc.w	_pack8
;	move.w	(sp)+,d0
;
***LSss handler
;	clr.w	-(sp)
;	move.l	#"LIDe",-(sp)
;	move.l	#"LSss",-(sp)	*sense status
;	pea	lide_sense_status(pc),-(sp)
;	clr.l	-(sp)
;	clr.b	-(sp)
;	move.w	#$91f,d0	*installevent handler
;	dc.w	_pack8
;	move.w	(sp)+,d0
;
;***LScm handler
;	clr.w	-(sp)
;	move.l	#"LIDe",-(sp)
;	move.l	#"LScm",-(sp)	*sense status
;	pea	lide_command(pc),-(sp)
;	clr.l	-(sp)
;	clr.b	-(sp)
;	move.w	#$91f,d0	*installevent handler
;	dc.w	_pack8
;	move.w	(sp)+,d0
;
	rts_	"install_ae_handlers"
	
***ae handlers

****quit
	if	PPC
ae_quit:	toc_routine
	else
ae_quit:
	endif
	if PPC	
;	mr	r22,r5	*AEvnt
;	mr	r21,r4	*reply
;	mr	r3,r3	*refcon
;	mflr	r17	*return addr
**Set up a5 and a6
;	move.l	(a0)+,a6
	else

**event handler (*theappleevent,*reply,refcon.l):oser
	qmove.l	(sp)+,d7	*return
	qmove.l	(sp)+,d0	*refcon
	qmove.l	(sp)+,a1	**reply
	move.l	(sp)+,a2	**the apple event
	addq.l	#2,sp	*pascal calling
	endif
	push	a5
	lea	my_a5(pc),a0
	move.l	(a0)+,a5
	qmove.w	#1,quit_tool(a5)
	pop	a5
*return
	if	PPC
	li	r3,0
	blr
	else
	clr.w	-(sp)
	move.l	d7,a0
	jmp	(a0)
	endif
****build
	if	PPC
ae_build:	toc_routine
	else
ae_build:
	endif
	if PPC	
	else

**event handler (*theappleevent,*reply,refcon.l):oserr
	qmove.l	(sp)+,d7	*return
	qmove.l	(sp)+,d0	*refcon
	qmove.l	(sp)+,a1	**reply
	qmove.l	(sp)+,a2	**the apple event
	addq.l	#2,sp	*pascal calling
	endif
	push	a5
	lea	my_a5(pc),a0
	move.l	(a0)+,a5
**This is where we start a build
	qmove.w	#1,remote_build_received(a5)
	pop	a5
*return
	if	PPC
	li	r3,0
	blr
	else
	clr.w	-(sp)
	move.l	d7,a0
	jmp	(a0)
	endif

****zap
	if	PPC
ae_zap:	toc_routine
	else
ae_zap:
	endif
	if PPC	
	else

**event handler (*theappleevent,*reply,refcon.l):oserr
	move.l	(sp)+,d7	*return
	move.l	(sp)+,d0	*refcon
	move.l	(sp)+,a1	**reply
	move.l	(sp)+,a2	**the apple event
	addq.l	#2,sp	*pascal calling
	endif
	push	a5
	lea	my_a5(pc),a0
	move.l	(a0)+,a5
**This is where we start a build
	qmove.w	#0x8001,remote_build_received(a5)
	pop	a5
*return
	if	PPC
	li	r3,0
	blr
	else
	clr.w	-(sp)
	move.l	d7,a0
	jmp	(a0)
	endif


****run
	if	PPC
ae_brun:	toc_routine
	else
ae_brun:
	endif
	if PPC	
	else

**event handler (*theappleevent,*reply,refcon.l):oserr
	move.l	(sp)+,d7	*return
	move.l	(sp)+,d0	*refcon
	move.l	(sp)+,a1	**reply
	move.l	(sp)+,a2	**the apple event
	addq.l	#2,sp	*pascal calling
	endif
	push	a5
	lea	my_a5(pc),a0
	move.l	(a0)+,a5
**This is where we start a build
	qmove.w	#0x0001,remote_build_received(a5)
	qmove.w	#1,remote_run_received(a5)
	pop	a5
*return
	if	PPC
	li	r3,0
	blr
	else
	clr.w	-(sp)
	move.l	d7,a0
	jmp	(a0)
	endif

	if	PPC
ae_run:	toc_routine
	else
ae_run:
	endif

	if	PPC
	else
**event handler (*theappleevent,*reply,refcon.l):oserr
	move.l	(sp)+,d7	*return
	move.l	(sp)+,d0	*refcon
	move.l	(sp)+,a1	**reply
	move.l	(sp)+,a2	**the apple event
	addq.l	#2,sp	*pascal calling
	endif
	push	a5
	lea	my_a5(pc),a0
	move.l	(a0)+,a5
**This is where we start a build
	qmove.w	#0x4000,remote_build_received(a5)	*bit 14 is run
	pop	a5
*return
	if	PPC
	li	r3,0
	blr
	else
	clr.w	-(sp)
	move.l	d7,a0
	jmp	(a0)
	endif

****
***odoc
;	 if	 PPC
;ae_display_manager:	 toc_routine
;	 else
;ae_display_manager:
;	 endif
;**event handler (*theappleevent,*reply,refcon.l):oserr
;	 if PPC	
;	 save_all
;	 mr	 r22,r3	*AEvnt
;	 mr	 r21,r4	*reply
;;	 mr	 r3,r3	 *refcon
;	 mflr	 r17	 *return addr
;**Set up a5 and a6
;	 lea	 my_a5(pc),a0
;	 move.l	(a0)+,a5
;	 move.l	(a0)+,a6
;	 else
;	 move.l	(sp)+,d7	 *return
;	 move.l	(sp)+,d0	 *refcon
;	 move.l	(sp)+,a1	 **reply
;	 move.l	(sp)+,a2	 **event
;	 addq.l	#2,sp	 *pascal calling
;	 endif
;
;	 debug
;
;*return
;	 if	 68K
;	 clr.w	 -(sp)
;	 move.l	d7,a0
;	 jmp	 (a0)	 *byeeee
;	 rts_	 "Anvil_ae_display_manager_SB050898"
;	 else
;	 mtlr	 r17
;	 restore_all	 *set a5 and a6 back to how they were etc.
;	 li	 r3,0
;	 blr
;	 endif
**********************************************	
****pdoc
	if	PPC
ae_pdoc:	toc_routine
	else
ae_pdoc:
	endif
**event handler (*theappleevent,*reply,refcon.l):oserr
	if PPC	

	mr	r22,r3	*AEvnt
	mr	r21,r4	*reply
;	mr	r3,r3	*refcon
	mflr	r17	*return addr
	save_all
**Set up a5 and a6
	lea	my_a5(pc),a0
	move.l	(a0)+,a5
	move.l	(a0)+,a6
	else
	move.l	(sp)+,d7	*return
	move.l	(sp)+,d0	*refcon
	move.l	(sp)+,a1	**reply
	move.l	(sp)+,a2	**event
	addq.l	#2,sp	*pascal calling
	endif
	qmove.l	#1,ae_do_print(a5)
	bra.s	ae_open_pdoc_entry
	
***odoc
	if	PPC
ae_open:	toc_routine
	else
ae_open:
	endif
**event handler (*theappleevent,*reply,refcon.l):oserr
	if PPC	
	save_all
	mr	r22,r3	*AEvnt
	mr	r21,r4	*reply
;	mr	r3,r3	*refcon
	mflr	r17	*return addr
**Set up a5 and a6
	lea	my_a5(pc),a0
	move.l	(a0)+,a5
	move.l	(a0)+,a6
	else
	move.l	(sp)+,d7	*return
	move.l	(sp)+,d0	*refcon
	move.l	(sp)+,a1	**reply
	move.l	(sp)+,a2	**event (we dont use)
	addq.l	#2,sp	*pascal calling
	endif
	clr.l	ae_do_print(a5)	*This is an odoc
**getparamsdesc
ae_open_pdoc_entry:
	qmove.l	a2,d0	*the event
	qmove.l	#keyDirectObject,d1
	qmove.l	#typeAEList,d2
	lea	open_desc(pc),a0		
	OSAEGetKeyDesc	d0,d1,d2,a0,d0
	bmi	ae_odoc_error	*fuck it!
**count items in list

	lea	open_desc(pc),a0
	lea	list_count(pc),a1
	OSAECountItems	a0,a1,d0
	bmi	ae_odoc_error

	qmove.l	list_count(pc),d6

**get the fsspec
get_next_file:
	movem.l	d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6,-(sp)
	lea	open_desc(pc),a0	*the list
	qmove.l	d6,d0	*the index
	qmove.l	#typeFSS,d1	*we want coerce to Fsspecs please
	lea	ae_keyword(pc),a1
	lea	return_type(pc),a2	*the type returned
	lea	temp_fsspec1(a5),a3	*where to put the fsspec
	qmove.l	#80,d2	*maximum size of data to return
	lea	actual_size(pc),a4
	qmove.l	d2,d3
	qmove.l	d0,d4
	qmove.l	d1,d5
	OSAEGetNthPtr	a0,d4,d5,a1,a2,a3,d3,a4,d0
	movem.l	(sp)+,d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6
	tst.w	d0
;	 clr.w	 -(sp)
;	 pea	 open_desc(pc)	 *the list
;	 move.l	d6,-(sp)	 *the index
;	 move.l	#typefss,-(sp)	*we want coerce to Fsspecs please
;	 pea	 ae_keyword(pc)
;	 pea	 return_type(pc)	*the type returned
;	 pea	 temp_Fsspec1(a5)	 *where to put the fsspec
;	 move.l	#80,-(sp)	 *maximum size of data to return
;	 pea	 actual_size(pc)
;	 move.w	#$100a,d0	 *AEGetNthPtr
;	 dc.w	 _pack8
;	 move.w	(sp)+,d0
	bmi	ae_odoc_error

	lea	temp_fsspec1(a5),a0
**1.4 mod - make directory current default
	qmove.w	(a0),current_vrefnum(a5)	*save current folder
	qmove.l	2(a0),current_parid(a5)
**End 1.4 mod
**make sure the type is text!
	save_all	*my fave macro :-)
	lea	finder_info(pc),a1
	OSFSpGetFInfo	a0,a1,d0
;	 clr.w	 -(sp)
;	 move.l	a0,-(sp)	 *FSspec
;	 pea	 finder_info(pc)
;	 moveq	 #7,d0
;	 dc.w	 _highlevelFSdispatch
;	 move.w	(sp)+,d0
	restore_all
	lea	finder_info(pc),a1

	cmp.l	#"TEXT",(a1)
	beq	text!	
	cmp.l	#"tXTb",(a1)
	beq	text!			*Fixes drag backup over eddie bug - 160
**PM
	cmp.l	#"LiP1",(a1)
	beq	text!
	cmp.l	#"LiP2",(a1)
	beq	text!
	cmp.l	#"FEpt",(a1)
	beq	text!			*Project setup
	cmp.l	#"FEpj",(a1)
	beq	project
	cmp.l	#"FEct",(a1)		*Colour set?
	beq.s	colour_table 	     	     
	cmp.l	#"eSND",(a1)
	beq	note
	cmp.l	#"Pref",(a1)
	beq	not_text!		*simply skip prefs files
	cmp.l	#"Aprf",(a1)		*secondary pref file?
	beq	not_text!
	cmp.l	#"Atoo",(a1)
	beq	not_text!
	cmp.l	#"Aplg",(a1)
	beq	not_text!
	cmp.l	#"AliT",(a1)
	beq	not_text!
	cmp.l	#"AliD",(a1)
	beq	not_text!
	cmp.l	#"AliF",(a1)
	beq	not_text!

**This file is NOT a text file, so report it and see if user wants open
**anyway
	movem.l	d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6,-(sp)
	addq.l	#6,a0	*->name
	bsr.l	do_open?	*in edit_menus
	movem.l	(sp)+,d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6
	subq.w	#1,d0
	beq	not_text!	1 is cancel on 511
	bra	text!
colour_table:
	save_all
	lea	white(a5),a1
	bsr.l	read_file
	lea	black(a5),a0

	lea	white(a5),a0
	OSRGBBackColor	a0
	bsr.l	find_window
;	tst.w	d0
	bmi.s	no_windows95	:-)

	bsr.l	erase_bg	
no_windows95:
	bsr	save_prefs
	restore_all
	bra.s	not_text!
note:
	save_all
	bsr.l	play_voice_note_auto	*in voice
	restore_all
	bra.s	not_text!	
text!:
	subq.l	#6,a0
	save_all
	clr.b	auto_switch(a5)	*Do not switch to, but ask if want copy
	bsr.l	auto_entry	*load it
	bsr.l	check_rebuild	*v1.4 for non eddie files dragged onto eddie
	tst.l	ae_do_print(a5)
	beq.s	no_aeprint
**here we need to print the doc
	bsr.l	pr_print
no_aeprint:
	restore_all
not_text!:
	subq.l	#1,d6
	bne	get_next_file	 
	clr.l	ae_do_print(a5)
*return
	if	68K
	clr.w	-(sp)
	move.l	d7,a0
	jmp	(a0)	*byeeee	
	else
	mtlr	r17
	restore_all	*set a5 and a6 back to how they were etc.
	li	r3,0
	blr
	endif
**OPen a project
project:
	lea	temp_string3(a5),a1
	addq.l	#6,a1		*skip gumf normally there
	bsr.l	the_copy_fsspec	*into temp_string3
	move.b	#1,project_auto(a5)	*auto open proj
	save_all
	bsr.l	open_new_project
	restore_all
	bra.s	not_text!
ae_odoc_error:
	lea	ae_error(pc),a0
	qmove.w	#1000,d0
	qmoveq	#47,d1	x
	qmoveq	#76,d2	y
	bsr.l	do_new_alert_3d
	if	68K
	move.w	#-1,-(sp)
	move.l	d7,a0
	jmp	(a0)
	else
	mtlr	r17
	restore_all	*set a5 and a6 back to how they were etc.
	li	r3,-1
	blr
	endif


*struct FInfo {
*0    OSType fdType;                      /*the type of the file*/
*4    OSType fdCreator;                   /*file's creator*/
*8    unsigned short fdFlags;             /*flags ex. hasbundle,invisible,locked, etc.*/
*10    Point fdLocation;                   /*file's location in folder*/
*14    short fdFldr;                       /*folder containing file*/
finder_info:	ds.b	32
my_a5:	ds.l	2	
open_desc:	ds.l	2
list_count:	ds.l	1	*items in open list
ae_keyword:	ds.l	1
return_type:	ds.l	1
actual_size:	ds.l	1

ae_error:	dc.b	"Error during Apple event handling!",0
	align
actualsize:	ds.l	1
actual_type:	ds.l	1
targetaddr:	ds.b	20

	global	handle_aevt,install_ae_handlers
	global	ae_quit,ae_run,ae_build,ae_zap,ae_brun

	extern	do_alert_3d,auto_entry,do_open?,do_edit_lide_command
	extern	check_rebuild,the_copy_fsspec,open_new_project
	extern	find_window,load_cset,erase_bg,save_prefs,read_file,play_voice_note_auto
	extern	pr_print,do_new_alert_3d