****************************************************
*Keyboard_filter checks key for valid and returns key in d0 
*or returns `d1=-1 if bad, else d1=0
*If an extended keyboard command key, calls relevant function.
*300696
**Takes key in d0

**Checked for volatile regs across OS calls - 2302 040997

keyboard_filter:
	lea	event_rec(a5),a0
;	qmoveq	#0,d1
	qcmove.w	14(a0),d1	modifiers (keyboard or mouse in menu)

	cmpi.l	#5,d0	*help?
	bne.s	not_help
	lea	event_rec(a5),a0
	qcmove.w	14(a0),d1	modifiers (keyboard or mouse in menu)
	lsr.l	#8,d1
	btst	#1,d1		*shift key? do language help
	bne.s	do_lang_help
	bsr.l	do_help_entry
	
kf_end:
	clr.l	d0
	moveq	#-1,d1	*Tell events we handled it
	rts
do_lang_help:
	bsr.l	do_lang_help_entry
	bra	kf_end
not_help:

**Check for f1-f3 (buttons)
	cmpi.l	#0x10,d0
	bne	not_fkey
	bsr.l	getkey_turbo	*a0=keymap
	qcmove.b	15(a0),d0
	btst	#2,d0
	beq.s	not_f1
	bsr.l	activate_plug1
	bra	kf_end
not_f1:
	btst	#0,d0
	beq.s	not_f2
	bsr.l	activate_plug2
	bra	kf_end
not_f2:
	move.b	12(a0),d0
	beq	not_f3
	btst	#3,d0
	beq.s	not_f3
	bsr.l	activate_plug3
	bra	kf_end
not_f3:
	btst	#0,d0
	beq	not_f5
**Toggle toolbar
	tst.b	toolbar_shut(a5)
	bne.s	do_open_toolbar
	qbset	#toolbar_closed_flag,sb_prefs(a5)
	lea	scratch_port(a5),a0
	OSGetPort	a0
	bsr.l	shut_toolbar
	qmove.l	scratch_port(a5),d0
	OSSetPort	d0
	bra	kf_end
do_open_toolbar:
	lea	scratch_port(a5),a0
	OSGetPort	a0
	bsr.l	open_toolbar
	bra	kf_end
	
not_f5:
	qmove.l	#1,d0
	OSSysBeep	d0
	bra	kf_end	*do nothing iwth other function keys
not_fkey:
	cmpi.l	#0xb,d0	*Pg up?
	bne.s	not_page_up
	bsr.l	find_window
;	tst.w	d0
	bmi.s	no_window
**Check we have pages
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	lea	ed_viewrect(a0),a1
;	clr.l	d0
	qcmove.w	4(a1),d0	bott
	sub.w	0(a1),d0	height in pxeils
	divs	ed_lineheight(a0),d0	in lines
	cmp.w	ed_nlines(a0),d0
	bge.s	no_pages

	bsr.l	page_up_entry
no_pages:
no_window:
	qmoveq	#0,d0		*Events expects a return in d0 -1=quit
	moveq	#-1,d1
	rts
not_page_up:
	cmpi.l	#0xc,d0
	bne.s	not_page_down
	bsr.l	find_window
;	tst.w	d0
	bmi.s	no_window
**Check we have pages
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	lea	ed_viewrect(a0),a1
;	clr.l	d0
	qcmove.w	4(a1),d0	bott
	sub.w	0(a1),d0	height in pxeils
	divs	ed_lineheight(a0),d0	in lines
	cmp.w	ed_nlines(a0),d0
	bge.s	no_pages

	bsr.l	page_down_entry
	qmoveq	#0,d0
	moveq	#-1,d1
	rts
	
not_page_down:
	cmpi.l	#01,d0
	bne.s	not_tof
	bsr.l	find_window
;	tst.w	d0
	bmi.s	no_window
	bsr.l	tof_entry
	moveq	#-1,d1
	rts
not_tof:
	cmpi.l	#4,d0
	bne.s	not_bof
	bsr.l	find_window
;	tst.w	d0
	bmi.s	no_window
	bsr.l	bof_entry
	moveq	#-1,d1
	rts
not_bof:
	lea	event_rec(a5),a0
;	clr.l	d1

	qcmove.w	14(a0),d1	modifiers (keyboard or mouse in menu)
	btst	#12,d1
	beq.s	no_ctrl
**check if c, C, v,V,x,x and filter if so.
	cmpi.l	#3,d0
	beq.s	ctrl_beep
	cmpi.l	#0X16,d0
	beq.s	ctrl_beep
	cmpi.l	#0X18,d0
	beq.s	ctrl_beep

	bra.s	not_delete
ctrl_beep:
	qmoveq	#1,d0
	OSSysBeep	d0
	moveq	#-1,d1
	rts
no_ctrl:
;	cmpi.b	#$7f,d0		*fwd delete now handled in te_events
;	bne.s	not_delete
;	moveq	#-1,d1
;	rts			*We ignore the delete key
not_delete:
	moveq	#0,d1
	rts_	"Keyboard_filter"
	global	keyboard_filter
	extern	do_help_entry,page_up_entry,page_down_entry,find_window
	extern	tof_entry,bof_entry,do_lang_help_entry
	extern	getkey_turbo,activate_plug1,activate_plug2,activate_plug3
	extern	open_toolbar,shut_toolbar