	include	ldfs.def	*Chroma structure
**load ldf
**SB 280698

	reset_locals
	local.l	fsspec_ptr,1
	local.l	ldf_ptr,1
	local.l	ldf_file_size,1
load_ldf:
	reserve_locals	a4
	cmpi.l	#31,number_of_ldfs(a5)
	beq	ldfs_error
	save_all
	qmove.l	a0,fsspec_ptr(a4)
	bsr.l	size_file
	tst.l	d0
	bmi	error
	qmove.l	d0,ldf_file_size(a4)
	OSNewPtr	d0,a0
	move.l	a0,d0
	beq.s	error
	
	qmove.l	d0,ldf_ptr(a4)
**Clear the data
	qmove.l	ldf_file_size(a4),d0
	move.l	ldf_ptr(a4),a0
clp:	clr.b	(a0)+
	subq.l	#1,d0
	bne.s	clp
	
	move.l	ldf_ptr(a4),a1	*file read here
	move.l	fsspec_ptr(a4),a0
	bsr.l	read_file
	tst.l	d0
	bmi	error_and_dispose
	move.l	ldf_ptr(a4),a0	*pass data, size in d0
;	clr.l	(a0,d0.l)	*terminate
	bsr	setup_chroma	*set up the right structure
	addq.l	#1,number_of_ldfs(a5)

error_and_dispose:
	move.l	ldf_ptr(a4),a0
	OSDisposePtr	a0
error:
	restore_all
	unlk	a4
	rts_	"load_ldf"
ldfs_error:
	qmove.l	#1000,d0
	lea	max_ldfs(pc),a0
	qmoveq	#25,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d
	rts
	
	reset_locals
	local.l	ldf_text_ptr,1
	local.l	ldf_size,1
	local.l	ldf_max_size,1
	local.l	chroma_table_base,1
	local.l	colour_table_size,1
setup_chroma:
	reserve_locals	a4
	clr.l	colour_table_size(a4)
	move.l	a0,ldf_text_ptr(a4)	*the file
	move.l	d0,ldf_size(a4)
	qmove.l	d0,template_size(a5)	*check for eof!
	clr.l	coml_counter(a5)	*to eol comments counter
**now we need to construct the chroma table for this language.
**we set up a 50k buffer
	move.l	ldf_size(a4),d0
	add.l	#10000,d0
	move.l	d0,ldf_max_size(a4)
	OSNewPtr	d0,a0
	move.l	a0,d0
	beq	setup_chroma_error	
	move.l	a0,chroma_table_base(a4)
**Clear the area
	qmove.l	ldf_max_size(a4),d0
clr_loop:
	clr.b	(a0)+
	subq.l	#1,d0
	bne.s	clr_loop
	move.l	chroma_table_base(a4),a0
	
	lea	ldfs_ptrs(a5),a1
	move.l	number_of_ldfs(a5),d0
	lsl.l	#2,d0
	add.l	d0,a1
	move.l	a0,(a1)	*store ptr to this ldf
**now evaluate the file
	move.l	ldf_text_ptr(a4),a2	*our src pointer

	move.l	chroma_table_base(a4),a3	*we build here
	lea	stop_chars(a3),a1
	qmove.b	#32,(a1)+	*insert space, CR and tab
	qmove.b	#9,(a1)+
	qmove.b	#13,(a1)+
	qmove.l	#0,insensitive(a3)	*default is sensitive
	qmove.l	#1,change_colour(a3)	*Default is leave alone
	clr.l	info_paste_size(a3)
	lea	line_comments_chars(a3),a1
	clr.l	(a1)
	clr.l	4(a1)
	clr.l	8(a1)
	clr.l	12(a1)
	lea	start_comments_chars(a3),a1
	clr.l	(a1)
	lea	end_comments_chars(a3),a1
	clr.l	(a1)
	lea	line_comments_chars(a3),a1
	clr.l	(a1)
	lea	open_bracks_chars(a3),a1
	clr.l	(a1)
	lea	str_chars(a3),a1
	clr.l	(a1)
	clr.b	start_chroma_char(a3)
	clr.b	stop_chroma_char(a3)
	qmove.l	#0,template_file_index(a5)

interpret_ldf:
	bsr	get_line		*get a line from the file
	tst.w	d0
	bmi.s	end_interpret_ldf
	lea	template_line(pc),a0
	bsr	crunch_ws		*skip tabs and spaces
	move.b	(a0),d0
	beq.s	end_interpret_ldf
	cmpi.b	#"*",d0	*comment?
	beq.s	interpret_ldf
	cmpi.b	#";",d0
	beq.s	interpret_ldf
	cmpi.b	#13,d0
	beq.s	interpret_ldf	*Blank line
	bsr	get_template_word	*into template_word
	lea	template_word(a5),a1
	bsr	match_with_command	*returns command ID or -1 in d0
	tst.w	d0
	bmi	interpret_ldf	*Noone command
	qmove.l	#0,d7
	qmove.w	d0,d7		    	*Save item
**Get parameters
	bsr	crunch_ws			*Eat space between command and params
**D7=command,a0=text for command
	bsr	process_command
	tst.w	d0
	beq	interpret_ldf	*do next else end
end_interpret_ldf:
sc_bye:
	unlk	a4
	rts_	"setup_chroma"

**D7=command, a0=text for command
**returns d0=0=continue else end
**a3 pointing to chroma table base
process_command:
	move.l	d7,d0
	cmpi.l	#0,d0
	bne.s	not_code
	push	a3
	move.l	a0,a3
	bsr.l	get_dec
	pop	a3
	move.w	d0,lang(a3)
	bra	proc_end
not_code:
	cmpi.l	#1,d0
	bne.s	not_name
	bsr	copy_name
	bra	proc_end
not_name:
	cmpi.l		#2,d0
	bne.s	not_col0
	moveq	#0,d0
	bsr	copy_colour_name
	bra	proc_end
not_col0:

	cmpi.l		#3,d0
	bne.s	not_col1
	moveq	#1,d0
	bsr	copy_colour_name
	bra	proc_end
not_col1:

	cmpi.l		#4,d0
	bne.s	not_col2
	moveq	#2,d0
	bsr	copy_colour_name
	bra	proc_end
not_col2:

	cmpi.l		#5,d0
	bne.s	not_col3
	moveq	#3,d0
	bsr	copy_colour_name
	bra	proc_end
not_col3:

	cmpi.l		#6,d0
	bne.s	not_col4
	moveq	#4,d0
	bsr	copy_colour_name
	bra	proc_end
not_col4:

	cmpi.l		#7,d0
	bne.s	not_col5
	moveq	#5,d0
	bsr	copy_colour_name
	bra	proc_end
not_col5:

	cmpi.l		#8,d0
	bne.s	not_col6
	moveq	#6,d0
	bsr	copy_colour_name
	bra	proc_end
not_col6:

	cmpi.l		#9,d0
	bne.s	not_col7
	moveq	#7,d0
	bsr	copy_colour_name
	bra	proc_end
not_col7:
**Coci
	cmpi.l	#10,d0
	bne.s	not_coci
	move.l	#1,insensitive(a3)
	bra	proc_end
not_coci:
	cmpi.l	#11,d0
	bne.s	not_cocs
	move.l	#0,insensitive(a3)
	bra	proc_end
not_cocs:
	cmpi.l	#12,d0
	bne.s	not_start_colour_table
	bsr	process_colour_table	*ends on ECOL:
**a2 is pointing to end of ct
	lea	sizeof_header(a3),a2	*CT tree here
	add.l	colour_table_size(a4),a2	*physical end of CT
	sub.l	a3,a2	*offset to help text
	move.l	a2,help_text_offset(a3)
	bra	proc_end
not_start_colour_table:
	cmpi.l	#14,d0
	bne.s	not_cstr
**string characters
	lea	str_chars(a3),a2
copy_chars:
	qmove.l	#0,d1	*we allow upto 16 of them
copy_str_chars:
	cmpi.l	#16,d1
	beq.s	end_strc
	qcmove.b	(a0)+,d0
	cmpi.l	#9,d0
	beq.s	end_strc
	cmpi.l	#13,d0
	beq.s	end_strc
	cmpi.l	#32,d0
	beq.s	end_strc
	qmove.b	d0,(a2,d1.l)
	addq.l	#1,d1
	bra.s	copy_str_chars
end_strc:
	bra	proc_end
	
not_cstr:

	cmpi.l	#15,d0
	bne.s	not_ob
**open bracks characters
	lea	open_bracks_chars(a3),a2
	bra	copy_chars
not_ob:

	cmpi.l	#16,d0
	bne.s	not_cb
**close bracks characters
	lea	close_bracks_chars(a3),a2
	bra	copy_chars
not_cb:

	cmpi.l	#17,d0
	bne.s	not_string_colour
	push	a3
	move.l	a0,a3
	bsr.l	get_dec
	pop	a3
	tst.l	d0
	bmi	bad_string_colour
	cmpi.l	#7,d0
	bgt	bad_string_colour
	move.l	d0,string_colour(a3)
	bra	proc_end

not_string_colour:

	cmpi.l	#18,d0
	bne.s	not_comments_colour
	push	a3
	move.l	a0,a3
	bsr.l	get_dec
	pop	a3
	tst.l	d0
	bmi	bad_comments_colour
	cmpi.l	#7,d0
	bgt	bad_comments_colour

	move.l	d0,comments_colour(a3)
	bra	proc_end

not_comments_colour:
	cmpi.l	#19,d0	*COLT
	bne.s	not_line_comment_char

	lea	line_comments_chars(a3),a2
	move.l	coml_counter(a5),d0
	lsl.l	#2,d0	*each entry is 4 chars max
	add.l	d0,a2
	qmove.l	#0,d1	*char count
get_coml:
	cmp.l	#3,d1
	beq.s	end_coml
	move.b	(a0)+,d0
	beq.s	end_coml
	cmpi.b	#13,d0
	beq.s	end_coml
	cmpi.b	#32,d0
	beq.s	end_coml
	cmpi.b	#9,d0
	beq.s	end_coml
	move.b	d0,(a2)+
	addq.l	#1,d1
	bra.s	get_coml
end_coml:
	addq.l	#1,coml_counter(a5)	*Should've been local!
	clr.b	(a2)
	bra	proc_end
not_line_comment_char:

	cmpi.l	#20,d0
	bne	not_lineterm_char
	lea	stop_chars(a3),a2
	addq.l	#3,a2	*skip over space and tab and CR
	qmove.l	#0,d1	*char count
get_lt:
	cmp.l	#124,d1	*we allow 124 extra ones
	beq.s	end_lt
	move.b	(a0)+,d0
	beq.s	end_lt
	cmpi.b	#13,d0
	beq.s	end_lt
	cmpi.b	#32,d0
	beq.s	end_lt
	cmpi.b	#9,d0
	beq.s	end_lt
	move.b	d0,(a2)+
	addq.l	#1,d1
	bra.s	get_lt
end_lt:
	clr.b	(a2)	*term proper like
	bra	proc_end
	
not_lineterm_char:

	cmpi.l	#21,d0
	bne	not_multcomm_schar
	lea	start_comments_chars(a3),a2
	qmove.l	#0,d1	*char count
get_smc:
	cmp.l	#16,d1
	beq.s	end_smc
	move.b	(a0)+,d0
	beq.s	end_smc
	cmpi.b	#13,d0
	beq.s	end_smc
	cmpi.b	#32,d0
	beq.s	end_smc
	cmpi.b	#9,d0
	beq.s	end_smc
	move.b	d0,(a2)+
	addq.l	#1,d1
	bra.s	get_smc
end_smc:
	clr.b	(a2)
	bra	proc_end
	
not_multcomm_schar:


	cmpi.l	#22,d0
	bne	not_multcomm_echar
	lea	end_comments_chars(a3),a2
	qmove.l	#0,d1	*char count
get_emc:
	cmp.l	#16,d1
	beq.s	end_emc
	move.b	(a0)+,d0
	beq.s	end_emc
	cmpi.b	#13,d0
	beq.s	end_emc
	cmpi.b	#32,d0
	beq.s	end_emc
	cmpi.b	#9,d0
	beq.s	end_emc
	move.b	d0,(a2)+
	addq.l	#1,d1
	bra.s	get_emc
end_emc:
	clr.b	(a2)
	bra	proc_end
	
not_multcomm_echar:
	cmpi.l	#24,d0
	bne	not_change_colour
	move.b	(a0)+,d0
	cmpi.b	#"0",d0
	bne.s	not_off
	move.l	#0,change_colour(a3)	*turn it on
not_off:
	bra	proc_end
	
not_change_colour:
	cmpi.l	#25,d0
	bne.s	not_start_chroma_char
	move.b	(a0)+,start_chroma_char(a3)
	bra	proc_end
not_start_chroma_char:
	cmpi.l	#26,d0
	bne.s	not_stop_chroma_char

	move.b	(a0)+,stop_chroma_char(a3)
	bra	proc_end
not_stop_chroma_char:
	
	cmpi.l	#27,d0
	bne	not_start_paste_text

	clr.l	d7	*text length counter
*get 3k for text
	push	a0	*save src
	qmove.l	#3*1024,d0
	OSNewPtr	d0,a0
	move.l	a0,d0
	pop	a0
	tst.l	d0
	beq	error
	move.l	d0,a1	*Save text here
	move.l	d0,info_paste_ptr(a3)

**Now get text, ends in CR HEDE
get_head_loop:
	move.l	ldf_text_ptr(a4),a0
	qmove.l	template_file_index(a5),d0
	cmp.l	template_size(a5),d0
	bgt.s	ghl_end
	add.l	d0,a0
	inc.l	template_file_index(a5)
	move.b	(a0),d0
	move.b	d0,(a1)+
	addq.l	#1,d7
	cmpi.l	#(3*1024)-1,d7
	beq.s	ghl_end
	cmpi.b	#13,d0
	bne.s	get_head_loop
	cmpi.l	#"HEDE",1(a0)
	bne.s	get_head_loop
ghl_end:
	move.l	d7,info_paste_size(a3)
	clr.l	d0
	bra	proc_end
	
	
not_start_paste_text:
	cmpi.l	#23,d0
	bne.s	not_help_text


	move.l	a3,a2
	add.l	help_text_offset(a2),a2	*text here
**Calc end of table
	qmove.l	a3,d0
	add.l	ldf_max_size(a4),d0
	sub.l	a2,d0	*max number of chars we can copy
	qmove.l	d0,d7
	sub.l	#128,d7	*call me Marvin but...
	
	qmove.l	ldf_text_ptr(a4),a0
	qmove.l	template_file_index(a5),d0
	add.l	d0,a0
	qmove.l	#0,d6	*char counter
copy_help_text:
	addq.l	#1,d6
	move.b	(a0)+,(a2)+
	beq.s	end_cht
	subq.l	#1,d7
	bne.s	copy_help_text
end_cht:
	clr.l	(a2)+
	clr.l	(a2)+
	clr.l	(a2)+
	qmove.l	d6,help_text_size(a3)
	moveq	#-1,d0
	bra.s	proc_bye
not_help_text:
proc_end:
	clr.l	d0
proc_bye:
	rts_	"ldf_process_command"

bad_string_colour:
	qmove.l	#1000,d0
	lea	string_colour_err(pc),a0
	qmoveq	#25,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d
	bra	proc_end

bad_comments_colour:
	qmove.l	#1000,d0
	lea	comments_colour_err(pc),a0
	qmoveq	#25,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d
	bra	proc_end

process_colour_table:
**x: string
	lea	sizeof_header(a3),a2	*CT tree here
	move.l	a2,last_tree_address_used(a5)

pct_loop:
	bsr	get_line
	lea	template_line(pc),a0
	bsr	get_template_word	*into template_word - the colour or ECOL
	bsr	crunch_ws	*to keyword
	lea	template_word(a5),a1
	cmpi.b	#":",4(a1)
	bne.s	not_ecol
	cmpi.l	#"ECOL",(a1)
	beq	end_pct
not_ecol:
**eval colour
	qcmove.b	(a1),d0
	cmpi.l	#0,d0
	beq	pct_loop
	cmpi.l	#"*",d0
	beq	pct_loop
	cmpi.l	#";",d0
	beq	pct_loop
	
	sub.l	#"0",d0
	bmi	colour_error
	cmpi.l	#7,d0
	bgt	colour_error
;	bsr	CTtree_insert	*d0=colour,
;	move.l	d0,12(a2)	*Store colour
**copy the word
;	clr.l	(a2)
;	clr.l	4(a2)
;	clr.l	8(a2)	*clear out
**get string in word_buff(pc)
	lea	word_buff(pc),a2
	qmove.l	#0,d1
cw_loop:
	cmpi.l	#15,d1
	beq.s	cw_end	*too long, truncate

	move.b	(a0)+,d2
	beq.s	cw_end
	cmpi.b	#13,d2
	beq.s	cw_end
	cmpi.b	#32,d2
	beq.s	cw_end
	cmpi.b	#9,d2
	beq.s	cw_end
	qmove.b	d2,(a2,d1.l)
	addq.l	#1,d1
	bra.s	cw_loop
cw_end:
	move.b	#0,(a2,d1.l)	*terminate word
	lea	sizeof_header(a3),a2	*CT tree here
	bsr	CTtree_insert	*d0=colour,word_buff(pc)=text
	tst.l	d0
	bne.s	skip_size_update
;	lea	16(a2),a2	*to next word
;	add.l	#sizeof_CT_node,colour_table_size(a4)
skip_size_update:
	bra	pct_loop	
end_pct:

	lea	sizeof_header(a3),a2	*CT tree here
	move.l	last_tree_address_used(a5),d0
	sub.l	a2,d0	*sizeof tree
	add.l	#sizeof_CT_node*2,d0
	move.l	d0,colour_table_size(a4)	*make sure this tree is 
				*terminated with two empty nodes
	rts_	"process_colour_table"
colour_error:
	qmove.l	#1000,d0
	lea	ldfs_colour(pc),a0
	qmoveq	#25,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d
	bra	end_pct

**Colour ID in d0
copy_colour_name:	*from a0 to colour_names(a3)
	lea	colour_names(a3),a1
	lsl.l	#6,d0	*each name is 64 bytes
	add.l	d0,a1
	bra	cn_loop

copy_name:	*from a0 to name(a3)
	lea	name(a3),a1
cn_loop:
	move.b	(a0)+,d0
	beq.s	end_cn
	cmpi.b	#13,d0
	beq.s	end_cn
	cmpi.b	#10,d0
	beq.s	end_cn
	move.b	d0,(a1)+
	bra.s	cn_loop
end_cn:
	clr.b	(a1)
	rts_	"ldf_copy_name"

setup_chroma_error:
	qmove.l	#1000,d0
	lea	ldfs_mem(pc),a0
	qmoveq	#25,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d
	bra	sc_bye



get_line:
	move.l	ldf_text_ptr(a4),a0

	lea	template_line(pc),a1
gl_loop:
	qmove.l	template_file_index(a5),d0
	cmp.l	template_size(a5),d0
	bgt.s	end_of_template
***LXT change
	qpush1	a0
	add.l	d0,a0
	qcmove.b	(a0),d1
	qpop1	a0
**End change
;	move.b	0(a0,d0.l),d1	 *get char
	cmpi.b	#13,d1
	beq.s	got_line
	qmove.b	d1,(a1)+
	inc.l	template_file_index(a5)
	bra.s	gl_loop
got_line:
	inc.l	template_file_index(a5)
	qmove.b	#13,(a1)+
	qmove.b	#0,(a1)
	qmoveq	#0,d0
	rts_	"get_template_line"
	
end_of_template:
	moveq	#-1,d0
	qmove.b	#0,(a1)
	rts



crunch_ws:
	qcmove.b	(a0),d0
	cmpi.l	#32,d0
	beq.s	crunch_ws1
	cmpi.l	#9,d0
	beq.s	crunch_ws1
	bra.s	ws_crunched
crunch_ws1:
	inc	a0
	bra.s	crunch_ws
ws_crunched:
	rts_	"Crunch_ws"



get_template_word:
	lea	template_word(a5),a1
get_word1:
	move.b	(a0)+,d0
	beq.s	got_word
	cmpi.b	#32,d0
	beq.s	got_word
	cmpi.b	#9,d0
	beq.s	got_word
	cmpi.b	#13,d0
	beq.s	got_word
	move.b	d0,(a1)+
	bra.s	get_word1
got_word:
	clr.b	(a1)
	rts_	"Get_template_word"


match_with_command:
**Cehck for a colon
	clr.l	d0
	cmpi.b	#":",4(a1)
	bne.s	no_command	*xxxx: is a command
	qmove.l	(a1)+,d2	*Get command
	lea	ldf_commands(pc),a2	*Each entry is twelve bytes
	qmoveq	#0,d0
check_command:
	move.l	(a2)+,d3
	bmi.s	no_command
	cmp.l	d2,d3
	bne.s	no_match
	rts
no_match:
	inc.l	d0
	bra.s	check_command
no_command:
	moveq	#-1,d0
	rts_	"Check_Command"


****************************************************************************
**colour table trees
**insert a node
**Tree at a2
**From preproc, but strings are in node rather than separate
**d0=colour,word_buff=string
CTtree_insert:
	qmove.l	d0,d3
CTtree_insert_loop:
	lea	word_buff(pc),a0
**get the string
	move.l	(a2),d0			*the string
**A0->string we wish to insert
**a2->string we are testing - is the node empty?
	beq.s	CTgot_empty_node		*yes - it.s not found, so insert away, Jimmy!
**now we have:
**a0->the word
**a2->the string offset for this node
	move.l	a2,a1	*string

	qbsr	strcmp2		*Compare em. d0=0=match,d0=-1=word is less than, +1=word is greater than
					*Leaves a2 alone
	beq	CTmatch!		
	bgt.s	CTgo_right

**This is go left as string we are comparing is less than node contents
	move.l	CT_tree_next_left(a2),a2	*to left node
	bra	CTtree_insert_loop		*walk the walk...

CTgo_right:
	move.l	CT_tree_next_right(a2),a2	*to right node
	bra	CTtree_insert_loop		*check next node

CTgot_empty_node:
**now copy identifier to string in node
	lea	word_buff(pc),a0
	move.l	a2,a1
CTcss:	
	addq.l	#1,d0			*update string counter
	move.b	(a0)+,(a1)+
	bne.s	CTcss
	move.l	d3,CT_colour(a2)	*Store the colour index
	
**now we have to set left/right pointers from this node - crucial bit of theory...
;	move.l	CTlast_tree_address_used(a5),d0

	move.l	last_tree_address_used(a5),d0
	add.l	#sizeof_CT_node,d0	 	 	 *each node is 16 bytes in size
	move.l	d0,CT_tree_next_left(a2)
	add.l	#sizeof_CT_node,d0
	move.l	d0,CT_tree_next_right(a2)		*a3 is node pointer
	move.l	d0,last_tree_address_used(a5)


;	 move.l	a2,d0	 *this node addr
;	 add.l	 #sizeof_CT_node,d0		 	 *each node is 16 bytes in size
;	 move.l	d0,CT_tree_next_left(a2)
;	 add.l	 #sizeof_CT_node,d0
;	 move.l	d0,CT_tree_next_right(a2)	 	 *a3 is node pointer
	clr.l	d0	*no error
	rts_	"CTtree_insert"

CTmatch!:
	moveq	#-1,d0	*return found
	rts_	"CT_Insert_Match"

**************************************************
*search the tree for the identifier in a0
*Destroys a1-a3,d0,d1
*retirns d0=-1 if not found else zero and d1=colour index

CTtree_search:
	qpush1	a3
	move.l	a0,a3
CTtree_search_cont:

	move.l	a3,a0	*the thing we're looking for
**get the string
	move.l	(a2),d0			*the string
**A0->string we wish to insert
**a2->string we are testing - is the node empty?
	move.l	a2,a1	*string
	beq.s	CTsearch_fail		*yes - search failed
**now we have:
**a2->the string
	qbsr	strcmp3		*Compare em. d0=0=match,d0=-1=word is less than, +1=word is greater than
					*Leaves a2 alone
	beq	CTsearch_match!	*found		
	bgt.s	CTsearch_go_right
**This is go left as string we are comparing is less than node contents
	move.l	CT_tree_next_left(a2),a2	*to left node
	if	PPC
	dcbt	r0,r22
	endif
	bra	CTtree_search_cont		*walk the walk...

CTsearch_go_right:
	move.l	CT_tree_next_right(a2),a2	*to right node
	if	PPC
	dcbt	r0,r22
	endif
	bra	CTtree_search_cont		*check next node

CTsearch_fail:
;	qpop1	a3
	qmoveq	#-1,d0	*no error
	bra	CTSearch_end
;	rts_	"CTsearch_fail"

CTsearch_match!:
	qmoveq	#0,d0	*return found
	qmove.l	CT_colour(a2),d1	*Return colour code
CTSearch_end:
	qpop1	a3
	rts_	"CTsearch_Match"
****************************************************************************	
***********
**a0 against a1
**use qbsr
strcmp2:
	qmove.l	#0,d0
strcmp1a:
	move.b	(a1)+,d0
	beq.s	strcmp_end_test
;        tst.b   (a1)
;       beq.s    strcmp_end_test
	qcmove.b	(a0)+,d1
	cmp.l	d0,d1
;        cmpm.b   (a1)+,(a0)+
    beq     strcmp1a                ; if equal, next one
	blt.s     strcmp_end_lessthan   ; unsigned compare
    moveq.l #1,d0   		; its greater than
    qrts
strcmp_end_test:
	tst.b   (a0)
	bne.s     strcmp_end_lessthan
	moveq.l #0,d0			;equal
	qrts
strcmp_end_lessthan:
	moveq.l #-1,d0
	qrts
	
**a0 against a1 (the table entries)
**use qbsr
**Does the chroma search and handles ? (char match) and * (match) in table
	section	str3
strcmp3:
	qmove.l	#0,d0
.strcmp3a:
	move.b	(a1)+,d0
	beq.s	.strcmp_end_test
	qcmove.b	(a0)+,d1
qmflag:	set	0
**if d0=? then this char matches
	if	PPC
	macs_last
	cmpwi	cr1,r3,"?"
	cmpwi	cr2,r3,"*"
	cmpw	cr3,r4,r3
	li	r3,1	*default gt return (for free)
	cmpwi	cr0,r3,0
	beq	cr1,.strcmp3a	*Char match
	beq	cr2,.strcmp_end_match
	beq	cr3,.strcmp3a
	blt	cr3,.strcmp_end_lt
	macs_first
	else
	cmp.l	#"?",d0
	beq	.strcmp3a	*Char match
**if d0=* then match to end of word
	cmp.l	#"*",d0
	beq.s	.strcmp_end_match
	cmp.l	d0,d1
    beq     .strcmp3a                ; if equal, next one
	blt.s     .strcmp_end_lt   ; unsigned compare
    moveq.l #1,d0   		; its greater than
	endif
    bra.s	.end_strcmp
.strcmp_end_test:
	tst.b   (a0)
	bne.s     .strcmp_end_lt
.strcmp_end_match:
	moveq.l #0,d0			;equal
	bra.s	.end_strcmp
.strcmp_end_lt:
	moveq.l #-1,d0
.end_strcmp:	qrts

**********************************************************************************
	align	4
ldf_commands:	dc.b	"CODE"	*0
	dc.b	"NAME"
	dc.b	"COL0"
	dc.b	"COL1"
	dc.b	"COL2"	*4
	dc.b	"COL3"
	dc.b	"COL4"
	dc.b	"COL5"
	dc.b	"COL6"
	dc.b	"COL7"	*9
	dc.b	"COCI"
	dc.b	"COCS"
	dc.b	"SCOL"	*12
	dc.b	"ECOL"	*13
	dc.b	"CSTR"	*14
	dc.b	"COPB"
	dc.b	"CCLB"
	dc.b	"COLS"
	dc.b	"COLC"
	dc.b	"COML"	*19
	dc.b	"COLT"
	dc.b	"COMS"	*21
	dc.b	"COME"
	dc.b	"LHPS"	*23
	dc.b	"CMOD"	*24
	dc.b	"STCC"	*25
	dc.b	"SPCC"	*26
	dc.b	"HEDS"	*27
	dc.b	"HEDE"	*28
	dc.b	0xff,0xff,0xff,0xff
	align


template_line:	ds.b	256
	align
	
max_ldfs:	cstring	"Too many language files!",13,"Maximum 31 allowed.",13,"Extra files ignored."
	align
ldfs_mem:	cstring	"Out of memory whilst loading language definition files."
	align
ldfs_colour:	cstring	"Bad colour entry in language definition file."
	align
string_colour_err:	cstring	"Bad string colour (COLS:) in language definition file."
	align
comments_colour_err:	cstring	"Bad comments colour (COLC:) in language definition file."
	align
STtree_max_entries:	pstring	"CT Tree reached max nodes Stu - I'm hosed."
	align
word_buff:	ds.b	24
	align
	global	load_ldf,CTtree_search
	extern	size_file,read_file,do_alert_3d,get_dec,do_new_alert_3d