	include	pm_equates.def
	include	client_commands.def
*******************************************************************************
*Project:       PF5                                                           *
*Author:        Lightsoft                                                     *
*Filename:      project_file_management.s                                     *
*Version:       5                                                             *
*Date started:  2:41:39 on 23rd January 1997                                  *
*Rev. History:                                                                *
*                                                                             *
*                                                                             *
*******************************************************************************
Ciocompletion:	equ	12	long
Cionameptr:	equ	18	long
Ciovrefnum:	equ	22	word
Ciodrdirid:	equ	48	long
Ciodirid:	  equ	  48	long
Ciofdirindex:	equ	28	word - set to zero initially
CioDRParID:	equ	100	long

**old name in old_file_selected_name, new name in temp_string
rename_user_folder:
	lea	old_file_selected_name(a5),a0
	bsr.l	find_file_given_name	*FInds the folder in the project file in a1
**Name at 32(a1)
	lea	temp_string(a5),a0
	lea	32(a1),a1
	qmoveq	#40,d2
	OSBlockMoveData	a0,a1,d2

	rts_	"rename_user_folder"

**Store output file needs data in a0
**And size of data in d0
**All offsets are relative to the start of the file and NOT the current position!

************IMPORTANT - ALL OFFSETS ARE RELATIVE TO THEMSELVES!!!!****************
**Takes a file list offset in d0, filenumber in d1
delete_file_from_project:
	st	must_rebuild4(a5)		*must do a complete rebuild from p4
**First find size of file being deleted
	qmove.w	d1,file_number_save(a5)
	qmove.l	d0,file_list_offset_save(a5)
	
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qmove.l	d0,d6	*save our offset
	add.l	d0,a1	*Offset to pointer to file base
	add.l	(a1),a1
	bsr	find_nth	*Finds the d1 file, returns a1->file, d0=0=ok, -1=not found
**Check if file being deleted is last file, if so we need to terminate previous file
**if file number is >0
	clr.l	d1
	move.w	file_number_save(a5),d1
	beq.s	theres_only_one	*no bother - this is the only file
;	pea	delete_not_one(pc)	
;	dc.w	_debugstr

	qmove.l	a1,our_file(a5)	*This points to the file to be deleted
**Find previous file and terminate it if this is the last file
*save old owner and ref
	qmove.l	this_file_uf_ref(a1),old_uf_ref(a5)
	qmove.l	this_file_uf_owner(a1),old_uf_owner(a5)
	cmpi.l	#$ffffffff,(a1)
	bne.s	not_last
	qmove.l	file_list_offset_save(a5),d0
	subq.l	#1,d1			*previous file
	qmove.l	proj_buffer_h(a5),a1
	qmove.l	(a1),a1
	add.l	d0,a1	*Offset to pointer to file base
	add.l	(a1),a1
	bsr	find_nth	*Finds the d1 file, returns a1->file, d0=0=ok, -1=not found
	qmove.l	#$ffffffff,(a1)	*terminate it!
	qmove.l	our_file(a5),a1
not_last:
theres_only_one:

**Now we need to move from our_file+size down by file_inserted_size
	qmove.l	4(a1),d0	*Size of file being deleted
	qmove.l	d0,d7		  *copy of size so we can subtract it from offsets
	movem.l	d6/d7,-(sp)
	qmove.l	a1,a0		    *src
	add.l	d0,a0		    *a0 is now source, a1 is dest < src
	clr.l	(a1)
	clr.l	4(a1)		*Wipe out the file
*Bytes to move is eof-d0
	save_volatile
	qmove.l	proj_buffer_h(a5),d0
	OSHLock	d0
	restore_volatile

	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	add.l	#eof_offset,a2	*pointing to the offset to the eof
	qmove.l	(a2),d0	*Offset from here to eof
	add.l	#eof_offset,d0	**OFfset from start ot eof
**add offset to source to find number of bytes to move
	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	add.l	d0,a2	*physical eof
	qmove.l	a2,d0
	qmove.l	a2,d6	*BEcause we have to clear out the space left behind
	
	sub.l	a0,d0	*src-eof=# of bytes to move
	beq.s	none_to_move
	qmove.l	d0,d2
	OSBlockMoveData	a0,a1,d2
none_to_move:
**Size of deleted file is in d7 - physically delete it!
	move.l	d6,a1
	sub.l	d7,a1	*start clearing here
	qmove.l	d7,d6
	lsr.l	#2,d6
	subq.l	#1,d6
clear_to_eof:
	clr.l	(a1)
	subq.l	#1,d6
	addq.l	#4,a1
	bne.s	clear_to_eof
	movem.l	(sp)+,d6/d7	*Size of deleted file and our file list offset
**Now we need to update offsets that point to files greater than this one
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	cmp.l	#folders_offset,d6
	blt	adjust_folders
	cmp.l	#bin_offset,d6
	blt	adjust_bin
	cmp.l	#notes_offset,d6
	blt	adjust_notes
	cmp.l	#vhl_offset,d6
	blt.s	adjust_vhl
	cmp.l	#vhlh_offset,d6
	blt.s	adjust_vhlh
	cmp.l	#hl_offset,d6
	blt.s	adjust_hl
	cmp.l	#hlh_offset,d6
	blt.s	adjust_hlh
	cmp.l	#source_offset,d6
	blt.s	adjust_source
	cmp.l	#glob_offset,d6
	blt.s	adjust_glob
	cmp.l	#sinc_offset,d6
	blt.s	adjust_sinc
	cmp.l	#obj_offset,d6
	blt.s	adjust_obj
	cmp.l	#libs_offset,d6
	blt.s	adjust_libs
	cmp.l	#slibs_offset,d6
	blt.s	adjust_slibs
	cmp.l	#res_offset,d6
	blt.s	adjust_res
	cmp.l	#homeless_offset,d6
	blt.s	adjust_homeless
	cmp.l	#untitled2_offset,d6
	blt.s	adjust_spare2
	cmp.l	#untitled3_offset,d6
	blt.s	adjust_spare3
	lea	invalid_offset(pc),a0
	OSDebugStr	a0
**d7 is size
adjust_folders:	sub.l	d7,folders_offset(a1)
adjust_bin:	sub.l	d7,bin_offset(a1)	
adjust_notes:	sub.l	d7,notes_offset(a1)
adjust_vhl:	sub.l	d7,vhl_offset(a1)
adjust_vhlh:	sub.l	d7,vhlh_offset(a1)
adjust_hl:	sub.l	d7,hl_offset(a1)
adjust_hlh:	sub.l	d7,hlh_offset(a1)
adjust_source:	sub.l	d7,source_offset(a1)
adjust_glob:	sub.l	d7,glob_offset(a1)
adjust_sinc:	sub.l	d7,sinc_offset(a1)
adjust_obj:	sub.l	d7,obj_offset(a1)
adjust_libs:	sub.l	d7,libs_offset(a1)
adjust_slibs:	sub.l	d7,slibs_offset(a1)
adjust_res:	sub.l	d7,res_offset(a1)
adjust_homeless:	sub.l	d7,homeless_offset(a1)
adjust_spare2:	sub.l	d7,untitled2_offset(a1)
adjust_spare3:	sub.l	d7,untitled3_offset(a1)
	sub.l	d7,depend_offset(a1)
	sub.l	d7,miscgumf_offset(a1)
	sub.l	d7,eof_offset(a1)
	save_volatile
	qmove.l	proj_buffer_h(a5),d0
	OSHUnlock	d0
	restore_volatile

	rts_	"Delete_file_from_project"
	
**needs filename in old_file_selected_name(a5)
**Find offset of file
delete_file_given_name:
	reset_locals
	local.l	file_list_offset_save1,1
	
	reserve_locals	a4
	push	a6
	st	must_rebuild4(a5)		*must do a complete rebuild from p4

	qmove.l	proj_buffer_h(a5),d0
	OSHLock	d0

	lea	old_file_selected_name(a5),a0
	bsr.l	find_file_in_proj	*returns an alias in scratch_1 and proj
	tst.l	d0
	bmi	dfgn_error
	movem.l	a0/a1/a2/d6/d7,-(sp)
	move.l	scratch_1(a5),a0
	move.l	a0,d0
	beq.s	no_alias
	OSDisposeHandle	d0		*get rid of alias
no_alias:
	movem.l	(sp)+,a0/a1/a2/d6/d7
**now calc PF offset
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	qmove.l	a1,d1		    *Copy our file start
	sub.l	a0,d1		    *PF offset for this file
**FInd file list base
	sub.l	#output_file_offset,d1
	add.l	#output_file_offset,a0
	cmp.l	(a0),d1
	blt	dfgn_error	*less than output file?
	qmoveq	#16,d5	*counter
try_next_base:
	subq.l	#4,d1
	addq.l	#4,a0
	cmp.l	(a0),d1
	bge.s	not_this
	qmove.l	a0,d0
	subq.l	#4,d0	*pf offset of file base offset
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a0
	sub.l	a0,d0	*file base offset in PF
	bra.s	got_base
not_this:
	subq.l	#1,d5
	bne.s	try_next_base
	bra	dfgn_error
got_base:

**if the base is vhl, hl, or src then we must delete output files from this file
**for example, if I delete a source file, then I must delete it's object file as well.
	qmove.l	d0,file_list_offset_save1(a4)	*the base
**is vhl
**is hl?
	cmp.l	#vhl_offset,d0
	bne.s	not_vhl
	push	d0	*save offset
	move.l	#1,d0	*from phase 2 output area
	lea	old_file_selected_name(a5),a0
	bsr	delete_file_at_phase	*Deletes trickle down files
	popq	d0	*restore offset
	bra	not_source
not_vhl:		
	cmp.l	#hl_offset,d0
	bne.s	not_hl
	push	d0	*save offset
	move.l	#2,d0	*from phase 2 output area
	lea	old_file_selected_name(a5),a0
	bsr	delete_file_at_phase	*Deletes trickle down files
	popq	d0	*restore offset
	bra	not_source
not_hl:		
	cmp.l	#source_offset,d0
	bne.s	not_source
	push	d0	*save offset
	move.l	#3,d0	*from phase 3 output area
	lea	old_file_selected_name(a5),a0
	bsr	delete_file_at_phase	*Deletes trickle down files
	popq	d0	*restore offset
not_source:

**now find file number again by strcmp
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qmove.l	d0,d6	*save our offset
	add.l	d0,a1	*Offset to pointer to file base
	add.l	(a1),a1
	move.l	a1,a2
	clr.l	d5			*File counter
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a6
	add.l	#depend_offset,a6
	add.l	(a6),a6		    	*EOF as physical addr
	lea	old_file_selected_name(a5),a0
try_next_file:
	move.l	a2,a1		    	*save this folder
	qmove.l	4(a2),d7		*size of this entry
	qmove.l	a1,-(sp)			*Save project_file pointer
	lea	this_file_name(a2),a1		     *Skip our stuff to get at the name
	move.l	a0,a3		  	  *save string we're looking for
	clr.l	d0
	qmove.b	(a0),d0
	inc.l	d0
	qbsr.l	strncmp
	move.l	a3,a0		    	*restore string
	qmove.l	(sp)+,a1			*restore proj pointer
	tst.l	d0
	beq.s	got_file
	inc.l	d5				*inc counter
	add.l	d7,a2
	cmp.l	a2,a6
	ble.s	dfgn_error	*this is an error that can't happen - reached eof
	bra.s	try_next_file
got_file:

	qmove.l	d5,d1		    *File number
	qmove.l	file_list_offset_save1(a4),d0
	bsr	delete_file_from_project
dfgn_error:
	qmove.l	proj_buffer_h(a5),d0
	OSHUnlock	d0
	pop	a6
	unlk	a4
	rts_	"Delete_file_given_name"
	
**Finds the nth file in a project area
**Expects a1->base of files and file number to find in d1
**Destroys d0,d2,a1
find_nth:
	clr.l	d2
	move.w	d1,d2	*counter
	beq.s	found_ok
;	subq.w	#1,d2
check_next_file:
	subq.w	#1,d2
	cmpi.l	#$ffffffff,(a1)
	beq.s	end_of_list
	add.l	4(a1),a1	*point to next entry
	tst.w	d2
	bne.s	check_next_file
end_of_list:
	tst.w	d2
	beq.s	found_ok
	moveq	#-1,d0
	bra.s	end_find_nth
found_ok:
	clr.l	d0
end_find_nth:
	rts_	"Find_nth_in_area"
**Expects a1->base of files and file number to find in d1
**Destroys d0,d2,a1,a2	
**Finds the nth file in the WHOLE project
find_nth_proj:
**calc physical end of file in a2
	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	add.l	#depend_offset,a2
	add.l	(a2),a2		    	*EOF as physical addr
	clr.l	d2
	move.w	d1,d2	*counter
	beq.s	found_ok_proj
check_next_file_proj:
	subq.w	#1,d2
	add.l	4(a1),a1	*point to next entry
	cmp.l	a2,a1
	bge.s	end_of_list_proj	*end of project!
	tst.w	d2
	bne.s	check_next_file_proj
end_of_list_proj:
	tst.w	d2
	beq.s	found_ok_proj
	moveq	#-1,d0
	bra.s	end_find_nth_proj
found_ok_proj:
	clr.l	d0
end_find_nth_proj:
	rts_	"Find_nth_in_proj"
**First determine what files need to be moved

*************If we delete a source file fro mthe project, then we should
*************also delete the binary file :-)
**Delete the binary file if the source is going
**called from delete_file_given_name, which this calls...
**Needs a source file name in old_file_selected_name(a5) and a phase in d0
delete_file_at_phase:
	reset_locals
	local.b	phase_name,80
	local.b	temp_fsspec2,100
	local.b	output_fsspec,100
	local.w	bin_folder_Vrefnum,1
	local.l	bin_folder_DirID,1
	local.b	bin_fsspec,80
	local.b	temp_str,80
	local.l	the_phase,1
	reserve_locals	a4
	move.l	d0,the_phase(a4)	*save phase
	save_all
**copy file name
	lea	old_file_selected_name(a5),a0
	lea	phase_name(a4),a1
	qmoveq	#64,d2
	OSBlockMoveData	a0,a1,d2
**make the filename=phase name
delete_next_file:
	lea	phase_name(a4),a0
**get filename
	qmove.l	#A_name_to_phase,d0
	move.l	a0,d1
	move.l	the_phase(a4),d2
	bsr.l	global_send_2	to client command processor	
	lea	global_pb(a5),a0
	move.l	(a0),d0
	lea	phase_name(a4),a0
**See if derived file is present in project
	lea	phase_name(a4),a0
	bsr.l	find_file_given_name
	tst.w	d0
	bmi	not_in_proj
**Dialog - do you want to delete the derived file
	lea	phase_name(a4),a0
	lea	ba_name(pc),a1
	qcmove.b	(a0),d0
	subq.l	#1,d0
	addq.l	#1,a0
	bmi	not_in_proj
cbn:
	qmove.b	(a0)+,(a1)+
	qdbra	d0,cbn
	clr.b	(a1)
	lea	binary_alias(pc),a0
	qcmove.w	#510,d0	*no/yes box
	qmove.l	#20,d1	x
	qmove.l	#70,d2	y
	bsr.l	do_new_alert_3d
	cmpi.l	#1,d0
	bne	cant_delete	*User does not want to delete derived file
**Save old file selected name
	lea	old_file_selected_name(a5),a0
	lea	temp_str(a4),a1
	qmoveq	#64,d2
	OSBlockMoveData	a0,a1,d2
**Delete derived file
	lea	phase_name(a4),a0
	lea	old_file_selected_name(a5),a1
	qmoveq	#34,d2
	OSBlockMoveData	a0,a1,d2
	push	a4
	bsr	delete_file_given_name
	pop	a4
**restore old_file_selected_name
	lea	old_file_selected_name(a5),a1
	lea	temp_str(a4),a0
	qmoveq	#64,d2
	OSBlockMoveData	a0,a1,d2
not_in_proj:
no_object:

**Find (and create if neccessary) phase  o/p folder

	qmove.l	#A_get_phase_x_op_spec,d0
	qmove.l	the_phase(a4),d1
	bsr.l	global_send_1	to client command processor	
	lea	global_pb(a5),a0
	move.l	(a0),d0
	bmi	cant_delete

	addq.l	#4,a0
	qmove.w	(a0),bin_folder_Vrefnum(a4)
	bsr	get_folder_dirid	*a0=fsspec, return d0=dirid
	qmove.l	d0,bin_folder_DirID(a4)

	qmove.w	bin_folder_Vrefnum(a4),d0	*Vrefnum
	qmove.l	bin_folder_DirID(a4),d1	*Dirid
	lea	phase_name(a4),a0
	lea		temp_fsspec2(a4),a1	*where? here!
	OSMakeFSspec	d0,d1,a0,a1,d0
	bmi.s	cant_delete
*delete the file
	lea	temp_fsspec2(a4),a0
	OSFSpDelete	a0,d0

cant_delete:
;obj_folder_not_found_FUCK4:
;**restore the original filename
;;	 lea	old_file_selected_name(a5),a0
;;	 lea	phase_name(a4),a1
;;	 qmoveq	#64,d2
;;	 OSBlockMove	a0,a1,d2

**inc phase and if not 4, do it all again
	move.l	the_phase(a4),d0
	addq.l	#1,d0
	move.l	d0,the_phase(a4)
	cmpi.l	#4,d0
	blt	delete_next_file
	restore_all
	unlk	a4
	rts_	"Delete_file_at_phase"
store_output_file:

**Get size of current output file
	add.l	#sizeof_file_entry,d0	 *acct for point to next, size, flags etc
	movem.l	d0/a0,-(sp)	*Save size and pointer to alias
	qmove.l	d0,file_inserted_size(a5)
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files
	bsr	move_shared_libs
	bsr	move_lib_files
	bsr	move_obj_files
	bsr	move_sinc_files
	bsr	move_glob_files
	bsr	move_source_files
	bsr	move_hl_headers
	bsr	move_hl_files
	bsr	move_vhl_headers
	bsr	move_vhl_files
	bsr	move_notes		*MUST be reverse order
	bsr	move_bin
	bsr	move_folders	

	movem.l	(sp)+,d0/a0
	qmove.l	d0,d1	*Size in d0
;	add.l	#16,d1 *acct for point to next, size, options and type

	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	d1,4(a1)	*offset to dependancies
	add.l	d1,8(a1)	*offset to misc gumph

	add.l	d1,folders_offset(a1)	*offset to folder aliases
	add.l	d1,bin_offset(a1)
	add.l	d1,notes_offset(a1)	*offset to eof
	add.l	d1,vhl_offset(a1)	*Offset to VHL files
	add.l	d1,vhlh_offset(a1)	  *Offset to HL files
	add.l	d1,hl_offset(a1)	*Offset to HL header files
	add.l	d1,hlh_offset(a1)	*OFfset to source incs
	add.l	d1,source_offset(a1)	*Offset to global inc files
	add.l	d1,glob_offset(a1)	  *Offset ot global incs
	add.l	d1,sinc_offset(a1)
	add.l	d1,obj_offset(a1)	*Offset to obj files
	add.l	d1,libs_offset(a1)	  *Offset to res files
	add.l	d1,slibs_offset(a1)	*offset to notes
	add.l	d1,res_offset(a1)	*Offset to shared libs
	add.l	d1,homeless_offset(a1)
	add.l	d1,untitled2_offset(a1)
	add.l	d1,untitled3_offset(a1)
	add.l	d1,eof_offset(a1)	
;	lea	8240(a1),a2		    *Point to output file spec
	lea	output_file_offset(a1),a2
	add.l	(a2),a2
	
	qmove.l	#-1,(a2)+	*Linked list - point to next entry or -1 if this is end
	qmove.l	d1,(a2)+	*Length of this entry
	clr.l	(a2)+		*options - not used here
	qmove.l	#"outp",(a2)+	*File is output spec
	clr.l	(a2)+			*time
	clr.l	(a2)+			*Spare 1
	clr.l	(a2)+			*spare 2
	clr.l 	(a2)+			*spare 3
**clr 64 bytes for name
	clr.l	(a2)			*first 4 bytes of name
	lea	64(a2),a2
**Now copy file id data
	sub.l	#sizeof_file_entry+1,d0		*96 for our stuff and one for dbra
copy:
	qmove.b	(a0)+,(a2)+
	dbra	d0,copy
	rts_	"Store_output_file"
**Fsspec of folder in a0, returns d0.l=dirid
	reset_locals
	local.b	my_pb,400
get_folder_dirid:
	reserve_locals	a4
	lea	my_pb(a4),a1
	clr.l	Ciocompletion(a1)	no completion routine
	lea	6(a0),a2
	qmove.l	a2,Cionameptr(a1)	point to filename
	qmove.w	(a0),Ciovrefnum(a1)	vrefnum
	qmove.l	2(a0),Ciodrdirid(a1)	dir id	  
	qmove.w	#0,Ciofdirindex(a1)	
	OSPBGetCatInfoSync	a1,d0
	lea	my_pb(a4),a0
	qmove.l	Ciodrdirid(a0),d0
	unlk	a4
	rts_	"PMget_folder_dirid"

**Needs a0->alias,d0=size,d1=type = hl  ,hlh ,src ,bin ,res ,glob,note
add_folder_alias:
**Move everything up
**Size of alias is in d0
	move.l	d1,d6	*Save folder type
	move.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	 *account for flags, offsets and things
	save_all
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files
	bsr	move_shared_libs
	bsr	move_lib_files
	bsr	move_obj_files
	bsr	move_sinc_files
	bsr	move_glob_files
	bsr	move_source_files
	bsr	move_hl_headers
	bsr	move_hl_files
	bsr	move_vhl_headers
	bsr	move_vhl_files
	bsr	move_notes		*MUST be reverse order
	bsr	move_bin
**Finally update pointers to stuff beyond res files
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qmove.l	file_inserted_size(a5),d5
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph

	add.l	d5,bin_offset(a1)
	add.l	d5,notes_offset(a1)	*offset to eof
	add.l	d5,vhl_offset(a1)	*Offset to VHL files
	add.l	d5,vhlh_offset(a1)	  *Offset to HL files
	add.l	d5,hl_offset(a1)	*Offset to HL header files
	add.l	d5,hlh_offset(a1)	*OFfset to source incs
	add.l	d5,source_offset(a1)	*Offset to global inc files
	add.l	d5,glob_offset(a1)	  *Offset ot global incs
	add.l	d5,sinc_offset(a1)
	add.l	d5,obj_offset(a1)	*Offset to obj files
	add.l	d5,libs_offset(a1)	  *Offset to res files
	add.l	d5,slibs_offset(a1)	*offset to notes
	add.l	d5,res_offset(a1)	*Offset to shared libs
	add.l	d5,homeless_offset(a1)
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)

	restore_all

	qmove.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	#folders_offset,a1		*offset to folder files
	add.l	(a1),a1		    	*-> first folder file

**Find empty folder slot
find_folder_slot:
	qmove.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_wahf
	qmove.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_folder_slot
	qmove.l	d1,(a2)		    	*update pointer (was end of list -1)
first_entry_wahf:
**Size in d0, data in a0
	qmove.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5	 	 	 *Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	qmove.l	#-1,(a1)+		*ptr to next
	qmove.l	d5,(a1)+		*Size of this
	qmove.l	d6,(a1)+		*folder type
	qmove.l	#0,(a1)+		*options - type
	clr.l	(a1)+			*time
	clr.l	(a1)+			*Spare 1
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**name
	clr.l	(a1)
	lea	64(a1),a1
	subq.l	#1,d7
copyf:
	qmove.b	(a0)+,(a1)+
	dbra	d7,copyf
	

**Now we have to move up notes,shared libs,res files by file_inserted_size(a5)
	rts_	"add_folder_alias"

****************************************
store_resource:
**Move everything up
**Size of alias is in d0
	qmove.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	 *account for flags, offsets and things
	save_all
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
**Finally update pointers to stuff beyond res files
	qmove.l	file_inserted_size(a5),d5
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph
	add.l	d5,homeless_offset(a1)
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)	*offset to eof

	restore_all
	qmove.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	#res_offset,a1		*offset to resource files
	add.l	(a1),a1		    	*-> first res file
	
	clr.l	d5
	move.w	file_add_pos(a5),d5
	bmi.s	at_res_end
find_res_ins:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq	first_entry_wahr
	tst.w	d5
	beq.s	got_res_pos
	qmove.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	subq.w	#1,d5
	cmpi.l	#-1,d0
	bne.s	find_res_ins
	qmove.l	d1,(a2)		    	*update pointer (was end of list -1)
	bra.s	first_entry_wahr
got_res_pos:
**Move all up from here (a1) to end of bin
	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	lea	res_offset+4(a2),a3
	add.l	(a3),a3		    *end of trash files
	sub.l	a1,a3		    	*size of trash files
	qmove.l	a3,d0
	sub.l	file_inserted_size(a5),d0
**move from a1 to a1+file_inserted_size for d0-a1 bytes?
	movem.l		a0/a1,-(sp)
	move.l	a1,a0
	add.l	file_inserted_size(a5),a1
	qmove.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,a0/a1
	qmove.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
	qmove.l	d5,(a1)+		*ptr to next
	bra.s	res_insert
	
at_res_end:

**Find empty res slot
find_res_slot:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_wahr
	move.l	4(a1),d1		*Size of this entry
	beq.s	first_entry_wahr
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_res_slot
	qmove.l	d1,(a2)		    	*update pointer (was end of list -1)
first_entry_wahr:
**Size in d0, data in a0
	qmove.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5		  	*Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	qmove.l	#-1,(a1)+		*ptr to next
res_insert:
	qmove.l	d5,(a1)+		*Size of this
	qmove.l	#"reso",(a1)+	*res alis
	qmove.l	d6,(a1)+		*options - type
	clr.l	(a1)+			*time
	qmove.w	uf_ref_number(a5),(a1)+	*if a user folder, it's serial number
	qmove.w	uf_owner(a5),(a1)+	  	    *owner of object (UF serial or zero)
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**Store filename
	qmoveq	#7,d0
	lea	add_file_name(a5),a3
	move.l	a1,a6		    	*save pos
sfn_r:
	qmove.l	(a3)+,(a1)+
	dbra	d0,sfn_r
	lea	64(a6),a1		    	*skip filename

	subq.l	#1,d7
	bmi.s	no_aliass
copyr:
	qmove.b	(a0)+,(a1)+
	dbra	d7,copyr
no_aliass:
	rts_	"Add_res_alias"

***************************************
store_highlevel:
**Move everything up
**Size of alias is in d0
	move.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	 *account for flags, offsets and things
	save_all
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files
	bsr	move_shared_libs
	bsr	move_lib_files
	bsr	move_obj_files
	bsr	move_sinc_files
	bsr	move_glob_files
	bsr	move_source_files
	bsr	move_hl_headers
**Finally update pointers to stuff beyond res files
	move.l	proj_buffer_h(a5),a1
	qmove.l	file_inserted_size(a5),d5
	move.l	(a1),a1
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph
	add.l	d5,hlh_offset(a1)
	add.l	d5,source_offset(a1)
	add.l	d5,glob_offset(a1)	  *Offset to glob files
	add.l	d5,sinc_offset(a1)
	add.l	d5,obj_offset(a1)	*offset to obj files
	add.l	d5,libs_offset(a1)
	add.l	d5,slibs_offset(a1)	*Offset to shared libs
	add.l	d5,res_offset(a1)	*Offset to res files
	add.l	d5,homeless_offset(a1)	  *offset to homeless files
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)	*offset to eof

	restore_all

	qmove.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	#hl_offset,a1		*offset to high level files
	add.l	(a1),a1		    	*-> first src file

	clr.l	d5
	move.w	file_add_pos(a5),d5
	bmi.s	at_hl_end
find_hl_ins:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq	first_entry_wahhl
	tst.w	d5
	beq.s	got_hl_pos
	qmove.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	subq.w	#1,d5
	cmpi.l	#-1,d0
	bne.s	find_hl_ins
	qmove.l	d1,(a2)		    	*update pointer (was end of list -1)
	bra.s	first_entry_wahhl
got_hl_pos:
**Move all up from here (a1) to end of bin
	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	lea	hl_offset+4(a2),a3
	add.l	(a3),a3		    *end of trash files
	sub.l	a1,a3		    	*size of trash files
	qmove.l	a3,d0
	sub.l	file_inserted_size(a5),d0

**move from a1 to a1+file_inserted_size for d0-a1 bytes?
	movem.l		a0/a1,-(sp)
	qmove.l	a1,a0
	add.l	file_inserted_size(a5),a1
	qmove.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,a0/a1
	qmove.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
	qmove.l	d5,(a1)+		*ptr to next
	bra.s	hl_insert
	
at_hl_end:

**Find empty res slot
find_hl_slot:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_wahhl
	move.l	4(a1),d1		*Size of this entry
	beq.s	first_entry_wahhl
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_hl_slot
	qmove.l	d1,(a2)		    	*update pointer (was end of list -1)
first_entry_wahhl:
**Size in d0, data in a0
	qmove.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	qmove.l	#-1,(a1)+		*ptr to next
hl_insert:
	qmove.l	d5,(a1)+		*Size of this
	qmove.l	#"hl  ",(a1)+	*hl alis
	qmove.l	d6,(a1)+		*options - type
	clr.l	(a1)+			*time
	qmove.w	uf_ref_number(a5),(a1)+	*if a user folder, it's serial number
	qmove.w	uf_owner(a5),(a1)+	  	    *owner of object (UF serial or zero)
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**Store filename
	qmoveq	#7,d0
	lea	add_file_name(a5),a3
	qmove.l	a1,a6		    	*save pos
sfn_hl:
	qmove.l	(a3)+,(a1)+
	qdbra	d0,sfn_hl
	lea	64(a6),a1		    	*skip filename

	subq.l	#1,d7
	bmi.s	no_aliashl
copyhl:
	qmove.b	(a0)+,(a1)+
	dbra	d7,copyhl
no_aliashl:
	rts_	"store_hl_alias"

store_hlh:
**Can we accept source files
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	tst.b	p_hl_fti(a1)
	bne.s	can_store_hl
	save_all
	lea	no_hl_area(pc),a0
	qcmove.w	#1002,d0	*no/yes box
	qmove.l	#20,d1	x
	qmove.l	#70,d2	y
	bsr.l	do_new_alert_3d

	restore_all
	bra	store_trash
can_store_hl:	

**Move everything up
**Size of alias is in d0
	qmove.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	*account for flags, offsets and things
	save_all
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files
	bsr	move_shared_libs
	bsr	move_lib_files
	bsr	move_obj_files
	bsr	move_sinc_files
	bsr	move_glob_files
	bsr	move_source_files
**Finally update pointers to stuff beyond res files
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qmove.l	file_inserted_size(a5),d5
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph
	add.l	d5,source_offset(a1)
	add.l	d5,glob_offset(a1)	  *Offset to glob files
	add.l	d5,sinc_offset(a1)
	add.l	d5,obj_offset(a1)	*offset to obj files
	add.l	d5,libs_offset(a1)
	add.l	d5,slibs_offset(a1)	*Offset to shared libs
	add.l	d5,res_offset(a1)	*Offset to res files
	add.l	d5,homeless_offset(a1)	  *offset to homeless files
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)	*offset to eof

	restore_all

	move.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	#hlh_offset,a1		*offset to high level files
	add.l	(a1),a1		    	*-> first src file
	clr.l	d5
	move.w	file_add_pos(a5),d5
	bmi.s	at_hlh_end
find_hlh_ins:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq	first_entry_wahhlh
	tst.w	d5
	beq.s	got_hlh_pos
	qmove.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	subq.w	#1,d5
	cmpi.l	#-1,d0
	bne.s	find_hlh_ins
	qmove.l	d1,(a2)		    	*update pointer (was end of list -1)
	bra.s	first_entry_wahhlh
got_hlh_pos:
**Move all up from here (a1) to end of bin
	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	lea	hlh_offset+4(a2),a3
	add.l	(a3),a3		    *end of trash files
	sub.l	a1,a3		    	*size of trash files
	qmove.l	a3,d0
	sub.l	file_inserted_size(a5),d0
**move from a1 to a1+file_inserted_size for d0-a1 bytes?
	movem.l		a0/a1,-(sp)
	qmove.l	a1,a0
	add.l	file_inserted_size(a5),a1
	qmove.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,a0/a1
	qmove.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
	move.l	d5,(a1)+		*ptr to next
	bra.s	hlh_insert
	
at_hlh_end:

**Find empty res slot
find_hlh_slot:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_wahhlh
	move.l	4(a1),d1		*Size of this entry
	beq.s	first_entry_wahhlh
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_hlh_slot
	qmove.l	d1,(a2)		    	*update pointer (was end of list -1)
first_entry_wahhlh:
**Size in d0, data in a0
	qmove.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	qmove.l	#-1,(a1)+		*ptr to next
hlh_insert:
	qmove.l	d5,(a1)+		*Size of this
	qmove.l	#"hlh ",(a1)+	 *src alis
	qmove.l	d6,(a1)+		*options - type
	clr.l	(a1)+			*time
	qmove.w	uf_ref_number(a5),(a1)+	*if a user folder, it's serial number
	qmove.w	uf_owner(a5),(a1)+	  	    *owner of object (UF serial or zero)
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**Store filename
	qmoveq	#7,d0
	lea	add_file_name(a5),a3
	qmove.l	a1,a6		    	*save pos
sfn_hlh:
	qmove.l	(a3)+,(a1)+
	qdbra	d0,sfn_hlh
	lea	64(a6),a1		    	*skip filename
	subq.l	#1,d7
	bmi.s	no_aliashlh
copyhlh:
	qmove.b	(a0)+,(a1)+
	dbra	d7,copyhlh
no_aliashlh:
	rts_	"store_hlh_alias"

store_src:
**Can we accept source files
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	tst.b	p_src_fti(a1)
	bne.s	can_store_source
	save_all
	lea	no_source_area(pc),a0
	qcmove.w	#1002,d0	*no/yes box
	qmove.l	#20,d1	x
	qmove.l	#70,d2	y
	bsr.l	do_new_alert_3d

	restore_all
	bra	store_trash
can_store_source:	
**Move everything up
**Size of alias is in d0
	qmove.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	*account for flags, offsets and things
	save_all

	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files
	bsr	move_shared_libs
	bsr	move_lib_files
	bsr	move_obj_files
	bsr	move_sinc_files
	bsr	move_glob_files
**Finally update pointers to stuff beyond res files
	qmove.l	file_inserted_size(a5),d5
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph
	add.l	d5,glob_offset(a1)	  *Offset to glob files
	add.l	d5,sinc_offset(a1)
	add.l	d5,obj_offset(a1)	*offset to obj files
	add.l	d5,libs_offset(a1)
	add.l	d5,res_offset(a1)	*Offset to res files
	add.l	d5,slibs_offset(a1)	*Offset to shared libs
	add.l	d5,homeless_offset(a1)	  *offset to homeless files
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)	*offset to eof

	restore_all

	qmove.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	qmove.l	(a1),a1
	add.l	#source_offset,a1		*offset to src files
	add.l	(a1),a1		    	*-> first src file

**Find empty src slot
	clr.l	d5
	move.w	file_add_pos(a5),d5
	bmi.s	at_src_end
find_src_ins:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq	first_entry_wahs
	tst.w	d5
	beq.s	got_src_pos
	qmove.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	subq.w	#1,d5
	cmpi.l	#-1,d0
	bne.s	find_src_ins
	qmove.l	d1,(a2)		    	*update pointer (was end of list -1)
	bra.s	first_entry_wahs
got_src_pos:
**Move up from here to here plus insert for end_of_these-here bytes
	
	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	lea	source_offset+4(a2),a3	  *GLOBS OFFSET	
	add.l	(a3),a3		    *Abs of end of source files
	sub.l	a1,a3		    	*sub here
	qmove.l	a3,d0		    	*bytes to move
	sub.l	file_inserted_size(a5),d0
**move from a1 to a1+file_inserted_size for end-here bytes
	movem.l		a0/a1,-(sp)
	move.l	a1,a0		    	*here
	add.l	file_inserted_size(a5),a1	*here+insert
	qmove.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,a0/a1
	qmove.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
	qmove.l	d5,(a1)+		*ptr to next

	bra.s	src_insert
	
at_src_end:
find_src_slot:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_wahs
	move.l	4(a1),d1		*Size of this entry
	beq.s	first_entry_wahs
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_src_slot
	qmove.l	d1,(a2)		    	*update pointer (was end of list -1)
first_entry_wahs:
**Size in d0, data in a0
	qmove.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	move.l	#-1,(a1)+		*ptr to next
src_insert:
	qmove.l	d5,(a1)+		*Size of this
	qmove.l	#"src ",(a1)+	*src alis
	qmove.l	d6,(a1)+		*options - type
	clr.l	(a1)+			*time
**uf_owner and uf if necessary
	qmove.w	uf_ref_number(a5),(a1)+	*if a user folder, it's serial number
	qmove.w	uf_owner(a5),(a1)+	  	    *owner of object (UF serial or zero)
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**Store filename
	qmoveq	#7,d0
	lea	add_file_name(a5),a3
	qmove.l	a1,a6		    	*save pos
sfn_s:
	qmove.l	(a3)+,(a1)+
	qdbra	d0,sfn_s
	lea	64(a6),a1		    	*skip filename
	subq.l	#1,d7
	bmi.s	no_aliassrc
copys:
	qmove.b	(a0)+,(a1)+
	dbra	d7,copys
no_aliassrc:
	rts_	"store_src_alias"


store_globs:
**Move everything up
**Size of alias is in d0
	qmove.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	*account for flags, offsets and things
	save_all
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files
	bsr	move_shared_libs
	bsr	move_lib_files
	bsr	move_obj_files
	bsr	move_sinc_files
**Finally update pointers to stuff beyond res files
	move.l	file_inserted_size(a5),d5
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph
	add.l	d5,obj_offset(a1)	*offset to obj files
	add.l	d5,libs_offset(a1)
	add.l	d5,res_offset(a1)	*Offset to res files
	add.l	d5,slibs_offset(a1)	*Offset to shared libs
	add.l	d5,homeless_offset(a1)	  *offset to homeless files
	add.l	d5,sinc_offset(a1)
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)	*offset to eof

	restore_all

	qmove.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	#glob_offset,a1		*offset to src files
	add.l	(a1),a1		    	*-> first src file
	clr.l	d5
	move.w	file_add_pos(a5),d5
	bmi.s	at_glob_end
find_glob_ins:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq	first_entry_wahg
	tst.w	d5
	beq.s	got_glob_pos
	qmove.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	subq.w	#1,d5
	cmpi.l	#-1,d0
	bne.s	find_glob_ins
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
	bra.s	first_entry_wahg
got_glob_pos:
**see source for details of move

	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	lea	glob_offset+4(a2),a3
	add.l	(a3),a3		    *end of trash files
	sub.l	a1,a3		    	*size of trash files
	move.l	a3,d0
	sub.l	file_inserted_size(a5),d0
**move from a1 to a1+file_inserted_size for d0-a1 bytes?
	movem.l		a0/a1,-(sp)
	move.l	a1,a0		    	*move from here
	add.l	file_inserted_size(a5),a1	*to here 
	qmove.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,a0/a1
	qmove.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
	qmove.l	d5,(a1)+		*ptr to next
	bra.s	glob_insert
	
at_glob_end:

**Find empty res slot
find_glob_slot:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_wahg
	move.l	4(a1),d1		*Size of this entry
	beq.s	first_entry_wahg
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_glob_slot
	qmove.l	d1,(a2)		    	*update pointer (was end of list -1)
first_entry_wahg:
**Size in d0, data in a0
	qmove.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	qmove.l	#-1,(a1)+		*ptr to next
glob_insert:
	qmove.l	d5,(a1)+		*Size of this
	qmove.l	#"glob",(a1)+	*global inc alis
	qmove.l	d6,(a1)+		*options - type
	clr.l	(a1)+			*time
	qmove.w	uf_ref_number(a5),(a1)+	*if a user folder, it's serial number
	qmove.w	uf_owner(a5),(a1)+	  	    *owner of object (UF serial or zero)
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**Store filename
	qmoveq	#7,d0
	lea	add_file_name(a5),a3
	qmove.l	a1,a6		    	*save pos
sfn_g:
	qmove.l	(a3)+,(a1)+
	qdbra	d0,sfn_g
	lea	64(a6),a1		    	*skip filename

	subq.l	#1,d7
	bmi.s	no_aliasglob
copyg:
	qmove.b	(a0)+,(a1)+
	dbra	d7,copyg
no_aliasglob:
	rts_	"store_glob_alias"


store_sinc:
**Move everything up
**Size of alias is in d0
	move.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	*account for flags, offsets and things
	save_all
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files
	bsr	move_shared_libs
	bsr	move_lib_files
	bsr	move_obj_files
**Finally update pointers to stuff beyond res files
	move.l	file_inserted_size(a5),d5
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph
	add.l	d5,obj_offset(a1)	*offset to obj files
	add.l	d5,libs_offset(a1)
	add.l	d5,res_offset(a1)	*Offset to res files
	add.l	d5,slibs_offset(a1)	*Offset to shared libs
	add.l	d5,homeless_offset(a1)	  *offset to homeless files
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)	*offset to eof

	restore_all

	move.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	#sinc_offset,a1		*offset to src files
	add.l	(a1),a1		    	*-> first src file
	clr.l	d5
	move.w	file_add_pos(a5),d5
	bmi.s	at_sinc_end
find_sinc_ins:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq	first_entry_wahsinc
	tst.w	d5
	beq.s	got_sinc_pos
	move.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	subq.w	#1,d5
	cmpi.l	#-1,d0
	bne.s	find_sinc_ins
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
	bra.s	first_entry_wahsinc
got_sinc_pos:
**see source for details of move

	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	lea	sinc_offset+4(a2),a3
	add.l	(a3),a3		    *end of trash files
	sub.l	a1,a3		    	*size of trash files
	move.l	a3,d0
	sub.l	file_inserted_size(a5),d0
**move from a1 to a1+file_inserted_size for d0-a1 bytes?
	movem.l		a0/a1,-(sp)
	move.l	a1,a0		    	*move from here
	add.l	file_inserted_size(a5),a1	*to here 
	move.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,a0/a1
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
	move.l	d5,(a1)+		*ptr to next
	bra.s	sinc_insert
	
at_sinc_end:

**Find empty res slot
find_sinc_slot:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_wahsinc
	move.l	4(a1),d1		*Size of this entry
	beq.s	first_entry_wahsinc
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_sinc_slot
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
first_entry_wahsinc:
**Size in d0, data in a0
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	move.l	#-1,(a1)+		*ptr to next
sinc_insert:
	move.l	d5,(a1)+		*Size of this
	move.l	#"sinc",(a1)+	*global inc alis
	move.l	d6,(a1)+		*options - type
	clr.l	(a1)+			*time
	move.w	uf_ref_number(a5),(a1)+	*if a user folder, it's serial number
	move.w	uf_owner(a5),(a1)+	  	    *owner of object (UF serial or zero)
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**Store filename
	moveq	#7,d0
	lea	add_file_name(a5),a3
	move.l	a1,a6		    	*save pos
sfn_sinc:
	move.l	(a3)+,(a1)+
	dbra	d0,sfn_sinc
	lea	64(a6),a1		    	*skip filename

	subq.l	#1,d7
	bmi.s	no_aliassinc
copysinc:
	move.b	(a0)+,(a1)+
	dbra	d7,copysinc
no_aliassinc:
	rts_	"store_sinc_alias"
	
***************************
store_note:
**Size of alias is in d0
	move.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	*account for flags, offsets and things
	save_all
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files
	bsr	move_shared_libs
	bsr	move_lib_files
	bsr	move_obj_files
	bsr	move_sinc_files
	bsr	move_glob_files
	bsr	move_source_files
	bsr	move_hl_headers
	bsr	move_hl_files
	bsr	move_vhl_headers
	bsr	move_vhl_files
	
**Finally update pointers to stuff beyond res files
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	move.l	file_inserted_size(a5),d5
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph
	add.l	d5,vhl_offset(a1)
	add.l	d5,vhlh_offset(a1)
	add.l	d5,hl_offset(a1)
	add.l	d5,hlh_offset(a1)
	add.l	d5,source_offset(a1)
	add.l	d5,glob_offset(a1)	  *Offset to glob files
	add.l	d5,sinc_offset(a1)
	add.l	d5,obj_offset(a1)	*offset to obj files
	add.l	d5,libs_offset(a1)
	add.l	d5,slibs_offset(a1)	*Offset to shared libs
	add.l	d5,res_offset(a1)	*Offset to res files
	add.l	d5,homeless_offset(a1)	  *offset to homeless files
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)	*offset to eof


	restore_all
	move.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	#notes_offset,a1		*offset to note files
	add.l	(a1),a1		    	*-> first src file
	clr.l	d5
	move.w	file_add_pos(a5),d5
	bmi.s	at_note_end
find_note_ins:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq	first_entry_wahn
	tst.w	d5
	beq.s	got_note_pos
	move.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	subq.w	#1,d5
	cmpi.l	#-1,d0
	bne.s	find_note_ins
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
	bra.s	first_entry_wahn
got_note_pos:
**see source for details of move
	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	lea	notes_offset+4(a2),a3
	add.l	(a3),a3		    *end of trash files
	sub.l	a1,a3		    	*size of trash files
	move.l	a3,d0
	sub.l	file_inserted_size(a5),d0
**move from a1 to a1+file_inserted_size for d0-a1 bytes?
	movem.l		a0/a1,-(sp)
	move.l	a1,a0
	add.l	file_inserted_size(a5),a1
	move.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,a0/a1
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
	move.l	d5,(a1)+		*ptr to next
	bra.s	note_insert
	
at_note_end:

**Find empty res slot
find_note_slot:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_wahn
	move.l	4(a1),d1		*Size of this entry
	beq.s	first_entry_wahn
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_note_slot
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
first_entry_wahn:
**Size in d0, data in a0
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	move.l	#-1,(a1)+		*ptr to next
note_insert:
	move.l	d5,(a1)+		*Size of this
	move.l	#"note",(a1)+	*res alis
	move.l	d6,(a1)+		*options - type
	clr.l	(a1)+			*time
	move.w	uf_ref_number(a5),(a1)+	*if a user folder, it's serial number
	move.w	uf_owner(a5),(a1)+	  	    *owner of object (UF serial or zero)
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**Store filename
	moveq	#7,d0
	lea	add_file_name(a5),a3
	move.l	a1,a6		    	*save pos
sfn_n:
	move.l	(a3)+,(a1)+
	dbra	d0,sfn_n
	lea	64(a6),a1		    	*skip filename

	subq.l	#1,d7
	bmi.s	no_aliasnote
copyn:
	move.b	(a0)+,(a1)+
	dbra	d7,copyn
no_aliasnote:
	rts_	"store_note_alias"


***************************
store_trash:
**Size of alias is in d0
	move.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	*account for flags, offsets and things
	save_all
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files
	bsr	move_shared_libs
	bsr	move_lib_files
	bsr	move_obj_files
	bsr	move_sinc_files
	bsr	move_glob_files
	bsr	move_source_files
	bsr	move_hl_headers
	bsr	move_hl_files
	bsr	move_vhl_headers
	bsr	move_vhl_files
	bsr	move_notes
	
**Finally update pointers to stuff beyond res files
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	move.l	file_inserted_size(a5),d5
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph
	add.l	d5,notes_offset(a1)
	add.l	d5,vhl_offset(a1)
	add.l	d5,vhlh_offset(a1)
	add.l	d5,hl_offset(a1)
	add.l	d5,hlh_offset(a1)
	add.l	d5,source_offset(a1)
	add.l	d5,glob_offset(a1)	  *Offset to glob files
	add.l	d5,sinc_offset(a1)
	add.l	d5,obj_offset(a1)	*offset to obj files
	add.l	d5,libs_offset(a1)
	add.l	d5,slibs_offset(a1)	*Offset to shared libs
	add.l	d5,res_offset(a1)	*Offset to res files
	add.l	d5,homeless_offset(a1)	  *offset to homeless files
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)	*offset to eof


	restore_all
	move.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	#bin_offset,a1		*offset to note files
	add.l	(a1),a1		    	*-> first trash file

**Find insert slot
	clr.l	d5
	move.w	file_add_pos(a5),d5
	bmi.s	at_trash_end
find_bin_ins:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq	first_entry_wahb
	tst.w	d5
	beq.s	got_trash_pos
	move.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	subq.w	#1,d5
	cmpi.l	#-1,d0
	bne.s	find_bin_ins
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
	bra.s	first_entry_wahb
got_trash_pos:
**see source for details of move
	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	lea	bin_offset+4(a2),a3
	add.l	(a3),a3		    *end of trash files
	sub.l	a1,a3		    	*size of trash files
	move.l	a3,d0
	sub.l	file_inserted_size(a5),d0
**move from a1 to a1+file_inserted_size for d0-a1 bytes?
	movem.l		a0/a1,-(sp)
	move.l	a1,a0
	add.l	file_inserted_size(a5),a1
	move.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,a0/a1
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
	move.l	d5,(a1)+		*ptr to next
	bra.s	trash_insert
	
at_trash_end:
find_bin_slot:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_wahb
	move.l	4(a1),d1		*Size of this entry
	beq.s	first_entry_wahb
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_bin_slot
	move.l	d1,(a2)		    	*update pointer (was end of list -1)

first_entry_wahb:
**Size in d0, data in a0
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	move.l	#-1,(a1)+		*ptr to next
trash_insert:
	move.l	d5,(a1)+		*Size of this
	move.l	#"bin ",(a1)+	*res alis
	move.l	d6,(a1)+		*options - type
	clr.l	(a1)+			*time
	move.w	uf_ref_number(a5),(a1)+	*if a user folder, it's serial number
	move.w	uf_owner(a5),(a1)+	  	    *owner of object (UF serial or zero)
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**Store filename
	moveq	#7,d0
	lea	add_file_name(a5),a3
	move.l	a1,a6		    	*save pos
sfn_t:
	move.l	(a3)+,(a1)+
	dbra	d0,sfn_t
	lea	64(a6),a1		    	*skip filename

	subq.l	#1,d7
	bmi.s	no_aliast
copyb:
	move.b	(a0)+,(a1)+
	dbra	d7,copyb
no_aliast:
	rts_	"store_trash_alias"

************************
store_obj:
**Move everything up
**Size of alias is in d0
	move.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	*account for flags, offsets and things
	save_all
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files
	bsr	move_shared_libs
	bsr	move_lib_files
**Finally update pointers to stuff beyond res files
	move.l	file_inserted_size(a5),d5
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph
	add.l	d5,libs_offset(a1)
	add.l	d5,res_offset(a1)	*Offset to res files
	add.l	d5,slibs_offset(a1)	*Offset to shared libs
	add.l	d5,homeless_offset(a1)	  *offset to homeless files
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)	*offset to eof
	restore_all

	move.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	#obj_offset,a1		*offset to object files
	add.l	(a1),a1		    	*-> first res file
	clr.l	d5
	move.w	file_add_pos(a5),d5
	bmi.s	at_obj_end
find_obj_ins:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq	first_entry_waho
	tst.w	d5
	beq.s	got_obj_pos
	move.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	subq.w	#1,d5
	cmpi.l	#-1,d0
	bne.s	find_obj_ins
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
	bra.s	first_entry_waho
got_obj_pos:
**see source for details of move
	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	lea	obj_offset+4(a2),a3
	add.l	(a3),a3		    *end of trash files
	sub.l	a1,a3		    	*size of trash files
	move.l	a3,d0
	sub.l	file_inserted_size(a5),d0
**move from a1 to a1+file_inserted_size for d0-a1 bytes?
	movem.l		a0/a1,-(sp)
	move.l	a1,a0
	add.l	file_inserted_size(a5),a1
	move.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,a0/a1
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
	move.l	d5,(a1)+		*ptr to next
	bra.s	obj_insert
	
at_obj_end:

**Find empty res slot
find_obj_slot:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_waho
	move.l	4(a1),d1		*Size of this entry
	beq.s	first_entry_waho
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_obj_slot
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
first_entry_waho:
**Size in d0, data in a0
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	move.l	#-1,(a1)+		*ptr to next
obj_insert:
	move.l	d5,(a1)+		*Size of this
	move.l	#"obj ",(a1)+	*obj alis
	move.l	d6,(a1)+		*options - type
	clr.l	(a1)+			*time
	move.w	uf_ref_number(a5),(a1)+	*if a user folder, it's serial number
	move.w	uf_owner(a5),(a1)+	  	    *owner of object (UF serial or zero)
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**Store filename
	moveq	#7,d0
	lea	add_file_name(a5),a3
	move.l	a1,a6		    	*save pos
sfn_o:
	move.l	(a3)+,(a1)+
	dbra	d0,sfn_o
	lea	64(a6),a1		    	*skip filename

	subq.l	#1,d7
	bmi.s	no_aliaso
copyo:
	move.b	(a0)+,(a1)+
	dbra	d7,copyo
no_aliaso:
	rts_	"Add_obj_alias"

************************
store_library:			*Static
**Size of alias is in d0
	move.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	*account for flags, offsets and things
**Move everything up
	save_all
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files
	bsr	move_shared_libs
**Finally update pointers to stuff beyond res files
	move.l	file_inserted_size(a5),d5
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph
	add.l	d5,res_offset(a1)	*Offset to res files
	add.l	d5,slibs_offset(a1)	*Offset to shared libs
	add.l	d5,homeless_offset(a1)	  *offset to homeless files
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)	*offset to eof
	restore_all

	move.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	#libs_offset,a1		*offset to object files
	add.l	(a1),a1		    	*-> first lib file
	clr.l	d5
	move.w	file_add_pos(a5),d5
	bmi.s	at_lib_end
find_lib_ins:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq	first_entry_wahl
	tst.w	d5
	beq.s	got_lib_pos
	move.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	subq.w	#1,d5
	cmpi.l	#-1,d0
	bne.s	find_lib_ins
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
	bra.s	first_entry_wahl
got_lib_pos:
**see source for details of move
	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	lea	libs_offset+4(a2),a3
	add.l	(a3),a3		    *end of trash files
	sub.l	a1,a3		    	*size of trash files
	move.l	a3,d0
	sub.l	file_inserted_size(a5),d0
**move from a1 to a1+file_inserted_size for d0-a1 bytes?
	movem.l		a0/a1,-(sp)
	move.l	a1,a0
	add.l	file_inserted_size(a5),a1
	move.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,a0/a1
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
	move.l	d5,(a1)+		*ptr to next
	bra.s	lib_insert
	
at_lib_end:

**Find empty res slot
find_lib_slot:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_wahl
	move.l	4(a1),d1		*Size of this entry
	beq.s	first_entry_wahl	*just in case
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_lib_slot
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
first_entry_wahl:
**Size in d0, data in a0
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	move.l	#-1,(a1)+		*ptr to next
lib_insert:
	move.l	d5,(a1)+		*Size of this
	move.l	#"lib ",(a1)+	*res alis
	move.l	d6,(a1)+		*options - type
	clr.l	(a1)+			*time
	move.w	uf_ref_number(a5),(a1)+	*if a user folder, it's serial number
	move.w	uf_owner(a5),(a1)+	  	    *owner of object (UF serial or zero)
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**Store filename
	moveq	#7,d0
	lea	add_file_name(a5),a3
	move.l	a1,a6		    	*save pos
sfn_lib:
	move.l	(a3)+,(a1)+
	dbra	d0,sfn_lib
	lea	64(a6),a1		    	*skip filename

	subq.l	#1,d7
	bmi.s	no_aliasl
copyl:
	move.b	(a0)+,(a1)+
	dbra	d7,copyl
no_aliasl:
	rts_	"Add_lib_alias"


************************
**Diffferent in that there is no alias!
store_shared_library:			
**Size of alias is in d0
	move.l	d0,file_inserted_size(a5)
	add.l	#sizeof_file_entry,file_inserted_size(a5)	*account for flags, offsets and things
**Move everything up
	save_all
	bsr	move_untitled3
	bsr	move_untitled2
	bsr	move_homeless
	bsr	move_res_files

**Finally update pointers to stuff beyond res files
	move.l	file_inserted_size(a5),d5
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	d5,4(a1)	*offset to dependancies
	add.l	d5,8(a1)	*offset to misc gumph
	add.l	d5,res_offset(a1)	*Offset to res files
	add.l	d5,homeless_offset(a1)	  *offset to homeless files
	add.l	d5,untitled2_offset(a1)
	add.l	d5,untitled3_offset(a1)
	add.l	d5,eof_offset(a1)	*offset to eof
	restore_all

	move.l	d0,d7		    	*Save size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	#slibs_offset,a1		*offset to object files
	add.l	(a1),a1		    	*-> first lib file
	clr.l	d5
	move.w	file_add_pos(a5),d5
	bmi.s	at_slib_end
find_slib_ins:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq	first_entry_wahsl
	tst.w	d5
	beq.s	got_slib_pos
	move.l	4(a1),d1		*Size of this entry
	add.l	d1,a1		    	*Point to next entry
	subq.w	#1,d5
	cmpi.l	#-1,d0
	bne.s	find_slib_ins
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
	bra.s	first_entry_wahsl
got_slib_pos:
**see source for details of move
	move.l	proj_buffer_h(a5),a2
	move.l	(a2),a2
	lea	slibs_offset+4(a2),a3
	add.l	(a3),a3		    *end of trash files
	sub.l	a1,a3		    	*size of trash files
	move.l	a3,d0
	sub.l	file_inserted_size(a5),d0
**move from a1 to a1+file_inserted_size for d0-a1 bytes?
	movem.l		a0/a1,-(sp)
	move.l	a1,a0
	add.l	file_inserted_size(a5),a1
	move.l	d0,d2
	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,a0/a1
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
	move.l	d5,(a1)+		*ptr to next
	bra.s	slib_insert
	
at_slib_end:

**Find empty slib slot
find_slib_slot:
	move.l	a1,a2		    	*So we can update pointer if need be
	move.l	(a1),d0		    	*Will be -1 if last entry
	beq.s	first_entry_wahsl
	move.l	4(a1),d1		*Size of this entry
	beq.s	first_entry_wahsl	*just in case
	add.l	d1,a1		    	*Point to next entry
	cmpi.l	#-1,d0
	bne.s	find_slib_slot
	move.l	d1,(a2)		    	*update pointer (was end of list -1)
first_entry_wahsl:
**Size in d0, data in a0
	move.l	d7,d5		    	*save this size
	add.l	#sizeof_file_entry,d5			*Acct for point to next, size and type and bits
;	move.l	d5,file_inserted_size(a5)
	move.l	#-1,(a1)+		*ptr to next
slib_insert:
	move.l	d5,(a1)+		*Size of this
	move.l	#"slib",(a1)+	*slib
	move.l	d6,(a1)+		*options - type
	clr.l	(a1)+			*time
	move.w	uf_ref_number(a5),(a1)+	*if a user folder, it's serial number
	move.w	uf_owner(a5),(a1)+	  	    *owner of object (UF serial or zero)
	clr.l	(a1)+			*spare 2
	clr.l 	(a1)+			*spare 3
**Store filename
	moveq	#7,d0
	lea	add_file_name(a5),a3
	move.l	a1,a6		    	*save pos
sfn_slib:
	move.l	(a3)+,(a1)+
	dbra	d0,sfn_slib
	lea	64(a6),a1		    	*skip filename

	subq.l	#1,d7
	bmi.s	no_aliassl	*this will always be the case - code left in for consistency
copysl:
	move.b	(a0)+,(a1)+
	dbra	d7,copysl
no_aliassl:
	rts_	"Add_slib_alias"

*******************************MOVE ROUTINES*********************************
*****************************************************************************
move_bin:	
	qmove.l	#bin_offset,d5
	bsr	move_block_up
	rts_	"move_untitled1_up"

move_untitled2:	
	qmove.l	#untitled2_offset,d5
	bsr	move_block_up
	rts_	"move_untitled2_up"

move_untitled3:	
	qmove.l	#untitled3_offset,d5
	bsr	move_block_up
	rts_	"move_untitled3_up"


move_homeless:
	qmove.l	#homeless_offset,d5
	bsr	move_block_up
	rts_	"Move_homeless"

move_glob_files:	
	qmove.l	#glob_offset,d5
	bsr	move_block_up
	rts_	"move_globfiles_up"

move_obj_files:	
	qmove.l	#obj_offset,d5
	bsr	move_block_up
	rts_	"move_objfiles_up"

move_res_files:	
	qmove.l	#res_offset,d5
	bsr	move_block_up
	rts_	"move_resfiles_up"

move_lib_files:	
	qmove.l	#libs_offset,d5
	bsr	move_block_up
	rts_	"move_libfiles_up"

move_shared_libs:	
	qmove.l	#slibs_offset,d5
	bsr	move_block_up
	rts_	"move_sharedlibs_up"

move_notes:	
	qmove.l	#notes_offset,d5
	bsr	move_block_up
	rts_	"move_notes_up"

move_sinc_files:
	qmove.l	#sinc_offset,d5
	bsr	move_block_up
	rts_	"move_sinc_up"
	
move_source_files:	
	qmove.l	#source_offset,d5
	bsr	move_block_up
	rts_	"move_source_up"

move_hl_headers:	
	qmove.l	#hlh_offset,d5
	bsr.s	move_block_up
	rts_	"move_hlh_up"
	
move_hl_files:	
	qmove.l	#hl_offset,d5
	bsr.s	move_block_up
	rts_	"move_hl_up"

move_vhl_headers:	
	qmove.l	#vhlh_offset,d5
	bsr.s	move_block_up
	rts_	"move_vhlh_up"

move_vhl_files:	
	qmove.l	#vhl_offset,d5
	bsr.s	move_block_up
	rts_	"move_vhl_up"

move_folders:	
	qmove.l	#folders_offset,d5
	bsr.s	move_block_up
	rts_	"move_folders_up"

**Takes proj offset in d5
	
move_block_up:	
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	d5,a1		    *offset to untitled 1 files
	add.l	(a1),a1		    	*-> first file
	qmove.l	a1,d0		    	*in d0
	save_volatile
	qmove.l	proj_buffer_h(a5),d0
	OSHLock	d0
	restore_volatile
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	addq.l	#4,d5
	add.l	d5,a1		    *offset to next files
	add.l	(a1),a1	
	qmove.l	a1,d1
	sub.l	d0,d1		    	*Size of block to move
	beq.s	no_move_up
	
	move.l	file_inserted_size(a5),d2	*count
**Move from d0 to d1 up by d2 bytes
	movem.l	d0/a0/a2,-(sp)
	qmove.l	d0,a0	*Src
	qmove.l	d0,a1	*dest
	add.l	d2,a1	*plus size of block we want to insert is new dest
	qmove.l	d1,d2	*number of bytes to move if my cardigan is right.

	OSBlockMoveData	a0,a1,d2
	movem.l	(sp)+,d0/a0/a2
	qmove.l	d0,a0
	clr.l	(a0)+
	clr.l	(a0)+	*Clear out old entry!
no_move_up:
;	save_all
;	move.l	proj_buffer_h(a5),a0
;	dc.w	_hunlock
;	restore_all
	rts_	"move_block_up"
************************************************************
cant_open_no_mem:
	qcmove.w	#1002,d0
	lea	open_mem_error(pc),a0
	qmoveq	#45,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d
	rts_	"Cant_open_no_mem"
open_new_project:
	qmove.l	last_known_mem(a5),d0
	cmpi.l	#600*1024,d0
	blt	cant_open_no_mem
**Save any current project
	qmove.l	proj_buffer_h(a5),saved_project_h(a5)
	lea	temp_fsspec(pc),a1
	lea	proj_fsspec(a5),a0
	bsr.l	the_copy_fsspec
	tst.b	project_auto(a5)
	bne.s	skip_selector

**Set folder back to pm
;	bsr	get_pm_folder
;	bsr	set_pm_folder
**find project to open
	clr.l	d0		*Filter func.
	qcmove.w	#1,d1	*NUm type
	lea	proj_type_list(pc),a0	*type list
	qmove.l	a0,d2
	lea	temp_string3(a5),a1	*Sfreply please
	qmove.l	#131,d7	*Dialog ID
	clr.l	d3	*Where
	clr.l	d4	*DLGHook
	clr.l	d5	*Modalfilter
	clr.l	d6	*Active list
	ifne	CARBON
	clr.l	d0	;carbon
	bra	return	;carbon
	else
	OSCustomGetFile	d0,d1,d2,a1,d7,d3,d4,d5,d6	;CARBON
	endif

	lea	temp_string3(a5),a0
	tst.b	(a0)
	beq	return
skip_selector:				*Come here if we have the fsspec already
	movem.l	d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6,-(sp)
	lea	temp_string3(a5),a0
	lea	6(a0),a0
	bsr.l	check_locked_d0
	movem.l	(sp)+,d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6
	tst.l	d0
	beq	proj_not_locked
project_is_locked:
	qcmove.w	#1002,d0
	lea	open_proj_error(pc),a0
	qmoveq	#15,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d
	bra	return
proj_not_locked:
	bsr.l	save_project_in_prefs
	extern	save_project_in_prefs
**Check if project is open already
	lea	temp_string3(a5),a0
	addq.l	#6,a0	
	qmove.w	(a0),current_vrefnum(a5)	*save current folder
	qmove.l	2(a0),current_parid(a5)
	lea	temp_string3(a5),a0
	qmove.l	a0,a3	*copy Fsspec
**copy fname to temp-string

	lea	temp_string(a5),a1
	lea	12(a0),a0	*->filename
;	clr.l	d0
	qcmove.b	(a0),d0	*count
cfn15:	qmove.b	(a0)+,(a1)+
	qdbra	d0,cfn15
	
**See if window is loaded already
**now find name that matches
	move.l	windows_records_h(a5),a1
	move.l	(a1),a1
	lea	w_fsspec(a1),a1	* ->FSspec
	addq.l	#6,a1	* ->Name
	clr.l	d7
search_loop1:
	lea	temp_string(a5),a0
	move.l	a1,a2	*save
;	clr.l	d0
	qcmove.b	(a0),d0

	addq.l	#1,d0	account for count byte
	qbsr.l	strncmp
	move.l	a2,a1	*restore
	tst.l	d0
	beq.s	found_it1!
	lea	w_rec_size(a1),a1
	addq.l	#1,d7
	cmp.w	#number_of_windows,d7
	beq.s	not_found	*Emergency protection (No need for it really)
	bra.s	search_loop1
found_it1!:

**Need to bring window to front
	qmove.l	a1,-(sp)
	lea	-w_fsspec(a1),a1	* ->start of eddie W record
	subq.l #6,a1
	qmove.l	(a1),a1
	OSSelectWindow	a1
	qmove.l	(sp)+,a1
	bra	return	
not_found:
open_proj_on_boot:
	global	open_proj_on_boot
	movem.l	d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6,-(sp)
	lea	temp_string3(a5),a0
	lea	6(a0),a0
	bsr.l	check_locked_d0
	movem.l	(sp)+,d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6
	tst.l	d0
	beq	proj_not_locked1
	bra	project_is_locked
proj_not_locked1:

	lea	temp_string3(a5),a0
	addq.l	#6,a0			*haha! Crash now doggy raper.
	lea	proj_fsspec(a5),a1
	bsr.l	the_copy_fsspec

	lea	temp_string3(a5),a0
	addq.l	#6,a0			*haha! Crash now doggy raper.
	lea	build_proj_fsspec(a5),a1
	bsr.l	the_copy_fsspec

**Create a handle for the project
	lea	temp_string3(a5),a0
	tst.w	in_background(a5)
	beq.s	no_curs	*cursor changes in bg	

	save_all
	qmove.l	busy_curs_h(a5),d0
	Curs	d0
	restore_all
no_curs:
	addq.l	#6,a0	*->FSspec
	bsr.l	size_file	*Get size
	tst.l	d0
	bmi	return			*Error
	add.l	#2000,d0	*Add on a bit
	OSNewHandle	d0,a0
	move.l	a0,d0
	bne.s	handle_ok
	bsr.l	mem_err
	bra	return
handle_ok:
**Now we have to read the file into that handle
	qmove.l	a0,proj_buffer_h(a5)	*Active project
	OSHLock	a0
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a1
	lea	temp_string3(a5),a0
	addq.l	#6,a0
	bsr.l	read_file
;**Check version is OK - now checked in verify_project
;	 move.l	proj_buffer_h(a5),a0
;	 move.l	(a0),a1
;	 cmp.l	 #proj_file_version,p_file_vers(a1)
;	 beq.s	 pv_ok	 *project version OK
;	 qcmove.w	 #1002,d0
;	 lea	version_error(pc),a0
;	 qmoveq	#25,d1
;	 qmoveq	#70,d2
;	 bsr.l	 do_alert_3d
;	 bra.s	 kill_proj
;pv_ok:	
**NOw, lets set up run time flags
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a1
**Set can build flag
	qbclr	#0,can_build(a1)	*not calculated yet
	qbset	#1,can_build(a1)	*tool missing - no
	qbclr	#2,can_build(a1)	*build missing for now
**Do we have a build tool?
	movem.l	a0/a1/a2,-(sp)
	lea	temp_string4(a5),a1
	qmove.l	#"BUIL",(a1)
	qmove.w	#"Dx",4(a1)	*do we have a PPC/68k chroma?
	bsr.l	get_tool_entry	*returns address in (a3)
	tst.l	d0
	bmi.s	no_build!	*in case it's been removed?
	move.l	proj_buffer_h(a5),a0
	move.l	(a0),a1
	qbset	#2,can_build(a1)	*yes we have build
no_build!:
**Do we have a debugger (NI yet)
	movem.l	(sp)+,a0/a1/a2
	bsr	verify_project	*Check out all aliases - file
	qmove.w	d0,-(sp)	*Save error from verify
	qmove.l	proj_buffer_h(a5),d0	*Active project
	OSHUnlock	d0
	move.w	(sp)+,d0
	beq.s	proj_verified_ok
**Here it did not, so dispose of it
kill_proj:
	qmove.l	proj_buffer_h(a5),d0
	OSDisposeHandle	d0
	qmove.l	saved_project_h(a5),proj_buffer_h(a5)
	lea	proj_fsspec(a5),a1
	lea	temp_fsspec(pc),a0
	bsr.l	the_copy_fsspec

	bra.s	return
proj_verified_ok:
**now we can open the project window

	bsr.l	open_proj_window	*File - proj_window.s
**finally, open files marked as open in project
	bsr	open_marked_files
return:
	rts_	"Open_project"

**Accessor to ptr to our psn
get_anvil_psn:
	lea	psn(pc),a0
	rts_	"get_anvil_psn"
	global	get_anvil_psn
	
get_pm_folder:
**Find folder named Project Setups
**Get PM's FSspec
;	clr.w	-(sp)

	lea	psn(pc),a0	where our psn will go
	OSGetCurrentProcess	a0,d0
;	move.w	#$37,-(sp)	getcurrentprocess
;	dc.w	_OSDispatch
;	move.w	(sp)+,d0	get error
	
;	clr.w	-(sp)
	lea	temp_string2(a5),a1
	lea	PIR(pc),a0
	qmove.l	a1,56(a0)

	lea	psn(pc),a0	processinforec
	lea	PIR(pc),a1
	OSGetProcessInformation	a0,a1,d0
;	move.w	#$3a,-(sp)	get process info in PIR
;	dc.w	_OSDispatch
;	move.w	(sp)+,d0

	lea	PIR(pc),a0
	lea	56(a0),a0	point to Fsspec
	qmove.l	(a0),a0	*->Fsspec data

**Make Fsspec for Project Setups
	qmove.w	0(a0),pm_vrefnum(a5)
	qmove.l	2(a0),pm_dirid(a5)
	rts_	"get_pm_folder"
	
set_pm_folder:
	qmove.l	pm_dirid(a5),d0	*make save folder same as windows dirid
	OSPutCurDirStore	d0
;	clr.l	d0
	qcmove.w	pm_vrefnum(a5),d0
	neg.w	d0
	OSPutSFSaveDisk	d0
	rts_	"Set_pm_folder"
	
**save the front project
save_project:
**quick check of some vital info to ensure not corrupt
	bsr	check_vital	*may not return if corrupt
	bsr	calc_project_size
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qmove.l	#"FEpj",creator(a5)
	lea	proj_fsspec(a5),a0	  *Point to the fsspec	    
	bsr.l	sys_write_file_set_type	*Write the project file
	rts_	"Save_project"
check_vital:
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	cmpi.l	#proj_file_version,p_file_vers(a1)
	beq.s	end_check_vers
	qmove.l	#666,d0
	lea	corrupt_proj_err(pc),a0
	qmoveq	#25,d1
	qmoveq	#50,d2
	bsr.l	do_new_alert_3d
**Save any dirty files
	lea	save_files(pc),a0
	qcmove.w	#510,d0	*no/yes box
	qmove.l	#20,d1	x
	qmove.l	#70,d2	y
	bsr.l	do_new_alert_3d
	cmpi.w	#1,d0
	bne.s	no_save
	bsr.l	save_all	*try to save changed files
	qcmove.w	#666,d0
	lea	files_ok(pc),a0
	qmoveq	#25,d1
	qmoveq	#50,d2
	bsr.l	do_new_alert_3d

no_save:

	OSExitToShell
end_check_vers:
	rts_	"check_vital"
***************************************************************************
**project to switch to in d6
switch_project:
	bsr.l	deselect_last
	clr.b	last_proj_char_search(a5)	*if not same char as last search, do from start
	qmove.l	d6,-(sp)
;	clr.w	-(sp)
	qmove.l	project_switch_h(a5),d0
	OSCountMenuItems	d0,d0
;	clr.l	d0
;	move.w	(sp)+,d0
	qmove.l	(sp)+,d6
	ext.l	d0
	subq.l	#1,d0
	bge.s	clear_mark
	clr.l	proj_buffer_h(a5)
	clr.l	current_project_windowref(a5)
	clr.w	project_file_index(a5)
	bra	end_switch	*no projects!
clear_mark:
	movem.l	d0/d6,-(sp)

	qmove.l	project_switch_h(a5),d1
	addq.l	#1,d0
	qmove.w	d0,d2
;	move.w	d0,-(sp)	*item
	qmove.l	#32,d3	*character
	OSSetItemMark	d1,d2,d3
;	dc.w	_setItemmark

	movem.l	(sp)+,d0/d6
	qdbra	d0,clear_mark
	
**Set item d6's mark
	qmove.l	d6,-(sp)
	
	qmove.l	project_switch_h(a5),d0
;	move.w	d6,-(sp)	*item
	qmove.l	#165,d3	*character
	OSSetItemMark	d0,d6,d3
;	dc.w	_setItemmark
	
	qmove.l	(sp)+,d6


	qmove.l	project_switch_h(a5),d0
;	move.w	d6,-(sp)
	lea	temp_string(a5),a0
	OSGetMenuItem	d0,d6,a0
;	dc.w	_getitem	*name in general string
**now find name that matches
	move.l	windows_records_h(a5),a1
	move.l	(a1),a1
	lea	w_fsspec(a1),a1	* ->FSspec
	addq.l	#6,a1	* ->Name
	clr.l	d7
ssearch_loop:
	lea	temp_string(a5),a0
	move.l	a1,a2	*save
	clr.l	d0
	qmove.b	(a0),d0
;	extb.l	d0
	addq.l	#1,d0	account for count byte
	qbsr.l	strncmp
	move.l	a2,a1	*restore
	tst.l	d0
	beq.s	sfound_it!
	lea	w_rec_size(a1),a1
	addq.l	#1,d7
	cmp.l	#number_of_windows,d7
	beq.s	end_switch	*Emergency protection (No need for it really)
	bra.s	ssearch_loop

sfound_it!:

	sub.l	#w_fsspec+6,a2	*To start of record
	lea	temp_string(a5),a0

	qmove.l	w_proj_ref(a2),d0		    *handle to proj file
	qmove.l	d0,proj_buffer_h(a5)
	qmove.l	d0,build_proj_buffer_h(a5)	  *This is the one we will build
	qmove.l	(a2),current_project_windowref(a5)
	qmove.l	(a2),build_proj_wref(a5)
	qmove.l	(a2),the_project_port(a5)
	save_all
**Copy fsspec to project fsspec
	lea	w_fsspec(a2),a0
	lea	proj_fsspec(a5),a1
	bsr.l	the_copy_fsspec
**Copy fsspec to build project fsspec
	lea	w_fsspec(a2),a0
	lea	build_proj_fsspec(a5),a1
	bsr.l	the_copy_fsspec

	restore_all

	qmove.l	(a2),a0	*Windowptr
	OSSelectWindow	a0
	bsr.l	remove_proj_w_ticks	*porject_window.s
	bsr.l	set_proj_window_tick
end_switch:
	bsr.l	inval_all_project_windows

	rts_	"Switch_project"
add_shared_lib:
**finally bring current proj window forward
	bsr	select_current_project	*make active front

	lea	slib_text(a5),a0	*shared lib to add (Hurrah!!!) Ends in CR
	lea	add_file_name+1(a5),a1
	qmoveq	#68,d0
	clr.l	d1
copyslib_name:
	qmove.b	(a0)+,d0
	cmpi.b	#0xd,d0
	beq.s	gotit
	addq.b	#1,d1
	qmove.b	d0,(a1)+
	bra.s	copyslib_name
gotit:
	lea	add_file_name(a5),a1
	qmove.b	d1,(a1)
	move.l	a1,a0
	bsr.s	check_file_in_project	*make sure there is no file with name already
	tst.w	d0
	bne.s	skip_add_shared_lib	*Found
	lea	add_file_name(a5),a1

	qmove.l	#"slib",file_type(a5)
	qmove.l	#-1,d0		*position
	clr.l	scratch_1(a5)	*NO alias
	bsr.l	internal_add_file
**Find end of name
	lea	slib_text(a5),a0
	qmove.l	#255,d0
find_end:
	cmpi.b	#13,(a0)+
	beq.s	got_end
	dbra	d0,find_end
got_end:
	subq.l	#1,a0
**copy shared lib added text
	lea	shared_lib_added(pc),a1
copy1:
	move.b	(a1)+,(a0)+
	bne.s	copy1
	lea	slib_text(a5),a0
	bsr.l	simple_speak
skip_add_shared_lib:
	rts_	"PFM_add_shlib"
**returns -1 if found
check_file_in_project:
	bsr.l	find_file_given_name
	tst.w	d0
	bne.s	cfip_ok	*not found
**Dialog user
**Drag addition 
**If in BG we CANT throw an alert, so we
**just send to log and beep :)
	lea	caf_name(pc),a1
	clr.l	d0
	move.b	(a0)+,d0
	beq.s	wot_file?
	subq.l	#1,d0
copy_nam:
	qmove.b	(a0)+,(a1)+
	qdbra	d0,copy_nam
	qmove.b	#13,(a1)+
	clr.b	(a1)

	lea	cant_add_file(pc),a0
	bsr.l	global_send_to_log

wot_file?:
	qmove.l	#-1,d0
	OSSysBeep	d0
	lea	oops(pc),a0
	bsr.l	simple_speak
	tst.w	in_background(a5)
	beq.s	no_dialog
	
	qmove.l	#1002,d0
	lea	cant_add_file(pc),a0
	qmoveq	#25,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d
no_dialog:
	moveq	#-1,d0
	bra.s	cfip_bye
cfip_ok:
	clr.l	d0
cfip_bye:
	rts_	"Check_file_in_proj"
	
select_current_project:
	qmove.l	build_proj_buffer_h(a5),d0
**now find name that matches
	move.l	windows_records_h(a5),a1
	move.l	(a1),a1
	clr.l	d7
scp_search_loop:
	cmp.l	w_proj_ref(a1),d0
	beq.s	scpfound_it!
	lea	w_rec_size(a1),a1
	addq.l	#1,d7
	cmp.w	#w_rec_size,d7
	beq.s	not_found?	*Emergency protection (No need for it really)
	bra.s	scp_search_loop
scpfound_it!:
	qmove.l	(a1),current_project_windowref(a5)
	qmove.l	(a1),a1		    *port
	OSSelectWindow	a1
**Set active fsspec
	lea	build_proj_fsspec(a5),a0
	lea	proj_fsspec(a5),a1
	qmove.l	#74,d2
	OSBlockMoveData	a0,a1,d2
**Set buffer
	qmove.l	build_proj_buffer_h(a5),proj_buffer_h(a5)	

not_found?:
	rts_	"PFM_select_current_proj"
**v2.1 stuff
**scan porject, open files marked as open
	reset_locals
	local.l	proj_w_id,1
open_marked_files:
**check with prefs
	btst	#0,prefs_flags6(a5)
	beq	no_open_marked
	reserve_locals	a4
**save proj window ref
	qmove.l	(a6),proj_w_id(a4)
**show message
	lea	opening(pc),a1
	bsr.l	draw_status_message

	qmove.l	#0,d7
comf_next:
	push	d7
	qmove.l	d7,d0
	bsr.l	find_file_given_index	*a1-proj entry if success
	popq	d7
	tst.w	d0
	bmi	end_open_marked_files
	push	a1
	qmove.l	proj_buffer_h(a5),d0
	OSHLock	d0			*Dont want it wandering about!
	pop	a1
	
**a1=file record for this file
	qmove.l	this_file_options(a1),d0
	btst	#this_file_is_open,d0
	beq	not_open
	save_all
**make handle to alias in scratch_1
	qmove.l	a1,d6	*save proj entry
	lea	sizeof_file_entry(a1),a0		*Skip our stuff to get at the alias
	lea	scratch_1(a5),a1
	qmove.l	#0,d2
	move.w	4(a0),d2		*size of alias
	beq.s	not_open1
	OSPtrToHand	a0,a1,d2
	move.l	d6,a1	*restore proj entry
	clr.l	name_to_match(a5)	*this will work, so we don't need a check
	push	a6
**must set up a6 to point to current project window
	qmove.l	active_window(a5),-(sp)	*pretend proj window is frontmost
	qmove.l	current_project_windowref(a5),a6
	qmove.l	a6,active_window(a5)
	bsr.l	internal_open_entry
    
	bsr.l	check_rebuild
	qmove.l	(sp)+,active_window(a5)
	pop	a6

not_open1:
	qmove.l	proj_buffer_h(a5),d0
	OSHUnlock	d0

	restore_all
not_open:

	inc.l	d7
	bra	comf_next
end_open_marked_files:
	lea	finished_opening(pc),a1
	bsr.l	draw_status_message

**bring proj window to front
	qmove.l	proj_w_id(a4),d0
	OSSelectWindow	d0
	unlk	a4
no_open_marked:
	rts_	"open_marked_files"

**search project foor file, if found, set it's this_file_is_open bit
*fsspec in a0
mark_file_open_in_proj:
	move.l	proj_buffer_h(a5),d0	*no proj
	beq.s	cant_mark
	tst.b	have_external_editor(a5)	*We dont have editor
	beq	can_mark
	btst	#0,prefs_flags8(a5)
	bne.s	cant_mark	*Editor in use, so don't mark
can_mark:
	lea	6(a0),a0	*file name
	bsr.l	find_file_in_proj
	tst.w	d0
	bmi.s	cant_mark
	move.l	this_file_options(a1),d0
	qbset	#this_file_is_open,d0
	move.l	d0,this_file_options(a1)
**Save project
;	bsr.l	update_proj_pwind
;	bsr.l	save_project
	move.l	proj_buffer_h(a5),a0	*no proj
	bsr.l	update_proj_given_p_buff

cant_mark:
	rts_	"mark_file_open_in_proj"
	global	mark_file_open_in_proj
	
**search project for file, if found, set it's this_file_is_open bit
*fsspec in a0
mark_file_closed_in_proj:
;	btst	#dont_close_in_proj,anvil3_mf1(a5)
;	bne.s	cant_mark_c	*set if we close files from proj with proj
	move.l	proj_buffer_h(a5),d0	*no proj
	beq.s	cant_mark_c
	lea	6(a0),a0	*file name
	bsr.l	find_file_in_proj
	tst.w	d0
	bmi.s	cant_mark_c
	qmove.l	this_file_options(a1),d0
	qbclr	#this_file_is_open,d0
	qmove.l	d0,this_file_options(a1)
**Save project
;	bsr.l	save_project
	move.l	proj_buffer_h(a5),a0	*no proj
	bsr.l	update_proj_given_p_buff
cant_mark_c:
	rts_	"mark_file_closed_in_proj"

	
**if prefs_flags6(5) is set, when we close a project, we also close files
**associated with it
	local.b	project_name,80
	local.l	project_window_id,1
close_files_with_project:
	link	a4,#-100
	btst	#5,prefs_flags6(a5)
	beq	no_cfwp
	qmove.l	(a6),project_window_id(a4)	*save proj wind ref
	save_all
**Save project name for compares
	lea	w_fsspec+6(a6),a0	*the project name
	lea	project_name(a4),a1
	qmoveq	#64,d2
	OSBlockMoveData	a0,a1,d2
**Find windows matching this project as owner - w_file_name
find_windows:
	qmove.l	#0,d7
	move.l	windows_records_h(a5),a1
	move.l	(a1),a1
	lea	w_from_project(a1),a1	*name of project this file came from
search_lp1:
	lea	project_name(a4),a0
	move.l	a1,a2	*save
	tst.b	(a1)
	beq.s	gone
	qbsr.l	pstring_cmp
	qmove.l	a2,a1	*restore
	tst.l	d0
	beq.s	found_one
gone:
	lea	w_rec_size(a1),a1
	addq.l	#1,d7
	cmp.l	#number_of_windows,d7
	beq.s	none_found	*all done
	bra.s	search_lp1
found_one:
**Close the window
	lea	-w_from_project(a1),a1	*name of project this file came from
	qmove.l	window_ptr(a1),d0
	bsr.l	find_window_d0
	bmi	I_DONT_BELIEVE_IT!
	qmove.l	active_window(a5),-(sp)
	qmove.l	(a6),active_window(a5)
	bsr.l	close_window	*and pray :)
	qmove.l	(sp)+,active_window(a5)
I_DONT_BELIEVE_IT!:
**Do all again
	bra	find_windows
	
none_found:
	restore_all
no_cfwp:
	unlk	a4
	rts_	"close_files_with_project"
	global	mark_file_closed_in_proj

******************************************************	
opening:	cstring	"Checking for open files...",13
	align
finished_opening:	cstring	"Finished checking for open files.",13
	align

oops:	cstring	"Oops, error!"
	align
invalid_offset:	pstring	"Invalid offset in delete_proj_file - STOP!"
	align
delete_not_one:	pstring	"Delete_file_from_project(d1) - index not zero?"
	align

proj_type_list:	dc.l	"FEpj"
	align
psn:	ds.l	2	Fants psn goes here
PIR:	dc.l	60	process info rec goes here - length
	dc.l	0	we don't want the name
	ds.l	2	PSN
	dc.l	1	type
	dc.l	1	sig
	dc.l	1	flags
	dc.l	1	address of partition
	dc.l	1	size
	dc.l	1
	dc.l	2	psn of launcher
	dc.l	1	date
	dc.l	1	active time
	ds.l	1	pointer to Fsspec
	ds.l	4
	align
temp_fsspec:	ds.b	80
	align
binary_alias:	dc.b	"A file derived from this file "
	dc.b	"exists in this project.",13,13
	dc.b	"Do you want to remove the derived file from the project?"
	dc.b	13,13,"File = "
ba_name:	ds.b	64
	align
pb_name:	pstring	"Anvil Project Bits"
	align	
open_mem_error:	cstring	"Can't open project.",13,13,"Not enough free memory.",13,"Need 600k free."
	align
version_error: dc.b		"This project is the wrong version.",13
	dc.b	"This Anvil needs rev4 proj. file."
	dc.b	13,"This is not a rev4 project.",13,13,"It cannot be opened."
	dc.b	13,13,"Sorry.",0
	align

shared_lib_added:	cstring	" has been added to your project."
	align
corrupt_proj_err:	dc.b	"Anvil has detected that this "
	dc.b	"project has been corrupted!",13
	dc.b	"The project will not be written "
	dc.b	"to disk.",13,13
	dc.b	"There is a possibility that Anvil "
	dc.b	"has also been written to and so "
	dc.b	"will quit when you hit OK.",0
	align
save_files:	dc.b	"EMERGENCY SHUTDOWN CHECK",13
	dc.b	"Anvil (and data) is possibly corrupt.",13
	dc.b	"Do you want to try to save "
	dc.b	"any dirty files?",0
	align
files_ok:	dc.b	"There were no errors from "
	dc.b	"the file system.",13,13
	dc.b	"Please hit OK to quit.",0
	align
cant_add_file:	dc.b	13,"Can't add the following file "
	dc.b	"to project because a file with "
	dc.b	"that name exists in the project.",13,"File: "
caf_name:	ds.b	80
	align
open_proj_error:	dc.b	"Project is either locked or on a "
	dc.b	"locked volume.",13,13
	dc.b	"Anvil can't work with locked projects. "
	dc.b	"The project will not be opened.",0
	align
no_source_area:	dc.b	"Can't add that file to this project "
	dc.b	"as there is no _Src area and the "
	dc.b	"file is an assembly language file.",13,13
	dc.b	"Will place the file in the User area.",0
	align
	
no_hl_area:	dc.b	"Can't add that file to this project "
	dc.b	"as there is no High level area and the "
	dc.b	"file is a High Level file.",13,13
	dc.b	"Will place the file in the User area.",0
	align
	global	store_output_file,add_folder_alias,store_resource,store_obj
	global	store_src,store_note,store_library,open_new_project,get_pm_folder
	global	delete_file_from_project,find_nth,store_globs
	global	save_project,delete_file_given_name,store_trash,store_highlevel
	global	store_hlh,store_sinc,rename_user_folder,switch_project
	global	add_shared_lib,store_shared_library
	global	check_file_in_project,find_nth_proj
	global	pb_name,close_files_with_project,get_folder_dirid
	
	extern	size_file,mem_err,read_file,verify_project,the_copy_fsspec
	extern	calc_project_size,sys_write_file_set_type
	extern	open_proj_window,find_file_in_proj,get_tool_entry
	extern	do_alert_3d,my_resolve_handle_everything,find_file_given_name

	extern	remove_proj_w_ticks,set_proj_window_tick,simple_speak
	extern	internal_add_file,save_all
	extern	find_file_given_index,internal_open_entry,draw_status_message
	extern	events,global_send_1,global_send_2,deselect_last
	extern	strncmp
	extern	filename_string
**Anvil 3.00
	extern	inval_all_project_windows,pstring_cmp,find_window_d0,close_window
	extern	update_proj_given_p_buff,global_send_to_log,check_locked_d0
	extern	check_rebuild,do_new_alert_3d