***********************************************************
*Replace.s

**Checked for volatile regs across OS calls - 2302 040997

*needs the cursor at the start of the word to be replaced, and replaces
*the search string with the replace string.
*Steps
*1. Set sel start and sel end from length of find_string.
*2. Call CUT
*3. Call paste.
***NOTE***Linestarts must be recalced after calling this routine!!!!!!!!!!!!!!
replace_all:
**Set busy cursor
	qmove.l	busy_curs_h(a5),d0	  
	OSSetCCursor	d0
rep_loop:
;	save_all
;	bsr.l	events
;	restore_all
	bsr	local_search	*in search.s
	tst.w	d0
	bmi.s	done_fr_all	*eof	    
**now the cursor is at the start of the word to be replaced
	bsr	replace
	bsr	int_recalc	*recalc line starts
	addq.l	#1,occurence(a5)	
	bra	rep_loop
done_fr_all:
;	 bra	 calc_lines_size	*recalc line starts	

	rts_	"Rep_all"
	even
**Needs column in d0
**Strategy:
**From start of text, count chars. If cr then reset count.
**If count gets>size then couht back looking for break.
**insert CR ,reset count and repeat

do_wrap:
	qmove.l	d0,-(sp)
	lea	replace_string(a5),a0
	lea	temp_string3(a5),a1
	bsr	copy_string
	qmove.l	busy_curs_h(a5),d0	  
	OSSetCCursor	d0
	qmove.l	(sp)+,d0
	subq.w	#2,d0
	lea	replace_string(a5),a1
	qmove.b	#1,(a1)+
	qmove.b	#13,(a1)	*we will be inserting cr's
	clr.l	d7
	qmove.w	d0,d7	*save column
	move.l	te_handle_ptr(a6),a0
	move.l	ed_htext(a0),a1
	move.l	(a1),a2	*point to text
	clr.l	ed_selpoint(a0)
	clr.l	ed_selstart(a0)
	clr.l	ed_selend(a0)
	qmove.l	#0,d5	*text counter
	qmove.l	d5,d4	*column counter
do_next:
**LXT change
	qpush1	a3
	move.l	a2,a3
	add.l	d5,a3
	qcmove.b	(a3),d0
	qpop1	a3
**end change
;	move.b	0(a2,d5.l),d0
	tst.l	d0
	beq.s	finished	
	cmpi.l	#13,d0
	beq.s	got_cr
	addq.l	#1,d5	*inc index
	cmp.l	d4,d7
	blt.s	too_big	*line is too big!
	addq.l	#1,d4	*Inc column counter
	cmp.l	ed_telength(a0),d5
	bge.s	finished
	bra.s	do_next
got_cr:	qmove.l	#0,d4
	addq.l	#1,d5
	bra.s	do_next
	
too_big:
	qmove.l	d5,d3	*copy index
tb_loop:
**LXT change
	qpush1	a3
	move.l	a2,a3
	add.l	d3,a3
	qcmove.b	(a3),d1
	qpop1	a3
**end change

;	move.b	0(a2,d3.l),d1
	tst.l	d1
	beq.s	got_crw	*start of text!
	cmpi.l	#13,d1
	beq.s	got_crw	*did not find a break!
	cmpi.l	#" ",d1
	beq.s	got_breakw
	cmpi.l	#9,d1
	beq.s	got_breakw
	subq.l	#1,d3
	bra.s	tb_loop
got_crw:

**here we found the start of the line, so we insert a break at d5
	qmove.l	d5,d3
	subq.l	#1,d3
*here we've found the previous word break, so we insert a cr
*and reset the column counter
got_breakw:
	addq.l	#1,d3	*skip break character
	qmove.l	d3,ed_selpoint(a0)
	qmoveq	#1,d0
	movem.l	d4/d5/d6/d7/a0/a2,-(sp)
	bsr	internal_paste	*can move memory!
	movem.l	(sp)+,d4/d5/d6/d7/a0/a2
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	move.l	ed_htext(a0),a2
	move.l	(a2),a2	*point to text

	addq.l	#1,ed_telength(a0)
	qmove.l	#0,d4	*reset column counter
	bra	do_next  
finished:
	lea	temp_string3(a5),a0
	lea	replace_string(a5),a1
	bsr	copy_string
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	clr.l	ed_selpoint(a0)
	clr.l	ed_selend(a0)
	clr.l	ed_selstart(a0)
**Clear window
	save_all
	save_all
	move.l	(a6),a0
	OSSetPortWindowPort	a0
	restore_all
	move.l	a0,a3
	lea	ed_viewrect(a0),a0
	OSClipRect	a0
;	pea	ed_viewrect(a0)
;	dc.w	_Cliprect
	lea	ed_viewrect(a3),a0
	OSEraseRect	a0
;	pea	ed_viewrect(a3)
;	dc.w	_eraserect
	restore_all
	move.l	ed_telength(a0),d6
	rts_	"do_wrap"
	even
*****

replace:
**Stage 1
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
;	move.l	ed_selstart(a0),d0	  *cut start
;	clr.l	d1
	qcmove.b	find_string(a5),d1	  *length of string to cut

	qmove.l	ed_selstart(a0),d0	  *start of string to cut
	add.l	d1,d0		    		*add basic length of string to make selend
;	sub.l	ed_selstart(a0),d0
**Now scan text, looking tabs
**add on any tabs in find string!

	lea	find_string(a5),a1
;	clr.l	d1
	qmove.l	#0,d2	*tab length of cut
	qmove.l	#0,d4	*for extension of tab width
	qcmove.b	(a1)+,d1
	subq.l	#1,d1
	bmi.s	no_str
ftab:	qcmove.b	(a1)+,d3
	cmpi.l	#9,d3
	bne.s	not_tab

	add.l	#1,d2
**calc real tab width
;	move.w	tab_width_w(a6),d4	  *wanted tab width
fnextrun:
	move.l	te_handle_ptr(a6),a3
	move.l	ed_htext(a3),a2
	move.l	(a2),a2
	add.l	ed_selstart(a3),a2
	add.l	d2,a2	*curernt point
	cmpi.b	#32,(a2)
	beq.s	ftab2
	bra.s	not_tab
ftab2:
	addq.l	#1,d2
	bra.s	fnextrun
not_tab:
	dbra	d1,ftab

	tst.l	d2
	beq.s	no_str
	subq.l	#1,d2
no_str:
	add.l	d2,d0	*total length of tabs
	qmove.l	d0,ed_selend(a0)	*cut end
**check if sel_start=selend then inc selend
;	move.l	ed_selend(a0),d4
;	cmp.l	ed_selstart(a0),d4
;	bne.s	no_frig2
;	inc.l	ed_selend(a0)
;no_frig2:

**if first char of cut string is \cthen dec sel_start and sel_end!
	cmpi.b	#13,find_string+1(a5)	*length of string to cut
	bne.s	no_frig
	subq.l	#1,ed_selstart(a0)
	subq.l	#1,ed_selend(a0)
**now inc selend for every \c at the start
;	clr.l	d0
;	move.b	find_string(a5),d0
;	subq.l	#1,d0
;	bmi.s	no_frig
;	lea	find_string+1(a5),a1
;inc_end:
; cmpi.b	#0xd,(a1)+
;	bne.s	done
;	subq.l	#1,ed_selstart(a0)
;	addq.l	#1,ed_selend(a0)
;	dbra	d0,inc_end
done:
no_frig:
**Anvil 2
**if replace string is zero then we goto do_clear
**Stage 2
	qmove.l	a0,-(sp)	
	bsr	internal_clear	 *goodbye :-)	 
	move.l	(sp)+,a0

**stage 3
**Expand tabs in replace string
**Copy replace string to temp

	lea	replace_string(a5),a0
	lea	temp_string(a5),a1
	qmove.l	#255,d2
	OSBlockMoveData	a0,a1,d2
;	dc.w	_Blockmove
**copy from temp_string to replace_string expanding tabs
	qmove.l	#0,d6	*if we've aligned on a tab this is set
	lea	replace_string+1(a5),a1
	lea	temp_string(a5),a0
	qmove.l	#0,d0
	qmove.l	#0,d2	*char counter
	move.b	(a0)+,d0
	beq	wot_string
	subq.l	#1,d0
et:	qcmove.b	(a0)+,d1	*what marvellous labels stu!
	cmpi.l	#9,d1
	bne.s	straight
	qmove.b	#9,(a1)+
	addq.l	#1,d2
**calc how man yspaces to insert

	tst.b	d6
	bne.s	aligned
	move.l	te_handle_ptr(a6),a2
	qmove.l	ed_selpoint(a2),d7	  *where we started	
	qmove.l	d7,d3	*so we can check if we run off thestart
	move.l	ed_htext(a2),a3
	move.l	(a3),a3
	add.l	d7,a3
	add.l	d2,a3	*current point in txt
	add.l	d2,d3
	subq.l	#1,a3	*allowing for a tab at the start!
	qmoveq	#1,d6	*set alignewd flag
**Count columns to start of line
	qmove.l	#0,d5
find_sol:
	subq.l	#1,d3
	beq.s	got_col
	move.b	-(a3),d4
	beq.s	got_col
	cmpi.b	#13,d4
	beq.s	got_col
	addq.l	#1,d5
	bra.s	find_sol
got_col:	*in d5
	divs	tab_width(a6),d5
	swap	d5
;	qmove.l	#0,d4
	qcmove.w	tab_width_w(a6),d4
	sub.w	d5,d4
	bra.s	got_t
aligned:
;	clr.l	d4
	qcmove.w	tab_width_w(a6),d4
got_t:
	subq.w	#2,d4	*one for that tab and one for the dbra
	bmi.s	dt
it:	move.b	#32,(a1)+
	addq.l	#1,d2
	dbra	d4,it
	bra.s	dt
straight:
	qmove.b	d1,(a1)+
	inc.l	d2
dt:	dbra	d0,et
wot_string:
	lea	replace_string(a5),a0
	qmove.b	d2,(a0)	*pascal
	move.l	te_handle_ptr(a6),a0	
;	clr.l	d0
	qcmove.b	replace_string(a5),d0
	qmove.l	d0,-(sp)	*save length of replace string
	bsr.s	internal_paste
	qmove.l	(sp)+,d0
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	add.l	d0,ed_selpoint(a0)	  *1.2 fix
	qmove.l	ed_selpoint(a0),ed_selstart(a0)	*cut start
	qmove.l	ed_selpoint(a0),ed_selend(a0)
**Copy temp back to replace
	lea	replace_string(a5),a1
	lea	temp_string(a5),a0
	qmove.l	#255,d2
	OSBlockMoveData	a0,a1,d2
;	dc.w	_Blockmove
	qmove.b	#-1,dirty(a6)	

;wot_string:
	rts_	"Clear"
	
		
internal_paste:
	clr.l	paste_size_add(a5)
**needs d0=size, replace string = Text
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	qmove.l	d0,d7	save size
	qmove.l	ed_telength(a0),d2	  telength
;	ext.l	d0
	andi.l	#0xffff,d0
	qmove.l	d0,scratch_2(a5)	save size of paste to add to insertpoint 
	add.l	d0,d2
	qmove.l	d2,d6	new size
	tst.l	d0
	beq	end_replace	*size was zerooooo
**get length of ed_htext
	qmove.l	d2,-(sp)	save new total length
	move.l	te_handle_ptr(a6),a0
	move.l	ed_htext(a0),a0	handle to text buffer
	OSGetHandleSize	a0,d0
;	dc.w	_gethandlesize	in d0
	qmove.l	(sp)+,d2
	sub.l	#5000,d0		5k slop
	cmp.l	d0,d2
	blt.s	te_has_space
	move.l	te_handle_ptr(a6),a0
	move.l	ed_htext(a0),a0	handle to text buffer

	qmove.l	d2,d1	new handle size
	add.l	#5000,d1	+5k slop
	OSSetHandleSize	a0,d1
	OSGetMemErr	d0
	bmi.s	te_space_err
	move.l	te_handle_ptr(a6),a0
	move.l	ed_htext(a0),a0	handle to text buffer
	move.l	a0,d0
	bne.s	te_has_space	double check
te_space_err:
	lea	Rte_no_space(pc),a0
	qmove.l	#1000,d0
	qmoveq	#34,d1	x
	qmoveq	#90,d2	y
	bsr.l	do_new_alert_3d
	bra.s	end_replace
te_has_space:
	move.l	te_handle_ptr(a6),a0
	move.l	ed_htext(a0),a0	handle to text buffer
	move.l	(a0),a1	a1-> start oftext
	move.l	a1,a3	save
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0	a0->te_rec
	add.l	ed_selpoint(a0),a3	  insertion point in text
**length to be copied is te_length-insert point
	qmove.l	ed_telength(a0),d3
	sub.l	ed_selpoint(a0),d3
**copy from end to end+paste_size
	add.l	ed_telength(a0),a1	  a1->end oftext
;	addq.l	#1,a1		for pre dec
	move.l	a1,a2		    a2->end of text

	add.l	d7,a2	a2->new end of text
	tst.l	d3
	beq.s	at_very_end_of_text
copy_down:	qmove.b	-(a1),-(a2)
	subq.l	#1,d3
	bne.s	copy_down	
at_very_end_of_text:

	lea	replace_string(a5),a2
	addq.l	#1,a2	*skip pascal byte count
insert:	qmove.b	(a2)+,(a3)+
	subq.l	#1,d7
	bne.s	insert	      
	qmove.b	#-1,dirty(a6)	
end_replace:
	rts_	"Int_paste"

****
internal_clear:
**check where bookmark is
	qmove.l	bookmark(a6),d1
	cmp.l	ed_selstart(a0),d1
	blt.s	bm_ok	*doesnot affect bm
	cmp.l	ed_selend(a0),d1
	bgt.s	move_bm
	clr.l	bookmark(a6)
	bra.s	bm_ok
move_bm:
	qmove.l	ed_selend(a0),d1
	sub.l	ed_selstart(a0),d1	  *size of clear
	sub.l	d1,bookmark(a6)	*move down by cut size	
bm_ok:

	move.l	te_handle_ptr(a6),a0	clear enters here
;	move.l	(a0),a0
	move.l	ed_htext(a0),a1
	move.l	(a1),a1	->start of text
	move.l	a1,a2
**************************************************************
	qmove.l	ed_selstart(a0),d0
	add.l	d0,a1	->start of selection
**now point a2 at end of selection
	qmove.l	ed_selend(a0),d1
	add.l	d1,a2	->end of selection
**now find size of text between end_sel and eot
	qmove.l	ed_telength(a0),d2
	sub.l	d1,d2	d2 is size of text from sel_end to eot
	sub.l	d0,d1	*size of selection (end-start)
	sub.l	d1,ed_telength(a0)	  **Important bit!
	qmove.l	d1,d0	*save length - 037
	tst.l	d2
	beq.s	clear_text	   *sel to end!
**now move d2 bytes from a2 to a1 (Move text up)
move_on_up:	qmove.b	(a2)+,(a1)+
	subq.l	#1,d2
	bne.s	move_on_up	*no challenge is it?
;	 clr.l	 -1(a1)	

clear_text:			*Clear out old text - 037
	qmove.b	#0,(a1)+
	subq.l	#1,d0
	bne.s	clear_text
**now recalc line starts
**IF sel_start is < selpoint then make selpoint=selstart
no_move:	qmove.l	ed_selpoint(a0),d0
	cmp.l	ed_selstart(a0),d0
	blt.s	point_ok
	qmove.l	ed_selstart(a0),ed_selpoint(a0)	we deleted the original point
point_ok:
	qmove.l	ed_selpoint(a0),ed_selstart(a0)
	qmove.l	ed_selpoint(a0),ed_selend(a0)
	qmove.b	#-1,dirty(a6)
	rts_	"Int_clear"

int_recalc:
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0	a0->te_rec
	move.l	ed_linestarts(a0),a0
	OSGetHandleSize	a0,d0
;	dc.w	_gethandlesize
	lsr.l	#2,d0	/4
	qmove.l	d0,d7	save max number of lines
	sub.l	#400,d7	400 lines buffer	
	bsr.l	count_lines	returns number of lines in d0
;	add.w	ed_nlines(a0),d0
;	qmove.l	#0,d1	*eb2
	qcmove.w	ed_nlines(a0),d1
	add.l	d1,d0	*FUCK IT!!!!!!!!!!!!!!!!!!!!!
	cmp.l	d0,d7
	bgt.s	lines_ok
	add.l	#100,d0
	lsl.l	#4,d0	times four for bytes
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0	a0->te_rec
	move.l	ed_linestarts(a0),a0
	qmove.l	d0,d1
qmflag:	set	0
	OSSetHandleSize	a0,d1
;	dc.w	_sethandlesize
	OSGetMemErr	d0
	bmi	te_space_err
	move.l	a0,d0
	beq	te_space_err
lines_ok:	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0

	qmove.l	d6,ed_telength(a0)	new length of text
	qmove.l	te_handle(a6),-(sp)	
	bsr.l	new_tecaltext
standard_move:
;	 pea	 ed_viewrect(a0)
;	 dc.w	 _eraserect
;	 move.b	#1,no_colour_sel(a5)	 *tell colour selection to dont
;	 move.l	te_handle(a6),a0
;	 move.l	(a0),a0
;	 bsr	 redraw_all_scroll	 draw all according to scroll bars
;	 move.w	#1,stat_now(a5)
;	 bsr	 do_status_line
;	 move.l	te_handle(a6),a0
;	 move.l	(a0),a0
;	 bsr	 do_auto_scroll
	clr.b	no_colour_sel(a5)	
	rts_	"Int_recalc"
	align  
Rte_no_space:	dc.b	"Out of memory!",0
	even

	global	replace,int_recalc,replace_all,internal_paste,internal_clear
	global	do_wrap
	extern	do_alert_3d
	extern	count_lines,new_tecaltext,redraw_all_scroll,do_status_line
	extern	do_auto_scroll,local_search,events,copy_string,do_clear,do_new_alert_3d