	include	pm_equates.def


*****************************
*Search.s
*handles searching and hyperjumping
*
***************	GLOBAL SEARCH

**Checked for volatile regs across OS calls - 2302 040997

*Simply copy the library search code out of Fantasm. This lets us recursively
*load every file in a directory. We load the files one at a time onto the
*system heap, as we can't passobly know how big the files are when we're setting
*the partition for Eddie.
*The file is loaded onto the sys heap and we use find and find again to find
*all occurences of the string. We build the list of occurences in a new
*window, which we'll call the find_window.
*AS each occurence is found, we print it in the window in the following format:

*File:xxxxxxxxxxxxxxxxxxxxxxxxx Line:xxxxx
*Line text
*blank line

;SO each error takes three lines. When the find_window is active, a global flag
;is set, which tells us, when the mouse is clicked in a window, we should
;compare the window_ptr with the find_window, if match, then we dont do normal
;mouse processing, but we do find_window processing, which is basically get the line number
;of the click, translate it to a text position - i.e. a file report, and execute
;the text contained in the three line report.
;
;Simply, check if the file is open, if not open it. Goto the line specified in the text.

Ciocompletion:	equ	12	long
Cionameptr:	equ	18	long
Ciovrefnum:	equ	22	word
Ciodrdirid:	equ	48	long
Ciofdirindex:	equ	28	word - set to zero initially
CioDRParID:	equ	100	long
**Unfortunately we have to use a pb here :-(
	rts_	"non_label1"
global_search:
	tst.b	find_string(a5)
	bne.s	str_okg
	rts
str_okg:
	qmove.b	#1,global_in_progress(a5)
	clr.b	cancel_global(a5)	*set to 1 in eents if escape is pressed
;	bsr	led_on			*light scroll lock led for global search
	qmove.l	busy_curs_h(a5),d0
	OSSetCCursor	d0
;	move.l	busy_curs_h(a5),-(sp)
;	dc.w	_setCcursor
**First see if window is open, if so close it.
	tst.l	find_window_id(a5)
	beq.s	find_is_shut
;	push	active_window(a5)
	qmove.l	find_window_id(a5),active_window(a5)
	bsr.l	close_it
;	pop	active_window(a5)
find_is_shut:
	qmove.l	#15000,d1	*size for text

	bsr.l	setup_find_window
	tst.w	d0
	bmi	find_failed1
	qmove.b	#1,doing_a_global_search(a5)	*so we know not to close the window!
************************************************************
	clr.l	total_number_of_finds(a5)	*how many occurences
	btst	#3,prefs_flags6(a5)
	beq	end_search_project	*global search
**New for 5.20b1 - search project
	tst.l	proj_buffer_h(a5)
	beq	end_search_project	*Stops us appearing as a bunch of wankers
	qmove.l	proj_buffer_h(a5),d0
	OSHLock	d0
	qmoveq	#0,d7	*file index into project
read_global_loopgp:
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	qmove.l	#vhl_offset,d0

	add.l	d0,a1	*Offset to pointer to file base
	add.l	(a1),a1

	qmove.l	d7,d1
	bsr.l	find_nth_proj	*Finds the d1 file, returns a1->file, d0=0=ok, -1=not found
	tst.w	d0
	bmi	end_globalgp	no more files
**Find file type, first resolve to fsspec
	qmove.l	this_file_type(a1),d0
	cmpi.l	#"src ",d0	*File types we can search
	beq	text_filegp

	cmpi.l	#"vhl ",d0
	beq	text_filegp
	cmpi.l	#"hl  ",d0
	beq	text_filegp
**headers
	cmpi.l	#"hlh ",d0
	beq	text_filegp
	cmpi.l	#"vhlh",d0
	beq	text_filegp
	cmpi.l	#"sinc",d0
	beq	text_filegp
	cmpi.l	#"glob",d0
	beq	text_filegp
	
**Quick get out when we hit object files
	cmpi.l	#"obj ",d0
	beq	end_globalgp

	bra	notr_text_filegp

text_filegp:
**Check file type (from it's icon ID)
	cmpi.w	#0x1100,this_file_options(a1)	*project file (icon 0x11)
	beq	notr_text_filegp	*Project file
	cmpi.w	#0x1000,this_file_options(a1)	*user folder (icon 0x10)
	beq	notr_text_filegp	*Project file

	lea	sizeof_file_entry(a1),a0
	qmove.l	a0,d0
	qcmove.w	4(a0),d2	*size of alias
	lea	scratch_1(a5),a1	*handle here
	OSPtrToHand	d0,a1,d2
	move.l	scratch_1(a5),a0

	push	a4
	clr.l	name_to_match(a5)
	bsr.l	my_resolve_handle_everything	*temp_string3=fsspec if found, error in d0
	pop	a4

	qmove.l	scratch_1(a5),d0
	OSDisposeHandle	d0
	lea	temp_string3(a5),a0
	save_volatile	*my fave macro :-)
	lea	temp_string4(a5),a1

	OSFSpGetFInfo	a0,a1,d0
	restore_volatile
	lea	temp_string4(a5),a0	*fndrinfo
	
	cmp.l	#"TEXT",(a0)	*Text file?
	bne	notr_text_filegp	*no
**now we have to get the size of the data fork
**open file
	lea	temp_string3(a5),a0
	lea	refnum(a5),a1
	qmoveq	#1,d1
qmflag:	set	0
	OSFSpOpenDF	a0,d1,a1,d0

	bmi	end_globalgp
**get size of file
	qbsr	get_temp_pb	a0->temp pb
	qmove.w	refnum(a5),24(a0)	refnum

	OSPBGetEOF	a0,d0

;	DC.W	_getEOF
	lea	temp_pb(a5),a0
	qmove.l	28(a0),d6	return size - phys end of data fork

	qmove.l	d7,search_proj_pos(a5)
	qmove.l	d6,d0
	OSNewHandleClear	d0,a0
;	dc.w	_newhandleclear
	move.l	a0,d0
	beq	find_failed2
	qmove.l	a0,search_scratch_1(a5)
	OSHLock	a0
;	dc.w	_hlock
	move.l	search_scratch_1(a5),a0
	move.l	(a0),a1		        *buffer for file
**Display file name in status line

	save_all
	lea	hl_name(pc),a1
	qmove.l	#64/4-1,d1
	qmove.l	#0,d0
clear_hlnamegp:
	qmove.l	d0,(a1)+
	qdbra	d1,clear_hlnamegp
	lea	phl_name(pc),a1
	lea	temp_string3+6(a5),a0	*->Filename
;	clr.l	d0
	qcmove.b	(a0),d0
	subq.l	#1,d0
	addq.l	#1,a0
	bmi.s	no_namegp
copy_hlnamegp:
	qmove.b	(a0)+,(a1)+
	qdbra	d0,copy_hlnamegp
no_namegp:
	clr.b	(a1)+		*c string
	lea	phl_name_start(pc),a1
	bsr.l	draw_status_message
	restore_all
	bsr.l	spin_right
	qbsr	get_temp_pb	a0->temp pb
	qmove.w	refnum(a5),24(a0)	refnum
	lea	temp_pb(a5),a0

	save_all
	bsr	quick_read_already_open
	restore_all

	qmove.l	#-1,gsearch_pos(a5)
	clr.l	gsearch_found(a5)	 
	clr.l	long_var1(a5)	 *this is our line counter

next_searchgp:
	move.l	search_scratch_1(a5),a1
	move.l	(a1),a3		        *a1->text of file
	qmove.l	long_var1(a5),d5
	bsr	global_searches
	tst.w	d0
	bmi	not_in_file_gp

	addq.l	#1,total_number_of_finds(a5)
	qmove.l	d5,long_var1(a5)	*save line counter	
**now we have to build the string to insert into the window
	lea	temp_string(a5),a1
**first copy fname(pc)
;	lea	fname(pc),a2

	lea	temp_string3+6(a5),a2	*->Filename

;	clr.l	d0
	qcmove.b	(a2)+,d0

	subq.l	#1,d0
copy_fnamegp:
	qmove.b	(a2)+,(a1)+
	qdbra	d0,copy_fnamegp	*Thats the file name

	qmove.l	#" Lin",(a1)+
	qmove.l	#"e = ",(a1)+	*"filename Line = "
	qmove.l	d5,d6
	addq.l	#1,d6	*start from line 1
	qmove.l	a1,a0
	bsr	printnum_mem		*"Filename at line xxxxx"
	qmove.l	a0,a1
	qmove.b	#".",(a1)+	  
	qmove.b	#9,(a1)+	*tab
**now we have to get the text from start of line

	qmove.l	search_scratch_1(a5),a2
	qmove.l	(a2),a3		        *a3->text of file
	qmove.l	a3,d4	*Start of text
	add.l	gsearch_pos(a5),a3	 
**scan back until either cr or start of file
sbgp:	move.b	(a3),d0
	beq.s	got_startgp
	cmpi.b	#13,d0
	beq.s	got_startgp
	cmpi.b	#10,d0
	beq.s	got_startgp	*1.6 support for unix
	subq.l	#1,a3
	cmp.l	d4,a3
	bge.s	sbgp
got_startgp:
	addq.l	#1,a3	*skip this cr!
**Copy to a3 until cr or zero or count=0
	qmoveq	#127,d7
copy_linegp:
	subq.l	#1,d7
	beq.s	got_eolgp
	move.b	(a3)+,d0
	beq.s	got_eolgp
	cmpi.b	#13,d0
	beq.s	got_eolgp
	cmpi.b	#10,d0
	beq.s	skip_unix1
	qmove.b	d0,(a1)+
skip_unix1:
	bra.s	copy_linegp
got_eolgp:
	qmove.b	#13,(a1)+
	
	clr.b	(a1)+

**Count length of string
	qmove.l	#-1,d7
	lea	temp_string(a5),a1
clsgp:	
	addq.l	#1,d7
	tst.b	(a1)+
	bne.s	clsgp
**now paste into find window
	lea	temp_string(a5),a1
	qmove.l	a1,scratch_1(a5)

	qmove.l	a6,-(sp)	*save current
	qmove.l	find_window_id(a5),active_window(a5)
	bsr.l	find_window
	bmi	oops	*USer closed find window!
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0
	bsr	gp_paste	*d7 is size, scratch is text to paste	 
	qmove.l	(sp)+,a6
	qmove.l	0(a6),active_window(a5)
	bsr.l	find_window
	bmi	oops
	qmove.l		(a6),d0
	OSSetPortWindowPort	  d0

**now go round and find next		 	
	bra	next_searchgp
not_in_file_gp:
;	qmove.l	search_scratch_1(a5),d0	
;	OSHUnlock	d0
	qmove.l	search_scratch_1(a5),d0	
	OSDisposeHandle	d0
;	clr.l	d7
	qmove.l	search_proj_pos(a5),d7

notr_text_filegp:
	clr.l	long_var1(a5)	 *line counter
	addq.l	#1,d7

	bra	read_global_loopgp

end_globalgp:
	tst.b	doing_build(a5)
	bne.s	no_unlock	*in case of searching whilst building!
	qmove.l	proj_buffer_h(a5),d0
	OSHUnlock	d0
no_unlock:
**End change for 5.20b1
end_search_project:

**Searech all in folder?
	btst	#2,prefs_flags6(a5)
	beq	end_global	*global search

*Search all files in folder

	qmoveq	#1,d7	file counter
	bsr	clear_pb
	lea	temp_pb(a5),a0
	qmove.w	current_vrefnum(a5),Ciovrefnum(a0)
	qmove.l	current_parid(a5),Ciodrdirid(a0)	dir id
	OSPBHSetVolSync	a0
;	dc.w	_Hsetvol	
read_global_loop:
	btst	#4,prefs_flags(a5)
	beq	no_switching
**Switcher
	save_all
	OSFrontWindow	d0
	qmove.l		d0,active_window(a5)
	bsr.l	find_window
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0
	qmove.l	te_handle_ptr(a6),a0
	bsr.l	events
	restore_all
	
	
	qmove.l	0(a6),active_window(a5)
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0

no_switching:
	tst.b	cancel_global(a5)
	bne	end_global1
	bsr.l	spin_right
	lea	temp_pb(a5),a0
	clr.l	Ciocompletion(a0)	no completion routine
	lea	fname(pc),a1
	qmove.l	a1,Cionameptr(a0)	point to filename
	clr.w	Ciovrefnum(a0)	vrefnum
	qmove.l	current_parid(a5),Ciodrdirid(a0)	dir id
;	 move.l	#0,ciodrdirid(a0)	  
	qmove.w	d7,Ciofdirindex(a0)	
	OSPBGetCatInfoSync	a0,d0
;	moveq	#9,d0
;	dc.w	_hfsdispatch	registered call
	tst.w	d0
	bmi	end_global	 no more files
**We've now got the file info in temp_pb
	lea	temp_pb(a5),a0
	cmp.l	#"TEXT",32(a0)	*Text file?
	bne	notr_text_file	*no
	qmove.l	d7,-(sp)
	qmove.l	54(a0),d6	*add size of data fork
	qmove.l	a0,a3
**now we need to get a buffer on sys heap for file
	qmove.l	d6,d0
	OSNewHandleClear	d0,a0
;	dc.w	_newhandleclear
	move.l	a0,d0
	beq	find_failed2
	qmove.l	a0,search_scratch_1(a5)
	OSHLock	a0
;	dc.w	_hlock
	qmove.l	search_scratch_1(a5),a0
	qmove.l	(a0),a1
	qmove.l	a3,a0	
	save_all
	bsr	show_filename	*1.6 - show name of file being searched
	bsr	quick_read
	restore_all

	qmove.l	#-1,gsearch_pos(a5)
	clr.l	gsearch_found(a5)	 
	clr.l	long_var1(a5)	 *this is our line counter
next_search:
	move.l	search_scratch_1(a5),a1
	move.l	(a1),a3		        *a1->text of file
	qmove.l	long_var1(a5),d5	
	bsr	global_searches
	tst.w	d0
	bmi	not_in_file

	addq.l	#1,total_number_of_finds(a5)
	qmove.l	d5,long_var1(a5)	*save line counter	
**now we have to build the string to insert into the window
	lea	temp_string(a5),a1
**first copy fname(pc)
	lea	fname(pc),a2
;	clr.l	d0
	qcmove.b	(a2)+,d0

	subq.l	#1,d0
copy_fname:
	qmove.b	(a2)+,(a1)+
	qdbra	d0,copy_fname	*Thats the file name

	qmove.l	#" Lin",(a1)+
	qmove.l	#"e = ",(a1)+	*"filename Line = "
	qmove.l	d5,d6
	addq.l	#1,d6	*start from line 1
	qmove.l	a1,a0
	bsr	printnum_mem		*"Filename at line xxxxx"
	qmove.l	a0,a1
	qmove.b	#".",(a1)+	  
	qmove.b	#9,(a1)+	*tab
**now we have to get the text from start of line

	qmove.l	search_scratch_1(a5),a2
	qmove.l	(a2),a3		        *a3->text of file
	qmove.l	a3,d4	*Start of text
	add.l	gsearch_pos(a5),a3	 
**scan back until either cr or start of file
sb:	move.b	(a3),d0
	beq.s	got_start
	cmpi.b	#13,d0
	beq.s	got_start
	cmpi.b	#10,d0
	beq.s	got_start	*1.6 support for unix
	subq.l	#1,a3
	cmp.l	d4,a3
	bge.s	sb
got_start:
	addq.l	#1,a3	*skip this cr!
**Copy to a3 until cr or zero or count=0
	qmoveq	#127,d7
copy_line:
	subq.l	#1,d7
	beq.s	got_eol
	move.b	(a3)+,d0
	beq.s	got_eol
	cmpi.b	#13,d0
	beq.s	got_eol
	cmpi.b	#10,d0
	beq.s	skip_unix2
	qmove.b	d0,(a1)+
skip_unix2:
	bra.s	copy_line
got_eol:
	qmove.b	#13,(a1)+
	
	clr.b	(a1)+

**Count length of string
	qmove.l	#-1,d7
	lea	temp_string(a5),a1
cls:	
	addq.l	#1,d7
	tst.b	(a1)+
	bne.s	cls
**now paste into find window
	lea	temp_string(a5),a1
	qmove.l	a1,scratch_1(a5)

	qmove.l	a6,-(sp)	*save current
	qmove.l	find_window_id(a5),active_window(a5)
	bsr.l	find_window
;	tst.w	d0
	bmi.s	  oops
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0
;	move.l	   0(a6),-(sp)
;	dc.w	_setport

	bsr	gp_paste	*d7 is size, scratch is text to paste	 
	qmove.l	(sp)+,a6
	qmove.l	0(a6),active_window(a5)
	bsr.l	find_window
;	tst.w	d0
	bmi.s	  oops
	qmove.l		(a6),d0
	OSSetPortWindowPort	  d0
;	move.l	   0(a6),-(sp)
;	dc.w	_setport

**now go round and find next		 	
	bra	next_search
oops:
**user has closed the window!
	addq.l	#8,sp	*tidy stackette
	bra.s	end_global
not_in_file:
	qmove.l	(sp)+,d7
;	qmove.l	search_scratch_1(a5),d0	
;	OSHUnlock	d0
;	dc.w	_hunlock
	qmove.l	search_scratch_1(a5),d0	
	OSDisposeHandle	d0
;	dc.w	_disposehandle

notr_text_file:
	clr.l	long_var1(a5)	 *line counter
	addq.l	#1,d7
	bra	read_global_loop
end_global1:
	save_all
	qmoveq	#1,d0
	OSSysBeep	d0
;	move.w	#1,-(sp)
;	dc.w	_sysbeep
	restore_all
end_global:
	qmove.l	a6,-(sp)	*save current
	qmove.l	find_window_id(a5),active_window(a5)
	bsr.l	find_window
	bmi.s	fquit
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0
;	move.l	0(a6),-(sp)
;	dc.w	_setport
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	bsr.l	redraw_all_scroll	draw all according to scroll bars

	tst.l	total_number_of_finds(a5)
	bne	got_some
	clr.b	doing_a_global_search(a5)	*so we can close the window
	qmove.l	find_window_id(a5),active_window(a5)
	bsr.l	close_it
;	tst.b	doin_global(a5)
;	bne.s	fquit	 *dont sound
	qmove.w	#131,d0
	bsr	run_sound1
;	qmove.l	#4,d0
;	bsr.l	play_a_sound
fquit:
	qmove.l	(sp)+,a6
	OSFrontWindow	d0
	qmove.l	d0,active_window(a5)
;	clr.l	-(sp)
;	dc.w	_frontwindow
;	move.l	(sp)+,active_window(a5)
	bsr.l	find_window
	bmi.s	bye
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0
;	move.l	0(a6),-(sp)
;	dc.w	_setport
bye:
;	bsr	led_off
	clr.b	global_in_progress(a5)
	rts
got_some:	 
	qmove.l	(sp)+,a6
	OSFrontWindow	d0
	qmove.l	d0,active_window(a5)

;	clr.l	-(sp)
;	dc.w	_frontwindow
;	move.l	(sp)+,active_window(a5)

	bsr.l	find_window
	bmi.s	no_docw
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0

;	move.l	(a6),-(sp)
;	dc.w	_setport
	bsr.l	delete_caret
no_docw:
	qmove.l	find_window_id(a5),active_window(a5)
	bsr.l	find_window
**Print total number of finds
	lea	search_end_find(pc),a0
	clr.l	(a0)
	clr.l	4(a0)		*Clear out upto 10 digits
	clr.w	8(a0)
	qmove.l	total_number_of_finds(a5),d6	*start from line 1
	qmoveq	#0,d1
	bsr	printnum_mem		*print number of finds in window title - length of string in d1
	add.b	#22,d1		*basic length of string plus length of number string
	lea	search_end(pc),a0
	qmove.b	d1,(a0)	
	qmove.l	(a6),d0
	OSSetWTitle	d0,a0	
;	move.l	 0(a6),-(sp)
;	move.l	a0,-(sp)
;	dc.w	_setWtitle

;	move.l	0(a6),-(Sp)
;	dc.w	_bringtofront
	qmove.l	(a6),d0
	OSSelectWindow	d0
;	move.l	0(a6),-(Sp)
;	dc.w	_selectwindow

;	move.l	0(a6),-(sp)
;	 dc.w	 _setport
	OSFrontWindow	d0
	qmove.l	d0,active_window(a5)
;	clr.l	-(sp)
;	dc.w	_frontwindow
;	move.l	(sp)+,active_window(a5)
	bsr.l	find_window
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0
;	move.l	0(a6),-(sp)
;	dc.w	_setport
;	bsr	led_off
	clr.b	global_in_progress(a5)
	rts
find_failed1:
;	bsr	led_off	
	qmove.l	#137,d0
	bsr.l	do_alert
	clr.b	global_in_progress(a5)

	rts
find_failed2:
;	bsr	led_off
	qmove.l	#139,d0
	bsr.l	do_alert
	clr.b	global_in_progress(a5)
	clr.b	doing_a_global_search(a5)
	qmove.l	textmenu(a5),d0
	qmoveq	#9,d1
	OSEnableMenuItem	d0,d1
;	move.l	   textmenu(a5),-(sp)
;	move.w	   #9,-(sp)
;	dc.w	_enableitem

	qmove.l	textmenu(a5),d0
	qmoveq	#10,d1
	OSEnableMenuItem	d0,d1
;	move.l	   textmenu(a5),-(sp)
;	move.w	   #10,-(sp)
;	dc.w	_enableitem

	bra	oops
**Display current serach file name in search window title	
show_filename:
	save_all
	qmove.l	a6,-(sp)	*save current
	qmove.l	find_window_id(a5),active_window(a5)
	bsr.l	find_window
	bmi	oops1
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0

;	move.l	   0(a6),-(sp)
;	dc.w	_setport
**Copy fname to searching string
	lea	fname(pc),a0
	lea	searching(pc),a1
	qmove.b	#12,(a1)	*initial length of string
;	clr.l	d0
	qcmove.b	(a0)+,d0
	add.b	d0,(a1)	*add pascal string length
	lea	13(a1),a1
	subq.l	#1,d0
	ble.s	short_filename!
copy_name1:
	qmove.b	(a0)+,(a1)+
	qdbra	d0,copy_name1
short_filename!:
	lea	searching(pc),a1
	qmove.l	(a6),d0
	OSSetWTitle	d0,a1
;	move.l	0(a6),-(sp)
;	pea	searching(pc)
;	dc.w	_setWtitle		*Set new name	
	qmove.l	(sp)+,a6
	qmove.l	0(a6),active_window(a5)
	bsr.l	find_window	*back to current window
	bmi.s	oops2
	qmove.l	(a6),d0
	OSSetPortWindowPort	  d0

;	move.l	0(a6),-(sp)
;	dc.w	_setport
	restore_all
	rts
oops1:	move.l	(sp)+,a6
oops2:	restore_all
	rts_	"show_filename"
***************************GLOBAL HYPER SEARCH 68K******************************

global_hyper_search_68k:
	qmove.l	busy_curs_h(a5),d0
	OSSetCCursor	d0
;	move.l	busy_curs_h(a5),-(sp)
;	dc.w	_setCcursor
;	bsr	led_on		*switch background led on
********************************************************************
**Search all files in this files project!
;	tst.l	proj_buffer_h(a5)
	
	qmoveq	#0,d7	*file_counter
	
	clr.l	total_number_of_finds(a5)	*how many occurences
	bsr.l	find_window	*set up a6 with current window
**Find this files project
	move.l	proj_buffer_h(a5),add_file_name(a5)	*save current
	beq	wot_project100
	lea	w_from_project(a6),a0	*PRoject filename
	cmpi.l	#0,(a0)
	beq	wot_project100
	push	a6
	move.l	windows_records_h(a5),a6
	move.l	(a6),a6

**Find window that matches names
	qmove.l	#number_of_windows-1,d1
fw_1:	lea	w_fsspec+6(a6),a1
;	clr.l	d0
	qcmove.b	(a1),d0
	addq.l	#1,d0
	push	a0	*Save name we're looking for
	qbsr.l	strncmp
	pop	a0
	tst.l	d0
	beq.s	got_window_rec
	lea	w_rec_size(a6),a6	*next window_rec
	qdbra	d1,fw_1
fw_failed:
	pop	a6
	bra	end_globalhp
got_window_rec:

	lea	w_fsspec+6(a6),a1	 
	qmove.l	w_proj_ref(a6),proj_buffer_h(a5)
	tst.l	proj_buffer_h(a5)
	bne.s	no_dbg
	debug
no_dbg:
	pop	a6	*restore original wref
	qmove.l	proj_buffer_h(a5),d0
	OSHLock	d0
	qmoveq	#0,d7	*file index into project
read_global_loophp:
	qmove.l	#vhl_offset,d0
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1
	add.l	d0,a1	*Offset to pointer to file base
	add.l	(a1),a1

	qmove.l	d7,d1
	bsr.l	find_nth_proj	*Finds the d1 file, returns a1->file, d0=0=ok, -1=not found
	tst.w	d0
	bmi	end_globalhp	no more files
;	cmpi.l	#-1,(a1)
;	beq	end_globalhp
**Find file type, first resolve to fsspec

;	cmpi.l	#"obj ",this_file_type(a1)
;	beq	notr_text_filehp
;	cmpi.l	#"reso",this_file_type(a1)
;	beq	notr_text_filehp
;	cmpi.l	#"slib",this_file_type(a1)
;	beq	notr_text_filehp
;	cmpi.l	#"lib ",this_file_type(a1)
;	beq	notr_text_filehp



**Find file type, first resolve to fsspec
	qmove.l	this_file_type(a1),d0
	cmpi.l	#"src ",d0	*File types we can search
	beq	text_filehp

	cmpi.l	#"vhl ",d0
	beq	text_filehp
	cmpi.l	#"hl  ",d0
	beq	text_filehp
**headers
	cmpi.l	#"hlh ",d0
	beq	text_filehp
	cmpi.l	#"vhlh",d0
	beq	text_filehp
	cmpi.l	#"sinc",d0
	beq	text_filehp
	cmpi.l	#"glob",d0
	beq	text_filehp
**Quick get out when we hit object files
	cmpi.l	#"obj ",d0
	beq	end_globalhp
	bra	notr_text_filehp

text_filehp:
**Check file type (from it's icon ID)
	cmpi.w	#0x1100,this_file_options(a1)	*project file (icon 0x11)
	beq	notr_text_filehp	*Project file
	cmpi.w	#0x1000,this_file_options(a1)	*user folder (icon 0x10)
	beq	notr_text_filehp	*Project file


	lea	sizeof_file_entry(a1),a0
	qmove.l	a0,d0
	qmoveq	#0,d2
	qmove.w	4(a0),d2	*size of alias
	lea	scratch_1(a5),a1
	OSPtrToHand	d0,a1,d2
	move.l	scratch_1(a5),a0
;	dc.w	_PtrToHand
***************DEBUG CODE to examine src list
;	 push	 a0
;	 debug
;	 move.l	proj_buffer_h(a5),a0
;	 move.l	(a0),a0
;	 add.l	 #source_offset,a0
;	 add.l	 (a0),a0
;	 nop
;	 pop	 a0
************************
	push	a4
	clr.l	name_to_match(a5)
	bsr.l	my_resolve_handle_everything	*temp_string3=fsspec if found, error in d0
	pop	a4

	qmove.l	scratch_1(a5),d0
	OSDisposeHandle	d0
;	dc.w	_DisposeHandle
	lea	temp_string3(a5),a0
	save_volatile	*my fave macro :-)
	lea	temp_string4(a5),a1

	OSFSpGetFInfo	a0,a1,d0
;	clr.w	-(sp)
;	move.l	a0,-(sp)	*FSspec
;	pea	temp_string4(a5)	*return info here
;	moveq	#7,d0
;	dc.w	_highlevelFSdispatch	*FspGetFinfo
;	move.w	(sp)+,d0
	restore_volatile
	lea	temp_string4(a5),a0	*fndrinfo
	
	cmp.l	#"TEXT",(a0)	*Text file?
	bne	notr_text_filehp	*no
**now we have to get the size of the data fork
**open file
	lea	temp_string3(a5),a0
	lea	refnum(a5),a1
	qmoveq	#1,d1
qmflag:	set	0
	OSFSpOpenDF	a0,d1,a1,d0

	bmi	end_globalhp
**get size of file
	qbsr	get_temp_pb	a0->temp pb
	qmove.w	refnum(a5),24(a0)	refnum

	OSPBGetEOF	a0,d0

;	DC.W	_getEOF
	lea	temp_pb(a5),a0
	qmove.l	28(a0),d6	return size - phys end of data fork

	qmove.l	d7,-(sp)
	qmove.l	d6,d0
	OSNewHandleClear	d0,a0
;	dc.w	_newhandleclear
	move.l	a0,d0
	beq	find_failed2
	qmove.l	a0,search_scratch_1(a5)
	OSHLock	a0
;	dc.w	_hlock
	move.l	search_scratch_1(a5),a0
	move.l	(a0),a1		        *buffer for file
**Display file name in status line

	save_all
	lea	hl_name(pc),a1
	qmove.l	#64/4-1,d1
	qmove.l	#0,d0
clear_hlnamep:
	qmove.l	d0,(a1)+
	qdbra	d1,clear_hlnamep
	lea	phl_name(pc),a1
	lea	temp_string3+6(a5),a0	*->Filename
;	clr.l	d0
	qcmove.b	(a0),d0
	subq.l	#1,d0
	addq.l	#1,a0
	bmi.s	no_namep
copy_hlnamep:
	qmove.b	(a0)+,(a1)+
	qdbra	d0,copy_hlnamep
no_namep:
	clr.b	(a1)+		*c string
;	debug
	lea	phl_name_start(pc),a1
	bsr.l	draw_status_message
	restore_all

	qbsr	get_temp_pb	a0->temp pb
	qmove.w	refnum(a5),24(a0)	refnum
	lea	temp_pb(a5),a0

	save_all
	bsr	quick_read_already_open
	restore_all

	qmove.l	#-1,gsearch_pos(a5)
	clr.l	gsearch_found(a5)	 
	clr.l	long_var1(a5)	 *this is our line counter
next_searchhp:
	move.l	search_scratch_1(a5),a1
	move.l	(a1),a3		        *a1->text of file
	qmove.l	long_var1(a5),d5	
;	debug
	bsr	global_searches_h
	tst.w	d0
	bmi	not_in_filehp

	addq.l	#1,total_number_of_finds(a5)
	qmove.l	d5,long_var1(a5)	*save line counter	
**now we have to build the string to insert into the window
	lea	temp_string(a5),a1
	lea	temp_string3+6(a5),a2	*->Filename
**first copy fname(pc)
;	ext.l	d0
	qcmove.b	(a2)+,d0
	subq.l	#1,d0
copy_fnamehp:
	qmove.b	(a2)+,(a1)+
	qdbra	d0,copy_fnamehp	*Thats the file name
	qmove.l	#" Lin",(a1)+
	qmove.l	#"e = ",(a1)+	*"filename Line = "
	qmove.l	d5,d6
	addq.l	#1,d6	*start from line 1
	qmove.l	a1,a0
	bsr	printnum_mem		*"Filename at line xxxxx"
	qmove.l	a0,a1
	qmove.b	#".",(a1)+	  
	clr.b	(a1)+
;	qmove.l	search_scratch_1(a5),d0	*dispose of text	
;	OSHUnlock	d0
;	dc.w	_hunlock
	qmove.l	search_scratch_1(a5),d0	*dispose of text	
	OSDisposeHandle	d0
;	dc.w	_disposehandle
**copy fsspec to fs_temp
	lea	temp_string3(a5),a0
	lea	fs_temp(a5),a1
	qmove.l	#78,d2
	OSBlockMoveData	a0,a1,d2
;	dc.w	_Blockmove
**Now we have to open the window and goto line
	qmove.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	lea	temp_string(a5),a1
	lea	temp_string3(a5),a2
copy_to_tempp:
	move.b	(a1)+,(a2)+
	bne.s	copy_to_tempp
	lea	temp_string3(a5),a1
	qmove.b	#1,doing_project_search(a5)
	bsr.l	global_hyper_load
	clr.b	doing_project_search(a5)
	qmove.l	(sp)+,d7	*proj file index
	bra	got_someh
not_in_filehp:
	qmove.l	(sp)+,d7
;	qmove.l	search_scratch_1(a5),d0	
;	OSHUnlock	d0
;	dc.w	_hunlock
	qmove.l	search_scratch_1(a5),d0	
	OSDisposeHandle	d0
;	dc.w	_disposehandle

notr_text_filehp:
	clr.l	long_var1(a5)	 *line counter
	addq.l	#1,d7

	bra	read_global_loophp
end_globalhp:
	tst.b	doing_build(a5)
	bne.s	no_unlock1	*in case of searching whilst building!
	qmove.l	proj_buffer_h(a5),d0
	OSHUnlock	d0
no_unlock1:

********************************************************************
**Search all files in this files folder
wot_project100:	qmoveq	#1,d7	*file counter
	clr.l	total_number_of_finds(a5)	*how many occurences
	bsr.l	find_window	*set up a6 with current window
	bmi.s	  no_dirID
	lea	w_fsspec(a6),a0
	tst.l	2(a0)
	beq.s	no_dirID
	qmove.l	2(a0),current_parid(a5)	*make search folder same as windows dirid
	qmove.w	0(a0),current_vrefnum(a5)	*heee, a doddelle :-)
	
no_dirID:
	bsr	clear_pb
	lea	temp_pb(a5),a0
	qmove.w	current_vrefnum(a5),Ciovrefnum(a0)
	qmove.l	current_parid(a5),Ciodrdirid(a0)	dir id

	OSPBHSetVolSync	a0
;	dc.w	_Hsetvol	
read_global_looph:
;	save_all
;;	bsr.l	handle_comms
;	bsr.l	events
;	restore_all

	lea	temp_pb(a5),a0
	clr.l	Ciocompletion(a0)	no completion routine
	lea	fname(pc),a1
	qmove.l	a1,Cionameptr(a0)	point to filename
	clr.w	Ciovrefnum(a0)	vrefnum
	qmove.l	current_parid(a5),Ciodrdirid(a0)	dir id
;	 move.l	#0,ciodrdirid(a0)	  
	qmove.w	d7,Ciofdirindex(a0)	
	OSPBGetCatInfoSync	a0,d0
;	moveq	#9,d0
;	dc.w	_hfsdispatch	registered call
	tst.w	d0
	bmi	end_globalh	no more files
**We've now got the file info in temp_pb
	lea	temp_pb(a5),a0
	cmp.l	#"TEXT",32(a0)	*Text file?
	bne	notr_text_fileh	*no
	qmove.l	d7,-(sp)
	qmove.l	54(a0),d6	*add size of data fork
	qmove.l	a0,a3
**now we need to get a buffer on sys heap for file
	qmove.l	d6,d0
;	dc.w	_newhandlesysclear
;	dc.w	_newhandleclear
	OSNewHandleClear	d0,a0
	move.l	a0,d0
	beq	find_failed2
	qmove.l	a0,search_scratch_1(a5)
	OSHLock	a0
;	dc.w	_hlock
	qmove.l	search_scratch_1(a5),a0
	move.l	(a0),a1
**Display file name in status line

	save_all
	lea	hl_name(pc),a1
	qmoveq	#64/4-1,d1
	qmove.l	#0,d0
clear_hlname:
	qmove.l	d0,(a1)+
	qdbra	d1,clear_hlname
	lea	hl_name(pc),a1
	
	qmove.l	0x12(a3),a0	*->Filename
;	clr.l	d0
	qcmove.b	(a0),d0
	subq.l	#1,d0
	addq.l	#1,a0
	bmi.s	no_name
copy_hlname:
	qmove.b	(a0)+,(a1)+
	qdbra	d0,copy_hlname
no_name:
	qmove.b	#0,(a1)+		*c string
	lea	hl_name_start(pc),a1
	bsr.l	draw_status_message
	restore_all
	move.l	a3,a0	
	save_all
	bsr	quick_read
	restore_all

	qmove.l	#-1,gsearch_pos(a5)
	clr.l	gsearch_found(a5)	 
	clr.l	long_var1(a5)	 *this is our line counter
next_searchh:
	qmove.l	search_scratch_1(a5),a1

	qmove.l	(a1),a3		        *a1->text of file
	qmove.l	long_var1(a5),d5	
	bsr	global_searches_h
	tst.w	d0
	bmi	not_in_fileh

	addq.l	#1,total_number_of_finds(a5)
	qmove.l	d5,long_var1(a5)	*save line counter	
**now we have to build the string to insert into the window
	lea	temp_string(a5),a1
**first copy fname(pc)
	lea	fname(pc),a2
;	ext.l	d0
	qcmove.b	(a2)+,d0
	subq.l	#1,d0
copy_fnameh:
	qmove.b	(a2)+,(a1)+
	qdbra	d0,copy_fnameh	*Thats the file name
	qmove.l	#" Lin",(a1)+
	qmove.l	#"e = ",(a1)+	*"filename Line = "
	qmove.l	d5,d6
	addq.l	#1,d6	*start from line 1
	qmove.l	a1,a0
	bsr	printnum_mem		*"Filename at line xxxxx"
	qmove.l	a0,a1
	qmove.b	#".",(a1)+	  
	clr.b	(a1)+
;	qmove.l	search_scratch_1(a5),d0	
;	OSHUnlock	d0
;	dc.w	_hunlock
	qmove.l	search_scratch_1(a5),d0	
	OSDisposeHandle	d0
;	dc.w	_disposehandle

**Now we have to open the window and goto line
	qmove.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	lea	temp_string(a5),a1
	lea	temp_string3(a5),a2
copy_to_temp:
	move.b	(a1)+,(a2)+
	bne.s	copy_to_temp
	lea	temp_string3(a5),a1
	bsr.l	global_hyper_load
	qmove.l	(sp)+,d7
	bra.s	  got_someh
**Count length of string
	qmoveq	#-1,d7
	lea	temp_string(a5),a1
clsh:	 
	addq.l	#1,d7
	tst.b	(a1)+
	bne.s	clsh
**now paste into find window
	lea	temp_string(a5),a1
	qmove.l	a1,scratch_1(a5)
	bsr	gp_paste	*d7 is size, scratch is text to paste	 
**now go round and find next		 	
	bra	next_searchh
not_in_fileh:
	qmove.l	(sp)+,d7
;	move.l	search_scratch_1(a5),d0	
;	OSHUnlock	d0
;	dc.w	_hunlock
	qmove.l	search_scratch_1(a5),d0	
	OSDisposeHandle	d0
;	dc.w	_disposehandle

notr_text_fileh:
	clr.l	long_var1(a5)	 *line counter
	addq.l	#1,d7
	bra	read_global_looph
	
end_globalh:
	qmove.l	add_file_name(a5),proj_buffer_h(a5)	*restore old proj
;	bsr	led_off
	moveq	#-1,d0
	rts_	"Global_hyper"
got_someh:
	qmove.l	add_file_name(a5),proj_buffer_h(a5)	*restore old proj
;	bsr	led_off
	clr.l	d0	  
	rts
***************
**needs a0->pb
**      a1->buffer
**      d6=length
**assumes to file really does exist, and the pb is set up with vref etc
quick_read:
	save_all
;	qmoveq	#0,d0	*i/o
;	qmoveq	#1,d1	*on/off
;	qmoveq	#0,d2	*green
	bsr.l	message_green
	extern	message_green
	restore_all
	push	a1
	qmove.l	a0,a4	*copy PB
	clr.b	26(a0)	*permission
	qmove.b	#1,27(a0)	*read status
	clr.l	28(a0)	*use volume buffer
;	 move.w	#$1a,d0	*_PBHopenDFSync	
;	 dc.w	 _hfsdispatch
	OSPBHOpenDFSync	a0,d0
;	OSPBOpen	a0,d0
;	dc.w	_open
	pop	a1
	qmove.l	a4,a0	*restore
quick_read_already_open:
	qmove.l	a0,a4	*save
	qmove.l	a1,32(a0) *where the buffer is
	qmove.l	d6,36(a0)	*length of data
	clr.w	44(a0)	*????
	clr.l	46(a0)	*NO OFFSET
	OSPBRead	a0,d0
;	dc.w	_read
	qmove.l	a4,a0
	OSPBClose	a0,d0
;	dc.w	_close
	bsr.s	clear_pb
	save_all
;	qmove.l	#0,d0	*i/o
;	qmove.l	#0,d1	*on/off
;	bsr.l	io_led_drive
	bsr.l	message_off
	extern	message_off
	restore_all

	rts_	"Quick_read"
**clear pb
clear_pb:	lea	temp_pb(a5),a0
	qmove.l	#256/4-1,d0
clr_temp:	 clr.l	 (a0)+
	qdbra	d0,clr_temp
	rts_	"clear_pb"
gp_paste:	 
**scratch_1 -> text to paste
**d7 is paste size
**a6->window
**this is new_tepaste
;paste_size:	reg	d7
;	 move.l	a1,-(sp)
;	 bsr	 find_window
;	 move.l	(sp)+,a1
	qmove.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	qmove.l	ed_telength(a0),d6	telength
	add.l	d7,d6		        *New te length
**********check size of text handle
	qmove.l	te_handle_ptr(a6),a0
	qmove.l	ed_htext(a0),a0	handle to text buffer
	OSGetHandleSize	a0,d0
;	dc.w	_gethandlesize	in d0
	sub.l	#1000,d0		1k slop
	cmp.l	d0,d6
	blt.s	te_has_space
	qmove.l	d6,d1	new handle size
	add.l	#5000,d1	+5k slop
	OSSetHandleSize	a0,d1
;	dc.w	_sethandlesize
	OSGetMemErr	d0
	bmi.s	te_space_err
	move.l	a0,d0
	bne.s	te_has_space	double check
te_space_err:
	lea	te_no_space(pc),a0
	qmove.l	#1000,d0
	qmoveq	#40,d1	x
	qmoveq	#90,d2	y
	bsr.l	do_new_alert_3d
	bra	error
te_has_space:
	qmove.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0

	move.l	ed_htext(a0),a1
	move.l	(a1),a3
	
	add.l	ed_selpoint(a0),a3	insertion point in text
**length to be copied is te_length-insert point
	qmove.l	ed_telength(a0),d3
	sub.l	ed_selpoint(a0),d3
**copy from end to end+paste_size
	add.l	ed_telength(a0),a1	a1->end oftext
;	addq.l	#1,a1		for pre dec
	move.l	a1,a2		        a2->end of text

	add.l	d7,a2	a2->new end of text
	tst.l	d3
	beq.s	at_very_end_of_text
copy_down:	move.b	-(a1),-(a2)
	subq.l	#1,d3
	bne.s	copy_down	
at_very_end_of_text:

	qmove.l	scratch_1(a5),a2	*text to paste
insert:	qmove.b	(a2),(a3)
	subq.l	#1,d7
	addq.l	#1,a2
	addq.l	#1,a3
	bne.s	insert
	
	qmove.b	#-1,dirty(a6)

**now see if line array is big enough
calc_lines_size:
	move.l	te_handle(a6),a0
	move.l	(a0),a0	a0->te_rec

	qmove.l	ed_linestarts(a0),a0
	OSGetHandleSize	a0,d0
;	dc.w	_gethandlesize
	lsr.l	#2,d0	/4
	qmove.l	d0,d7	save max number of lines
	sub.l	#400,d7	400 lines buffer	
	bsr.l	count_lines	returns number of lines in d0
	add.w	ed_nlines(a0),d0	*FUCK IT!!!!!!!!!!!!!!!!!!!!!
	cmp.l	d0,d7
	bgt.s	lines_ok
	add.l	#100,d0
	lsl.l	#4,d0	times four for bytes
	move.l	te_handle(a6),a0
	move.l	(a0),a0	a0->te_rec
	move.l	ed_linestarts(a0),a0
	qmove.l	d0,d1
	OSSetHandleSize	a0,d1
;	dc.w	_sethandlesize
	OSGetMemErr	d0
;	tst.w	
qmflag:	set	0
	bmi	te_space_err
lines_ok:
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0
	qmove.l	d6,ed_telength(a0)	new length of text
	qmove.l	d6,ed_selpoint(a0)
	
	qmove.l	te_handle(a6),-(sp)	
	bsr.l	new_tecaltext
standard_move:
;	 move.l	te_handle(a6),a0
;	 move.l	(a0),a0
;	 bsr	 redraw_all_scroll	 draw all according to scroll bars
error:
	rts_	"Gp_paste"

**************************GLobal searches*****************************
**NEED:
**a3 ->text
**gsearch_pos(a5) is position of search in text
**Gsearch_found(a5) is position of string in text
**Returns d0=-1 nont found, else zero.
global_searches:
not_wordsg:
	qmove.l	gsearch_pos(a5),d7	*current sel point.
**V1.2 removes following line
	addq.l	#1,d7	*Because we will find the same item every time...
	btst	#1,prefs_flags(a5)
	beq	do_insensitive2g
**Check for sensitive word search
	btst	#3,prefs_flags(a5)
	bne	try_next_word_sen_word_g
*****************************sensitive gen search*************************
try_next_word2g:
	lea	find_string(a5),a2
	move.l	a3,a1	*start of text
	add.l	d7,a1	*->insert point
	qmove.l	d7,d6	*save start of word in case its found
	qcmove.b	1(a2),d1	*first char
search_for_first2g:
	tst.b	(a1)
	beq	deff_not_foundg	*EOF
	qcmove.b	(a1),d0	*get char
	cmpi.l	#13,d0
	addq.l	#1,a1
;	beq.s	got_cr_c
;	cmpi.l	#10,d0		*160 mod
	bne.s	not_cr_c
got_cr_c:
	addq.l	#1,d5	inc line counter
not_cr_c:
**if a tab, then ignore rest of space run
	
	cmpi.b	#9,d0
	bne.s	not_t2
	clr.l	d2
st2:
	move.b	(a1),d2
	beq	deff_not_foundg	*EOF
	
	cmpi.l	#9,d2
	beq.s	gt2
	cmpi.l	#32,d2
	beq.s	gt2
	bra.s	not_t2
gt2:
	add.l	#1,d7
	addq.l	#1,a1
	bra.s	st2
not_t2:
	addq.l	#1,d7
	cmp.b	d0,d1
	bne.s	search_for_first2g
;	clr.l	d2
	qcmove.b	0(a2),d2	count

	qmove.l	d7,d6
	subq.l	#1,d6
	subq.l	#2,d2
	blt	got_matchg	 *1 byte search string!
check_rest_of_word2g:

	addq.l	#2,a2
crw_loop2g:	qcmove.b	(a1),d0
	cmp.b	(a2)+,d0
	addq.l	#1,a1
	bne.s	try_next_word2g
	qdbra	d2,crw_loop2g
	bra	got_matchg	 
	rts_	"Sens_gen_search"

**Sensitive global word search
try_next_word_sen_word_g:
	lea	find_string(a5),a2
	move.l	a3,a1	*start of text
	add.l	d7,a1	*->insert point
	qmove.l	d7,d6	*save start of word in case its found
	qcmove.b	1(a2),d1	*first char
search_for_first2gw:
	tst.b	(a1)
	beq	deff_not_foundg	*EOF
	qcmove.b	(a1),d0	*get char
	cmpi.l	#13,d0
	addq.l	#1,a1
;	beq.s	got_cr_Cw
;	cmpi.l	#10,d0		*160 mod
	bne.s	not_cr_Cw
got_cr_Cw:
	addq.l	#1,d5	inc line counter
not_cr_Cw:

	addq.l	#1,d7	
	cmp.b	d0,d1
	bne.s	search_for_first2gw
;	clr.l	d2
	qcmove.b	0(a2),d2	count

	qmove.l	d7,d6
	subq.l	#1,d6
	subq.l	#2,d2
	blt	got_matchg	 *1 byte search string!
check_rest_of_word2gw:

	addq.l	#2,a2
crw_loop2gw:	move.b	(a1),d0

	cmp.b	(a2)+,d0
	addq.l	#1,a1
	bne	try_next_word_sen_word_g
	qdbra	d2,crw_loop2gw
**Check end of word is a space, a tab or a CR
;	debug
	qcmove.b	(a1),d0
	cmpi.l	#32,d0
	beq	got_matchg
	cmpi.l	#13,d0
	beq	got_matchg
	cmpi.l	#10,d0
	beq	got_matchg
	cmpi.l	#9,d0
	beq	got_matchg
	cmpi.l	#".",d0
	beq	got_matchg
	cmpi.l	#":",d0
	beq	got_matchg
	cmpi.l	#0x2c,d0
	beq	got_matchg
	cmpi.l	#")",d0
	beq	got_matchg
	cmpi.l	#"(",d0
	beq	got_matchg

	bra	try_next_word_sen_word_g	
	rts_	"Sens_gen_search_word"

***********************Insensitive general search***************************
****Word
**Sensitive global word search
**Enters from below after find string has been capitalised
try_next_word_wgi:
	lea	temp_string2(a5),a2
	move.l	a3,a1	*start of text
	add.l	d7,a1	*->insert point
	qmove.l	d7,d6	*save start of word in case its found
	qcmove.b	1(a2),d1	*first char
search_for_first2gwi:
	tst.b	(a1)
	beq	deff_not_foundg	*EOF
	qcmove.b	(a1),d0	*get char
	cmpi.b	#13,d0
	addq.l	#1,a1
;	beq.s	got_cr_Cwi
;	cmpi.b	#10,d0		*160 mod
	bne.s	not_cr_Cwi
got_cr_Cwi:
	addq.l	#1,d5	inc line counter
not_cr_Cwi:
**to upper pasted in
	ext.w	d0
**if a tab, then ignore rest of space run
	cmpi.b	#9,d0
	bne.s	not_t4
st4:	move.b	(a1),d2
	beq	deff_not_foundg	*EOF
	
	cmpi.b	#9,d2
	beq.s	gt4
	cmpi.b	#32,d2
	beq.s	gt4
	bra.s	not_t4
gt4:
	add.l	#1,d7
	addq.l	#1,a1
	bra.s	st4
not_t4:

	cmpi.w	#"a",d0
	blt.s	not_lowerwgi
	cmpi.w	#"z",d0
	bgt.s	not_lowerwgi
	sub.w	#$20,d0	make upper
not_lowerwgi:

	addq.l	#1,d7	
	cmp.b	d0,d1
	bne.s	try_next_word_wgi
;	clr.l	d2
	qcmove.b	0(a2),d2	count
	qmove.l	d7,d6
	subq.l	#1,d6
	subq.l	#2,d2
	blt	got_matchg	 *1 byte search string!
check_rest_of_word2gwi:

	addq.l	#2,a2
crw_loop2gwi:	qcmove.b	(a1),d0
;	ext.w	d0
	cmpi.l	#"a",d0
	addq.l	#1,a1
	blt.s	not_lower1wgi
	cmpi.l	#"z",d0
	bgt.s	not_lower1wgi
	sub.l	#$20,d0	make upper
not_lower1wgi:
	cmp.b	(a2)+,d0
	bne	try_next_word_wgi
	qdbra	d2,crw_loop2gwi
**Check end of word is a space, a tab or a CR
;	debug
	qcmove.b	(a1),d0
	cmpi.b	#32,d0
	beq	got_matchg
	cmpi.b	#13,d0
	beq	got_matchg
	cmpi.b	#10,d0
	beq	got_matchg
	cmpi.b	#9,d0
	beq	got_matchg
	cmpi.b	#".",d0
	beq	got_matchg
	cmpi.b	#":",d0
	beq	got_matchg
	cmpi.b	#0x2c,d0
	beq	got_matchg
	cmpi.b	#")",d0
	beq	got_matchg
	cmpi.b	#"(",d0
	beq	got_matchg

	bra	try_next_word_wgi	 
	rts_	"Gen_search_word"

****not word
**WIll add crs to d5!
do_insensitive2g:
	lea	find_string(a5),a1
	lea	temp_string2(a5),a2
;	clr.l	d6
	qcmove.b	(a1)+,d6
	qmove.b	d6,(a2)+		*copy length

	subq.l	#1,d6
make_upper2g:	 qcmove.b	(a1)+,d0
	qbsr.l	toupper
	qmove.b	d0,(a2)+
	qdbra	d6,make_upper2g	*Upper case now in temp_string2 as pascal
	qmove.l	gsearch_pos(a5),d7	*current sel point.
	addq.l	#1,d7	*Because we will find the same item every time...
	btst	#3,prefs_flags(a5)
	bne	try_next_word_wgi	*sensitive global word search


try_next_word2ig:
	lea	temp_string2(a5),a2
	move.l	a3,a1	*start of text
	add.l	d7,a1	*->insert point
;	move.l	d7,d6	*save start of word in case its found
	qcmove.b	1(a2),d1	*first char
search_for_firstg:
	tst.b	(a1)
	beq.s	  deff_not_foundg	  *EOF
	qcmove.b	(a1),d0	*get char
	cmpi.b	#13,d0
	addq.l	#1,a1
;	beq.s	got_cr_i
;	cmpi.b	#10,d0
	bne.s	not_cr_i
got_cr_i:
	addq.l	#1,d5	inc line counter
not_cr_i:
	addq.l	#1,d7
**to upper pasted in
	ext.w	d0

	cmpi.w	#"a",d0
	blt.s	not_lower
	cmpi.w	#"z",d0
	bgt.s	not_lower
	sub.w	#$20,d0	make upper
not_lower:
	cmp.b	d0,d1
	bne.s	search_for_firstg
;	clr.l	d2
	qcmove.b	0(a2),d2	count
	qmove.l	d7,d6
	subq.l	#1,d6
	subq.l	#2,d2
	blt.s	  got_matchg	*1 byte search string!
check_rest_of_wordg:
	addq.l	#2,a2
crw_loopg:	 qcmove.b	(a1),d0
;	ext.w	d0
	cmpi.l	#"a",d0
	addq.l	#1,a1
	blt.s	not_lower1
	cmpi.l	#"z",d0
	bgt.s	not_lower1
	sub.l	#$20,d0	make upper
not_lower1:
	cmp.b	(a2)+,d0
	bne.s	try_next_word2ig
	qdbra	d2,crw_loopg	

got_matchg:	qmove.l	d6,gsearch_pos(a5)
	qmove.l	d6,gsearch_found(a5)
	clr.l	d0
	rts		*line count in d5?
	
not_foundg:
deff_not_foundg:
	moveq	#-1,d0
	rts_	"Global_search"


**************************GLobal searches hyperlinking 68k*****************************
**NEED:
**a3 ->text
**gsearch_pos(a5) is position of search in text
**Gsearch_found(a5) is position of string in text
**Returns d0=-1 nont found, else zero.
global_searches_h:
not_wordsgh:
do_insensitive2gh:
	qmove.l	gsearch_pos(a5),d7	*current sel point.
**v1.2 removes following line
	addq.l	#1,d7	*Because we will find the same item every time...
try_next_word2igh:
	lea	temp_string2(a5),a2
	move.l	a3,a1	*start of text
	add.l	d7,a1	*->insert point
;	move.l	d7,d6	*save start of word in case its found
	qcmove.b	1(a2),d1	*first char
search_for_firstgh:
	tst.b	(a1)
	beq.s	  deff_not_foundgh	   *EOF
	qcmove.b	(a1),d0	*get char
	cmpi.l	#13,d0
	addq.l	#1,a1
	bne.s	not_cr_ih
	addq.l	#1,d5	inc line counter
not_cr_ih:
	addq.l	#1,d7
	qbsr.l	toupper
	cmp.b	d0,d1
	bne.s	search_for_firstgh
;	clr.l	d2
	qcmove.b	0(a2),d2	count
	qmove.l	d7,d6
	subq.l	#1,d6
	subq.l	#2,d2
	blt.s	  got_matchgh	  *1 byte search string!
check_rest_of_wordgh:
	addq.l	#2,a2
crw_loopgh:	
;	clr.l	d0
	qcmove.b	(a1)+,d0
	qbsr.l	toupper
	cmp.b	(a2)+,d0
	bne.s	try_next_word2igh
	qdbra	d2,crw_loopgh
	
	cmpi.b	#":",(a1)	*Check it really is a label
	beq.s	  got_matchgh	
	cmpi.b	#" ",(a1)
	beq.s	  got_matchgh
	cmpi.b	#9,(a1)
	beq.s	  got_matchgh
	cmpi.b	#13,(a1)
	beq.s	  got_matchgh
	tst.b	(a1)
	beq.s	  got_matchgh	 
	bra.s	  try_next_word2igh
got_matchgh:
**Check for caret being on cr

	qmove.l	d6,gsearch_pos(a5)
	qmove.l	d6,gsearch_found(a5)
	clr.l	d0
	rts		*line count in d5?
	
not_foundgh:
deff_not_foundgh:
	moveq	#-1,d0
	rts_	"Global_searchH"

************************LOCAL SEARCHES********************************
local_search_again:
	tst.b	find_string(a5)
	bne.s	str_ok1
	rts
str_ok1:
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0	*handle to te rec
	qmove.l	ed_selpoint(a0),d7	*current sel point.

	addq.l	#1,d7	*Because we will find the same item every time...
	btst	#3,prefs_flags(a5)
	beq	not_words_again		*not a word search

	bra.s	do_local
	
local_search:
	tst.b	find_string(a5)
	bne.s	str_ok
	rts
str_ok:	btst	#3,prefs_flags(a5)
	beq	not_words		*not a word search


	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0	*handle to te rec
	qmove.l	ed_selpoint(a0),d7	*current sel point.

*v1.2 removes following line because cursor is moved to end of search string
;	addq.l	#1,d7	*Because we will find the same item every time...
do_local:
	btst	#1,prefs_flags(a5)
	beq.s	do_insensitive_word

*****************************Sensitive word search********************
	move.l	ed_htext(a0),a1
	move.l	(a1),a3		        *->text
	
try_next_word:
	move.l	a3,a1	*start of text
	add.l	d7,a1	*->insert point
	qmove.l	d7,d6	*save start of word in case its found
	bsr	getword	*in tempstring1(a5)
	tst.w	d0
	bmi	not_found	*EOF
	cmpi.b	#" ",temp_string(a5)
	beq.s	try_next_word	*for space runs
	
	qmove.l	a0,-(sp)
	lea	find_string(a5),a0
	lea	temp_string(a5),a1
;	clr.l	d0
	qcmove.b	(a0),d0	*Get byte count from find string
	cmp.w	d0,d5
	addq.l	#1,a0
	bne.s	nope1
;	addq.l	#1,a1	*skip pascal byte count
	qbsr.l	strncmp
nope1:
	qmove.l	(sp)+,a0
	tst.l	d0
	bne.s	try_next_word
	bra.s	got_match

**************************Insensitive word search**************************
**here we make everything upper case
**we copy find_string to temp_string2
do_insensitive_word:

	lea	find_string(a5),a1
	lea	temp_string2(a5),a2
;	clr.l	d6
	qcmove.b	(a1)+,d6
	qmove.b	d6,(a2)+		*copy length

	subq.l	#1,d6
make_upper:	qcmove.b	(a1)+,d0
	qbsr.l	toupper
	qmove.b	d0,(a2)+
	qdbra	d6,make_upper

	move.l	ed_htext(a0),a1
	move.l	(a1),a3		        *->text
	
do_insensitive_loop:
	move.l	a3,a1
	add.l	d7,a1	*->insert point
	qmove.l	d7,d6	*save start of word in case its found
	bsr	getwordupper	*in tempstring1(a5)
	tst.l	d0
	bmi	not_found	*EOF
	cmpi.b	#" ",temp_string(a5)
	beq.s	do_insensitive_loop	*for space runs
 
	qmove.l	a0,-(sp)
	lea	temp_string2(a5),a0
	lea	temp_string(a5),a1
;	clr.l	d0
	qcmove.b	(a0),d0	*Get byte count from find string
	cmp.w	d0,d5
	addq.l	#1,a0
	bne.s	nope
;	addq.l	#1,a1	*skip pascal byte count
	qbsr.l	strncmp
nope:
	qmove.l	(sp)+,a0
	tst.l	d0
	bne.s	do_insensitive_loop

	
got_match:
	move.l	ed_htext(a0),a1
	move.l	(a1),a3		        *->text
**LXT change
	qpush1	a3
	add.l	d6,a3
	qcmove.b	(a3),d0
	qpop1	a3
**end change

;	move.b	0(a3,d6.l),d0
	cmpi.b	#13,d0
	bne.s	no_inc
	addq.w	#1,d6		*So caret isn't in front of cr!
no_inc:
;	save_all
;	 bsr	 delete_caret_during_hyper
;	 restore_all
**Are we in the middle of a tab?
**LXT change
	qpush1	a3
	add.l	d6,a3
	qcmove.b	(a3),d0
	qpop1	a3
**end change

;	move.b	0(a3,d6.l),d0
	cmpi.b	#32,d0
	bne.s	not_in_tab
**Check for in tab
	move.l	d6,d0	*current pos
	beq.s	not_in_tab
check_in_tab:	subq.l	#1,d0
	bmi.s	not_in_tab
**LXT change
	qpush1	a3
	add.l	d0,a3
	qcmove.b	(a3),d1
	qpop1	a3
**end change

;	move.b	0(a3,d0.l),d1
	cmpi.b	#9,d1
	beq.s	got_tab
	cmpi.b	#32,d1
	beq.s	check_in_tab
	bra.s	not_in_tab
got_tab:
	qmove.l	d0,d6
not_in_tab:
	qmove.l	d6,ed_selpoint(a0)
	qmove.l	d6,ed_selstart(a0)
	qmove.l	d6,ed_selend(a0)
**1.6 change - hilite found word
	qmove.l	d6,d2	*do double needs selpoint in d2
	qmove.l	a0,-(sp)
	bsr	highlight_to_end
	qmove.l	(sp)+,a0
	btst	#6,prefs_flags2(a5)	*doing search all?
	bne.s	search_all
;	move.l	a0,-(sp)
;	pea	ed_viewrect(a0)
;	dc.w	_invalrect
;	move.l	(sp)+,a0

	bsr	do_auto_scroll
	lea	find_ok(pc),a1
	bsr.l	dsm
;	move.w	#message_delay,message_delay_counter(a5)
	clr.l	d0
	rts
search_all:
	qmove.l	occurence(a5),d6
	lea	find_all_numb(pc),a0
	bsr	printnum_mem	*in debug
	clr.b	(a0)
	lea	find_all(pc),a1
	bsr.l	dsm
;	move.w	#message_delay,message_delay_counter(a5)
	clr.l	d0
	rts
	
not_found:
deff_not_found:
	btst	#6,prefs_flags2(a5)	*doing search all?
	bne.s	search_all_end

	tst.b	doin_global(a5)
	bne.s	dont_sound	 	 
;	lea	search_failed(pc),a0
;	bsr.l	simple_speak

	lea	Find_failed(pc),a1
	bsr.l	draw_status_message
	qmove.w	#message_delay,message_delay_counter(a5)

	qmove.w	#131,d0
	bsr	run_sound1
	
;	qmove.l	#4,d0
;	bsr.l	play_a_sound
;	lea	not_found_text(pc),a0
;	qmove.l	#999,d0	*ok box
	bsr.l	not_found_alert
	extern not_found_alert
	moveq	#-1,d0
	rts
dont_sound:
	lea	linking(pc),a1
	bsr.l	draw_status_message
search_all_end:
	qmove.w	#message_delay,message_delay_counter(a5)
	moveq	#-1,d0
	rts_	"Local_search"
highlight_to_end:
	move.l	ed_htext(a0),a2
	move.l	(a2),a2	*text
	qmove.l	d2,d0	*start sel
**make sure we'ere not on a space or tAb!
**LXT change
	qpush1	a2
	add.l	d0,a2
	qcmove.b	(a2),d3
	qpop1	a2
**end change

;	move.b	0(a2,d0.l),d3
	cmpi.b	#32,d3
	beq	dc_end
	cmpi.b	#9,d3
	beq	dc_end
	cmpi.b	#13,d3
	beq	dc_end	*Not on cr!

;	addq.l	#1,d0
	qmove.l	d0,ed_selstart(a0)	*store start sel
	qmove.l	d0,ed_selpoint(a0)	*initially at the start of the word
	qmove.l	d0,ed_selend(a0)
	qmove.l	d0,old_start(a5)
	qmove.l	d0,scratch(a5)
**now find end of slection
	qmove.l	ed_telength(a0),d4	*eof!
find_end:
**LXT change
	qpush1	a2
	add.l	d2,a2
	qcmove.b	(a2),d3
	qpop1	a2
**end change

;	move.b	0(a2,d2.l),d3
	tst.l	d3
	beq	got_end
	cmpi.l	#13,d3
	beq	got_end
	cmpi.l	#9,d3
	beq	got_end
	cmpi.l	#32,d3
	beq	got_end
	cmpi.l	#"(",d3
	beq.s	got_end
	cmpi.l	#")",d3
	beq.s	got_end
	cmpi.l	#"*",d3
	beq.s	got_end
	cmpi.l	#"/",d3
	beq.s	got_end
	cmpi.l	#"+",d3
	beq.s	got_end
	cmpi.l	#"-",d3
	beq.s	got_end
	cmpi.l	#0x2c,d3
	beq.s	got_end
	cmpi.l	#";",d3
	beq.s	got_end
	cmpi.l	#0x22,d3
	beq.s	got_end
	cmpi.l	#"{",d3
	beq.s	got_end
	cmpi.l	#"}",d3
	beq.s	got_end
	cmpi.l	#":",d3
	beq.s	got_end
	cmpi.l	#".",d3
	beq.s	got_end
	cmpi.l	#"!",d3
	beq.s	got_end
	cmpi.l	#"?",d3
	beq.s	got_end
	
	cmp.l	d2,d4
	beq.s	got_end
	addq.l	#1,d2
	bra	find_end	
got_end:
	qmove.l	d2,ed_selend(a0)
;	bsr	colour_selection
	save_all
	bsr.l	calculate_cursor_xy
	qmove.l	ed_selstart(a0),d0
	qmove.l	ed_selend(a0),d1
	bsr	do_hilite
	restore_all
	qmove.l	scratch(a5),old_start(a5)
dc_end:
	rts_	"Highlight_to_end"
****************************************************
**We try the long search, which is get word, then compare first
**chars until either length of string is < length of find_string or 
**we get match.
not_words:	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0	*handle to te rec
	qmove.l	ed_selpoint(a0),d7	*current sel point.
**V1.2 removes the following line because we will be at end of previous search string
;	addq.l	#1,d7	*Because we will find the same item every time...
not_words_again:
	btst	#1,prefs_flags(a5)
	beq.s	do_insensitive2
*****************************sensitive gen search*************************

	move.l	ed_htext(a0),a1
	move.l	(a1),a3		        *->text
try_next_word2:
	lea	find_string(a5),a2
	move.l	a3,a1	*start of text
	add.l	d7,a1	*->insert point
	qmove.l	d7,d6	*save start of word in case its found
	qcmove.b	1(a2),d1	*first char
search_for_first2:
	tst.b	(a1)
	beq	deff_not_found	*EOF
	qcmove.b	(a1),d0	*get char
**if a tab, then ignore rest of space run
	cmpi.l	#9,d0
	addq.l	#1,a1
	bne.s	not_t3
st3:	qmoveq	#0,d2
	move.b	(a1),d2
	beq	deff_not_found	*EOF
	
	cmpi.l	#9,d2
	beq.s	gt3
	cmpi.l	#32,d2
	beq.s	gt3
	bra.s	not_t3
gt3:
	add.l	#1,d7
	addq.l	#1,a1
	bra.s	st3
not_t3:

	addq.l	#1,d7
	cmp.b	d0,d1
	bne.s	search_for_first2
;	clr.l	d2
	qcmove.b	0(a2),d2	count
	qmove.l	d7,d6
	subq.l	#1,d6

	subq.l	#2,d2
	blt	got_match	*1 byte search string!
check_rest_of_word2:
	addq.l	#2,a2
crw_loop2:	qcmove.b	(a1),d0
	cmp.b	(a2)+,d0
	addq.l	#1,a1
	bne.s	try_next_word2
	qdbra	d2,crw_loop2
	bra	got_match	
	

***********************Insensitive g3eneral search***************************
do_insensitive2:
	lea	find_string(a5),a1
	lea	temp_string2(a5),a2
;	clr.l	d6
	qcmove.b	(a1)+,d6
	qmove.b	d6,(a2)+		*copy length
	subq.w	#1,d6
make_upper2:	qcmove.b	(a1)+,d0
	qbsr.l	toupper
	qmove.b	d0,(a2)+
	qdbra	d6,make_upper2	*Upper case now in temp_string2 as pascal

;	move.l	te_handle(a6),a0
;	move.l	(a0),a0	*handle to te rec
;	move.l	ed_selpoint(a0),d7	*current sel point.
**V1.2 removes following line
;	addq.l	#1,d7	*Because we will find the same item every time...
	
	move.l	ed_htext(a0),a1
	move.l	(a1),a3		        *->text
try_next_word2i:
	lea	temp_string2(a5),a2
	qmove.l	a3,a1	*start of text
	add.l	d7,a1	*->insert point
;	move.l	d7,d6	*save start of word in case its found
	qcmove.b	1(a2),d1	*first char
search_for_first:

	tst.b	(a1)
	beq	deff_not_found	*EOF
	qcmove.b	(a1),d0	*get char
**if a tab, then ignore rest of space run
	cmpi.l	#9,d0
	addq.l	#1,a1
	bne.s	not_t1
st1:	qmoveq	#0,d2
	move.b	(a1),d2
	beq	deff_not_found	*EOF
	
	cmpi.l	#9,d2
	beq.s	gt1
	cmpi.l	#32,d2
	beq.s	gt1
	bra.s	not_t1
gt1:
	add.l	#1,d7
	addq.l	#1,a1
	bra.s	st1
not_t1:
	addq.l	#1,d7
	qbsr.l	toupper	*uppercase in d0
	cmp.b	d0,d1
	bne.s	search_for_first

;	move.l	a1,a3	save pos
;	clr.l	d2
	qcmove.b	0(a2),d2	count
	qmove.l	d7,d6
	subq.l	#1,d6
	subq.w	#2,d2
	blt	got_match	*1 byte search string!
check_rest_of_word:
	addq.l	#2,a2
crw_loop:	qcmove.b	(a1)+,d0
	qbsr.l	toupper
	cmp.b	(a2)+,d0
	bne.s	try_next_word2i
	qdbra	d2,crw_loop
	bra	got_match	

********************************Hyper label search*************************
**hyper link enters here, with upper case string in temp_string a5
**Does 68k and PPC
hyper_local_entry_68k:
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0	*handle to te rec
	qmove.l	ed_selpoint(a0),d7	*current sel point.
**V1.2 removes following line
;	addq.l	#1,d7	*Because we will find the same item every time...

	move.l	ed_htext(a0),a1
	move.l	(a1),a3		        *->text
try_next_word2ih:
	lea	temp_string2(a5),a2
	qmove.l	a3,a1	*start of text
	add.l	d7,a1	*->insert point
;	move.l	d7,d6	*save start of word in case its found
	qcmove.b	1(a2),d1	*first char
search_for_firsth:
	tst.b	(a1)
	beq	deff_not_found	*EOF
	qcmove.b	(a1)+,d0	*get char
	addq.l	#1,d7
	qbsr.l	toupper	*uppercase in d0
	cmp.b	d0,d1
	bne.s	search_for_firsth

;	move.l	a1,a3	save pos
;	clr.l	d2
	qcmove.b	0(a2),d2	count
	qmove.l	d7,d6
	subq.l	#1,d6
	subq.w	#2,d2
	blt	got_match	*1 byte search string!
check_rest_of_wordh:
	addq.l	#2,a2
crw_looph:	 qcmove.b	(a1)+,d0
	qbsr.l	toupper
	cmp.b	(a2)+,d0
	bne.s	try_next_word2ih
	qdbra	d2,crw_looph
	
	cmpi.b	#":",(a1)	*Check it really is a label
	beq	got_match	
	cmpi.b	#" ",(a1)
	beq	got_match
	cmpi.b	#9,(a1)
	beq	got_match
	cmpi.b	#13,(a1)
	beq	got_match
	tst.b	(a1)
	beq	got_match	 
	bra	try_next_word2ih	
**Needs a1->text
**adds 1 to d7 for every char moved.
**gets word in temp_string1(a5)
getword:
	qmoveq	#0,d5
	lea	temp_string(a5),a2
gw_loop:	addq.l	#1,d7
	qcmove.b	(a1),d0
	cmpi.l	#13,d0
	addq.l	#1,a1
	beq.s	got_word
	cmpi.l	#9,d0
	beq.s	got_word
	cmpi.l	#32,d0
	beq.s	got_word
	tst.l	d0
	beq.s	eof
	qmove.b	d0,(a2)+
	addq.l	#1,d5
	bra.s	gw_loop
got_word:	clr.b	(a2)	terminate
	clr.l	d0
	rts
eof:	moveq	#-1,d0
	rts_	"Getword"

**Check for sstr
**a1 is string from text, a0 is str to find, d0 is length of str in a0
check_for_str:
**first find first char match
	clr.l	d2
	qmove.w	d0,d2
	subq.w	#1,d2
	qmove.w	d2,d3
	qmoveq	#0,d4
not_first:	qmove.b	(a0),d1
check_first:
	cmp.b	(a1),d1
	beq.s	got_first
;	addq.l	#1,a1
	addq.l	#1,d4	*offset
	tst.b	(a1)+	
	bne.s	check_first
	moveq	#-1,d0
	rts
got_first:	move.l	a0,a2
;	addq.l	#1,a2
	qmove.w	d3,d2	reset counter
find_next:	cmpm.b	(a2)+,(a1)+	
	bne.s	not_first
	qdbra	d2,find_next
	clr.l	d0
	rts_	"Check_for_str"
*******
**Needs a1->text
**adds 1 to d5 for every char moved.
**gets word in temp_string1(a5)
getwordupper:
	qmove.l	#0,d5
	lea	temp_string(a5),a2
gwu_loop:	addq.l	#1,d7
	qcmove.b	(a1),d0
	cmpi.l	#13,d0
	addq.l	#1,a1
	beq.s	got_wordu
	cmpi.l	#9,d0
	beq.s	got_wordu
	cmpi.l	#32,d0
	beq.s	got_wordu
	tst.l	d0
	beq.s	eofu
	qbsr.l	toupper	*make it upper case
	qmove.b	d0,(a2)+
	addq.l	#1,d5
	bra.s	gwu_loop
got_wordu:	clr.l	d0
	rts
eofu:	moveq	#-1,d0
	rts_	"Getword"

;fname1:	ds.b	140
not_found_text:	cstring	"The string was not found in the current document."
	align
Find_failed:	dc.b	"   Search failed...",0
linking:	dc.b	"   Hyperlinking...",0
find_ok:	dc.b	"   Text found.",0
find_all:	dc.b	"   Replaced: "	*prints found: xxxx
find_all_numb:	ds.b	16	*space for count
	even
te_no_space:	dc.b	"Free memory getting low!",13,"Using emergency reserve.",0
	even
	printlog	"End of pass"
search_failed:	cstring	"Search failed"
	align
search_end:	dc.b	22,"Search End. Matches = "
search_end_find:	dc.b	"                "	*Print number of matches here
	even
	align	4
searching:	dc.b	12,"Searching->                                                                 "
	align
searching_proj:	dc.b	20,"Searching (Proj) ->                                                             "
	align
hl_name_start:	dc.b	"   Scan ->(Folder) "
hl_name:	ds.b	68
phl_name_start:	dc.b	"   Scan->(Proj) "
phl_name:	ds.b	68
	align
	
	global	local_search,global_search
	global	hyper_local_entry_68k,global_hyper_search_68k
	global	gp_paste,local_search_again,highlight_to_end,clear_pb
	
	extern	simple_speak
	extern	do_auto_scroll,strncmp,draw_status_message,run_sound1
	if	68k
	extern	fname
	else
	extern_data	fname
	endif
	extern	setup_find_window,printnum_mem,find_window,count_lines
	extern	new_tecaltext,redraw_all_scroll,close_window,close_it
	extern	do_alert_3d,global_hyper_load,events,find_window_d0
	extern	delete_caret_during_hyper,do_alert
	extern	toupper,chroma_line,delete_caret
	extern	led_on,led_off,handle_comms,do_double,colour_selection,calculate_cursor_xy
	extern	do_hilite,dsm,find_nth_proj,my_resolve_handle_everything,get_temp_pb
	extern	io_led_drive,play_a_sound,do_new_alert_3d,spin_right