include pm_equates.def

*******************************************************************************
*Project:       Eddie                                                         *
*Author:        SBB                                                           *
*Filename:      send_shutdown_to_finder.s                                     *
*Version:       1.6                                                           *
*Date started:  16:04:57 on 31st December 1996                                *
*Rev. History:                                                                *
*                                                                             *
*                                                                             *
*******************************************************************************
**Sends a shutdown aevnt to Finder
kAEShutdown:	equ	"shut"	*was shut
kAERestart:	equ	"rest"
kAEFinderEvents:	equ	"FNDR"
kFinderSig:	equ	"FNDR"

typeBoolean	equ	"bool"
typeChar	equ	"TEXT"
typeSMInt	equ	"shor"
typeInteger	equ	"long"
typeSMFloat	equ	"sing"
typeFloat	equ	"doub"
typeLongInteger	equ	"long"
typeShortInteger	equ	"shor"
typeLongFloat	equ	"doub"
typeShortFloat	equ	"sing"
typeExtended	equ	"exte"
typeComp	equ	"comp"
typeMagnitude	equ	"magn"
typeAEList	equ	"list"
typeAERecord	equ	"reco"
typeTrue	equ	"true"
typeFalse	equ	"fals"
typeAlias	equ	"alis"
typeEnumerated	equ	"enum"
typeType	equ	"type"
typeAppParameters	equ	"appa"
typeProperty	equ	"prop"
typeFSS	equ	"fss "
typeKeyword	equ	"keyw"
typeSectionH	equ	"sect"
typeWildCard	equ	"****"

typeApplSignature	equ	"sign"
typeSessionID	equ	"ssid"
typeTargetID	equ	"targ"
typeProcessSerialNumber	equ	"psn "
typeNull	equ	"null"                 /*the type of null/nonexistent data*/

kCoreEventClass	equ	"aevt"

kAEOpenApplication	equ	"oapp"
kAEOpenDocuments	equ	"odoc"
kAEPrintDocuments	equ	"pdoc"
kAEQuitApplication	equ	"quit"

kAECreatorType	equ	"crea"
kAEQuitAll	equ	"quia"

kAEApplicationDied	equ	"obit"
keyProcessSerialNumber	equ	"psn "

keyErrorNumber	equ	"errn"
keyErrorString	equ	"errs"

kAEAnswer	equ	"ansr"

keyDirectObject	equ	"----"


* keyword used in install special handler */
keyPreDispatch	equ	"phac"           * PreHandler Accessor Call */
keySelectProc	equ	"selh"            * More selector Call */

* keywords used in attributes */
keyTransactionIDAttr	equ	"tran"
keyReturnIDAttr	equ	"rtid"
keyEventClassAttr	equ	"evcl"
keyEventIDAttr	equ	"evid"
keyAddressAttr	equ	"addr"
keyOptionalKeywordAttr	equ	"optk"
keyTimeoutAttr	equ	"timo"
keyInteractLevelAttr	equ	"inte"     /*this attribute is read only will be set in AESend*/
keyEventSourceAttr	equ	"esrc"       /* this attribute is read only */
keyMissedKeywordAttr	equ	"miss"     /* this attribute is read only */

* constants for use in AESendMode */

kAENoReply	equ	$00000001            /* Sender doesn"t want a reply to event */
kAEQueueReply	equ	$00000002         /* Sender wants a reply but won"t wait */
kAEWaitReply	equ	$00000003          /* Sender wants a reply and will be waiting */

kAENeverInteract	equ	$00000010      /* Server should not interact with user */
kAECanInteract	equ	$00000020        /* Server may try to interact with user */
kAEAlwaysInteract	equ	$00000030     /* Server should always interact with user where appropriate */

kAECanSwitchLayer	equ	$00000040     /* Interaction may switch layer */

kAEDontReconnect	equ	$00000080      /* don"t reconnect if there is a sessClosedErr from PPCToolbox */

* constants to be used in AESendPriority */

kAENormalPriority	equ	$00000000     /* Post message at the end of event queue */

* special constants in generating events */

kAnyTransactionID	equ	0              /* no transaction is in use */
kAutoGenerateReturnID	equ	-1         /* AECreateAppleEvent will generate a session-unique ID */

* constant for use AESend */
kAEDefaultTimeout	equ	-1             /* timeout value determined by AEM */
kNoTimeOut	equ	-2                    /* wait until reply comes back, however long it takes */

* dispatch parameter to AEResumeTheCurrentEvent takes a pointer to a dispatch
*table, or one of these two constants */
kAENoDispatch	equ	0
kAEUseStandardDispatch	equ	-1

**Createdescriptor, create apple event, send appleevnt,dispose descriptor
send_shutdown_to_finder:
**Create descriptor
	move.l	#typeApplSignature,d0
	lea	fsig(pc),a0
	move.l	#4,d1	*sizeof
	lea	finder_addr(pc),a1	*we want descriptor here
	move.l	d1,d2
	OSAECreateDescriptor	d0,a0,d2,a1,d0
;	clr.w	-(sp)
;	move.l	#typeApplSignature,-(sp)
;	pea	fsig(pc)
;	move.l	#4,-(sp)	*sizeof
;	pea	finder_addr(pc)	*we want descriptor here
;	move.w	#$825,d0	*createdescriptor
;	dc.w	_pack8
;	move.w	(sp)+,d0	*OSErr

	lea	finder_addr(pc),a0
	
**Create apple event
	move.l	#kAEFinderEvents,d0	*event class
	move.l	#kAEShutdown,d1	*EVent ID
	lea	finder_addr(pc),a0		 	 *descriptor
	move.w	#kAutoGenerateReturnID,d3	*tells Apple Event Manager */
                                            * to generate a unique */
                                            * return ID*/
	move.l	#kAnyTransactionID,d4	*The apple event is not part of any transaction	
	lea	myshutdown(pc),a1			*AEvent here pse.
	OSAECreateAppleEvent	d0,d1,a0,d3,d4,a1,d0
;	 clr.w	 -(sp)
;	 move.l	#kAEFinderEvents,-(Sp)	*event class
;	 move.l	#kAEShutDown,-(SP)	*EVent ID
;	 pea	finder_Addr(pc)		 	 *descriptor
;	 move.w	#kAutoGenerateReturnID,-(sp)	 *tells Apple Event Manager */
;                                            * to generate a unique */
;                                            * return ID*/
;	 move.l	#kAnyTransactionID,-(sp)	 *The apple event is not part of any transaction	
;	 pea	myShutDown(pc)		 	 *AEvent here pse.
;	 move.w	#$0B14,d0
;	 dc.w 	 $A816	 	 *createappleevent
;	 move.w	(sp)+,d0	 *error
	lea	myshutdown(pc),a0
	
**Send apple event
	lea	myshutdown(pc),a0	*The aevt
	lea	nilreply(pc),a1	*The reply
	move.l	#kAENoReply+kAECanSwitchLayer+kAEAlwaysInteract,d2	*Sendmode
	move.w	#kAENormalPriority,d3	*priority
	move.l	#kAEDefaultTimeout,d4	*Timeout
	move.l	#0,a2	*no idle proc
	move.l	#0,a3	*No event filter proc
	OSAESend	a0,a1,d2,d3,d4,a2,a3,d0

;	 clr.w	 -(sp)
;	 pea	myShutDown(pc)	*The aevt
;	 pea	nilreply(pc)	 *The reply
;	 move.l	#kAENoReply+kAEcanSwitchLayer+kAEAlwaysInteract,-(sp)	 *Sendmode
;	 move.w	#kAENormalPriority,-(sp)	 *priority
;	 move.l	#kAEDefaultTimeOut,-(SP)	 *Timeout
;	 clr.l	 -(sp)	 *no idle proc
;	 clr.l	 -(sp)	 *No event filter proc
;	 move.w	#$0d17,d0	*AESend
;	 dc.w 	 $A816
;	 move.w	(sp)+,d0
	rts_	"Send_shutdown_ae"

send_restart_to_finder:
	move.l	#typeApplSignature,d0
	lea	fsig(pc),a0
	moveq	#4,d2	*sizeof
	lea	finder_addr(pc),a1	*we want descriptor here

	OSAECreateDescriptor	d0,a0,d2,a1,d0

**Create descriptor
;	 clr.w	 -(sp)
;	 move.l	#typeApplSignature,-(sp)
;	 pea	fsig(pc)
;	 move.l	#4,-(sp)	 *sizeof
;	 pea	finder_addr(pc)	*we want descriptor here
;	 move.w	#$825,d0	 *createdesc
;	 dc.w	 _pack8
;	 move.w	(sp)+,d0	 *OSErr
	lea	finder_addr(pc),a0
	
**Create apple event
	move.l	#kAEFinderEvents,d0	*event class
	move.l	#kAERestart,d1	*EVent ID
	lea	finder_addr(pc),a0		 	 *descriptor
	move.w	#kAutoGenerateReturnID,d3	*tells Apple Event Manager */
                                            * to generate a unique */
                                            * return ID*/
	move.l	#kAnyTransactionID,d4	*The apple event is not part of any transaction	
	lea	myshutdown(pc),a1			*AEvent here pse.
	OSAECreateAppleEvent	d0,d1,a0,d3,d4,a1,d0

;	 clr.w	 -(sp)
;	 move.l	#kAEFinderEvents,-(Sp)	*event class
;	 move.l	#kAERestart,-(SP)	 *EVent ID
;	 pea	finder_Addr(pc)		 	 *descriptor
;	 move.w	#kAutoGenerateReturnID,-(sp)	 *tells Apple Event Manager */
;                                            * to generate a unique */
;                                            * return ID*/
;	 move.l	#kAnyTransactionID,-(sp)	 *The apple event is not part of any transaction	
;	 pea	myShutDown(pc)		 	 *AEvent here pse.
;	 move.w	#$0B14,d0
;	 dc.w 	 $A816	 	 *creat apple event
;	 move.w	(sp)+,d0	 *error
	lea	myshutdown(pc),a0
	
**Send apple event
	lea	myshutdown(pc),a0	*The aevt
	lea	nilreply(pc),a1	*The reply
	move.l	#kAENoReply+kAECanSwitchLayer+kAEAlwaysInteract,d2	*Sendmode
	move.w	#kAENormalPriority,d3	*priority
	move.l	#kAEDefaultTimeout,d4	*Timeout
	move.l	#0,a2	*no idle proc
	move.l	#0,a3	*No event filter proc
	OSAESend	a0,a1,d2,d3,d4,a2,a3,d0

;	 clr.w	 -(sp)
;	 pea	myShutDown(pc)	*The aevt
;	 pea	nilreply(pc)	 *The reply
;	 move.l	#kAENoReply+kAEcanSwitchLayer+kAEAlwaysInteract,-(sp)	 *Sendmode
;	 move.w	#kAENormalPriority,-(sp)	 *priority
;	 move.l	#kAEDefaultTimeOut,-(SP)	 *Timeout
;	 clr.l	 -(sp)	 *no idle proc
;	 clr.l	 -(sp)	 *No event filter proc
;	 move.w	#$0d17,d0	*AESend
;	 dc.w 	 $A816
;	 move.w	(sp)+,d0
	rts_	"Send_restart_ae"


shutdown_finder:
**Create descriptor
	move.l	#typeApplSignature,d0
	lea	fsig(pc),a0
sdf1:	 move.l	#4,d2	 *sizeof
	lea	finder_addr(pc),a1	*we want descriptor here

	OSAECreateDescriptor	d0,a0,d2,a1,d0

	lea	finder_addr(pc),a0
	
**Create apple event
	move.l	#kCoreEventClass,d0	*event class
	move.l	#kAEQuitApplication,d1	*EVent ID
	lea	finder_addr(pc),a0		  	  *descriptor
	move.w	#kAutoGenerateReturnID,d3	*tells Apple Event Manager */
                                            * to generate a unique */
                                            * return ID*/
	move.l	#kAnyTransactionID,d4	*The apple event is not part of any transaction	
	lea	myshutdown(pc),a1			*AEvent here pse.
	OSAECreateAppleEvent	d0,d1,a0,d3,d4,a1,d0

	lea	myshutdown(pc),a0
	
**Send apple event
	lea	myshutdown(pc),a0	*The aevt
	lea	nilreply(pc),a1	*The reply
	move.l	#kAENoReply+kAECanSwitchLayer+kAEAlwaysInteract,d2	*Sendmode
	move.w	#kAENormalPriority,d3	*priority
	move.l	#kAEDefaultTimeout,d4	*Timeout
	move.l	#0,a2	*no idle proc
	move.l	#0,a3	*No event filter proc
	OSAESend	a0,a1,d2,d3,d4,a2,a3,d0

	rts_	"shutdown_finder"

shutdown_TS:
	tst.b	TS_Running(a5)
	beq.s	no_shutdown_TS
**Create descriptor
	move.l	#typeApplSignature,d0
	lea	TSsig(pc),a0
	bra	sdf1
no_shutdown_TS:
	rts_	"Shutdown_TS"
	
******Other ae routines

Ciocompletion:	equ	12	long
Cionameptr:	equ	18	long
Ciovrefnum:	equ	22	word
Ciodrdirid:	equ	48	long
Ciofdirindex:	equ	28	word - set to zero initially
CioDRParID:	equ	100	long
CioFrefnum:	equ	24	*file refnum on output from getcatinfo

**D0=phase
**returns a0 pointing to fsspec
	reset_locals
	local.b	temp_fsspec,80
	local.l	p_dir,1
	local.l	wanted_phase,1
	local.l	pbits_dirid,1
	local.w	pbits_vref,1
	local.w	pad1,1
	local.b	temp_pb,400
	local.b	pbits_name,100
	local.b	phase_folder_name,80
	local.l	bits_dirid,1
	local.w	bits_vrefnum,1
run_target_with_debugger:
;find the xcoff
	reserve_locals	a4
	qmove.l	#3,d0	;phase 3 output folder pse
	bsr.l	get_phase_x_op_spec
	tst.l	d0
	bmi	could_not_launch_debug1
**get cat info to get dirID
	lea	temp_fsspec(a4),a1
	move.l	#78,d2
	OSBlockMoveData a0,a1,d2	;copy to temp fsspec
	lea	temp_pb(a4),a0
	bsr.l	clear_pb
	lea	temp_pb(a4),a0
	qmove.l	#0,Ciocompletion(a0)	no completion routine
	lea	temp_fsspec(a4),a3
	lea	6(a3),a1	*name
	qmove.l	a1,Cionameptr(a0)	point to filename
	qmove.w	(a3),Ciovrefnum(a0)	vrefnum
	qmove.w	(a3),bits_vrefnum(a4)
	qmove.l	2(a3),Ciodrdirid(a0)	dir id	
	qmove.w	#0,Ciofdirindex(a0)	
	OSPBGetCatInfoSync	a0,d0
	lea	temp_pb(a4),a0
	qmove.l	Ciodrdirid(a0),bits_dirid(a4)	;finally, the directory ID
***Now make fsspec of file
	lea	temp_fsspec(a4),a0	*name here
	qmove.l	bits_dirid(a4),2(a0)	*directory ID
	addq.l	#6,a0	;point to name
;find target name
	move.l	proj_buffer_h(a5),a1
	move.l	(a1),a1

	lea	p_filename(a1),a3
	clr.l	d2
	move.b	(a3)+,d3	;length
	beq	bad_target_name
	qmove.l	a0,a1	;save qwhere length byte to go
	addq.l	#1,a0
lp:
    move.b	(a3)+,(a0)+
    addq.l	#1,d2
    subq.l	#1,d3
    bne.s	lp
    move.b	#".",(a0)+
    addq.l	#1,d2
    move.l	#"xcof",(a0)+
    move.b	#"f",(a0)+
    addq.l	#5,d2
    qmove.b	d2,(a1)
    subq.l	#6,a1	;fsspec
;make an alias - handle in scratch_1(a5)
	qmove.l	a1,a0	;fsspec
	qmove.l	2(a0),file_type(a5)	*Store type for later evaluation

	lea	proj_fsspec(a5),a0	*From file
;	lea	temp_string3+6(a5),a1	*the file
	lea	scratch_1(a5),a2	*handle here
	OSNewAlias	a0,a1,a2,d0
    tst.w	d0
    bmi	no_xcoff
;send to finder
    bsr	send_odoc_to_finder

end_rwd:
    unlk	a4
	rts_	"run_target_with_debugger"

could_not_launch_debug1:
	push	a4
	qmove.l	#1002,d0	*error
	lea	xcoff_not_found(pc),a0
	qmoveq	#30,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d	*fatal error

	pop	a4
	bra	end_rwd

bad_target_name:
	push	a4
	qmove.l	#1002,d0	*error
	lea	bad_name(pc),a0
	qmoveq	#30,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d	*fatal error

	pop	a4
	bra	end_rwd		

no_xcoff:
	push	a4
	qmove.l	#1002,d0	*error
	lea	no_debug(pc),a0
	qmoveq	#30,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d	*fatal error

	pop	a4
	bra	end_rwd		

**Send odoc to finder - needs alias of file in scratch_1(a5)
send_odoc_to_finder:
**Create descriptor
	move.l	#typeApplSignature,d0
	lea	fsig(pc),a0
	moveq	#4,d2	*sizeof
	lea	finder_addr(pc),a1	*we want descriptor here

	OSAECreateDescriptor	d0,a0,d2,a1,d0

;	 clr.w	 -(sp)
;	 move.l	#typeApplSignature,-(sp)
;	 pea	fsig(pc)
;	 move.l	#4,-(sp)	 *sizeof
;	 pea	finder_addr(pc)	*we want descriptor here
;	 move.w	#$825,d0	 *createdesc
;	 dc.w	 _pack8
;	 move.w	(sp)+,d0	 *OSErr
	lea	finder_addr(pc),a0
	
**Create apple event
	move.l	#kCoreEventClass,d0	*event class
	move.l	#"odoc",d1	*EVent ID
	lea	finder_addr(pc),a0		 	 *descriptor
	move.w	#kAutoGenerateReturnID,d3	*tells Apple Event Manager */
                                            * to generate a unique */
                                            * return ID*/
	move.l	#kAnyTransactionID,d4	*The apple event is not part of any transaction	
	lea	myshutdown(pc),a1			*AEvent here pse.
	OSAECreateAppleEvent	d0,d1,a0,d3,d4,a1,d0

;	 clr.w	 -(sp)
;	 move.l	#kCoreEventClass,-(Sp)	*event class
;	 move.l	#"odoc",-(SP)	 *EVent ID
;	 pea	finder_Addr(pc)		 	 *descriptor
;	 move.w	#kAutoGenerateReturnID,-(sp)	 *tells Apple Event Manager */
;                                            * to generate a unique */
;                                            * return ID*/
;	 move.l	#kAnyTransactionID,-(sp)	 *The apple event is not part of any transaction	
;	 pea	myShutDown(pc)		 	 *AEvent here pse.
;	 move.w	#$0B14,d0
;	 dc.w 	 $A816	 	 *creat apple event
;	 move.w	(sp)+,d0	 *error
;	 lea	myshutdown(pc),a0

**Add alias of file to open
*     pascal OSErr AEPutParamDesc(const AppleEvent *theAppleEvent,
*     AEKeyword theAEKeyword,
*     const AEDesc *theAEDesc);
**Create discriptor

	lea	my_discriptor(pc),a0
	move.l	#"alis",(a0)
	move.l	scratch_1(a5),4(a0)
	
    lea	myshutdown(pc),a0	**appleevent
    move.l	#"----",d1	*keyword - direct object - the one and only
 	lea	my_discriptor(pc),a1
 	OSAEPutParamDesc	a0,d1,a1,d0

;    OSerr
;    pea	myshutdown(pc)	**appleevent
;    move.l	#"----",-(sp)	 *keyword - direct object - the one and only
; 	 pea	my_discriptor(pc)
;    move.w	#$0610,d0
;    dc.w	 $a816
;    OSerr_Ret
**Send apple event
	lea	myshutdown(pc),a0	*The aevt
	lea	nilreply(pc),a1	*The reply
	move.l	#kAENoReply+kAECanSwitchLayer+kAEAlwaysInteract,d2	*Sendmode
	move.w	#kAENormalPriority,d3	*priority
	move.l	#240,d4	*Timeout
	move.l	#0,a2	*no idle proc
	move.l	#0,a3	*No event filter proc
	OSAESend	a0,a1,d2,d3,d4,a2,a3,d0


;	clr.w	-(sp)
;	pea	myShutDown(pc)	*The aevt
;	pea	nilreply(pc)	*The reply
;	move.l	#kAENoReply+kAEcanSwitchLayer+kAEAlwaysInteract,-(sp)	*Sendmode
;	move.w	#kAENormalPriority,-(sp)	*priority
;;	move.l	#kAEDefaultTimeout,-(SP)	*Timeout - 4 secs
;	move.l	#240,-(sp)
;	clr.l	-(sp)	*no idle proc
;	clr.l	-(sp)	*No event filter proc
;	move.w	#$0d17,d0	*AESend
;	dc.w 	$A816
;	move.w	(sp)+,d0
;	lea	nilreply(pc),a0
;	move.l	4(a0),a0
;	move.l	(a0),a0
	rts_	"Send_odoc_to_fndr"
	

send_odoc_to_external:
**Send an oapp to editor
**Find out if editor is running, launch if not
	bsr	launch_editor
**Create descriptor
	move.l	#typeApplSignature,d0
	lea	editor_creator(a5),a0
	moveq	#4,d2	*sizeof
	lea	finder_addr(pc),a1	*we want descriptor here

	OSAECreateDescriptor	d0,a0,d2,a1,d0

	lea	finder_addr(pc),a0
	
**Create apple event
	move.l	#kCoreEventClass,d0	*event class
	move.l	#"odoc",d1	*EVent ID
	lea	finder_addr(pc),a0		 	 *descriptor
	move.w	#kAutoGenerateReturnID,d3	*tells Apple Event Manager */
                                            * to generate a unique */
                                            * return ID*/
	move.l	#kAnyTransactionID,d4	*The apple event is not part of any transaction	
	lea	myshutdown(pc),a1			*AEvent here pse.
	OSAECreateAppleEvent	d0,d1,a0,d3,d4,a1,d0

**Create discriptor

	lea	my_discriptor(pc),a0
	move.l	#"alis",(a0)
	move.l	scratch_1(a5),d0
	move.l	d0,4(a0)
	
    lea	myshutdown(pc),a0	**appleevent
    move.l	#"----",d1	*keyword - direct object - the one and only
 	lea	my_discriptor(pc),a1
 	OSAEPutParamDesc	a0,d1,a1,d0

**Send apple event
	lea	myshutdown(pc),a0	*The aevt
	lea	nilreply(pc),a1	*The reply
;	move.l	#kAENoReply+kAECanSwitchLayer+kAEAlwaysInteract,d2	*Sendmode
	move.l	#kAENoReply+kAECanSwitchLayer+kAEAlwaysInteract,d2	*Sendmode
	move.w	#kAENormalPriority,d3	*priority
	move.l	#240,d4	*Timeout
	move.l	#0,a2	*no idle proc
	move.l	#0,a3	*No event filter proc
	OSAESend	a0,a1,d2,d3,d4,a2,a3,d0
	tst.w	d0
	beq.s	no_ae_error
	bsr	show_ae_error
	bra	skip_switch
no_ae_error:
**Switch to editor
**find the editor process (compare editor_creator)
**switch to it
**Find editor process
	reset_locals
	local.l	current_process,2

	reserve_locals	a4
	lea	current_process(a4),a0
	clr.l	(a0)	*start with no process
	clr.l	4(a0)
get_next_process:
	lea	current_process(a4),a0
	OSGetNextProcess	a0,d0
**if current_process is zero, then end
	move.l	current_process(a4),d0
	or.l	current_process+4(a4),d0
	beq	didnt_find
	lea	current_process(a4),a0
	lea	search_pir(pc),a1
	clr.l	4(a1)	*dont want name
	clr.l	56(a1)	*dont want fsspec
	OSGetProcessInformation	a0,a1,d0
	lea	search_pir(pc),a0
	move.l	20(a0),d0	*sig
	cmp.l	editor_creator(a5),d0
	bne	get_next_process
**Found editor
***Switch to it
	lea	current_process(a4),a0
	OSSetFrontProcess	a0,d0
didnt_find:
	unlk	a4
skip_switch:
;	lea	nilreply(pc),a0
;	move.l	4(a0),a0
;	move.l	(a0),a0
	


	rts_	"Send_odoc_to_external"

	reset_locals
	local.l	the_process,2
	local.b	editor_name,40
	local.b	Editor_FSspec,80
	local.b	TheFSspec,80
	local.l	TheVRefNum,1
	local.l	TheDirID,1
	local.b	ThePB,260
	local.b	ThePStr,40
launch_editor:
	reserve_locals	a4
	lea	the_process(a4),a0
	clr.l	(a0)	*start with no process
	clr.l	4(a0)
search_next_process:
	lea	the_process(a4),a0
	OSGetNextProcess	a0,d0
**if current_process is zero, then end
	move.l	the_process(a4),d0
	or.l	the_process+4(a4),d0
	beq.s	didnt_find1
	lea	the_process(a4),a0
	lea	search_pir(pc),a1	
	lea	editor_name(a4),a2
	move.l	a2,4(a1)	*we want the name
	lea	Editor_FSspec(a4),a2
	move.l	a2,56(a1)	*we want the fsspec as well
	OSGetProcessInformation	a0,a1,d0
	lea	search_pir(pc),a0
	move.l	20(a0),d0	*sig
	cmp.l	editor_creator(a5),d0
	bne	search_next_process
	bra	found_editor	*tis running
didnt_find1:
**here we need to launch the editor
**is it an alias

	lea	TheFSspec(a4),a0
	move.w	editor_vrefnum(a5),(a0)
	move.l	editor_dirid(a5),2(a0)
	lea	6(a0),a0
	move.b	#6,(a0)+
	move.l	#"edit",(a0)+
	move.w	#"or",(a0)

	lea	TheFSspec(a4),a1
	cmpi.l	#"adrp",editor_type(a5)
	bne	do_launch_editor
do_alias_launch:
	bsr.l	launch_alias	*file
	bra	found_editor
;**Didnt Found editor
;**message to log - launching xyz editor
;	 lea	editor_name(a4),a0
;	 lea	the_editor_name(pc),a1
;	 qmove.b	(a0)+,d0
;	 subq.l	#1,d0
;	 bmi.s	 wot_name
;copy_edit_name:	move.b	(a0)+,(a1)+
;	 dbra	 d0,copy_edit_name
;wot_name:
;	 clr.b	 (a1)
;	 debug
;	 lea	editor_name_string(pc),a0
;	 bsr.l	 global_send_to_log
***Launch it

**we have to get an fsspec for the editor
;	li		r3,0
;	la		r4,TheVRefNum(sp)
;	la		r5,TheDirID(sp)
;	Xcall	HGetVol
	lea	ThePB(a4),a0
	clr.l	12(a0)	*Iocompletion
	clr.l	18(a0)	*nameptr
	OSPBHGetVolSync	a0,d0
	tst.w	d0
	bne		found_editor
	lea	ThePB(a4),a0
	move.w	22(a0),TheVRefNum(a4)

;	 li		 r4,0
;	 la		 r3,ThePB(sp)
;	 lhz		 r5,TheVRefNum(sp)
;	 stw		 r4,12(r3)	 	 	 	 	 	 ; ioCompletion = NIL
;	 stw		 r4,18(r3)	 	 	 	 	 	 ; ioNamePtr = NIL
;	 sth		 r5,22(r3)	 	 	 	 	 	 ; set ioVRefNum
;
;	 Xcall	 PBDTGetPath
	lea	ThePB(a4),a0
	move.w	TheVRefNum(a4),d0
	clr.l	12(a0)	*Iocompletion
	clr.l	18(a0)	*nameptr
	move.w	d0,22(a0)	*ioVrefNum
	OSPBDTGetPath	a0,d0
	tst.w	d0
	bne		found_editor
	lea	ThePB(a4),a0
	move.w	24(a0),d0

;	 li		 r4,0
;	 la		 r3,ThePB(sp)
;	 la		 r6,ThePStr(sp)
;	 lwz		 r5,gBrowserSignature(`bss)
;	 stw		 r4,12(r3)	 	 	 	 	 	 ; ioCompletion = NIL
;	 stw		 r6,18(r3)	 	 	 	 	 	 ; ioNamePtr = NIL
;	 sth		 r4,26(r3)	 	 	 	 	 	 ; ioIndex = NIL
;	 stw		 r5,52(r3)	 	 	 	 	 	 ; ioFileCreator = NIL
;
;	 Xcall	 PBDTGetAPPLSync
	lea	ThePB(a4),a0
	lea	ThePStr(a4),a1
	clr.l	12(a0)
	move.l	a1,18(a0)
	clr.w	26(a0)
	move.l	editor_creator(a5),52(a0)
	OSPBDTGetAPPLSync	a0,d0
	tst.w	d0
	bne		cant_find_editor
	
	lea	ThePB(a4),a0
	move.w	TheVRefNum(a4),d0	*verfnum
	move.l	100(a0),d1	*DirID
	lea	ThePStr(a4),a0
	lea	TheFSspec(a4),a1
	OSMakeFSspec	d0,d1,a0,a1,d0
	tst.w	d0
	bne.s	found_editor
	lea	TheFSspec(a4),a1
;
;	 cmpwi	 r3,0
;	 bne		 LaunchBrowserEnd
;
;	 lhz		 r3,TheVRefNum(sp)
;	 lwz		 r4,ThePB+100(sp)
;	 la		 r5,ThePStr(sp)
;	 la		 r6,TheFSSpec(sp)
;
;	 Xcall	 FSMakeFSSpec
;
;	 cmpwi	 r3,0
;	 bne		 LaunchBrowserEnd
;
;	 la		 r3,LaunchPBRec(sp)
;	 li		 r4,$4C43
;	 li		 r5,32
;	 li		 r6,0
;	 li		 r7,$4200
;	 la		 r8,TheFSSpec(sp)
;
;	 sth		 r4,6(r3)
;	 stw		 r5,8(r3)
;	 sth		 r6,12(r3)
;	 sth		 r7,14(r3)
;	 stw		 r8,16(r3)
;	 stw		 r6,40(r3)
;
;	 Xcall	 LaunchApplication
;
;
do_launch_editor:
	bsr.l	launch_app_from_external

found_editor:
	unlk	a4
	rts_	"Launch_editor"
cant_find_editor:
	push	a4
	qmove.l	#1002,d0	*error
	lea	editor_not_found(pc),a0
	qmoveq	#30,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d	*fatal error

	pop	a4
	bra.s	found_editor	
******************************************************************************
**Get fsspec for app
do_launch:
	rts
*;	 lea	doc_dir(a5),a0
*	 OSGetCurDirStore	 d0
*	 move.l	d0,doc_dir(a5)
*;	 move.l	$398,doc_dir(a5)
*;	 lea	doc_vref(a5),a0
*	 OSGetSFSaveDisk	d0
*	 move.w	d0,doc_vref(a5)
*;	 move.w	$214,doc_vref(a5)	 *Save document dir
***Check app ref
*	 tst.w	 app_vref(a5)
*	 beq.s	 got_app_vref	 	 *Its empty so use current
***Set app ref
*	 move.l	app_dir(a5),d0
*	 OSPutCurDirStore	 d0	*make save folder same as windows dirid
*	 move.w	app_vref(a5),d0
*	 neg.w	 d0
*	 OSPutSFSaveDisk	d0
*got_app_vref:
*	 
***Enhanced get gfile - sys 7 and later
*OPENSELECTOR:
*
*
*	 lea	temp_string3(a5),a0
*	 move.l	a0,scratch_1(a5)
*
*	 move.l	#0,d0	 *File filter
*	 move.w	#1,a0	 *NUm type
*	 lea	type_string(pc),a1	*Typelist
*	 move.l	scratch_1(a5),a2	 *Sfreply please
*	 move.w	#144,d6	*Dialog ID - launch app
*	 clr.l	 d7
*	 clr.l	 d3
*	 clr.l	 d4	*Modalfilter
*	 clr.l	 d5	*Active list
*	 OSCustomGetFile	d0,a0,a1,a2,d6,d7,d3,d4,d5	*ran out of params!
*
*	 
*
*	 move.l	scratch_1(a5),a0	 buffer
*	 tst.b	 (a0)
*	 beq.s	 cancelled
*	 move.l	scratch_1(a5),a0	 fsspec
*
***Copy fsspec to project_app_fsspec
*	 lea	6(a0),a1
*	 
*	 bsr.l	 launch_app_from_external
***Save app ref
*	 OSGetCurDirStore	 d0
*	 move.l	d0,app_dir(a5)
*	 OSGetSFSaveDisk	d0
*	 neg.w	 d0
*	 move.w	d0,app_vref(a5)
*	 
***Set back to doc ref
*	 move.l	doc_dir(a5),d0
*	 OSPutCurDirStore	 d0
*;	 move.l	doc_dir(a5),$398	 *make save folder same as windows dirid
*	 move.w	doc_vref(a5),d0
*	 OSPutSFSaveDisk	d0


	rts_	"Do_launch"
cancelled:	moveq	#-1,d0
	move.b	#1,user_cancelled(a5)
	rts
show_ae_error:
	qmove.l	#1002,d0	*error
	lea	ae_not_handled_text(pc),a0
	qmoveq	#30,d1
	qmoveq	#70,d2
	bsr.l	do_new_alert_3d	*fatal error

	rts_	"Show_ae_error"
**********************************
launch_finder:
**FIND PREFS FOLDER
	move.w	#$8000,d0	vrefnum
	move.l	#"macs",d1
	clr.b	d2	*DO NOT CREATE IF NOT FOUND
	lea	sys_vrefnum(a5),a0
	lea	sys_dir(a5),a1
	OSFindFolder	d0,d1,d2,a0,a1,d0
;	MOVEQ	#0,d0
;	DC.W	_FINDFOLDER



;	 CLR.W	 -(SP)	 OSerr
;	 MOVE.W	#$8000,-(SP)	 VREFNUM
;	 MOVE.L	#"macs",-(SP)
;	 clr.b	 -(SP)	 *DO NOT CREATE IF NOT FOUND
;	 PEA	SYS_VREFNUM(a5)
;	 PEA	SYS_DIR(a5)
;	 MOVEQ	 #0,d0
;	 DC.W	 _FINDFOLDER
;	 MOVE.W	(SP)+,d0	 ERROR
	
**try to create an fsspec for the finder
	move.w	sys_vrefnum(a5),d0
	move.l	sys_dir(a5),d1
	lea	finder_name(pc),a0
	lea	finder_fsspec(a5),a1
	bsr.l	make_fsspec		*make fsspec at a1
	cmpi.w	#$ffd5,d0		*no file
	beq.s	no_finder
**Got finder
	lea	finder_fsspec(a5),a1
	bsr.l	launch_app_from_external
	bsr.l	set_front_dir
	clr.l	d0
	rts	
no_finder:
	bsr.l	set_front_dir
	moveq	#-1,d0
	rts_	"Launch_finder"
finder_name:	pstring	"finder"
	align
******************************************************************************	
type_string:	dc.l	"APPL"
	dc.l	"adrp"
	
finder_addr:	ds.l	4	*KEyword,handle to data
myshutdown:	ds.l	4	*Shutdown apple event here
nilreply:	ds.l	4	*Reply from send
fsig:	dc.l	"MACS"
finder_sig:	dc.l	"FNDR"
my_discriptor:	ds.l	2

TSsig:	dc.l	"MPSX"
ae_not_handled_text:	cstring	"The Apple Event was not handled.",13,13,"The editor is not running."
	align	4
search_pir:	dc.l	60	process info rec goes here - length
	dc.l	0	we don't want the name
	ds.l	2	PSN
	dc.l	1	type
	dc.l	1	sig
	dc.l	1	flags
	dc.l	1	address of partition
	dc.l	1	size
	dc.l	1
	dc.l	2	psn of launcher
	dc.l	1	date
	dc.l	1	active time
	dc.l	0	we dont want pointer to Fsspec
	ds.l	4
	align	4
editor_name_string:	dc.b	"Launching external editor: "
the_editor_name:	ds.b	40
	align	4
editor_not_found:	cstring	"Can't find the editor in the Desktop Database.",13,13,"Suggest rebuilding your desktop.",13
	align
xcoff_not_found:    cstring "Can't find the project XCOFF file",13,"in the Phase 3 Output Area." 
	align
bad_name:    cstring "Bad target name!" 
	align
no_debug:    cstring "Can't Debug because there is no debug information",13,"for this project.",13,"This command only works for C projects built",13,"with Master Debug (the MetalBug icon in the project window) On.",13,13,"Please see the manual for more information."
 
	align
launching_editor:	cstring	"Attempting to launch external editor.",13,13
	align
	global	send_shutdown_to_finder,shutdown_finder,do_launch,launch_finder,send_restart_to_finder
	global	send_odoc_to_finder,send_odoc_to_external,shutdown_TS,run_target_with_debugger
	extern	launch_app_from_external	*in boot fantasm
	extern	make_fsspec,set_front_dir,do_alert_3d
	extern	global_send_to_log,launch_alias,do_new_alert_3d,get_phase_x_op_spec,clear_pb