

*******************************************************************************
*Project:       Anvil                                                         *
*Author:        Lightsoft 97                                                  *
*Filename:      show_tool_info.s                                              *
*Version:                                                                     *
*Date started:  18:53:47 on 20th March 1997                                   *
*Rev. History:                                                                *
*                                                                             *
*                                                                             *
*******************************************************************************
show_tool_info:
	reset_locals
	local.l	tool_info_h,1	
	local.w	current_res,1
	reserve_locals	a4

**Set window title to show time
	lea	dt_rec(pc),a0	*pointer to where record is to go
	OSGetTime	a0
	lea	dt_rec(pc),a3
	lea	title_time(pc),a0	
;;	clr.l	d6
	qcmove.w	6(a3),d6	*hours
	bsr.l	printnum99_mem_lead
;	move.b	#":",(a0)+
;	clr.l	d6
	qcmove.w	8(a3),d6	*mins
	bsr.l	printnum99_mem_lead
;	move.b	#":",(a0)+
;	clr.l	d6
	qcmove.w	10(a3),d6	*secs
	bsr.l	printnum99_mem_lead

	qmove.l	a4,-(sp)	
	qmove.l	#15000,d1	default 35k for new text
	qmove.w	#"RO",new_window_type(a5)	*read only

	bsr.l	setup_window
	move.l	(sp)+,a4
	tst.w	d0
	bmi.l	open_failed_window
	qmove.w	#"RO",window_type(a6)	*read only

	qmove.l	0(a6),d0
	lea	title_string(pc),a0
	OSSetWTitle	d0,a0
;	dc.w	_setWtitle		*Set new name
**To insert any text, we first have to set the item to a crap string, then modify its
**text using setitem...

;
;	 move.l	windowsmenu(a5),-(sp)
;	 pea	duff_string(pc)	*File name
;	 move.w	d0,-(sp)
;	 dc.w	 _insmenuitem
;	 move.w	(sp)+,d0	 *item
;	 addq.w	#1,d0
;	 
;	 move.l	windowsmenu(a5),-(sp)
;	 move.w	d0,-(sp)
;	 pea	title_string(pc)
;	 dc.w	 _setitem

	save_all
	qmove.l	window_ptr(a6),d0
	OSShowWindow	d0
	restore_all

	bsr.l	  find_window
	qmove.w	#0,editable(a6)	*this window is not editable
**Setup prefs
	clr.b	prefs_flags_w(a6)
	clr.b	prefs_flags2_w(a6)
	qmove.w	#8,tab_width_w(a6)	*all help files tabbed to 8
	clr.w	chroma_state_w(a6)

**Now lets print the info
**We use paste_A_line which needs a C string in a0
	qmove.l	number_of_tools_available(a5),d7
	subq.l	#1,d7
	bmi.s	goodbye
	
	move.l	tool_classes_h(a5),a2
	move.l	(a2),a2
	clr.l	d7
show_next_tool:
	lea	class(pc),a0
	bsr.l	paste_a_line
	lea	class_str(pc),a3
	qmove.l	(a2),(a3)+
	qmove.w	4(a2),(a3)+
	lea	class_str(pc),a0
	bsr.l	paste_a_line
	lea	name(pc),a0
	bsr.l	paste_a_line
	lea	tool_name(a2),a0
	bsr.l	paste_a_line
	lea	is_loaded(pc),a0
	bsr.l	paste_a_line
	tst.l	tool_code1_handle(a2)
	beq.s	no
	lea	yesstr(pc),a0
	bra.s	doneyn
no:	lea	nostr(pc),a0
doneyn:
	bsr.l	paste_a_line
**Show number of calls to tool
	lea	run_count(pc),a0
	bsr.l	paste_a_line
	qmove.l	tool_called_n(a2),d0
	lea		times_count(pc),a0
	bsr.l	printnum
	lea	times_count(pc),a0
	bsr.l	paste_a_line
	lea	return(pc),a0
	bsr.l	paste_a_line
**now show tool info
	tst.l	tool_code1_handle(a2)
	beq	not_loaded

	save_all
	OSCurResFile	d0
	qmove.w	d0,current_res(a4)

	qcmove.w	tool_res_refnum(a2),d0
	OSUseResFile	d0

	qmove.l	#"TLin",d0
	qcmove.w	#128,d1
	OSGet1Resource	d0,d1,d0
	move.l	d0,tool_info_h(a4)
	beq	no_tool_info
	qmove.l	tool_info_h(a4),a0
	OSHLock	a0
	move.l	tool_info_h(a4),a0
	move.l	(a0),a0
	lea	256(a0),a0	  *info string
	bsr.l	paste_a_line
	lea	return(pc),a0
	bsr.l	paste_a_line
	move.l	tool_info_h(a4),a0
	move.l	(a0),a0	*Copyright string
	bsr.l	paste_a_line
	
	lea	return(pc),a0
	bsr.l	paste_a_line

	move.l	tool_info_h(a4),a0
	OSReleaseResource	a0
no_tool_info:
	move.w	current_res(a4),a0
	OSUseResFile	a0	*back to anvil
	restore_all
not_loaded:
	lea	return_dash(pc),a0
	bsr.l	paste_a_line
	
	inc.l	d7
	lea	tool_entry_size(a2),a2
	cmp.l	number_of_tools_available(a5),d7	*counter
	bne	show_next_tool
goodbye:
	move.l	te_handle_ptr(a6),a0
;	move.l	(a0),a0	*terec
	move.l	ed_telength(a0),d6
	qmove.l	a4,-(sp)
	bsr.l	calc_lines_size
	move.l	(sp)+,a4

open_failed_window:
	unlk	a4
	rts_	"Show_tool_info"
dt_rec:	ds.b	16
	align
title_string:	dc.b	29+6,"Your tools/plugs snapshot at "
title_time:	dc.b	"162400",0,0,0,0
	align
duff_string:	dc.b	1,"a"	*Duff string for windows menu items
	even
class:	cstring	"Anvil Class: ",0x22
	align
name:	cstring	"  Name: ",0x22
	align
is_loaded:	dc.b	0x22,"  Loaded: ",0
	align
yesstr:	cstring	"Yes."
	align
nostr:	cstring	"No."
	align
run_count:	dc.b	" Called: ",0
times_count:	dc.b	0,0,0,0,0,0,0,0,0,0,0
	align
return:	dc.b	" ",13,0
	align
return2:	dc.b	" ",13,13,0
	align
return_dash:	dc.b	"",13,0
	align
class_str:	dc.b	"xxxxxx",0x22,0
	align
	global	show_tool_info
	extern	setup_window,find_window,paste_a_line,calc_lines_size
	extern	printnum,printnum99_mem_lead,do_auto_scroll,events