*******************************************************************************
*Project:                                                                     *
*Author:        Lightsoft                                                     *
*Filename:      timer_tasks.s                                                 *
*Version:       V1.00 (Auto)                                                  *
*Date started:  10:38:29 on 13th May 1997                                     *
*Rev. History:                                                                *
*                                                                             *
*                                                                             *
*******************************************************************************
setup_slow_timer:
**Set up slow timer task
	lea	my_a5(pc),a0
	move.l	a5,(a0)
	lea	my_slow_timer_task_rec(pc),a0
	lea	my_slow_timer_task(pc),a1
	move.l	a1,6(a0)	*insert task pointer
	dc.w	_InsTime
	lea	my_slow_timer_task_rec(pc),a0
	move.l	#1000,d0
	dc.w	_PrimeTime	*reset timer
	rts_	"Install_R2D2"
**task record in a1
my_slow_timer_task:
	reset_locals
	local.l	stl_old_port,1
	movem.l	d3-d7/a3-a6,-(sp)
	link	a4,#-100
	lea	my_a5(pc),a0
	move.l	(a0),a5
	eori.b	#0xff,slow_timer_flag(a5)
	move.l	a1,-(sp)	*save record
	pea	stl_old_port(a4)
	dc.w	_getport
	move.l	toolbar_ptr(a5),-(Sp)
	dc.w	_Setport
	move.l	toolbar_ptr(a5),a0	*grafport
	move.l	2(A0),a0		*handle
	move.l	(a0),a0			*bitmap
	move.l	(a0),a1			*vram
	clr.l	d5
	clr.l	d6
	move.w	32(a0),d5		*bits per pixel
	lsr.w	#3,d5			*h count
	move.l	d5,d6			*hcount 2
	move.b	slow_timer_flag(a5),d0
	bne.s	tblack
	move.l	#0xc0c0c0c0,d2	*our eor value
	bra.s	done_colour
tblack:	
	move.l	#0x70707070,d2
done_colour:
	clr.l	d1
	move.w	4(a0),d1		*byte/row
	andi.w	#0x7fff,d1		*so we don't get silly values
	move.l	d1,d3			*add value
	mulu	#35,d1			*down 42 lines
	move.l	#2,d7
	mulu	d5,d7
	add.l	d7,d1			*x offset
	add.l	d1,a1
	move.l	a1,a2
hloop1:
	move.l	d2,(A2)+
	subq.l	#1,d5
	bgt.s	hloop1
	moveq	#4,d4
	move.l	d6,d7
loop:
	add.l	d3,a1
	move.l	a1,a2
hloop2:
	move.l	d2,(A2)+
	subq.l	#1,d6
	bgt.s	hloop2
	move.l	d7,d6		*reset h count
	dbra	d4,loop
	
	bsr.l	getkey_turbo	*a0->keymap
	move.b	7(a0),d0
	btst	#3,d0
	beq.s	no_control
	move.b	6(A0),d0		*D is bit 5
	btst	#5,d0			*escape key?
	beq.s	no_debug
	pea	r2d2_text(pc)
	dc.w	_Debugstr

no_debug:
no_control:
	move.l	stl_old_port(a4),-(sp)
	dc.w	_setport
	move.l	(sp)+,a0	*record
	move.l	#500,d0
	dc.w	_PrimeTime	*reset timer
	unlk	a4
	movem.l	(sp)+,d3-d7/a3-a6
	rts_	"R2D2_task"
remove_r2d2:
	lea	my_slow_timer_task_rec(pc),a0
	dc.w	_RmvTime
	rts_	"Remove_r2d2"
r2d2_set_top_level_stack:
	lea	top_stack(pc),a0
	move.l	sp,(a0)
	rts_	"R2D2_Set_top_level_stack"	
	
my_a5:	ds.l	1	*Anvil's a5 goes here
my_slow_timer_task_rec:	ds.b	32
	align
r2d2_text:	pstring	"Anvil R2D2 Break. You may not necessarily be in Anvil!"
	align
top_stack:	ds.l	1
	align
	global	setup_slow_timer,my_slow_timer_task,remove_r2d2,r2d2_set_top_level_stack
	extern	getkey_turbo
