*****    ****     *     *   ****   *              *****
     *       *    *     *  *    *  *             *     *
     *       *    *     *  *    *  *             *
 ****    ****      *   *   ******  *              *****
     *  *          *   *   *    *  *                   *
     *  *           * *    *    *  *         **  *     *
*****   ******       *     *    *  *******   **   *****

*************************************************************
**F432Val.s - Fantasm V5 test file. 32 bit instructions only.
**
**DO NOT RUN, simply set log, ILP, then ES
**Lightsoft 95/98
**
**Note1: Whilst this file cannot test all possible permutations (nothing ever could), it 
**can be considered a basic confidence test.
**Note2: Only a small selection of extended instructions are tested.
**SB 031295
**UPDATES
**22/2/98 - SB for Fant 510,.
*************************************************************
	entry
**Branches
	stdx	r10,r11,r12		*This is an illegal instruction on 32bit procs. Say hello to Macsbug.
	b	fred
	ba	fred
	bl	fred
	bla	fred
	
	bc	12,0,fred	*blt fred
	blt	fred
	bc	4,10,fred	*bne cr2,fred
	nop
	bne	cr2,fred
	bc	16,0,fred	*bdnz fred
	bdnz	fred
fred:
		
	bclr	12,0	*bltlr
	bltlr
	bclr	4,10	*bnelr cr2
	bnelr	cr2
	bclr	16,0	*bdnzlr
	bdnzlr
	
	bcctr	12,0	*bltctr
	bltctr
	bcctr	4,10	*bnectr cr2
	bnectr	cr2
**406 tests

	sc
	
	crand	0,1,2
	cror	0,1,2
	crmove	4,5
	crxor	4,5,6
	crclr	4
	crnand	8,9,10
	crnor	8,9,10
	crnot	8,9
	creqv	12,13,14
	crset	12
	crandc	16,17,18
	crorc	cr3*4+lt,cr4*4+lt,cr5*4+lt
	mcrf	cr3,cr2

**end of branch processor - all ok in build #9

**Fixed point processor
	lbz	r3,32(r4)
	lbzx	r4,r5,r6
	lbzu	r7,32(rtoc)		*From build 8 we can use rtoc and sp
	lbzux	r9,r10,r11
	lhz	r12,(sp)
	lhzx	r14,r15,r16
	lhzu	r17,-32000(r18)
	lhzux	r19,r20,r21
	lha	r22,32000(r23)
	lhax	r1,r2,r3
	lhau	r24,(r25)
	lhaux	r26,r27,r28
	lwz	r29,32(r30)
	lwzx	r31,r0,r1
	lwzu	r2,32(r3)
	lwzux	sp,r5,r6
**end of 32 bit loads - ok in build #9

	stb	r1,0(r10)
	stbx	r3,r4,r5
	stbu	r6,32000(r7)
	stbux	r8,r9,r10
	sth	r11,-32000(r12)
	sthx	r13,r14,r15
	sthu	r16,(r17)
	sthux	r18,r19,r20
	stw	r21,12(r22)
	stwx	r23,r24,r25
	stwu	r26,-12(SP)		*make sure upper case SP is ok
	stwux	r28,r29,r30
**End of 32 bit stores - all ok in build #9

**Byte reversal insts.
	lhbrx	r3,r4,r5
	lwbrx	r6,r7,r8
	sthbrx	r9,r10,r11
	stwbrx	r12,r13,r14
	
**load/store multiple instructions
	lmw	r5,(r6)
	stmw	r7,20(RTOC)
	lswi	r5,r20,16	*16 bytes from r20 into r9
	lswx	r5,r20,r21	*byte count in XER
	stswi	r5,r20,8	
	stswx	r5,r20,r21
**All ok in build #9

**Storage sync
	lwarx	r3,r4,r5
	stwcx.	r6,r7,r8
	sync
**Fixed point arithmetic
	addi	r3,r4,0x50
		*extended adds
	li	r3,0x20
	li	r3,0+("a"*2)
	la	r3,$20(r4)
	subi	r3,r4,0x50
*
	addis	r3,r4,20
		*extended addis
	lis	r3,200
	subis	r3,r4,200
*
	add	r3,r4,r5
	add.	r3,r4,r5
	addo	r3,r4,r5
	addo.	r3,r4,r5
	
	subf	r3,r4,r5
	subf.	r3,r4,r5
	subfo	r3,r4,r5
	subfo.	r3,r4,r5
		*extended subf
	sub	r3,r4,r5 - build 8 fails
*
	addic	r3,r4,100
	addic.	r3,r4,100
		*extended addic
	subic	r3,r4,100
	subic.	r3,r4,100
*
	subfic	r3,r4,100

	addc	r3,r4,r5
	addc.	r3,r4,r5
	addco	r3,r4,r5
	addco.	r3,r4,r5
	
	subfc	r3,r4,r5
	subfc.	r3,r4,r5	
	subfco	r3,r4,r5
	subfco.	r3,r4,r5
		*extended subfc
	subc	r3,r4,r5 - failed in build 8
*
	adde	r3,r4,r5
	adde.	r3,r4,r5
	addeo	r3,r4,r5
	addeo.	r3,r4,r5
	
	subfe	r3,r4,r5
	subfe.	r3,r4,r5
	subfeo	r3,r4,r5
	subfeo.	r3,r4,r5
	
	addme	r3,r4
	addme.	r3,r4
	addmeo	r3,r4
	addmeo.	r3,r4
	
	subfme	r3,r4
	subfme.	r3,r4
	subfmeo	r3,r4
	subfmeo.	r3,r4
	
	addze	r3,r4
	addze.	r3,r4
	addzeo	r3,r4
	addzeo.	r3,r4
	
	subfze	r3,r4
	subfze.	r3,r4
	subfzeo	r3,r4
	subfzeo.	r3,r4
	
	neg	r3,r4
	neg.	r3,r4
	nego	r3,r4
	nego.	r3,r4
	
	mulli	r3,r4,5

	mullw	r3,r4,r5
	mullw.	r3,r4,r5
	mullwo	r3,r4,r5
	mullwo.	r3,r4,r5
	
	mulhw	r3,r4,r5
	mulhw.	r3,r4,r5
	
	mulhwu	r3,r4,r5
	mulhwu.	r3,r4,r5
	
	divw	r3,r4,r5
	divw.	r3,r4,r5
	divwo	r3,r4,r5
	divwo.	r3,r4,r5
	
	divwu	r3,r4,r5
	divwu.	r3,r4,r5
	divwuo	r3,r4,r5
	divwuo.	r3,r4,r5
**All ok in build 9
**32 bit compares
	cmpi	0,0,r3,20
	cmpi	7,0,r30,0x20
		*extended
	cmpwi	cr3,r10,0x20
*	
	cmp	3,0,r3,r4
		*extended
	cmpw	cr4,r3,r4
*
	cmpli	5,0,r3,0x20
		*extended
	cmplwi	cr7,r3,0x20
*
	cmpl	1,0,r3,r4
		*extended
	cmplw	cr3,r3,r4

**Fixed point 32 bit traps
	twi	8,r3,20
		*extended
	twgti	r3,20
	twllei	r3,20
*
	tw	4,r3,r4
		*extended
	tweq	r3,r4
	twlge	r3,r4
	trap

**Fixed point 32 bit logical operations
**note no need for dots with these - fant knows they need a dot
	andi.	r3,r4,20
	andis.	r3,r4,20
	ori	r3,r4,20
		*extended
	nop
*
	oris	r3,r4,20
	xori	r3,r4,20
	xoris	r3,r4,20
**the following have dotted forms
	and	r3,r4,r5
	and.	r3,r4,r5
	or	r3,r4,r5
	or.	r3,r4,r5
		*extended
	mr	r3,r4
	mr.	r3,r4		*Note Macsbug does not show dot on mr?
*
	xor	r3,r4,r5
	xor.	r3,r4,r5
	nand	r3,r4,r5
	nand.	r3,r4,r5
	nor	r3,r4,r5
	nor.	r3,r4,r5
		*extended
	not	r3,r4
	not.	r3,r4	*Note Macsbug does not show dot on not?
*
	eqv	r3,r4,r5
	eqv.	r3,r4,r5
	andc	r3,r4,r5
	andc.	r3,r4,r5
	orc	r3,r4,r5
	orc.	r3,r4,r5
	extsb	r3,r4
	extsb.	r3,r4
	extsh	r3,r4
	extsh.	r3,r4
	cntlzw	r3,r4
	cntlzw.	r3,r4
**All OK in build 9  
**32 bit rotates and shifts

	rlwinm	r10,r11,2,3,4
	rlwinm.	r10,r11,2,3,4
		**extended
	extlwi	r10,r11,2,3
	srwi	r10,r11,5
	clrrwi	r10,r11,5
**
	rlwnm	r10,r12,r2,3,4
	rlwnm.	r10,r12,r2,3,4
		**Extended
	rotlw	r10,r11,r12
**
	rlwimi	r10,r11,2,3,4
	rlwimi.	r10,r11,2,3,(2-2)+4
		**extended
	inslwi	r10,r11,2,3
**shifts
	slw	r10,r11,r12
	slw.	r10,r11,r12
	
	srw	r10,r11,r12
	srw.	r10,r11,r12
	
	srawi	r10,r11,2
	srawi.	r10,r11,2
	
	sraw	r10,r11,r12
	sraw.	r10,r11,r12

	nop
**406 immediate data evaluation test
	rlwinm	r10,r11,(1+1),(1+2),1+(1+1+1)
	
	rlwinm.	r10,r11,1+(1),1+2,(1+1+1+1)
		**extended
	extlwi	r10,r11,5-(3),1+(1+1)
	srwi	r10,r11,2+(9/3)
	clrrwi	r10,r11,(5+5)/2
**
rtocy:	equ	13
	rlwnm	r10,r12,r2,rtocy,4
	rlwnm.	r10,r12,r2,3,4
		**Extended
	rotlw	r10,r11,r12
**
	rlwimi	r10,r11,2,3,4
	rlwimi.	r10,r11,2,3,(2-2)+4
		**extended
	inslwi	r10,r11,2,3
**shifts
	slw	r10,r11,r12
	slw.	r10,r11,r12
	
	srw	r10,r11,r12
	srw.	r10,r11,r12
	
	srawi	r10,r11,2
	srawi.	r10,r11,2
	
	sraw	r10,r11,r12
	sraw.	r10,r11,r12

**move to from SPR's (selected)
	mtspr	XER,R10	*NOTE SPRS must be in upper case.
	mtspr	1,r10	*1 is xer
		**extended
	mtxer	r10
	mtlr	r10
	mtctr	r10
*
	mfspr	r10,LR
	mfspr	r10,XER
	mfxer	r10
	mfspr	r10,TBL
	mfspr	r10,8	*8 is lr
		**extended
	mfxer	r10
	mflr	r10
	mfctr	r10
*
	mtcrf	cr1,r10	*FP condition register field
	mcrxr	cr0		*int condition reg field from xer
	mfcr	r10
**All ok in build 9

*********************************************************

**32 bit floating instructions.
**Loads
	lfs	f1,(r13)
	lfsx	f2,r10,r11
	lfsu	f3,(r14)		
	lfsux	f4,r10,r11	
	lfd	f5,(r14)
	lfdx	f6,r10,r11
	lfdu	f7,(r10)
	lfdux	f8,r10,r11
**Stores
	stfs	f9,(r10)
	stfsx	f10,r10,r11
	stfsu	f11,(r10)
	stfsux	f12,r10,r11
	stfd	f13,(r10)
	stfdx	f14,r10,r11
	stfdu	f15,(r10)
	stfdux	f16,r10,r11		*sage and onion please (yum yum)
**All ok in build #9
**Moves
	fmr	f17,f18
	fmr.	f19,F20		*Quick check of upper case F
	fneg	f20,f21
	fneg.	f22,f23
	fabs	f24,f25
	fabs.	f26,f27
	fnabs	f28,f29
	fnabs.	f30,f31
**Simple Maths
	fadd	f1,f2,f3
	fadd.	f1,f2,f3
	fadds	f1,f2,f3
	fadds.	f1,f2,f3
	fsub	f1,f2,f3
	fsub.	f1,f2,f3
	fsubs	f1,f2,f3
	fsubs.	f1,f2,f3
	fmul	f1,f2,f3
	fmul.	f1,f2,f3
	fmuls	f1,f2,f3
	fmuls.	f1,f2,f3
	fdiv	f1,f2,f3
	fdiv.	f1,f2,f3
	fdivs	f1,f2,f3
	fdivs.	f1,f2,f3	
**The good maths
	fmadd	f1,f2,f3,f4		*Float mult add - Oooeer!
	fmadd.	f1,f2,f3,f4	
	fmadds	f1,f2,f3,f4
	fmadds.	f1,f2,f3,f4
	fmsub	f1,f2,f3,f4	
	fmsub.	f1,f2,f3,f4
	fmsubs	f1,f2,f3,f4	
	fmsubs.	f1,f2,f3,f4
	fnmadd	f1,f2,f3,f4
	fnmadd.	f1,f2,f3,f4		*Float negative mult add
	fnmadds	f1,f2,f3,f4
	fnmadds.	f1,f2,f3,f4		*Float negative mult add
	fnmsub	f1,f2,f3,f4
	fnmsub.	f1,f2,f3,f4		*Float negative mult sub
	fnmsubs	f1,f2,f3,f4
	fnmsubs.	f1,f2,f3,f4
**Rounding and conversion
	frsp	f1,f2
	frsp.	f1,f2
	fctiw	f1,f2
	fctiw.	f1,f2
	fctiwz	f1,f2
	fctiwz.	f0,f1	*round towards zero
**Compares
	fcmpu	cr0,f0,f1	*unordered
	fcmpo	cr1,f2,f3	*ordered
**FPU Status and control
	mffs	f1
	mffs.	f1
	mcrfs	cr1,1
	mtfsfi	0,2
	mtfsfi.	1,3
	mtfsf	2,f1
	mtfsf.	4,f1	
	mtfsb0	13		*clear bit 13 of fpscr
	mtfsb0.	13
	mtfsb1	9
	mtfsb1.	9
**All ok in build 9
**Evaluator checks
        li	r5,3^6	*729
        li	r5,(2-2)+2	*2
        li	r5,2-2+2	*-2 (+ overrides -)
        li	r5,3^(2*2)	*81
        li	r5,(2*2)^3	*64

errors:	equ	0
	if	errors
	oris.	r3,r4,5	*Don't not used on this instruction (522)
	li.	r3,23		*same
	lbz.	r3,6(r4)	*same
	endif       

**END OF 32 BIT TEST**	

**AltiVec Test
	lvebx	`fred,r3,r4
	lvehx	v31,r4,r5
	lvewx	v0,r5,r6
	lvsl	v10,r6,r7
	lvsr	v15,r7,r8
	lvx	v27,r8,r9
	lvxl	v22,r9,r10
	mfvscr	v3
	mtvscr	v5,v6
	stvebx	v4,r3,r4
	stvehx	v5,r4,r5
	stvewx	v6,r5,r6
	stvx	v7,r6,r7
	stvxl	v8,r7,r8
	vaddcuw	v3,v4,v5
	vaddfp	v5,v6,v7
	vaddsbs	v8,v9,v10
	vaddshs	v11,v12,v13
	vaddsws	v14,v15,v16
	vaddubm	v17,v18,v19
	vaddubs	v20,v21,v22
	vadduhm	v23,v24,v25
	vadduhs	v26,v27,v28
	vadduwm	v29,v30,v31
	vadduws	v0,v1,v2

	vmaxfp	v0,v1,v2
	vmaxsb	v0,v1,v2
	vmaxsh	v0,v1,v2
	vmaxsw	v0,v1,v2
	vmaxub	v0,v1,v2
	vmaxuh	v0,v1,v2
	vmaxub	v0,v1,v2

	vminfp	v0,v1,v2
	vminsb	v0,v1,v2
	vminsh	v0,v1,v2
	vminsw	v0,v1,v2
	vminub	v0,v1,v2
	vminuh	v0,v1,v2
	vminub	v0,v1,v2

	vmrghb	v0,v1,v2
	vmrghh	v0,v1,v2
	vmrghw	v0,v1,v2
	vmrglb	v0,v1,v2
	vmrglh	v0,v1,v2
	vmrglw	v0,v1,v2

	vmulesb	v0,v1,v2
	vmulesh	v0,v1,v2
	vmuleub	v0,v1,v2
	vmuleuh	v0,v1,v2
	vmulosb	v0,v1,v2
	vmulosh	v0,v1,v2
	vmuloub	v0,v1,v2
	vmulouh	v0,v1,v2

	vpkshss	v0,v1,v2
	vpkshus	v0,v1,v2
	vpkswss	v0,v1,v2
	vpkuhum	v0,v1,v2
	vpkuhus	v0,v1,v2
	vpkuwum	v0,v1,v2
	vpkusus	v0,v1,v2

	vrlb	v0,v1,v2
	vrlh	v0,v1,v2
	vrlw	v0,v1,v2
	vsl	v0,v1,v2
	vslb	v0,v1,v2
	vslh	v0,v1,v2
	vslo	v0,v1,v2
	vslw	v0,v1,v2

	vspltw	v0,v1,v2
	vsr	v0,v1,v2
	vsrab	v0,v1,v2
	vsrah	v0,v1,v2
	vsraw	v0,v1,v2
	vsrb	v0,v1,v2
	vsrh	v0,v1,v2
	vsro	v0,v1,v2
	vsrw	v0,v1,v2
	vsubcuw	v0,v1,v2
	vsubfp	v0,v1,v2
	vsubsbs	v0,v1,v2
	vsubshs	v0,v1,v2
	vsubsws	v0,v1,v2
	vsububm	v0,v1,v2

**vbasic_dot
	vcmpbfpx	v0,v1,v2
	vcmpbfpx.	v3,v4,v5
	vcmpeqf.	v5,v6,v7
	vcmpequb.	v8,v9,v10
	vcmpequh.	v8,v9,v10
	vcmpequw.	v8,v9,v10
	vcmpgefp.	v8,v9,v10
	vcmpgtfp.	v8,v9,v10
	vcmpgtsb.	v8,v9,v10
	vcmpgtsh.	v8,v9,v10
	vcmpgtsw.	v8,v9,v10
	vcmpgtub.	v8,v9,v10
	vcmpgtuh.	v8,v9,v10
	vcmpgtuw.	v8,v9,v10

	vcfsx	v3,v4,2
	vcfux	v5,v29,29
	vctsxs	v30,v31,3
	vctuxs	v0,v1,4
	vspltb	v2,v3,18
	vsplth	v4,v5,19
	vspltw	v6,v7,20
	
	vnor	v3,v4,v5
	vor	v3,v4,v5
	vmsummbm	v6,v7,v8,v9
	vmsumshm	v10,v11,v12,v13
	vmsumshs	v14,v15,v16,v17
	vmsumubm	v18,v19,v20,v21
	vmsumuhm	v22,v23,v24,v25
	vmsumuhs	v26,v27,v28,v29
	vnmsubfp	v0,v9,v3,v8
	vperm	v5,v6,v7,v8
	vmhaddshs	v9,v10,v11,v12
	vmhraddshs	v13,v14,v15,v16
	vmaddfp	v17,v18,v19,v20
	
	vmladduhm	v0,v1,v2,v3
	vsel	v4,v5,v6,v7
	vexptefp	v3,v4
	vlogefp	v5,v6
	vrfip	v7,v8
	vrfiz	v9,v10
	vrsqrtefp	v11,v12
	
	vrefp	v13,v14
	vrfim	v15,v16
	vrfin	v17,v18
	vpkpx	v19,v20,v21	*PMac Debugger decodes this as vpkpx v19,v21?????????
	vspltisb	v3,5	
	vspltisb	v3,-15	
	vspltish	v31,15
	vspltish	v0,-0
	vspltisw	v7,-1
	vspltisw	v8,3
	vsldoi	v1,v2,v3,4
	vsldoi	v5,v6,v7,0
	vsubuhm	v1,v2,v3
	vsububs	v4,v4,v5
	vsubuhs	v6,v7,v8
	vsubuwm	v9,v10,v11
	vsubuws	v12,v13,v14
	vsumsws	v15,v16,v17
	vsum2sws	v18,v19,v20
	vsum4sbs	v18,v19,v20
	vsum4shs	v18,v19,v20
	vsum4ubs	v18,v19,v20
	vupkhpx	v20,v21
	vupkhsb	v23,v24
	vupkhsh	v26,v27
	vupklpx	v29,v30
	vupklsb	v31,v29
	vupklsh	v27,v27
	vxor	v2,v13,v26
**Stream prefetch instrcutions go here - not implemented at this time.
	dst	*error
**vrsave
	mfspr	r3,VRSAVE
	mtspr	VRSAVE,r3
	mfvrsave	r3
	mtvrsave	r3
	mfspr	r3,256
	mtspr	256,r3
	blr		